c *************************************************************
c *   DODASPK
c *
c *   PvK 931102
c *************************************************************
      subroutine dodaspk(t,tout,init)
      implicit double precision(a-h,o-z)
      parameter(MXNEQ=10 000)

c     *** DASPK declarations
      parameter(MXORD=5, MAXL=5, MXML=1, MXMU=1)
      parameter(LENRW = 50+(MXORD+5)*MXNEQ+(MAXL+4)*MXNEQ+
     v                  (MAXL+3)*MAXL+1)
      parameter(LENIW=40)
      parameter(LENWP=MXNEQ*(2*MXML+MXMU+1)+2*(MXNEQ*(MXML+MXMU+1)+1))       
      parameter(LENIWP = MXNEQ)
      dimension iwork(LENIW+LENIWP), rwork(2*(LENRW+LENWP))
      dimension yprime(MXNEQ)
      dimension info(20),rpar(20),ipar(20)
      save info,rpar,ipar
c     *** External function for DASPK
      external djack, dpsol, res
c     *** End DASPK declarations
      common /myseparrays/ kmesh(100),kprob(100),intmat(5),
     v       isol(5),matr(5),ihelp(5),irhsd(5),matrm(5),
     v       iuser(100),user(100)
      common /corder/ torder(10000),iforder,norder(10000)


      common ibuffr(1)
      common /cbuffr/ nbuffr,kbuffr,intlen,ibfree
      common /carray/ iinfor,infor(3,1500)
      common /caccu/accu

      dimension igradt(5)
      save igradt

c     *** Find actual number of equations
      nusol=kprob(5)
      nbound = kprob(10)
      npboun = kprob(34)
      neq = nusol-nbound-npboun
      if (neq.gt.MXNEQ) then
         write(6,*) 'PERROR(dodaspk): neq > NEQMAX'
         call instop
      endif

      lrw = LENRW
      liw = LENIW

c     *** Multiply stiffness matrix and rhsd vector with inverse(M)
      call peinver(matrm)
c     call prinmt(intmat,matr,kprob)
c     call maver(matr,matrm,idum,intmat,kprob,1)
      call pemav(matr,matrm,idum,intmat,kprob,1)
c     call prinmt(intmat,matr,kprob)

c     call prinrv(irhsd,kmesh,kprob,4,1,'irhsd')
c     call maver(matrm,irhsd,idum,intmat,kprob,2)
      call pemav(matrm,irhsd,idum,intmat,kprob,2)

c     call prinrv(irhsd,kmesh,kprob,4,1,'irhsd')


      ipsol = infor(1,isol(1))
      ipar(1) = neq

      if (init.eq.0) then
c        *** initialize y and y'
         call yinit(ibuffr(ipsol),yprime,rpar,ipar)
c        *** enable the code to initialize itself
         info(1) = 0
c        ** accuracy: use RTOL and ATOL both as scalars
         info(2) = 0
c        *** give solution only at TOUT
         info(3) = 1
c        **** no restrictions on time t
         info(4) = 0
c        **** Direct method: Calculate partial derivs automatically
         info(5) = 0
c        **** Direct method: Forget about bandedness of dG/dY + CJ*dG/dYPRIME
         info(6) = 0
c        **** Code should decide on its maximum stepsize
         info(7) = 0
c        **** Code should decide on its initial stepsize
         info(8) = 0
c        rwork(3) = 0.00001
c        **** Maximum order is 5 by default 
         info(9) = 0
c        **** No special nonnegativity constraints
         info(10) = 0
c        **** t,y and y' are not consistent
         info(11) = 1
c        **** Use Krylov method
c        info(12) = 0
         info(12) = 1
c        **** Default parameters for iteration
         info(13) = 0
c        **** Dummy parameter
         info(14) = 0
c        **** Provide external JACK function to update preconditioner periodically
         info(15) = 1

c        **** information on preconditioner (copied form DXAMPL)
         ml  = 1
         mu  = 1
         lml = 3
         lmu = 4
         ipar(lml) = ml
         ipar(lmu) = mu
         lnre = 5
         ipar(lnre) = 0
         lenpd = (2*ipar(lml)+ipar(lmu)+1)*neq
         mband = ipar(lml)+ipar(lmu)+1
         msave = (neq/mband)+1
         lwp   = lenpd+2*msave
         liwp  = neq
         iwork(27) = lwp
         iwork(28) = liwp
         lrw = 2*(lrw + lwp)
         liw = liw + liwp
   
         rtol = 0d0
         atol = accu
   
         write(6,30) neq,ipar(lml),ipar(lmu),rtol,atol
30       format(' Advection-diffusion equation problem',//,
     v          ' NEQ=', i10,/,
     v          ' Solution by DASPK, iterative mode;',/,
     v          ' Method is precondition GMRES;',/,
     v          ' Preconditioner is banded approximation',/,
     v          ' to the Jacobian (ML=',i3,'   MU = ',i3,');',/,
     v          ' RTOL = ',e10.1,'    ATOL = ',e10.1//)
  
         i=0
      endif
      write(6,40)
40    format(5x,'t',13x,'Nu',9x,'q',8x,'h',8x,'steps',5x,'nni',
     v       5x,'nli',/)
100   continue     
      if (t.lt.tout) then
         i=i+1
         call ddaspk(res,neq,t,ibuffr(ipsol),yprime,tout,info,rtol,
     v          atol,idid,rwork,lrw,iwork,liw,rpar,ipar,djack,dpsol)
c        call deriva(0,2,0,1,0,igradt,kmesh,kprob,isol,isol,
c    v               iuser,user,ielhlp)
c        gnus = bounin(2,3,1,1,kmesh,kprob,1,2,igradt,iuser,user)
c        call algebr(6,1,isol,isol,isol,kmesh,kprob,
c    v            tmax,tmin,p,q,ip)

         hu = rwork(7)
         nqu = iwork(8)
         nst = iwork(11)
         nni = iwork(19)
         nli = iwork(12)
         write(6,60) i,t,tmax,tmin,nqu,hu,nst,nni,nli
         if (iforder.lt.10000) then
            torder(iforder) = t
            norder(iforder) = nqu
            iforder = iforder+1
         endif
         goto 100
      endif

60    format(i5,e15.5,2e12.4,i5,e14.3,i7,i9,i9)    
      nst = iwork(11)
      nre = iwork(12) + ipar(lnre)
      npe = iwork(13)
      liw = iwork(17)
      lrw = iwork(18)
      nni = iwork(19)
      nli = iwork(20)
      nps = iwork(21)
      if (nni.ne.0) afps = dfloat(nli)/dfloat(nni)
      ncfn = iwork(15)
      ncfl = iwork(16)
      write(6,80) lrw,liw,nst,nre,npe,nps,nni,nli,afps,
     v            ncfn,ncfl
80    format(//' Final statistics for this subroutine... ',/,
     v       ' Rwork size = ',i8,'  Iwork size ',i5,/,
     v       ' Number of time steps .................... ',i5,/,
     v       ' Number of function evaluations .......... ',i5,/,
     v       ' Number of preconditioner evaluations .... ',i5,/,
     v       ' Number of preconditioner solves ......... ',i5,/,
     v       ' Number of nonlinear iterations .......... ',i5,/,
     v       ' Number of linear iterations ............. ',i5,/,
     v       ' Average Krylov dimension ................ ',f8.4,/,
     v       ' Nonlinear convergence failures .......... ',i5,/,
     v       ' Linear convergence failurs .............. ',i5)

      return
      end
