      subroutine rffti(n,wsave)
      implicit real*8(a-h,o-z)
      parameter(precis=2.)
      parameter(zero=0.d0, one=1.d0, oneneg=-1.d0, two=2.d0, three=3.d0,
     1          four=4.d0, five=5.d0, six=6.d0, seven=7.d0, eight=8.d0,
     2          nine=9.d0, ten=10.d0,
     3          half=0.5d0, quarter=.25d0, eighth=.125d0, tenth=.1d0,
     4          threq=.75d0,
     5          hundr=100.0d0, hundinv=.01d0)
c***begin prologue  rffti
c***date written   790601   (yymmdd)
c***revision date  830401   (yymmdd)
c***category no.  j1a1
c***keywords  fourier transform
c***author  swarztrauber, p. n., (ncar)
c***purpose  initialize for rfftf and rfftb.
c***description
c
c  subroutine rffti initializes the array wsave which is used in
c  both rfftf and rfftb.  the prime factorization of n together with
c  a tabulation of the trigonometric functions are computed and
c  stored in wsave.
c
c  input parameter
c
c  n       the length of the sequence to be transformed.
c
c  output parameter
c
c  wsave   a work array which must be dimensioned at least 2*n+15.
c          the same work array can be used for both rfftf and rfftb
c          as long as n remains unchanged.  different wsave arrays
c          are required for different values of n.  the contents of
c          wsave must not be changed between calls of rfftf or rfftb.
c***references  (none)
c***routines called  rffti1
c***end prologue  rffti
      dimension       wsave(*)
c***first executable statement  rffti
      if (n .eq. 1) return
      call rffti1 (n,wsave(n+1),wsave(2*n+1))
      return
      end
