      subroutine abeaddr(ij_index,iindex,jindex,m,n,ijob,ifill,imp_sym)
c $Log:   /pvcs.config/mc3dvv/src/abeaddr.F_a  $
c   
c      Rev 1.1   Fri Jul 30 15:06:08 1999   lowman
c     Made iabeaddr matrix allocatable and added it to flow.h 
c   
c      Rev 1.0   Tue Mar 23 16:51:38 1999   lowman
c   Initial revision.

c    JPL Add Nov. 98
c    This function takes advantage of the f(i,j)=f(j,i) 
c    symmetry of the differential equation coefficient matrix if
c    imp_sym =1
c    Addresses for the abe matrix are calculated here and passed
c    back to flow as needed in a way that saves machine memory.

c    ifill = 0 fill abecount matrix
c          = 1 recall value from abecount matrix

c    ijob = 1 return index values of upper triangular matrix
c         = 0 return index values of a full matrix
c         =-1 return index values of lower triangular matrix
      use module_precision
      use module_param
      use module_flow

c      common/cabecount/iabeaddr(200,200)

      if(ifill.eq.0)then

      ij_index = 2 

c      write(*,*) 'iindex=',iindex,'jindex=',jindex

      if(ijob.eq.1)then

       isave=iindex
       jsave=jindex
       if((jindex.gt.1).and.(mod(jindex,2).eq.1))then
         jindex=jindex-1  
       endif

c       write(*,*) jindex

        if((imp_sym.eq.1).and.(iindex.lt.jindex))then
          iindex=jindex
          jindex=isave
          if((jindex.gt.1).and.(mod(jindex,2).eq.1))then
            jindex=jindex-1
          endif
        endif 

        do jj = 1,jindex

          if (imp_sym.eq.1)then
            kindex = jj 
          else
            kindex = 1
          endif

          if (jj.lt.jindex) then
            lindex=m
          else
            lindex=iindex
          endif

          do ii = kindex,lindex
           if(((ii.eq.1).and.(mod(jj,2).eq.0)).or.
     $       ((jj.eq.1).and.(mod(ii,2).eq.0)).or.
     $       ((mod(ii,2).eq.0).and.(mod(jj,2).eq.0))) 
     $       ij_index = ij_index + 1
          enddo

        enddo
      iabeaddr(isave,jsave)=ij_index
      
c      write(*,*) 'iindex=',isave,'jindex=',jsave
c      write(*,*) 'ij_index=',ij_index

      iindex=isave
      jindex=jsave

      elseif(ijob.eq.0)then
        write(*,*) 'ijob=0 not implemented in function abeaddr'
        stop 'PROGRAM WILL STOP'
      elseif(ijob.eq.-1)then
        write(*,*) 'ijob=-1 not implemented in function abeaddr' 
        stop 'PROGRAM WILL STOP' 
      endif

      elseif(ifill.eq.1)then
       ij_index=iabeaddr(iindex,jindex)

      endif

      return
      end
