c $Log:   /pvcs.config/mc3dvv/src/bc.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:20:50 1997   pvcs
c 
c *************************************************************
c *   BC
c *   
c *   u,v,w i/o  Solution arrays, either describing velocity
c *              or stress
c *   idim1 i    x-Dimension of velocity arrays
c *
c *   lbcx  i    Indicates type of side boundary conditions
c *                = 0 for periodic
c *                = 1 for free slip sides
c *                = 2 for no slip sides
c *   idim2 i    y-Dimension of velocity arrays
c *   mbcy  i    See lbcx, but now for y direction.
c *   ijob  i    obsolete
c *************************************************************
c *   OUTPUT
c *   Boundary values in solution arrays may have been updated.
c *************************************************************
      subroutine bc 
     1 (u,v,w,idim1,ncx,ndx,lbcx,idim2,ncy,ndy,mbcy,ncz,ijob)
      use module_precision
      dimension u(idim1,idim2,*), v(idim1,idim2,*), w(idim1,idim2,*)

      if (ncy.eq.1) then
        ncyp1=1
      else
        ncyp1=ncy+1
      endif

      do 70 k=1,ncz
c        *** For each depth level

        if (lbcx.eq.0) then
c         *** Periodic in x
          do 10 i=1,ncx
            u(i,ncyp1,k)=u(i,1,k)
            v(i,ncyp1,k)=v(i,1,k)
            w(i,ncyp1,k)=w(i,1,k)
   10     continue
        endif
        if (mbcy.eq.0) then
c         *** Periodic in y
          do 20 j=1,ncy
            u(ncx+1,j,k)=u(1,j,k)
            v(ncx+1,j,k)=v(1,j,k)
            w(ncx+1,j,k)=w(1,j,k)
   20     continue
        endif
        if ((lbcx.eq.0).and.(mbcy.eq.0)) then
          u(ncx+1,ncyp1,k)=u(1,1,k)
          v(ncx+1,ncyp1,k)=v(1,1,k)
          w(ncx+1,ncyp1,k)=w(1,1,k)
        endif

c       *** Symmetry conditions
        if ((lbcx.eq.1).and.(ndy.ne.1)) then
          do 30 j=1,ndy
            u(1,j,k)=0.
            u(ndx,j,k)=0.
   30     continue
        endif
        if (mbcy.eq.1) then
          do 40 i=1,ndx
            v(i,1,k)=0.
            v(i,ndy,k)=0.
   40     continue
        endif

c       *** Rigid boundary conditions
        if (lbcx.eq.2) then
          do 50 j=1,ndy
            u(1,j,k)=0.
            u(ndx,j,k)=0.
            v(1,j,k)=0.
            v(ndx,j,k)=0.
            w(1,j,k)=0.
            w(ndx,j,k)=0.
   50     continue
        endif

        if (mbcy.eq.2) then
           do 60 i=1,ndx
              u(i,1,k)=0.
              u(i,ndy,k)=0.
              v(i,1,k)=0.
              v(i,ndy,k)=0.
              w(i,1,k)=0.
              w(i,ndy,k)=0.
   60      continue
        endif

   70 continue

      return
      end
