c $Log:   /pvcs.config/mc3dvv/src/difeq4.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:10 1997   pvcs
c 
c *************************************************************
c *   DIFEQ4
c *************************************************************
      subroutine difeq4(k,k1,k2,j9,ic3,ic4,indexv,ne,s,nsi,nsj,y,nyj,
     . nyk)
c
c     user supplied routine to form the s matrix for 2 point
c     boundary value solution via relaxation method
c
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_gia9
      use module_a9
      use module_viscom
      real l,l2
      common /a8/ l2,l,vps,vts
      dimension s(nsi,nsj),y(nyj,nyk),indexv(nyj)
      if(k.eq.k1) then
c
c     equations at bottom boundary
c
      do 10 ii=1,4
      do 10 jj=1,4
  10  s(jj,indexv(ii))=zero
      do 20 ii=1,4
      do 20 jj=1,4
  20  s(jj,4+indexv(ii))=zero
      if(ibcb.eq.2) then
      s(3,4+indexv(1))=one
      s(4,4+indexv(2))=one
      s(3,j9)=y(1,1)
      s(4,j9)=y(2,1)
      else
      s(3,4+indexv(2))=one
      s(4,4+indexv(3))=one
      s(3,j9)=y(2,1)
      s(4,j9)=y(3,1)
      endif
c
      else if(k.gt.k2) then
c
c     equations at top boundary
c
 
      do 30 ii=1,4
      do 30 jj=1,4
  30  s(jj,indexv(ii))=zero
      do 40 ii=1,4
      do 40 jj=1,4
  40  s(jj,4+indexv(ii))=zero
      if(ibct.gt.1) then
      s(1,4+indexv(1))=one
      s(2,4+indexv(2))=one
c cg      s(1,j9)=y(1,nz)-vps
      s(1,j9)=y(1,k)-vps
c cg      s(2,j9)=y(2,nz)
      s(2,j9)=y(2,k)
      else
      s(1,4+indexv(2))=one
      s(2,4+indexv(3))=one
c cg      s(1,j9)=y(2,nz)
      s(1,j9)=y(2,k)
c cg      s(2,j9)=y(3,nz)
      s(2,j9)=y(3,k)
      endif
c
c**   else
c**---------------------------------------------***
c     equations for chemical boundary
c**---------------------------------------------***
      else if (k.eq.kchem)then
	  km1 = k-1
          do i=1,4
	      do j=1,4
                  s(i,j)   = zero
                  s(i,j+4) = zero
              enddo
	      s(i,9) = zero
          enddo
	  s(1,indexv(2))  = one
 	  s(2,4+indexv(2))  = one
	  s(3,indexv(1))  = -one
	  s(3,4+indexv(1))  = one
	  s(4,indexv(3))  = -one
	  s(4,4+indexv(3))  = one

	  s(1,j9)  = y(2,km1)
	  s(2,j9)  = y(2,k)
	  s(3,j9)  = y(1,k) - y(1,km1)
	  s(4,j9)  = y(3,k) - y(3,km1)
      else
	  if (k.lt.kchem) then
              kdum = k
          else
              kdum = k-1
          endif
c**---------------------------------------------***

c
c     equations for interior points
c
c**   dz=(z(k)-z(k-1))*0.5
      dz=(z(kdum)-z(kdum-1))*0.5
      dzl=l*dz
      dz4l=4.*l*dzl
      km1=k-1
      kdumm1 = kdum-1
      s(1,indexv(1))=oneneg
      s(1,indexv(2))=-dzl
c**   s(1,indexv(3))=-dz*vnu(km1)
      s(1,indexv(3))=-dz*vnu(kdumm1)
      s(1,indexv(4))=zero
      s(1,4+indexv(1))=one
      s(1,4+indexv(2))=-dzl
c**   s(1,4+indexv(3))=-dz*vnu(k)
      s(1,4+indexv(3))=-dz*vnu(kdum)
      s(1,4+indexv(4))=zero
      s(2,indexv(1))=dzl
      s(2,indexv(2))=oneneg
      s(2,indexv(3))=zero
      s(2,indexv(4))=zero
      s(2,4+indexv(1))=dzl
      s(2,4+indexv(2))=one
      s(2,4+indexv(3))=zero
      s(2,4+indexv(4))=zero
c**   s(3,indexv(1))=-dz4l*vis(km1)
      s(3,indexv(1))=-dz4l*vis(kdumm1)
      s(3,indexv(2))=zero
      s(3,indexv(3))=oneneg
      s(3,indexv(4))=-dzl
c**   s(3,4+indexv(1))=-dz4l*vis(k)
      s(3,4+indexv(1))=-dz4l*vis(kdum)
      s(3,4+indexv(2))=zero
      s(3,4+indexv(3))=one
      s(3,4+indexv(4))=-dzl
      s(4,indexv(1))=zero
      s(4,indexv(2))=zero
      s(4,indexv(3))=dzl
      s(4,indexv(4))=oneneg
      s(4,4+indexv(1))=zero
      s(4,4+indexv(2))=zero
      s(4,4+indexv(3))=dzl
      s(4,4+indexv(4))=one
c
      s(1,j9)=y(1,k)-y(1,km1)-dz*(l*(y(2,k)+
c**  . y(2,km1))+(vnu(k)*y(3,k)+vnu(km1)*y(3,km1)))
     . y(2,km1))+(vnu(kdum)*y(3,k)+vnu(kdumm1)*y(3,km1)))
c
      s(2,j9)=y(2,k)-y(2,km1)+dz*l*(y(1,k)+
     . y(1,km1))
c
      s(3,j9)=y(3,k)-y(3,km1)-dz*(4.*l2*
c**  .(vis(k)*y(1,k)+vis(km1)*y(1,km1))+l*(y(4,k)+y(4,km1)))
     .(vis(kdum)*y(1,k)+vis(kdumm1)*y(1,km1))+l*(y(4,k)+y(4,km1)))
c
      s(4,j9)=y(4,k)-y(4,km1)+dz*(l*(y(3,k)+
c**  . y(3,k-1))-(rr(k)+rr(k-1)))
     . y(3,k-1))-(rr(kdum)+rr(kdumm1)))
      endif
      return
      end
