c $Log:   /pvcs.config/mc3dvv/src/fieldout.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:14 1997   pvcs
c 
c *************************************************************
c *   FIELDOUT
c *************************************************************
      subroutine fieldout(luout,itypef,ifspdp)
C************BEGIN PROLOGUE********************************
C   PROGRAM NAME  xxxxx
C   DATE WRITTEN   90????   (YYMMDD)
C   REVISION DATE  xxxxxx   (YYMMDD)
C   AUTHOR  Carl W. Gable   (Los Alamos National Laboratory)
C   PURPOSE  Write output files
C   DESCRIPTION/COMMENTS
c
c     this routine writes 3-d vector or scalar data 
c
c     fields are converted to single precision before output
c
c     I don't use the sngl function because that makes transport
c     from 64 bit to 32 bit more of a pain.
c
c     itypef  = 1 temperature field
c             = 2 velocity field
c             = 3 concentration field
c
C   MODIFICATIONS
c cwg 3/16/93 Eliminate use of 1d equivelence arrays for output
c             Use DPTOSP to convert to single precision output array
c
C**********END PROLOGUE************************************
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_ac1
      use module_a2
      use module_gia3
      use module_a3
cspdp      
      use module_spwork
      real*4 stime,sdt
cspdp
c  cg
c      use module_fieldout
c

      iotype = ifspdp
c
      lutem = luout
      luvel = luout
      lucon = luout
c
      stime=time
      sdt=dt
      if (itypef .eq. 2) then
         if(iotype .eq. 2)then
            write (luvel) time,dt
            write (luvel) (((u(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            write (luvel) (((v(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            write (luvel) (((w(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         elseif(iotype .eq. 1)then
            write (luvel) stime,sdt
            call dptosp(inx,jnx,knx,u,spwk,idum)
            write (luvel) (((spwk(i,j,k),i=1,nx),j=1,j3),k=1,nz)
            call dptosp(inx,jnx,knx,v,spwk,idum)
            write (luvel) (((spwk(i,j,k),i=1,nx),j=1,j3),k=1,nz)
            call dptosp(inx,jnx,knx,w,spwk,idum)
            write (luvel) (((spwk(i,j,k),i=1,nx),j=1,j3),k=1,nz)
         endif
      endif
      if (itypef .eq. 1) then
         if(iotype .eq. 2)then
            write (lutem) time,dt
            write (lutem) (((t(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         elseif(iotype .eq. 1)then
            write (lutem) stime,sdt
            call dptosp(inx,jnx,knx,t,spwk,idum)
            write (lutem) (((spwk(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         endif
      endif
      if (itypef .eq. 3) then
         if(iotype .eq. 2)then
            write (lucon) time,dt
            write (lucon) (((c(i,j,k,1),i=1,icx),j=1,jcx),k=1,kcx)
         elseif(iotype .eq. 1)then
            write (lucon) stime,sdt
            call dptosp(icx,jcx,kcx,c,spwk,idum)
            write (lucon) (((spwk(i,j,k),i=1,icx),j=1,jcx),k=1,kcx)
         endif
      endif

      return
      end
