c $Log:   /pvcs.config/mc3dvv/src/flow_layer.F_a  $
c
c   Rev 1.1   Fri Jul 30 15:15:00 1999   lowman
c  Fixed argument list for call to netflow
c
c   Rev 1.0   Mon Jul 14 14:21:18 1997   pvcs
c 
c *************************************************************
c *   FLOW_LAYER
c *************************************************************
      subroutine flow_layer
c
c     this routine computes the velocity field using various
c     methods selected by isolve
c
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_afftw
c#include<a4.h>
      use module_a6
      use module_a7
      use module_gia9
      use module_a9
      use module_a11
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a13
      use module_a14
      use module_a20
      use module_a26
      use module_a30
c relax
      use module_flow
      use module_ftcoef
      real l, l2
      common /start1/ restrt, initlt, istart
      common /a4/ vsij(700)
      common /a8/ l2, l, vps, vts
      common /a10/ jcycle
      real*8 ss(2,5), s(4,9)
      real*8 sscalv(2), iindexv(2)
      real*8 scalv(4), indexv(4)


      dimension ytmp(6)
c lu
      jcycle=icycle
      twopi=2.*pimach(dumm)
c cg      pi=acos(-1.)
      pi=pimach(dumm)
      if((isolve .gt. 2) .and. ((icycle .eq. 1) .or. (restrt .ne. 0.0
     1   )))then
c
c     initialize flow
c
      call initflow
c
      endif
      if((icycle.eq.1) .or. (restrt .ne. 0.0)) then
c
c     flow driven plates
c
      if((ibct .eq. 2) .and. (isurfv .lt. 0))then
         call plflow
         call inttaup
      endif
      if(ibct.eq.3) then
c
c     calculate surface velocity induced flow
c
       do 4 j=1,ny
       do 4 i=1,nx
       vsurf(i,j,1)=0.
   4   vsurf(i,j,2)=0.
      if(isurfv.ne.0) then
      if(isurfv.eq.1) then
c
c     get surface velocity from input table vsij
c
      ll=1
   5  i1=int(vsij(ll))
      i2=int(vsij(ll+1))
      j1=int(vsij(ll+2))
      j2=int(vsij(ll+3))
      uxs=vsij(ll+4)
      vys=vsij(ll+5)
      if(i1.eq.0) go to 7
      do 15 j=j1,j2
      do 15 i=i1,i2
      vsurf(i,j,1)=uxs
   15 vsurf(i,j,2)=vys
      ll=ll+6
      go to 5
      endif
      if(isurfv.ne.1) then
c
c     get surface velocity from user supplied function in
c      subroutine surfv
c
      call surfv(vsurf,nx,ny)
      endif
c
c      insure that imposed velocity agrees with side b.c.
c
      if(lbd .eq. 0)then
      do  20 i=1,nxr+1
         vsurf(i,nyr+1,1)=vsurf(i,1,1)
         vsurf(i,nyr+1,2)=vsurf(i,1,2)
   20 continue
      elseif((lbd .eq. 1) .or. (lbd .eq. 2))then
        do  22 j=1,ny
         vsurf(1,j,1)=0.
         vsurf(nx,j,1)=0.
   22   continue
      endif
      if(mbd .eq. 0)then
      do  21 j=1,nyr+1
         vsurf(nxr+1,j,1)=vsurf(1,j,1)
         vsurf(nxr+1,j,2)=vsurf(1,j,2)
   21 continue
      elseif((mbd .eq. 1) .or. (mbd .eq. 2))then
        do  23 i=1,nx
         vsurf(i,1,2)=0.
         vsurf(i,ny,2)=0.
   23   continue
      endif
c
c     this call to conplt does not work because vsurf has
c     dimensions iqx,jqx, which is one smaller than
c     planes that are expected by conplt.
c cg   7  call conplt(4)
c
c    7 call velvec(ny,nx,vsurf,vsurf(1,1,2),2,9)
   7  continue
c
      if(isolve.gt.2) then
c
c     calculate fft of surface velocity and calculate  vp, vt
c
      do 8 j=1,ny
      do 8 i=1,nx
      fftvx(i,j)=vsurf(i,j,1)
   8  continue
      call ft2nrm(1,lpu,nxu,mpu,nyu,1,iqx,jqx,fftvx)
      do 9 j=1,ny
      do 9 i=1,nx
      fftvy(i,j)=vsurf(i,j,2)
   9  continue
      call ft2nrm(1,lpv,nxv,mpv,nyv,1,iqx,jqx,fftvy)
      do 11 j=1,nyr
      do 11 i=1,nxr
      vpb(i,j)=fli(i,j)*fftvx(i,j)+flj(i,j)*fftvy(i,j)
      vtb(i,j)=flj(i,j)*fftvx(i,j)-fli(i,j)*fftvy(i,j)
   11 continue
      endif
      if(isolve.gt.3) then
c
c      not set for variable mesh size
c
c      call velols(1)
      endif
      endif
      endif
      endif
c
c
      if(isolve.eq.3) then
c
c    solve 4 1st order ode's for primitive variables
c
c
c     fft of temperature
c
      if((icycle.eq.1).or. (restrt .ne. 0)) then
      ytmp(1)=0.
      ytmp(2)=0.
      ytmp(3)=0.
      ytmp(4)=0.

      do 271 k=1,nz
      do 271 j=1,ny
      do 271 i=1,nx
      vp(i,j,k)=0.
      v3(i,j,k)=0.
      taup(i,j,k)=0.
      tau3(i,j,k)=0.
      vtf(i,j,k)=0.
  271 taut(i,j,k)=0.
      endif
c
      if(initlt .eq. 16)then
         if((icycle.eq.1).or.(restrt.ne.0))then
            continue
         else
           call ttoft
         endif
      else
         call ttoft
      endif
c
c     fft of temperature
      call ft2nrm(1,lpft,nxft,mpft,nyft,nz,isx,jsx,ft)
cc
c     mean field variable viscosity
c
      if(ivistype .lt. 0)then
         call viscos(vis,vnu,ft)
      endif
c
c
c       change of variables (multiply by i = (-1)**.5)
        ijob = 1
        call chvar (ft,isx,nxr,lbd,jsx,nyr,mbd,nz,ijob)
c
c      call chvar(ft,isx,nxr,lbd,jsx,nyr,mbd,nz,1)
c
      numeq=0
      conv=1.e-10
c sunend
      itmax=60
c chem
      if(kchem .ne. 0)then
         m=nz+1
      else
         m=nz
      endif
c chem
      slowc=1.e6
      scalv(1)=1.*rat
      scalv(2)=1.*rat
      scalv(3)=1.*rat
      scalv(4)=1.*rat
      ne=4
      nyk=m
      nyj=ne
      nb=2
      nci=ne
      ncj=ne-nb+1
      nck=m+1
      nsi=ne
      nsj=ne+ne+1
      if(ibcb.eq.2) then
      indexv(1)=1
      indexv(2)=2
      indexv(3)=3
      indexv(4)=4
      else
      indexv(1)=3
      indexv(2)=2
      indexv(3)=1
      indexv(4)=4
      endif
      if(icycle .ne. 1)then
      scalv(1)=.01
      scalv(2)=.01
      scalv(3)=.01
      scalv(4)=.01
      do 245 ll=1,nz
      do 244 j=1,ny
      do 244 i=1,nx
      scalv(1)=max(abs(vp(i,j,ll)),scalv(1))
      scalv(2)=max(abs(v3(i,j,ll)),scalv(2))
      scalv(3)=max(abs(taup(i,j,ll)),scalv(3))
      scalv(4)=max(abs(tau3(i,j,ll)),scalv(4))
  244 continue
  245 continue
c
c
c      the function isamax does not work here
c
c cg      nxnynz=nx*ny*nz
c cg      imax=isamax(nxnynz,evp,1)
c cg      scalv(1)=abs(evp(imax))
c cg      imax=isamax(nxnynz,ev3,1)
c cg      scalv(2)=abs(ev3(imax))
c cg      imax=isamax(nxnynz,etaup,1)
c cg      scalv(3)=abs(etaup(imax))
c cg      imax=isamax(nxnynz,etau3,1)
c cg      scalv(4)=abs(etau3(imax))
c
      slowc=max(scalv(1),scalv(2),scalv(3),scalv(4))
      endif
      do 185 j=1,nyr
      do 180 i=1,nxr
      irtst=0
      do 183 ll=1,nz
      if((lbd .eq. 0) .and. (mbd .eq. 0))then
      rr(ll)=ft(i,j,ll)
      if(abs(rr(ll)) .gt. 1.e-8)irtst=1
      elseif((lbd .eq. 1) .and. (mbd .eq. 1))then
      rr(ll)=-ft(i,j,ll)
      if(abs(rr(ll)) .gt. 1.e-8)irtst=1
      else
c        error not set up for mixed b.c.
      endif
  183 continue
      l=fl(i,j)
      l2=l**2
      vps=0.
      if(ibct.eq.3) vps=vpb(i,j)
      if(((irtst .eq. 0) .and. (abs(vps) .lt. conv)) .or.
     1 ( l .eq. 0.0))then
      do 251 ll=1,nz
        vp(i,j,ll)=0.
        v3(i,j,ll)=0.
        taup(i,j,ll)=0.
        tau3(i,j,ll)=0.
  251 continue
      else
c
c     set initial guess to solution from last time step
c
      llm=0
      do 175 ll=1,m
      lm=ll+llm
      if(ll .eq. kchem)then
      y(1,ll)=ytmp(1)
      y(2,ll)=ytmp(2)
      y(3,ll)=ytmp(3)
      y(4,ll)=ytmp(4)
      llm=-1
      else
      y(1,ll)=vp(i,j,lm)
      y(2,ll)=v3(i,j,lm)
      y(3,ll)=taup(i,j,lm)
      y(4,ll)=tau3(i,j,lm)
      endif
  175 continue
c
      npt=4
      numeq=numeq+1
      call solvde(itmax,conv,slowc,scalv,indexv,ne,nb,m,y,nyj,nyk,
     . cc1,nci,ncj,nck,s,nsi,nsj,npt)
      llm=0
      do 177 ll=1,m
      lm=ll+llm
      if(ll .eq. kchem)then
      ytmp(1)=y(1,ll)
      ytmp(2)=y(2,ll)
      ytmp(3)=y(3,ll)
      ytmp(4)=y(4,ll)
      llm=-1
      else      
      vp(i,j,lm)=y(1,ll)
      v3(i,j,lm)=y(2,ll)
      taup(i,j,lm)=y(3,ll)
      tau3(i,j,lm)=y(4,ll)
      endif
  177 continue
      endif
  180 continue
  185 continue
c
c cg      write(6,187)numeq
c cg  187 format("solvde called  ",i8)
c
c     solve toroidal part on only first two iteration
c      and only when surface velocity is specified
c
      if((ibct .eq. 3) .and.
     1  ((icycle .lt. 3) .or. (restrt .ne. 0.0)))then
      cconv=conv
      iitmax=itmax
      sslowc=1.e6
      sscalv(1)=1.*rat
      sscalv(2)=1.*rat
      nn=nz
      nne=2
      nnb=1
      nnyk=nn
      nnyj=nne
      nnci=nne
      nncj=nne-nnb+1
      nnck=nn+1
      nnsi=nne
      nnsj=2*nne+1
      if (ibcb .eq. 2) then
         iindexv(1)=1
         iindexv(2)=2
      else
         iindexv(1)=2
         iindexv(2)=1
      endif
      if(icycle .ne. 1)then
      sscalv(1)=.01
      sscalv(2)=.01
      do 1301 ll=1,nz
      do 1301 j=1,nyr
      do 1301 i=1,nxr
      sscalv(1)=max(abs(vtf(i,j,ll)),sscalv(1))
      sscalv(2)=max(abs(taut(i,j,ll)),sscalv(2))
 1301 continue
c
c     isamax does not catch case when values are negative
c cg      imax=isamax(nxnynz,evtf,1)
c cg      sscalv(1)=evtf(imax)
c cg      imax=isamax(nxnynz,etaut,1)
c cg      sscalv(2)=etaut(imax)
c
      sslowc=max(sscalv(1),sscalv(2))
      endif
c
      do 1310 j=1,ny
      do 1309 i=1,nx
 
      l=fl(i,j)
      l2=l**2
      vts=0.
      if(ibct .eq. 3) vts=vtb(i,j)
      if((ibct .ne. 3) .or. (abs(vts) .lt. cconv) .or.
     1  (l .eq. 0.0))then
      do 1303 ll=1,nz
        vtf(i,j,ll)=0.
        taut(i,j,ll)=0.
 1303 continue
      else
c
c     set initial guess to solution from last time step
c
      do 1302 ll=1,nz
         yy1(1,ll)=vtf(i,j,ll)
 1302    yy1(2,ll)=taut(i,j,ll)
      npt=2
      call solvde(iitmax,cconv,sslowc,sscalv,iindexv,nne,nnb,
     1            nn,yy1,nnyj,nnyk,ccc1,nnci,nncj,nnck,ss,nnsi,nnsj,
     2            npt)
 
      do 1304 ll=1,nz
         vtf(i,j,ll)=yy1(1,ll)
 1304    taut(i,j,ll)=yy1(2,ll)
      endif
 
 1309 continue
 1310 continue
       endif
c
c    calculate integrated shear stress on plate due to
c    convection and scale velocity of surface plates.
c
      if((ibct .eq. 2) .and. (isurfv .lt. 0))then
         call inttauc
      endif
c
c
c     Change from poloidal and toroidal fields to
c     u and v and superimpose plate velocity when
c     plates are present. Also convert vertical w field.
c
        call pttouv(0,0)
c
        call ft2nrm (-1,lpu,nxu,mpu,nyu,nz,inx,jnx,u)
        call ft2nrm (-1,lpv,nxv,mpv,nyv,nz,inx,jnx,v)
        call ft2nrm (-1,lpw,nxw,mpw,nyw,nz,inx,jnx,w)
c
c    assign values to end points for periodic boundary
c
      call netflow(nx,ny,inx,jnx,u,v,vis,wk1d,netflo)
      call bc (u,v,w,inx,nxr,nx,lbd,jnx,nyr,j3,mbd,nz,1)
c
c
 
      endif
c
      return
      end
