c $Log:   /pvcs.config/mc3dvv/src/incheck.F_a  $
c
c   Rev 1.1   Fri Jul 30 15:23:42 1999   lowman
c  Increased dimensions on maximum size job warning
c
c   Rev 1.0   Mon Jul 14 14:21:28 1997   pvcs
c 
c *************************************************************
c *   INCHECK
c *************************************************************
      subroutine incheck(imx, jmx, kmx, nxyz, isx, jsx, ksx, nbdd,
     1  ijksx, iqx, jqx, kqx, ijkqx, inx, jnx, knx, mxmy, 
     2  ijknx, ijkmx,  ijksf, inxsf, jnxsf, knxsf, imxsf, jmxsf,
     3  kmxsf, npla, npssd, ncabe, nabe,icx,jcx,kcx,nspecies)
c***begin prologue incheck
c***date written   880101   (yymmdd)
c***revision date  930324   (yymmdd)
c***category no.  ????
c***keywords  
c             type=???? precision
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose Check for valid/compatible input values
c***description
c***references (none)
c***routines called  (none)
c***modifications (yymmdd) modification
c 930324 Add check for valid lbd and mbd
c 930709 Add output (208) for number of plates and array storage
c***end prologue  incheck
      use module_precision
      use module_gia3
      use module_a3
      use module_afftw
      use module_routput
      common/csym/ ifsym
c
c    check for valid input parameters
c
      if ((imx.lt.nx).or.(kmx.lt.nz)) then
        write (6,20)
        stop
      endif
c     in 2-D version ny=2 but arrays can have dimension 1 in the y direc
      if ((ny.ne.2).and.(jmx.lt.ny)) then
        write (6,20)
        stop
      endif
      if (isolve.eq.3) then
        if (lbd.ne.mbd) then
          write (6,30)
          stop
        endif
        if ((lbd.ne.0) .and. (lbd .ne. 1))then
          write (6,32)lbd
          stop
        endif
        if ((mbd.ne.0) .and. (mbd .ne. 1))then
          write (6,34)mbd
          stop
        endif
      endif
      if (isurfv.lt.0) then
        if (ibct.ne.2) then
          write (6,40)
          stop
        endif
        if (ivistype.lt.0) then
          write (6,50)
          stop
        endif
        if ((ibct.eq.3).and.(isolve.ne.3)) then
          write (6,60)
          stop
        endif
        if ((lbd.ne.0).or.(mbd.ne.0)) then
          write (6,65)isurfv,lbd,mbd
          stop
        endif
      endif
      if ((ibcb.ne.1).and.(ibcb.ne.2)) then
        write (6,70)ibcb
        stop
      endif
      if ((ibct.lt.1).or.(ibct.gt.3)) then
        write (6,80)ibct
        stop
      endif
      if ((ibct.eq.3).and.(isurfv.lt.0)) then                 !G.Ito 10/9/94
        write (6,90)
        stop
      endif

      if ((ibct.ne.3).and.(isurfv.gt.1)) then
          write (6,94)
      endif
      if ((ibct.eq.3).and.(isurfv.gt.1)) then
        if (iqx.ne.imx) then
          write (6,95)
          stop
        endif
        if (jqx.ne.jmx) then
          write (6,96)
          stop
        endif
c        if (kqx.ne.kmx) then
c          write (6,97)
c          stop
c        endif
      endif

      if (nx.lt.3) then
        write (6,100)
        stop
      endif
      if ((ny.eq.2).and.(yl.ne.1.)) then
        write (6,110)
        stop
      endif
      if ((ny.ne.2).and.(ny.lt.4)) then
        write (6,120)
        stop
      endif
      if (isolve.eq.3) then
        if (imx.ne.isx) then
          write (6,130)
        endif
        if (jmx.ne.jsx) then
          write (6,130)
        endif
        if (kmx.ne.ksx) then
          write (6,130)
        endif
      endif
      if (ivistype.ge.0) then           !G.Ito 7/95
        itvv=1
      elseif (itvv.eq.1) then
         print *, 'Variable viscosity itvv=1?'
         stop
      endif
      if ((ivistype.ne.0).and.(isolve.ne.3)) then
        write (6,140)
        stop
      endif
      if (dprnt.ge.0.) then
        write(6,*) 'PERROR(incheck): dprnt is obsolete'
        stop
      endif
      if (dplot.ge.0.) then
        write(6,*) 'PERROR(incheck): dplot is obsolete'
        stop
      endif
      if (dplt3.ge.0.) then
        write(6,*) 'PERROR(incheck): dplt3 is obsolete'
        stop
      endif
      if (icplan(1).ge.0.) then
        write(6,*) 'PERROR(incheck): icplan is obsolete'
        stop
      endif
      if (ncplan.ge.0.) then
        write(6,*) 'PERROR(incheck): ncplan is obsolete'
        stop
      endif
      if (idot3.ge.0.) then
        write(6,*) 'PERROR(incheck): idot3 is obsolete'
        stop
      endif
      if (ivelp3.ge.0.) then
        write(6,*) 'PERROR(incheck): ivelp3 is obsolete'
        stop
      endif
      if (ivelp.ge.0.) then
        write(6,*) 'PERROR(incheck): ivelp is obsolete'
        stop
      endif
      if (nxpcon(1).ge.0.or.nxpcon(2).ge.0) then
        write(6,*) 'PERROR(incheck): nxpcon is obsolete'
        stop
      endif

      do 10 ij=1,ncplan
      icp1=icplan(ij+ij-1)
      icp2=icplan(ij+ij)+1
      if ((ny.eq.2).and.(icp1.eq.2).and.(icp2.ne.1)) then
        icplan(ij+ij)=0
        write (6,170)
        write (6,180) icplan(ij+ij-1),icplan(ij+ij)
      endif
   10 continue
      if ((dtout.eq.0.).and.((idot3.eq.1).or.(ivelp3.eq.1))) then
        write (6,190)
        stop
      endif
      if((ifssd .eq. 1) .and. (isurfv .ge. 0))then
         write (6,200)
c        stop
      endif
      if((ifssd .eq. 1) .and. (npssd .ne. 1))then
         write (6,208)ifssd,npssd,nplate,npla
         write (6,210)
         stop
      endif
      if((npssd .lt. 2*nplate) .and. (ifssd .ne. 1))then
         write (6,208)ifssd,npssd,nplate,npla
         write (6,220)
         stop
      endif
      if((nx .gt. 4097).or.(ny .gt. 4097))then
         write (6,230)
         stop
      endif
c     if((ivistype .eq. -2) .and. (nabe .ne. 1))then         !G.Ito 5/95
c        write (6,340)                                       !only on itvv=1
c        stop
c     endif
      if((netflo .ne. 0) .and. (lbd .ne. 0))then
         write (6,350)lbd, mbd, netflo
         stop
      endif
      if((ibct .eq. 2) .and. (isurfv .lt. 0)) then
        if (ny-1 .eq. 1) then
          if (nplai .lt. nplate) then
            write (6,360)nplate
            stop
          elseif (nplai .gt. nplate) then
            write (6,361)nplate
          endif
        elseif (ny-1 .ge. 3) then
          if (nplai .lt. (2*nplate)) then
            write (6,362)2*nplate
            stop
          elseif (nplai .gt. (2*nplate)) then
            write (6,363)2*nplate
          endif
        endif
      endif

      if((ifsym.ne.0).and.(ny.ne.1))then
        write(6,*) 'ifsym =',ifsym,'ny=',ny
        write(6,*) 'ifsym option not supported in 3D'
        write(6,*) 'ifsym option only works for ny=1'
        stop
      endif

c
c    calculate apx size of arrays in common blocks
c     na1 = 3*inx*jnx*knx
c     nac1 = 2*icx*jcx*kcx*nspecies
c     na2 = 3*inx*jnx*knx
c     na3 = 23+4*514+100
c     na4 = 300
c     na6 = iqx*jqx*npla+iqx*jqx
c     na7 = iqx*jqx*2
c     na9 = kmx
c     na11 = 3*inx*jnx+inx+jnx
c     na13 = 2*iqx*jqx
c     na14 = 2*iqx*jqx
c     na20 = 3*isx*jsx*ksx
c     na22 = 6*isx*jsx*ksx
c     na23 = 2*iqx*jqx*npla
c     na25 = 6*iqx*jqx*kqx*npssd
c     na26 = 4*kmx*npssd
c     na30 = npla*npla+3*npla
c     na77 = 3*inx*jnx*knx*3
c      nfftw = 7*257
c     nfftw = 2*(numfftmax2+16)+10*(numfftmax+15)
c     nfftcoef = isx*jsx*ksx
c     nviscom = 2*ksx
c     ntemp4 = isx*ksx
c     nspwork = inx*jnx*knx
c     ndfluxd = 4*inx*jnx*knx
c     ndabe = 4*kmx*ncabe*nabe+4*kmx+4*kmx*nabe
c     ntotal=na1+nac1+na2+na3+na4+na6+na7+na9+na11+na13+na14+na20+na23+
c    1       na25+na26+na30+na77+nfftw+nfftcoef+nviscom+ntemp4+
c    2       nspwork+ndfluxd+ndabe
c     nspbyte=ntotal*8/1000000
c     ndpbyte=ntotal*16/1000000
      
c     write(6,239)
c     write(6,240)na1
c     write(6,241)nac1
c     write(6,242)na2
c     write(6,244)na3
c     write(6,246)na4
c     write(6,248)na6
c     write(6,250)na7
c     write(6,252)na9
c     write(6,254)na11
c     write(6,256)na13
c     write(6,258)na14
c     write(6,260)na20
c     write(6,262)na22
c     write(6,264)na23
c     write(6,266)na25
c     write(6,268)na26
c     write(6,270)na26
c     write(6,272)na30
c     write(6,274)na77
c     write(6,276)nfftw
c     write(6,278)nfftcoef
c     write(6,280)ntemp4
c     write(6,282)nspwork
c     write(6,284)ndfluxd
c     write(6,286)ndabe
c     write(6,287)
c     write(6,288)ntotal
c     write(6,290)nspbyte
c     write(6,292)ndpbyte
c     
  239 format(" Apx. number of words in common and dimension ",/)
  240 format("na1      = ",i12)
  241 format("nac1     = ",i12)
  242 format("na2      = ",i12)
  244 format("na3      = ",i12)
  246 format("na4      = ",i12)
  248 format("na6      = ",i12)
  250 format("na7      = ",i12)
  252 format("na9      = ",i12)
  254 format("na11     = ",i12)
  256 format("na13     = ",i12)
  258 format("na14     = ",i12)
  260 format("na20     = ",i12)
  262 format("na22     = ",i12)
  264 format("na23     = ",i12)
  266 format("na25     = ",i12)
  268 format("na26     = ",i12)
  270 format("na26     = ",i12)
  272 format("na30     = ",i12)
  274 format("na77     = ",i12)
  276 format("nfftw    = ",i12)
  278 format("nfftcoef = ",i12)
  280 format("ntemp4   = ",i12)
  282 format("nspwork  = ",i12)
  284 format("ndfluxd  = ",i12)
  286 format("ndabe    = ",i12)
  287 format("---------------------------------")
  288 format("ntotal   = ",i12," Apx. Total Words of Memory Program ")
  290 format("nspbyte  = ",i12," Mb if single precision ")
  292 format("ndpbyte  = ",i12," Mb if double precision ")
      
      return
c
   20 format ("input error *****:dimension of problem is larger",/,"than
     1 dimension of arrays set in parameter statement")
   30 format ("input error ******: lbd .ne. mbd")
   32 format ("input error ******: lbd can only be 0 or 1  lbd =",i5)
   34 format ("input error ******: mbd can only be 0 or 1  mbd =",i5)
   40 format ("input error ******: ibct must .eq. 2 when isurfv     .lt.
     1 0",/,"for flow driven plates")
   50 format ("input error ******: ivistype .lt. 0 & isurfv         .lt.
     1 0;",/,"mean field viscosity does not work with plates")
   60 format ("input error ******: flow driven plates              only
     1works when isolve=3")
   65 format ("input error ******: isurfv=",i5," lbd=",i5," mbd=",i5,/,
     1 "Flow driven plates only work with periodic boundary conditions")
   70 format ("input error ******: invalid value for ibcb=",i5)
   80 format ("input error ******: invalid value for ibct=",i5)
   90 format ("input error ******: invalid value for isurfv           w/
     1 imposed surface velocity")
   94 format ("input warning ***: isurfv.gt.1, ibct.ne.3")
   95 format ("input error ***: check param iqx.ne.imx, imposed surfv")
   96 format ("input error ***: check param jqx.ne.jmx, imposed surfv")
   97 format ("input error ***: check param kqx.ne.kmx, imposed surfv")
  100 format ("input error ******: nx must be .ge. 3")
  110 format ("input error ******: yl must be 1 for 2-D runs",/,"if this
     1 is a 2-d restart set ny=2",/,"or let program get ny from tape1. N
     2ote in init during",/,"startup ny has 1 added to it.")
  120 format ("input error ******: ny must be .ge. 3 or =1")
  130 format ("input warning ******: check  param")
  140 format ("input error ******: variable viscosity only works
     1  w/ primitive variables")
  150 format ("input error ******: dprnt is obsolete")
  160 format ("input error ******: output to TAPE9 will be at every    c
     1ylcle. This will cause excessive output.")
  170 format ("input error ******:This is a 2D run and output",/,"is spe
     1cified for a Y plane other than 0. 2D runs should",/,"have variabl
     2e icplan=2,0 for x-z slice of data.")
  180 format (/,'**********************************',/,'ICPLAN has been
     1reset to ',2i8,/,'******************')
  190 format ("input error ******: output to TAPE11 will be at every   c
     1ycle. This will cause excessive output.")
  200 format ("input error ******: solid state disk is called without
     1dynamic plates. isurfv >= 0")
  208 format ("ifssd =",i5," npssd= ",i5," nplate=",i5," npla=",i5)
  210 format ("input error ******: npssd .ne. 1 and ssd is called")
  220 format ("input error ******: npla in parameter is .lt. 2*nplate
     1 and ssd is not called.")
  230 format ("input error ******: max. dim is 4096 in horizontal 
     1 direction. The parameter statements in afftw.h and calnus.F
     2 must be reset for higher resolution jobs. Limits on the size of  
     3 vsij, xpos and ypos also exist.")
  340 format ("input error ******: ivistype .eq. -2 and nabe .ne. 1",/,
     2   "incompatible dimensions for variable viscosity calculation")
  350 format ("input error ******: netflow .ne. 0 and not periodic",/,
     2   "side boundary conditions. Set lbd=mbd=0 or netflow=0",/,3i15)
  360 format ("input error ******: nplai .lt. nplate ",/, 
     2   "Set nplai=",i10)
  361 format ("input warning ******: nplai .gt. nplate ",/,
     2   "To conserve memory, restart with nplai=",i10)
  362 format ("input error ******: nplai .lt. 2*nplate ",/,
     2   "Set nplai=",i10)
  363 format ("input warning ******: nplai .gt. 2*nplate ",/,
     2   "To conserve memory, restart with nplai=",i10) 
      end
