c $Log:   /pvcs.config/mc3dvv/src/init.F_a  $
c
c   Rev 1.6   Fri Jul 30 11:47:26 1999   lowman
c
c   Rev 1.5   Tue Feb 09 14:57:22 1999   lowman
c
c   Rev 1.4   Tue Oct 06 16:41:38 1998   lowman
cAdd lines to make sure temperatures stay in the range 0 to 1 after
cT-field perturbations are added
c
c   Rev 1.3   Fri Sep 26 08:33:54 1997   hall
cNo change.
c
c   Rev 1.2   Tue Jul 22 18:39:04 1997   hall
cNo change.
c
c   Rev 1.1   Tue Jul 22 18:15:38 1997   hall
cChanged the z-index on the incorporation of a perturbation so as not to include the top boundary (k=1,nz1-1), violating the BCs.
cApparently GI and PvK were running w/a bad top boundary, though as long as the perturbation amplitude was small, it should not be a big deal.
c
c   Rev 1.0   Mon Jul 14 14:21:30 1997   pvcs
c 
c *************************************************************
c *   INIT
c *
c *   Version 49
c *
c *   Initializes MC3D. Completely rewritten in August 1995.
c *
c *   Eliminated most options for INITLT
c *   Eliminated restart possibilities
c *
c *************************************************************
      subroutine init
c***begin prologue  init
c***date written   890101   (yymmdd)
c***revision date  930802   (yymmdd)
c***category no.  ????
c***keywords
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose Initialize startup parameters
c***description
c***references (none)
c***routines called  funcper, output, tbase, tempflip, xyzijk
c***modifications (yymmdd) modification
c***modifications (930802) cwg Add user defined function call
c                 for case initlt = 15
c***end prologue  init
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
c      common /xxxxx/ restrt
c      common /xxxxxx/ initlt
c      common /xxxxxxx/ istart
      use module_ftcoef
      use module_spwork
      use module_intfac
      use module_viscom
      use module_alam
      use module_ac1
      use module_fnames
      use module_timeint
      use module_petracer
      character dtitle*72
      common /start1/ restrt, initlt, istart
      common /a4/ vsij(700)
c      equivalence (ixa2,nx), (xa2,xl)
      dimension ixa2(1), xa2(1)
      dimension xmm(4)

#ifdef MPI
      include 'mpif.h'
#endif

      common /cviscos/ vis1, vis2, vis3, vis4, vis5,
     1     kdepth1, kdepth2, kdepth3, kdepth4, kdepth5
      namelist /setup2/ nzold,nxold,nyold

#ifdef MPI
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif

      if (time .lt. 0.0) then
        time=0.0
      endif
 
      dz=1./float(nz)
      dx=xl/float(nx)
      dy=yl/float(ny)
      nx=nx+1
      ny=ny+1
      nz=nz+1
      if (itimechoice.eq.0) then
        nx1=nx+1
        ny1=ny+1
        nz1=nz+1
      else
        nx1 = nx
        ny1 = ny
        nz1 = nz
      endif

c     **** j1-j4 are used to avoid using a 2 cell wide grid on 2D runs
      if (ny.eq.2) then
        j1=1
        j2=1
        j3=1
        j4=1
      else
        j1=1
        j2=2
        j3=ny
        j4=ny1
      endif

c     *** Find coordinates
      if (itimechoice.eq.0) then
        z(1)=0.
        do k=2,nz
           z(k)=z(k-1)+dz
        enddo
        avz(1)  = zero
        avx(1)  = zero
        avy(j1) = zero
        avz(2)  = half*dz
        avy(j2) = half*dy
        avx(2)  = half*dx
        do k=3,nz
          avz(k)=avz(k-1)+dz
        enddo
        avz(nz1)=avz(nz)+half*dz
        do i=3,nx
           avx(i)=avx(i-1)+dx
        enddo
        avx(nx1)=avx(nx)+half*dx
        if(ny .gt. 2)then
        do j=j2+1,j3
           avy(j)=avy(j-1)+dy
        enddo
        endif
        avy(j4)=avy(j3)+half*dy
        if (ny.eq.2) then
          do j=1,j4
            avy(j)=zero
          enddo
        endif

        do k=1,nz1
          do j=1,j4
             do i=1,nx1
                dtensr(i,j,k)=zero
             enddo
          enddo
        enddo

      else

c       *** itimeint = 1, -1
c       *** Initialize Z (used to be used in Nu calculation)
        z(1)=zero
        do k=2,nz
           z(k)=z(k-1)+dz
        enddo

c       *** Initialize coordinates in AVX,AVY,AVZ
        avz(1)= (1-norder/2)*dz
        avx(1)= -norder/2*dx
        avy(1)= -norder/2*dy
        do k=2,nz1+norder-2
           avz(k)=avz(k-1)+dz
        enddo
        do i=2,nx1+norder
           avx(i)=avx(i-1)+dx
        enddo
        do j=2,ny1+norder
           avy(j)=avy(j-1)+dy
        enddo

c       *** Correct Y for the 2-D situation
        if (ny.eq.2) then
           do j=1,ny1+norder
              avy(j)=zero
           enddo
        endif
      endif

      do k=1,nz
        do j=1,j3
          do i=1,nx
             u(i,j,k)=zero
             v(i,j,k)=zero
             w(i,j,k)=zero
          enddo
        enddo
      enddo
      do k=1,ksl
        do j=1,jsl
          do i=1,isl
             xlam1(i,j,k)=zero
             xlam2(i,j,k)=zero
             xlam3(i,j,k)=zero
             xlam4(i,j,k)=zero
          enddo
        enddo
      enddo

      na1l=2*ijknx
      na2l=23+4*258+100
      na3l=6*ijksx
      na4l=48+100
      ptime3=time
      prnt=time
      pltime=time

      if (itimechoice.eq.1.or.itimechoice.eq.-1) then
c        ** Take into account the offset that the real
c        ** virtual points incur. The output file is
c        ** supposed to contain the temperature in the
c        ** physical nodal points only.
         ioff = norder/2
         joff = norder/2
         if (ny.lt.3) joff=0
         koff = norder/2-1
         if (myid .eq. 0) 
     &        write(6,'(''INIT: ioff: '',3i3)') ioff,joff,koff
      else
         ioff = 0
         joff = 0
         koff = 0
      endif

c *************************************************************
c *   Initialize temperature field
c *
c *   Options:  
c *      initlt=1   Define temperature by function: 
c *                     t(i,j,k) = FUNCINIT(x,y,z)
c *                 Default is a conductive temperature profile,
c *                 but at link time FUNCINIT may be replaced by
c *                 a user provided function.
c *      initlt=2   Obtain temperature from nodal point values
c *                 stored on file TSTARTNAME (see INPUTS.F).
c *                 The file should be an unformatted file, containing
c *                 NX,NY,NZ in the first record, and the nodal point
c *                 values in the second record.
c *
c *   A perturbation may be added to the temperature field by providing
c *   a function FUNCPER. FUNCPER is called only if AMP != 0.
c *   Default is an harmonic perturbation with amplitude AMP and 
c *   wavelength ALFX and ALFY (see INPUTS.F).
c *************************************************************

      if (initlt.eq.1) then
         do k=koff+1,koff+nz1
            zinit = avz(k)
            do j=joff+1,joff+j4
               yinit = avy(j)
               do i=ioff+1,ioff+nx1
                  xinit = avx(i)
                  t(i,j,k) = funcinit(xinit,yinit,zinit)
               enddo
            enddo
         enddo
 
      endif

c     *** INITLT==2: Read initial condition from file
      if (initlt.eq.2) then
         dummycall=funcinit(zero,zero,zero) 
         open(unit=7,file=tstartname,form='unformatted')
         rewind(7)
         read(7) nxinit,nyinit,nzinit
         if (nyinit.eq.1) then
            j4old = 1
         else
            j4old = ny1
         endif

         if (myid .eq. 0) write(6,*) 'nxinit: ',nxinit,nyinit,nzinit
         if (nyinit.eq.1) then
            if (nxinit.ne.nx1.or.nzinit.ne.nz1) then
              write(6,*) 'PERROR(init): nxinit != nx1 or nzinit != nz1'   
              write(6,*) '  nxinit = ',nxinit,' nx1 = ',nx1
              write(6,*) '  nzinit = ',nzinit,' nz1 = ',nz1
              stop
            endif
         else if (nxinit.ne.nx1.or.nyinit.ne.ny1.or.nzinit.ne.nz1) then 
            write(6,*) 'PERROR(init): nxinit != nx1 or nyinit != ny1'
            write(6,*) '              or nzinit != nz1'
            write(6,*) '  nxinit = ',nxinit,' nx1 = ',nx1
            write(6,*) '  nyinit = ',nyinit,' ny1 = ',ny1
            write(6,*) '  nzinit = ',nzinit,' nz1 = ',nz1
            stop
         endif
         if (myid .eq. 0) 
     &      write(6,'(''INIT: dimensions: '',3i5)') nx1,j4old,nz1

         if(j4.ne.nyinit.and.nyinit.eq.1)then
         read(7) (((t(i+ioff,1+joff,k+koff),i=1,nx1),j=1,j4old),k=1,nz1)
         do k=1,nz1
          do j=2,ny1
           do i=1,nx1
            t(i,j,k)=t(i,1,k)
            if(t(i,j,k).lt.zero) t(i,j,k) =zero
           enddo
          enddo
         enddo
         else
         read(7) (((t(i+ioff,j+joff,k+koff),i=1,nx1),j=1,j4old),k=1,nz1)
         endif

c        if (itimechoice.eq.1) then
c          do k=1,ktx
c             write(6,'(20i5,:)') (nint(100*t(i,1,k)),i=1,itx)
c          enddo
c        endif
      endif


c     *** Add perturbation if necessary
       icount=0
      if (amp.ne.0) then
         do k=koff+2,koff+(nz1-1)
            zinit = avz(k)
            do j=joff+1,joff+j4
               yinit = avy(j)
               do i=ioff+1,ioff+nx1
                  xinit = avx(i)
                   icount=icount+1
                  t(i,j,k) = t(i,j,k) + funcper(xinit,yinit,zinit)
                  if(t(i,j,k).lt.zero) t(i,j,k) =zero
               enddo
            enddo
         enddo

      endif

c *************************************************************
      if (itimechoice.eq.0) then
c        *** Check boundary conditions
         if (ibot .lt. 0) call tbase(0,t,inx,jnx,knx)
         if (itop .lt. 0) call tbase(1,t,inx,jnx,knx)
 
         if (lbd.eq.1) then
            do 120 k=1,nz1
              do 120 j=j2,j3
                 t(1,j,k)=t(2,j,k)
  120       t(nx1,j,k)=t(nx,j,k)
         else
           do 130 k=1,nz1
              do 130 j=j2,j3
                 t(1,j,k)=t(nx,j,k)
  130      t(nx1,j,k)=t(2,j,k)
         endif
         if (mbd.eq.1) then
           do 140 k=1,nz1
              do 140 i=1,nx1
                t(i,1,k)=t(i,j2,k)
  140           t(i,j4,k)=t(i,j3,k)
         else
           do 150 k=1,nz1
              do 150 i=1,nx1
                 t(i,1,k)=t(i,j3,k)
                 t(i,j4,k)=t(i,j2,k)
  150      continue   
         endif

c        *** Initialize coefficients for heatflo/ctensr
         xmm(1)=2./3.
         xmm(2)=4./9.
         xmm(3)=1.
         xmm(4)=half
         dz=1./float(nz-1)
         dxdyc(1) = dy*dz/64.
         dxdyc(2) = dx*dz/64.
         dxdyc(3) = dx*dy/64.
         do 200 i = 2,nz
            d3(i,3) = dz
            do 200 j=1,4
               ytb(i,j,1) = 1.+xmm(j)
               ybb(i,j,1) = 1.+xmm(j)
               ytb(i,j,2) = 1.+xmm(j)
  200          ybb(i,j,2) = 1.+xmm(j)
         do 210 j=1,4
            ytb(nz,j,1) = xmm(j)+half*float(j/4)
            ytb(nz,j,2) = xmm(j)+half*float(j/4)
            ybb(2,j,1)  = xmm(j)+half*float(j/4)
  210       ybb(2,j,2)  = xmm(j)+half*float(j/4)
         d3(1,3)  = half*dz
         d3(nz,3) = half*dz
    
         do 220 i=2,ny
            d3(i,2)=dy
            do 220 j=1,4
               xlb(i,j,1) = 1.+xmm(j)
               xrb(i,j,1) = 1.+xmm(j)
               ytb(i,j,3) = 1.+xmm(j)
  220          ybb(i,j,3) = 1.+xmm(j)
         do 230 j=1,4
            xlb(2,j,1)  = xmm(j) + half*float(j/4)
            xrb(ny,j,1) = xmm(j) + half*float(j/4)
            ytb(ny,j,3) = xmm(j) + half*float(j/4)
  230       ybb(2,j,3)  = xmm(j) + half*float(j/4)

         if (mbd.ne.0) then
            d3(1,2)=half*dy
            d3(ny,2)=half*dy
         else
            d3(1,2)=dy
         endif
 
         do 240 i=2,nx
            d3(i,1)=dx
            do 240 j=1,4
               xlb(i,j,2) = 1.+xmm(j)
               xrb(i,j,2) = 1.+xmm(j)
               xlb(i,j,3) = 1.+xmm(j)
  240          xrb(i,j,3) = 1.+xmm(j)
         do 250 j=1,4
            xlb(nx,j,2) = xmm(j)+half*float(j/4)
            xrb(2,j,2)  = xmm(j)+half*float(j/4)
            xlb(2,j,3)  = xmm(j)+half*float(j/4)
  250       xrb(nx,j,3) = xmm(j)+half*float(j/4)

         if (lbd.ne.0) then
            d3(1,1)=half*dx
            d3(nx,1)=half*dx
         else
            d3(1,1)=dx
         endif
      endif

      if (itracoption.eq.1) then
         call inittrac
      endif
 
      return
      end
