c $Log:   /pvcs.config/mc3dvv/src/initflow.F_a  $
c
c   Rev 1.1   Fri Jul 30 15:44:34 1999   lowman
c  Added to argument list in call to viscos
c
c   Rev 1.0   Mon Jul 14 14:21:30 1997   pvcs
c 
c ************************************************************* 
c *   INITFLOW
c * 
c * 
c *   initialize wave numbers, viscosity coef. etc. for
c *   sub flow and plflow
c *************************************************************
      subroutine initflow
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_afftw
      use module_a11
      use module_spwork
      use module_a12
      use module_viscom
 

      itst=0
      jcycle=icycle
      twopi=2.*pimach(dumm)
      pi=pimach(dumm)

      if (ivistype.ge.0) then
c        *** obtain coefficients for depth dependent viscosity
c        *** This is only for position dependent viscosity.
c        *** For temperature dependent viscosity VISCOS is called every
c        *** time step.
         call viscos(vis,vnu,ft)
      endif
 
c     *** Initialize wave numbers 
      do i = 1,inx
         wni(i) = zero
      enddo
      do j = 1,jnx
         wnj(j) = zero
      enddo
 
c *************************************************************
c *   First for boundary conditions in X-direction
c *************************************************************
      if (lbd.eq.0) then
c        ***  for periodic side boundary conditions
c        ***  x direction
         lpu =   1
         lpv =   1
         lpw =   1
         lpt13 = 1
         lpt23 = 1
         lpt33 = 1
         lpft =  1
         nxu =   nx-1
         nxv =   nx-1
         nxw =   nx-1
         nxt13 = nx-1
         nxt23 = nx-1
         nxt33 = nx-1
         nxft =  nx-1
         nxr =   nx-1
         call rffti (nxr,wx)
c        *** calculate wave number to index relation for rfft*
         wni(1)=0.
c        ** wni(nxr)=(2.*float(nxr))
c        ** wni(nxr)=float(nxr)
         wni(nxr)=((2.*float(nxr))/xl)*
     v        sin(float(nxr)*pi/(2.*float(nxr)))
         do i=3,nxr,2
            wni(i-1)=((2.*float(nxr))/xl)*
     v               sin(float(i-1)*pi/(2.*float(nxr)))
            wni(i)=wni(i-1)
         enddo

      else if (lbd.eq.1) then
c        *** for reflecting (free slip) side boundary conditions
c        *** x direction
         xxl=pi/xl
         ddx=dx/2.
         do i=1,nx
            wni(i)=sin(xxl*float(i-1)*ddx)/ddx
         enddo
         lpu=2
         lpv=4
         lpw=4
         lpt13=2
         lpt23=4
         lpt33=4
         lpft=4
         nxu=nx-2
         nxv=nx
         nxw=nx
         nxt13=nx-2
         nxt23=nx
         nxt33=nx
         nxft=nx
         nxr=nx
         call costi (nx,wxc)
         call sinti (nx-2,wxs)
  
      else if (lbd.eq.2) then
c        *** for no slip side boundary conditions
c        *** x direction

         xxl=pi/xl
         do i=1,nx
            wni(i)=sin(xxl*float(i-1)*dx)/dx
         enddo
         lpu=2
         lpv=2
         lpw=2
         lpt13=4
         lpt23=4
         lpt33=4
         lpft=2
         nxu=nx-2
         nxv=nx-2
         nxw=nx-2
         nxt13=nx
         nxt23=nx
         nxt33=nx
         nxft=nx-2
         nxr=nx
c  ?
         call costi (nx,wxc)
         call sinti (nx-2,wxs)
      endif
 
c *************************************************************
c *   Now for boundary conditions in Y-direction
c *************************************************************
 
      if (mbd.eq.0) then
c        *** for periodic side boundary conditions
c        *** y direction
         mpu   = 1
         mpv   = 1
         mpw   = 1
         mpt13 = 1
         mpt23 = 1
         mpt33 = 1
         mpft  = 1
         nyu   = ny-1
         nyv   = ny-1
         nyw   = ny-1
         nyt13 = ny-1
         nyt23 = ny-1
         nyt33 = ny-1
         nyft  = ny-1
         nyr   = ny-1
         call rffti (nyr,wy)
  
c        ***  calculate wave number to index relation for rfft*
 
         wnj(1)=0.
         if (ny.ne.2) then
c           *** wnj(nyr)=(2.*float(nyr))
            wnj(nyr)=(2.*float(nyr)/yl)*
     v              sin(float(nyr)*pi/(2.*float(nyr)))
            do j=3,nyr,2
               wnj(j-1)=(2.*float(nyr)/yl)*
     v             sin(float(j-1)*pi/(2.*float(nyr)))
               wnj(j)=wnj(j-1)
            enddo
         endif
         if (nyr.eq.1) wnj(1)=0.
 
      else if (mbd.eq.1) then
c        *** for reflecting (free slip) side boundary conditions
c        *** y direction
         yyl=pi/yl
         ddy=dy/2.
         do j=1,j3
            wnj(j)=sin(yyl*float(j-1)*ddy)/ddy
         enddo
         mpu=4
         mpv=2
         mpw=4
         mpt13=4
         mpt23=2
         mpt33=4
         mpft=4
         nyu=j3
         nyv=ny-2
         nyw=j3
         nyt13=j3
         nyt23=ny-2
         nyt33=j3
         nyft=j3
         nyr=j3
         call costi (ny,wyc)
         call sinti (ny-2,wys)
 
c        *** two dimensional case
         if ((ny.eq.2).and.(jnx.gt.1)) wnj(2)=0.
 
 
      elseif (mbd.eq.2) then
c        *** for no slip side boundary
c        *** y direction

         yyl=pi/yl
         do j=j1,j3
            wnj(j)=sin(yyl*float(j-1)*dy)/dy
         enddo
         mpu=2
         mpv=2
         mpw=2
         mpt13=4
         mpt23=4
         mpt33=4
         mpft=2
         nyu=ny-2
         nyv=ny-2
         nyw=ny-2
         nyt13=ny
         nyt23=ny
         nyt33=ny
         nyft=ny-2
  
c  ?
         nyr=ny
 
         call costi (ny,wyc)
         call sinti (ny-2,wys)

      endif

c     *** Normalize wavenumbers
      do j=1,j3
         do i=1,nx
            fl(i,j)=sqrt(wni(i)**2+wnj(j)**2)
            if (fl(i,j).ne.0.0) then
              fli(i,j)=wni(i)/fl(i,j)
              flj(i,j)=wnj(j)/fl(i,j)
            else
              fli(i,j)=0.
              flj(i,j)=0.
            endif
        enddo
      enddo

      return
      end
