c $Log:   /pvcs.config/mc3dvv/src/mig_mach.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:44 1997   pvcs
c 
c ************************************************************
c *   MIG_MACH
c *
c *   9508: Do not support machine dependent routines.
c *         Replace system random number generator by
c *         one from Numerical Recipes (in the works)
c *         forget about the remaining CPU time, and
c *         use sys/time.h to figure out the cpu time.
c *
c *      ijob  i  Choice parameter:
c *               1   Return elapsed CPU-time
c *               2   Return remaining CPU-time (set to 1e37)
c *               3   Return machine precision (2=single, 1=double precision)
c *                   This version always returns 1. For using MC3D
c *                   on the Cray you may want to change this
c *
c * mach_type  i  Dummy character variable              
c *    rargin  i  Dummy real input array. 
c *   rargout  o  Real array specifying output
c *   iargin   i  Dummy integer input array
c *  iargout   o  Integer output array
c ************************************************************
      subroutine mig_mach(ijob,mach_type,rargin,rargout,iargin,iargout) 
      use module_precision
      dimension rargin(10), rargout(10), iarray(3)
      dimension iargin(10), iargout(10)
      real rnd

      real seconds

      if (ijob.lt.1.or.ijob.gt.3) then
        write(6,*) 'PERROR(mc3d: mig_mach): '
        write(6,*) '       unknown option ijob = ',ijob
        stop
      endif

      if (ijob.eq.1) then
c         call second(seconds)
         rargout(1) = seconds
      else if (ijob .eq. 2) then
         rargout(1) = 99.e37
      else if (ijob .eq. 3) then
         iargout(1) = 1
      endif

      return
      end 
