      subroutine mpiblock(nx,ny,nprocs,myid,
     &                   ixstart,ixstop,iystart,iystop)
c
c   Subroutine determines the indicies for the spectral 
c   loops (and arrays) given nx, ny, and nprocs
c
c   Written and tested by S.D.K. 3/30/99
c   Fixed an Error in 3D problems with  >4 processors S.D.K. 11/12/99
c
      if ((nprocs .lt. 4).or.(ny .eq. 1)) then
        nprocy=1
        nprocx=nprocs
c
c If there are four or more processors, divide both i and j
c
      elseif ((nprocs.ge.4).and.(mod(nprocs,4) .eq. 0)) then
c       write(iout,*) "in else if 1"

c
c An even number of processors, so divide the mesh evenly
c
          nprocx = 4
          nprocy = nprocs/4
      elseif (mod(nprocs,3) .eq. 0) then
c       write(iout,*) "in else if 2"
c
c An odd number of processors, and divisible by three divide the mesh evenly
c
          nprocx = 3
          nprocy = nprocs/3
      elseif (mod(nprocs,2) .eq. 0) then
c       write(iout,*) "in else if 3"
c
c An even number of processors, so divide the mesh evenly
c
          nprocx = nprocs/2
          nprocy = 2
      else
c
c An odd number of processors, we can't split 
c
          nprocx = nprocs
          nprocy = 1
      end if
c
      myidx = int(myid/nprocy)
      myidy = mod(myid,nprocy)
c     write(iout,*) "myidx = ", myidx, "myidy = ", myidy
c     write(iout,*) "nprocx = ", nprocx, "mprocy = ", nprocy
      ixstart =  myidx*nx/nprocx+1
      ixstop  =  (myidx+1)*nx/nprocx
      iystart =  myidy*ny/nprocy+1
      iystop  =  (myidy+1)*ny/nprocy
      if (iystop .gt. ny) iystop = ny
c     write(iout,*) nprocs, myid, ixstart,ixstop,iystart,iystop
c
      return
      end
