      subroutine mpiprint(iswitch,nx,ny,nz,ublock,ii,jj,kk)
c
c  iswitch = 1:
c    print data which is stored in x,y blocks in array ublock from 
c    Solvlu parallelism to a z-oriented (plane layers) storage
c    so that the ffts and the energy equation and be distributed in
c    the vertical direction.
c    NB: Unused and untested!  Probably does not work.
c
c  iswitch = -1:
c    Move data which is stored in z-oriented (plane layers) storage
c    in array ublock to x,y blocks needed for Solvlu parallelism.
c
c  This elliminates the need for global communication
c
c  Written S.D.K 3/31/99
c
      use module_precision
      use module_mpibuf
#ifdef MPI
      include 'mpif.h'
      integer stat(MPI_STATUS_SIZE)
#endif
c
c
c for now, the buffer size is set here, once this is debugged,
c the buffers should be allocated at run time
c
      dimension ublock(ii,jj,*) 
      real*4 endtime, tarray(2)

#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
      if (numprocs .eq. 1) return
c      btime = etime(tarray)
      izero = 0
c
c either transform from block to layers or layers to blocks
c
      if (iswitch .eq. 1) then
c
c find the maximum buffer length needed for all messages
c this is now done in allocmem
c 
c move array elements from block pattern to row pattern
c each processors has to send a chunk of its block of data to
c each other processor
c
c NB: MPI starts numbering processors with 0 
c           
        if (myid .ne. 0) then
c
c calculate the x,y values that are on this processor
c
          call mpiblock(nx,ny,numprocs,myid,
     &               ixstart,ixstop,iystart,iystop)
          izstart = 1
          izstop  = nz
c
c pack send buffer with the data to be sent to processor isend
c
          do 190 i=ixstart,ixstop
          do 190 j=iystart,iystop
            index = 0
            do 180 k=izstart,izstop
              knz = izstop-izstart+1
              kny = iystop-iystart+1
              index = index + 1
              sbuff(index+knz*((j-iystart)+kny*(i-ixstart)))
     &                     =ublock(i,j,k)
 180        continue
 190      continue
          isize = nz+knz*(ny + ny*(nx))
          call MPI_SEND(sbuff,isize,MPI_DOUBLE_PRECISION,
     &                  izero,isize,MPI_COMM_WORLD,ierr)
        else
c
c I'm processor zero, c prepare to receive messages from other 
c  processors in receive buffer
c
          do 1000 irec = 1, numprocs-1
            call MPI_RECV(rbuff,ibuff,MPI_DOUBLE_PRECISION,
     &           MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,
     &           stat,ierr)
            nsize = stat(MPI_TAG)
            ifrom = stat(MPI_SOURCE)
c
c figure out the x and y indicies of the buffered message based on 
c the processor id that the message came from
c
            call mpiblock(nx,ny,numprocs,ifrom,
     &                    ixstart,ixstop,iystart,iystop)
            izstart = 1
            izstop = nz
c
c unpack message from the receive buff into ublock array
c
          index = 0
          do 300 k=izstart,izstop
            index = index+1
            knz = izstop-izstart+1
            kny = iystop-iystart+1
            do 290 i=ixstart,ixstop
              do 280 j=iystart,iystop
                ublock(i,j,k) =
     &          rbuff(index+knz*((j-iystart)+kny*(i-ixstart))) 
 280          continue
 290        continue
 300      continue
c
c end loop over all processors
c
 1000   continue
c
c end receive all messages on processor zero
c
        endif
c
c take layers and communicate to a block pattern
c
      else if (iswitch .eq. -1) then
c
c
c
        if (myid .ne. 0) then
c
c calculate the z values that need to be sent
c
          call mpilayer(nz,numprocs,myid,izstart,izstop)
c
c calculate the x,y values that are on this processor
c
          ixstart = 1
          ixstop =  nx+1
          iystart = 1
          iystop =  ny+1
c
c pack send buffer with the data to be sent to processor isend
c
          knz = izstop-izstart+1
          kny = iystop-iystart+1
          do i=ixstart,ixstop
            do j=iystart,iystop
              index = 0
              do k=izstart,izstop
                index = index + 1
                sbuff(index+knz*((j-iystart)+kny*(i-ixstart)))
     &                     =ublock(i,j,k)
              enddo
            enddo
          enddo
          isize = nz+knz*(ny + ny*(nx))
          if (isize .gt. ibuff) then
          write(6,*) "WARNING: PROBLEM WITH MPI BUFFERS"
          write(6,*) "in mpiprint", isize,ibuff,myid
          endif
          call MPI_SEND(sbuff,ibuff,MPI_DOUBLE_PRECISION,
     &                  izero,ibuff,MPI_COMM_WORLD,ierr)
c
c prepare to receive message from another processor in receive buffer
c
        else
          do 2000 irec = 1, numprocs-1
          call MPI_RECV(rbuff,ibuff,MPI_DOUBLE_PRECISION,
     &         MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,
     &         stat,ierr)
          nsize = stat(MPI_TAG)
          ifrom = stat(MPI_SOURCE)
c
c figure out the x and y indicies of the buffered message based on 
c the processor id that the message came from
c
          ixstart = 1
          iystart = 1
          ixstop =  nx+1
          iystop =  ny+1
c
c ublock is distributed in the z direction
c
          call mpilayer(nz,numprocs,ifrom,izstart,izstop)
c
c unpack message from the receive buff into ublock array
c
          knz = izstop-izstart+1
          kny = iystop-iystart+1
          do i=ixstart,ixstop
            do j=iystart,iystop
              index = 0
              do k=izstart,izstop
                index = index+1
                ublock(i,j,k) = 
     &          rbuff(index+knz*((j-iystart)+kny*(i-ixstart))) 
              enddo
            enddo
          enddo
c
c end loop over all processors
c
 2000   continue
        endif
      else
        if (myid .eq. 0) then
          write(6,*) "Error in calling mpiprint:"
          write(6,*) "iswitch must be 1 or -1"
          write(6,*) "aborting program"
          stop
        endif
      endif

c
c update timing and return
c
c      endtime = etime(tarray)
      commtime = commtime + endtime-btime
#endif
c
c return
c
      return
      end
