      subroutine mpiswitch(nx,ny,iz,ublock,ii,jj)
c
      use module_precision
      use module_mpibuf
#ifdef MPI
      include 'mpif.h'
#endif
c
      dimension ublock(ii,jj,*)
      real*4 endtime,tarray(2)

#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
      if (numprocs .eq. 1) return
c      btime = etime(tarray)
c     do 1 i=1,ibuff
c       sbuff(ibuff) = 0.0d0
c       rbuff(ibuff) = 0.0d0
c1    continue
c
c This section handles communication from
c the spectial (x,y-chunk) data to f.d. (z-chunk) 
c data pattern
c
        isize = 0
        knxx_max = 0
        kny_max = 0
        do 400 ichunk = 0, numprocs-1
          call mpiblock(nx,ny,numprocs,ichunk,
     &         ixstart,ixstop,iystart,iystop)
          knxx = ixstop - ixstart + 1
          kny = iystop - iystart + 1
          knxx_max = max(knxx_max,knxx)
          kny_max = max(kny_max,kny)
 400    continue
        isize = max(isize,knxx_max*kny_max)
c
c loop over all the chunks in the 'z' discritization
c for the processors x,y chunk and pack these into
c the send_buffer with uniform spacing
c
        do 450 ichunk = 0, numprocs-1
          call mpiblock(nx,ny,numprocs,myid,
     &         ixstart,ixstop,iystart,iystop)
          knxx = ixstop - ixstart + 1
          kny = iystop - iystart + 1
          do 425 j=1,kny
          do 425 i=1,knxx
           sbuff(ichunk*isize + knxx_max*(j-1)+i) 
     &           = ublock(i+ixstart-1,j+iystart-1,iz)
 425      continue
 450    continue
        if (isize*numprocs .gt. ibuff) then
        write(6,*) "WARNING: PROBLEM WITH MPI BUFFERS"
        write(6,*) "mpiswitch",isize*numprocs,ibuff,myid
        endif
        call MPI_ALLTOALL(
     &        sbuff,isize,MPI_DOUBLE_PRECISION,
     &        rbuff,isize,MPI_DOUBLE_PRECISION,
     &        MPI_COMM_WORLD,ierr)
c
c here the x,y chunk size is determined by where the
c data came from while the z chunk size is determined
c by the local processor 
c
        do 550 ichunk = 0, numprocs-1
          call mpiblock(nx,ny,numprocs,ichunk,
     &         ixstart,ixstop,iystart,iystop)
          knxx = ixstop - ixstart + 1
          kny = iystop - iystart + 1
          do 525 j=1,kny
          do 525 i=1,knxx
           ublock(i+ixstart-1,j+iystart-1,iz) =
     &     rbuff(ichunk*isize + knxx_max*(j-1)+i) 
 525      continue
 550    continue
c
c update timing and return
c
c      endtime = etime(tarray)
      commtime = commtime + endtime-btime
#endif
c
      return
      end
