c $Log:   /pvcs.config/mc3dvv/src/output.F_a  $
c
c   Rev 1.4   Fri Jul 30 15:17:48 1999   lowman
c  Added Nu.h and a4.h includes and fixed argument list
c  for netflow call
c
c   Rev 1.3   Tue Oct 06 16:45:26 1998   lowman
cRemoved various hardwired output calls. e.g., calls to wavsfield are
cnow controlled by userout. Removed hardwired argument calls in pttouv
c
c   Rev 1.2   Fri Aug 22 13:32:08 1997   hall
cAdded AVS output via call to wavsfield
c
c   Rev 1.1   Tue Jul 22 13:17:42 1997   hall
cCommented out bad (?) definition of tzero (tzero = time).  This was producing spurious results for tavg in tape42.
c
c   Rev 1.0   Mon Jul 14 14:21:52 1997   pvcs
c 
c *************************************************************
c *   OUTPUT
c***begin prologue output
c***date written   890101   (yymmdd)
c***revision date  930422   (yymmdd)
c***category no.  ????
c***keywords  output 
c             type=double precision
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose  Control nearly all output from this routine.
c***description
c
c     ijob = 1   open (input.in, tapeout, tape90)
c        
c            2   Open(tape16 tape17)
c                Called after initalizing temperature
c                and defining surface geometry. Write
c                input parameters to tapeout.
c            3   Called after quick restart (restrt.eq.-2) when
c                temperture solver never gets called. Writes
c                temperature and velocity
c            4   Called after quick restart (restrt.eq.-3). Write
c                temperature, velocity, poloidal velocity, toroidal
c                velocity.
c            5   Write power spectrum of temperature field.
c
c            6   Called every iteration after heatflo is finished.
c                This is where most output files are opened/initialized.
c            7   Called every iteration after heatflo is finished.
c                Depending upon input/output control and time this
c                is where most of the output is taken care of.
c            8   Called once every CPU hour to write backup restart
c                files.
c            9   Output of timeseries information.
c           10   Last call before shut down of program. Write restart
c                file,
c                close files that are open. Write tape80.
c           11   Write temperature raster files.
c           12   Output of superposition velocity fields and factored
c                matrix from LU decomposition.
c           13   Write velocity fields to individual files. For use with
c                AVS.
c           14   Write velocity and temperature for comparison in 3D
c                benchmarks.
c
c***references (none)
c***routines called  avsheader bc bm3drs fieldout ft2nrm laser
c***routines called  namefile mig_mach namefile netflow
c***routines called  outin plt3dv pttotau pttouv  plt3dv prntit
c***routines called  rastemp tauout ttoft velprm wheader
c***routines called  wavsfield
c***modifications (yymmdd) modification
c***modifications 930422 cwg Add timeseries output to tape30
c***modifications 9300824 [cwg] Using modified version of rastemp
c***modifications 970725 [PSH]  Added AVS friendly field writes
c***end prologue  output
c *************************************************************
      subroutine output(ijob)
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_a3
      use module_gia3
      use module_a22
      use module_nu
c      common /xxx/ tavrg(514), znu(514), tbar
      use module_ftcoef
c#include<a4.h>
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a30
      use module_a77
      use module_output
      use module_routput
      use module_timeint
      use module_craster
      use module_petracer
      common /start1/ restrt, initlt, istart
      common /a4/ vsij(700)
      common /ijc/ ijcycle
      common /peprinterror/ error,errmx,itvv

c      equivalence (ixa2,nx), (xa2,xl)
      dimension ixa2(1), xa2(1)
      dimension kkp(10)
      real*4 sptime
      real*8 scal(2)
      integer iscal(2)
      character*25 velroot,rasroot,naampje
      character*60 fname
      character*60 fname_header
      save inum
      data inum /0/
      data icall, ncalls, ivcall, ibmcall / 1, 1, 1, 1 /
      data icrash / 0 /
      data nrestrt / 1 /
      data qfso, znu1o, energko, tznuo / 0., 0., 0., 0. /
 
c     hard wire on-off switch for time series of a few 
c     temperature spectral values
c
      ifspectime = 1
      iftaverage = 1
      if (ifspectime .eq. 1)then
        if (ny .gt. 3)then
          i1x = 2
          i1y = 2
          i2x = 2
          i2y = 3
          i3x = 2
          i3y = 4
          i4x = 2
          i4y = 5
        else
          i1x = 2
          i1y = 1
          i2x = 2
          i2y = 1
          i3x = 2
          i3y = 1
          i4x = 2
          i4y = 1
        endif
      endif

      if (ncalls .eq. 0) then
        do i=1,2
          do j=1,npla
            dvpl(i,j)=0.
            vplo(i,j)=0.
          enddo 
        enddo
      endif
      
      ncalls=ncalls+1

c------------------------------------------------------------
      if (ijob .eq. 2) then
c        called after reading input file, initalizing temperature,
c        and defining surface geometry.
c        Temperature power spectrum
         open (unit=16,file='tape16',form='formatted')
         call wheader(16,2)
c        Velocity power .vs. depth to tape17
         open (unit=17,file='tape17',form='formatted')
         call wheader(17,2)
c        Write input parameters to TAPEOUT (unit 6)
         call outin(                                               
     1    rat,      rah,      xl,       yl,      time,
     1    tend,     nx,       ny,       nz,      lbd,     mbd,
     2    isolve,   ibcb,     ibct,     ibot,    itop,   alfx,
     3    alfy,     amp,      ampr,     dwate,   curant,
     4    isurfv,   ivistype, vsij,     icycle,  mcycle,
     5    initlt,   idot3,    ivelp3,   ivelp,   nxpcon(1),
     6    nxpcon(2),istedy,   ifssd,    dplot,   dprnt,
     7    dplt3,    resist,   netflo,   kchem,   icycmax, itvvmax,
     8    sprate,   bigd,     xf1,xf2, visfact,   imelt,
     9    delta, delt, f0, ithalf,    rad,  ram, vcut, cv1,cv2,
     1    relax, vis0)

          do k=8,1,-1
             write(6,'(8f8.3)') (t(i,1,k),i=1,8)
          enddo
      endif

      if (ijob .eq. 3) then
         write(6,*) 'PERROR(output): option 3 is obsolete'
         stop
      endif

      if (ijob .eq. 4) then
         write(6,*) 'PERROR(output): option 4 is obsolete'
         stop
      endif
c------------------------------------------------------------
      if (ijob .eq. 5) then
         write(6,*) 'PERROR(output): option 5 is obsolete'
         stop
      endif

      if (ijob.eq.6) then
         write(6,*) 'PERROR(output): option 6 is obsolete'
         stop
      endif

      if (ijob.eq.7) then
c        *** called every iteration after heatflo

c *************************************************************
c *      Initialization of some files. Only at first call 
c *************************************************************
         if (istart.eq.0) then
            istart=1
c           *** Time series information
            open (unit=35,file='tape35',form='formatted')
c            call wheader (35,2)
            open (unit=34,file='tape34',form='formatted')
c            call wheader (34,2)
c           *** Time series of selected spectral components
            if (ifspectime.eq.1) then
               open (unit=39,file='tape39',form='formatted')
c               call wheader (39,2)
            endif
c           *** Time series of velocity near plume patch
            if (int(vsij(20)).eq.1) then
               open (unit=30,file='tape30',form='formatted')
               call wheader(30,2)
               write(6,*) 'Patch location information'
               write(6,*)'icenter = ',vsij(17)
               write(6,*)'jcenter = ',vsij(18)
               write(6,*)'izptch  = ',vsij(19)
               write(6,*)'****************************'
            endif
c           *** Migrating ridge information
            if ((isurfv.ge.500) .and. (isurfv .le. 599)) then
               open (unit=31,file='tape31',form='formatted')
               call wheader (31,2)
            endif
            if (iftaverage.eq.1) then
c PSH 220797               tzero = time
               nspec = 0
               do j = 1,nyft
                  do i = 1,nxft
                     tavg(i,j,1) = zero
                     tavg(i,j,2) = zero
                  enddo
               enddo
            endif
c           *** Stress written by tauout
            open (unit=33,file='tape33',form='formatted')
            call wheader (33,2)
            open (unit=32,file='tape32',form='formatted')
            call wheader (32,2)
c           *** Surface geoid anamoly
c            open (unit=37,file='tape37',form='formatted')
c            call wheader (37,2)
         endif  ! istart=0

c ************************************************************
c *      Output of Nu, Vrms: every timestep.
c *************************************************************
c calculated in heatflo
c        vrms = calvrms(1)
         if (itimechoice.eq.1) then
            vrms = calvrms(1)
            tznu = calnus(norder,1)
         endif
         if (ivistype.ge.-1) then
             write (6,78) icycle,time,znu(1),vrms
         else 
             write (6,79) icycle,time,tznu,vrms,itvv,errmx
         endif
         call flush(6)
          

c *************************************************************
c *      *** Write some info to a file every 20 steps. This comes in
c *      *** handy if you've redirected stdout to a file on a HP...
c *      Create Restart file
c *************************************************************
         if ((icycle/20)*20.eq.icycle) then
            open(89,file='monitor.out')
            write (89,'(i10,3e15.7,i10,e15.7)') icycle,time,tznu,vrms,
     v         itvv,errmx
           close(89)
c          *** Write restart file
           if (itimechoice.eq.0) then
              open (unit=7,file='tape7_restart',form='unformatted')
              rewind (7)
              write (7) nx1,j4,nz1
              write (7) (((t(i,j,k),i=1,nx1),j=1,j4),k=1,nz1)
              close (7)
           else
              call ttoft
              open (unit=7,file='tape7_restart',form='unformatted')
              rewind (7)
              write (7) nx1,j4,nz1
              write (7) (((ft(i,j,k)/rat,i=1,nx1),j=1,j4),k=1,nz1)
              close (7)
           endif

         endif

c *************************************************************
c *      *** Write raster output file every DTRAST 
c *************************************************************
         if (time.ge.trast) then
            ifscal = 0
            rasroot = 'rast           '
            if (itimechoice.eq.0) then
c
c
            ifscal = 1
            scal(1) = 0.0
            scal(2) = 1.1
            iscal(1) = 0
            iscal(2) = 255
            itail = 1
            lu_out = 55
            io_type = 2
            sptime = time
            
	    iformat = 2
            itail = 1
	    call namefile1(irast,lu_out,iformat,rasroot,itail,fname)
c
c           Create a character string in fname which is the the name
c           used by the peras3 routine.
c
            itail = 0
            call setname(irast,rasroot,itail,fname)
c
c    Write the file descriptor
            call avsheader_scale
     1      (lu_out,io_type,nx,j3,nz,sptime,irast,fname,
     2       ifscal,iscal,scal)
 	    close(lu_out)
            call ttoft
            do k = 1,kmx
               do j = 1,jmx
                  do i = 1,imx
                    ft(i,j,k) = ft(i,j,k)/rat
                  enddo
               enddo
            enddo
               rasroot = 'rast                '
               call peras3(irast,isx,jsx,ksx,nx,j3,nz,ft,ifscal,
     v                    iscal,scal,rasroot)
            else
               call ttoft
               call peras3(irast,isx,jsx,ksx,nx1,j4,nz1,ft,ifscal,
     v              iscal,scal,rasroot)
            endif
            if (itracoption.eq.1) then
              write(naampje,'(''tracers.'',i3.3)') irast
              open(unit=78,file=naampje,form='unformatted')
              rewind(78)
              idimtrac=2
              if (ny.gt.2) idimtrac = 3
              write(78) ndist,(ntrac(idist),idist=1,ndist),idimtrac
              ip = 0
              do idist=1,ndist
                 write(78) (coormark(ip+i),i=1,idimtrac*ntrac(idist))
                 ip=ip+idimtrac*ntrac(idist)
              enddo
              close(78)
            endif
            irast = irast+1
            trast = trast+dtrast

         endif

c *************************************************************
c      980522   JPL
c   Moved the following control of avs output to subroutine
c                      userout.F
c             
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c ~  970725	PSH
c ~	WRITE ft TO AVS FORMAT FILE EVERY STEP
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c      if ((icycle/25)*25.eq.icycle) then
c	call wavsfield(1)
c      endif

c ~ OR, FOR INITIAL T FIELD ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

c      if (icycle.eq.1) then
c	call wavsfield(1)
c	write(6,*) 'dx= ',dx
c	write(6,*) 'dy= ',dy
c	write(6,*) 'dz= ',dz
c	write(6,*) 'dt= ',dt
c      endif
c *************************************************************
c *      Write temperature solution every DTOUT 
c *************************************************************
         if (time.ge.tout) then
            if (itimechoice.eq.0) call prntit
c >>>> Do not output temperature and velocity in tape11,tape12
c           call plt3dv
c >>>>>>>>>>>>
            call mig_mach(1,'sun***',rdum,seconds,idum,idum)
            if (itimechoice.eq.0) then
c             vrms = calvrms(1)
              write(6,'(''OUTPUT: '',f12.5,f7.2,2f12.5)') 
     v            time,seconds,znu(1),vrms
            endif
            noutje = time/dtout
            write(naampje,'(''tape7_'',i3.3)') noutje
            if (itimechoice.eq.0) then
              open (unit=7,file=naampje,form='unformatted')
              rewind (7)
              write (7) nx1,j4,nz1
              write (7) (((t(i,j,k),i=1,nx1),j=1,j4),k=1,nz1)
              close (7)
c             *** Output a cell-centered version as well.
              write(naampje,'(''temp_'',i3.3)') noutje
              open (unit=7,file=naampje,form='unformatted')
              rewind (7)
              call ttoft
              write (7) nx,j3,nz
              write (7) (((ft(i,j,k)/rat,i=1,nx),j=1,j3),k=1,nz)
              close (7)
            else
              call ttoft
              open (unit=7,file=naampje,form='unformatted')
              rewind (7)
              write (7) nx1,j4,nz1
              write (7) (((ft(i,j,k)/rat,i=1,nx1),j=1,j4),k=1,nz1)
              close (7)
            endif

            tout=tout+dtout
          endif
      endif

      if (ijob.eq.8) then
c        *** called once every hour (on the clock) and 
c        *** writes restart file every hour to protect run against 
c        *** machine crash. Alternates between tape91 and tape92.
         if (icrash .eq. 0)then
            lucr=91
            icrash=1
            open(unit=91,file='tape91',form='unformatted')
         else
            lucr=92
            icrash=0
            open(unit=92,file='tape92',form='unformatted')
         endif
         write (lucr) ptitle
         write (lucr) na1l,(((t(i,j,k),i=1,nx1),j=1,j4),k=1,nz1)
         write (lucr) na2l,(xa2(i),i=1,na2l)
         write (lucr) na4l,(ixa2(i),i=1,na4l)
         endfile lucr
         rewind lucr
         close(lucr)
      endif
      
      if (ijob.eq.9) then
c        *** Write out time-series information
         if (itimechoice.eq.1.or.itimechoice.eq.-1) then
            qfs = calnus(norder,1)
            znu(1) = calnus(norder,1)
            tznu = calnus(norder,1)
            energk = calvrms(1)
         else
            qfs = znu(nz)
         endif
         write(35,80) icycle,time,qfs,znu(1),vrms,tznu
         dqfs = qfso-qfs
         dznu1 = znu1o-znu(1)
         denergk = energko-energk
         dtznu = tznuo-tznu
         write(34,80) icycle,dt,dqfs,dznu1,denergk,dtznu
c        *** Time series of velocity near plume patch

        if (int(vsij(20)) .eq. 1)then
           i=vsij(17)+0.5
           j=vsij(18)+0.5
           k=vsij(19)+0.5
           if (ny.gt.2) then
              write(30,80)icycle,time,u(i,j,k-1),u(i,j,k),
     1                             u(i,j,k+1),v(i,j,k-1)
              write(30,82)v(i,j,k),w(i,j,k-1),w(i,j,k),w(i,j,k+1)  
           else
              write(30,80)icycle,time,u(i,j,k-1),u(i,j,k),
     1                         u(i,j,k+1),u(i,j,k+2)
              write(30,82)w(i,j,k+2),w(i,j,k-1),w(i,j,k),w(i,j,k+1)
           endif
        endif
        if (ifspectime.eq.1) then
c          call ttoft
           write(39,80)icycle, time,ft(i1x,i1y,nz/2),ft(i2x,i2y,nz/2),  
     1                           ft(i3x,i3y,nz/2),ft(i4x,i4y,nz/2)
        endif
c       *** for dynamic plates track plate velocity
        if (nplate.ne.0) then
           do i=1,2
             do j=1,nplate
               dvpl(i,j) = vplo(i,j)-vpl(i,j)
               vplo(i,j) = vpl(i,j)
             enddo
           enddo
c           write (34,82) ((dvpl(i,j),i = j1,j2),j = 1,nplate)
c           write (35,82) (( vpl(i,j),i = j1,j2),j = 1,nplate)
        endif
        qfso=qfs
        znu1o=znu(1)
        energko=energk
        tznuo=tznu
        if (iftaverage.eq.1) then
c          *** track time averaged temperature spectrum
           do j = 1,nyft
              do i = 1,nxft
                 tavg(i,j,1) = tavg(i,j,1) + abs(ft(i,j,nz/2))*dt
              enddo
           enddo
           do j = 1,nyft
             do i = 1,nxft
                tavg(i,j,2) = tavg(i,j,2) + abs(ft(i,j,nz-2))*dt
             enddo
           enddo
           nspec = nspec + 1
        endif
        call flush(35) 
        call flush(34)
        call flush(30)
        call flush(39)

      endif

      if (ijob.eq.10) then
c        *** last call before shut down
c commented out by sdk 8/6/02
c        open (unit=1,file='tape1',form='unformatted')
c        rewind (1)
c        write (1) ptitle
c        write (1) na1l,(((t(i,j,k),i=1,nx1),j=1,j4),k=1,nz1)
c        write (1) na2l,(xa2(i),i=1,na2l)
c        write (1) na4l,(ixa2(i),i=1,na4l)
c        endfile 1
c        rewind 1
         if (itimechoice.eq.0) then
            open (unit=7,file='tape7s',form='unformatted')
            rewind (7) 
            write (7) nx1,j4,nz1
            write (7) (((t(i,j,k),i=1,nx1),j=1,j4),k=1,nz1)
            close (7)
         else
            call ttoft
            open (unit=7,file='tape7s',form='unformatted')
            rewind (7) 
            write (7) nx1,j4,nz1
            write (7) (((ft(i,j,k)/rat,i=1,nx1),j=1,j4),k=1,nz1) 
            close (7)
         endif
         rnone=-1.0
c         if (ijcycle.ne.1) call plt3dv
c >>>>>>>>> PETER (begin)
c        if (icycle.ne.1) call prntit
c >>>>>>>>> PETER (end)
c        ***  write tape8 for restart at twice the resolution
         if (istedy.eq.-2) then
            open (unit=8,file="tape8",status='new',form='unformatted')
            write (8) isx,jsx,ksx
            write (8) (((ft(i,j,k),i=1,isx),j=1,jsx),k=1,ksx)
            close (8)
         endif
 
c        *** output for 3d benchmark calculations
         if ((idot3.eq.3) .and. (ivelp3.eq.3)) then
c           call bm3dout
         endif
 
c        *** output for euro-benchmark calculations
         call ttoft
c SDK isolve check added 1/15/02 to pass automatic test suite
         if (isolve .ne. 5) then
           ijob_pttouv=0
           ipttype_pttouv=0
c           call mmverify
c          call pttouv(ipttype_pttouv,ijob_pttouv)
           call ft2nrm (-1,lpu,nxu,mpu,nyu,nz,inx,jnx,u)
           call ft2nrm (-1,lpv,nxv,mpv,nyv,nz,inx,jnx,v)
           call ft2nrm (-1,lpw,nxw,mpw,nyw,nz,inx,jnx,w)
           call netflow(nx,ny,inx,jnx,u,v,vis,wk1d,netflo)
           call bc (u,v,w,inx,nxr,nx,lbd,jnx,nyr,j3,mbd,nz,1)
         endif
      
         open (unit=80,file="tape80")
         call wheader (80,2)
c        ***  (i)
         write (80,470) icycle, time, tznu, energk
c        (ii) vertical velocity and temperature at specific points (corners).
         write (80,472)(nz/2)+1,nx,j3,float(nx-1)*dx,float(ny-1)*dy
         write (80,473)
     1      w(1,1 ,(nz/2)+1), w(nx,1 ,(nz/2)+1),
     2      w(1,j3,(nz/2)+1), w(nx,j3,(nz/2)+1),
     3      w(1,(j3/2)+1,(nz/2)+1)
         write (80,474)z((nz/2)+1),
     1      ft(1,1 ,(nz/2)+1)/rat, ft(nx,1 ,(nz/2)+1)/rat,
     2      ft(1,j3,(nz/2)+1)/rat, ft(nx,j3,(nz/2)+1)/rat
         write (80,479)z(nz),
     1      ft(1,1 ,nz  )/rat, ft(nx,1 ,nz  )/rat,
     2      ft(1,j3,nz  )/rat, ft(nx,j3,nz  )/rat
         write (80,480)z(nz-1),
     1      ft(1,1 ,nz-1)/rat, ft(nx,1 ,nz-1)/rat,
     2      ft(1,j3,nz-1)/rat, ft(nx,j3,nz-1)/rat
         write (80,481)z(nz-2),
     1      ft(1,1 ,nz-2)/rat, ft(nx,1 ,nz-2)/rat,
     2      ft(1,j3,nz-2)/rat, ft(nx,j3,nz-2)/rat
         write (80,479)avz(nz1),
     1      t(1,1 ,nz1   ), t(nx,1 ,nz1   ),
     2      t(1,j3,nz1   ), t(nx,j3,nz1   )
         write (80,480)avz(nz1-1),
     1      t(1,1 ,nz1-1), t(nx,1 ,nz1-1),
     2      t(1,j3,nz1-1), t(nx,j3,nz1-1)
         write (80,481)avz(nz1-2),
     1      t(1,1 ,nz1-2), t(nx,1 ,nz1-2),
     2      t(1,j3,nz1-2), t(nx,j3,nz1-2)
c        *** (iii) surface heat flux, surface topography, geoid anomaly
         write(80,477)
     1    (t(1  ,1  ,nz1)-t(1  ,1  ,nz1-1))/(avz(nz1)-avz(nz1-1)),
     2    (t(nx1,1  ,nz1)-t(nx1,1  ,nz1-1))/(avz(nz1)-avz(nz1-1)),
     3    (t(1  ,j4, nz1)-t(1  ,j4, nz1-1))/(avz(nz1)-avz(nz1-1)),
     4    (t(nx1,j4, nz1)-t(nx1,j4, nz1-1))/(avz(nz1)-avz(nz1-1))
 
         c1=yl*0.5
         c2=0.5
         indx=2
         call laser(c1,c2,indx,t,inx,jnx,knx)
         call ft2nrm (1,lpft,nxft,mpft,nyft,nz,isx,jsx,ft)
c        *** (v) mean temperature
         zdepth= .75
         do  k=1,nz1
           if ((avz(k) .le. zdepth) .and. (avz(k+1) .ge. zdepth)) then
             slope=(tavrg(k+1)-tavrg(k))/(z(k+1)-z(k))
             bval = tavrg(k)-slope*z(k)
             tofz = slope*zdepth+bval
             write(80,476)k,zdepth,z(k),slope,bval,tofz
           endif
         enddo
         zdepth= .25
         do  k=1,nz1
           if ((avz(k) .le. zdepth) .and. (avz(k+1) .ge. zdepth)) then
             slope=(tavrg(k+1)-tavrg(k))/(z(k+1)-z(k))
             bval = tavrg(k)-slope*z(k)
             tofz = slope*zdepth+bval
             write(80,476)k,zdepth,z(k),slope,bval,tofz
           endif
         enddo
 
c        *** output for time averaged spectrum
c        *** when iftaverage = 1
         if (iftaverage .eq. 1)then
            open (unit=42,file='tape42',form='formatted')
            call wheader (42,2)
            do k = 1,2
              do j = 1,nyft
                do i = 1,nxft
                  tavg(i,j,k) = tavg(i,j,k)/(time-tzero)
                enddo
              enddo
            enddo
            write (42,365) icycle,ptitle,nspec,time-tzero,tzero
            write (42,370) icycle,time,nxft,nyft,nz,(k,k=1,nz)
            write (42,380) (((tavg(i,j,k),i=1,nxft),j=1,nyft),k=1,2) 
            close (unit=42)
         endif
 
         call mig_mach(1,'sun***',rdum,seconds,idum,idum)
         secpcy=seconds/float(ijcycle)
         cypsec=1./secpcy
         cypmin=cypsec*60.
         rminute=seconds/60.
         hour=rminute/60.
         open(unit=90,file='tape90')
         write(90,450) seconds,rminute,hour
         write(90,452) secpcy,cypsec,cypmin
         close(90)
      endif

      if (ijob.eq.11) then
         write(6,*) 'PERROR(output): option 11 is obsolete'
         stop
      endif

      if (ijob.eq.12) then
         write(6,*) 'PERROR(output): option 12 is obsolete'
         stop
      endif

      if (ijob.eq.13) then
         write(6,*) 'PERROR(output): option 13 is obsolete'
         stop
      endif

      if (ijob.eq.14) then
         write(6,*) 'PERROR(output): option 14 is obsolete'
         stop
      endif

      if (ijob.eq.15) then
         write(6,*) 'PERROR(output): option 15 is obsolete'
         stop
      endif

   78 format (i8,4e15.7)
   79 format (i8,3e15.7,i8,e15.7)
   80 format (i8,5e15.7)
   82 format (8e15.7)
   90 format (i8,5e15.7)
  360 format (i5,2x,a72)
  365 format (i5,2x,a72,i5,3e15.7)
  370 format (i5,e12.5,3i5,25(10i5,/))
c  380 format (13000(10e12.5,/))
  380 format (512(512(512(10e12.5,/))))
  450 format('Run time for MC3D ',f10.4,' seconds or',/,
     1       'Run time          ',f10.4,' minutes or',/,
     1       'Run time          ',f10.4,' hours ')
  452 format('seconds/cycles= ',f10.4,/,
     1       ' cycles/sec=    ',f10.4,/,
     2       ' cycles/min=    ',f10.4)
c
c     euro-benchmark output
c  
  470 format(/,'Cycle          = ',i8   ,/
     1         'Time           = ',e14.7,/
     2         'Nusselt number = ',e14.7,/
     3         'Rms velocity   = ',e14.7,/)
  472 format('NZ/2+1 = ',i5,' nx = ',i5,' ny = ',i5,/,
     1        ' a = ',e14.7,' b = ',e14.7,/)
  473 format('Vertical velocity at four corners and centre of sidewall',/,
     1   '   w(0,0,.5)     w(a,0,.5)     w(0,b,.5)     w(a,b,.5)',
     2'     w(0,b/2,.5)',/,
     3        6e14.7,/)
  474 format('Temperature at four corners z = ',e14.7,/,
     1   '   t(0,0,.5)     t(a,0,.5)     t(0,b,.5)     t(a,b,.5)',/,
     2        4e14.7,/)
  479 format('Temperature at four corners z = ',e14.7,/,
     1   '   t(0,0,1.)     t(a,0,1.)     t(0,b,1.)     t(a,b,1.)',/,
     2        4e14.7,/)
  480 format('Temperature at four corners z = ',e14.7,/,
     1   '   t(0,0,1.-dz)  t(a,0,1.-dz)  t(0,b,1.-dz)  t(a,b,1.-dz)',/,
     2        4e14.7,/)
  481 format('Temperature at four corners z = ',e14.7,/,
     1   '   t(0,0,1.-2dz) t(a,0,1.-2dz) t(0,b,1.-2dz) t(a,b,1.-2dz)',/,
     2        4e14.7,/)

  476 format(i5,' Depth = ',f10.4,' Z(k) = ',f10.4,' Slope = ',e14.7,
     1  ' Intercept = ',e14.7,/,
     2  ' Average Temperature at Z = slope*zdepth+intercept = ',e14.7,/)
  477 format('Surface heat flux at four corners',/,
     1'   dt(0,0,1)     dt(a,0,1)     dt(0,b,1)     dt(a,b,1)',/,
     2        4e14.7,/)
51    format('*',/,'if ssd obtained, 1=yes 2=no; ifgot=',i1,/,'*')
52    format(
     1  '*',/,'if ssd obtained for lu, 1=yes 2=no; ifgot=',i1,/,'*')
902   format(4i8)
      return
      end
     
