c $Log:   /pvcs.config/mc3dvv/src/plflow.F_a  $
c
c   Rev 1.3   Fri Jul 30 11:54:24 1999   lowman
c Made call to filter active. This produces a velocity ramp
c at the boundaries of dynamic plates.
c Added include of slvelu.h and added an allocatable zwork
c
c   Rev 1.2   Tue Feb 09 14:40:48 1999   lowman
cremoved hardwired value of lith
cadded call to open veloc_ts
c
c   Rev 1.1   Tue Oct 06 16:47:58 1998   lowman
cAdded calls to chvarx and chvary to impose correct velocity b.c. on
cdynamic plots
cZero out vpb and vtb before filling them
cAdded calls to chvarx and chvary to arrange tau13pl and tau23pl
cin Cartesian space before calculating stresses for PICs
c
c   Rev 1.0   Mon Jul 14 14:22:00 1997   pvcs
c 
c *************************************************************
c *   PLFLOW
c *************************************************************
      subroutine plflow
c***begin prologue  plflow
c***date written   880101   (yymmdd)
c***revision date  930819   (yymmdd)
c***category no.  ????
c***keywords
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose Solve for plate driven component of flow and calculate
c           plate interaction coefficients.
c***description
c***references (none)
c***routines called  ????
c***modifications (yymmdd) modification
c***modifications (930819) [cwg] corrected solvlu call arguments
c***modifications (930823) [cwg] nvisdim, nvnudim, nrdim, nzdim were not defined
c***modifications (930824) [cwg] viscom.h was not included, was causing crash
c***end prologue  plflow
      use module_precision
c
c     this routine calculates the flow field for
c     a given plate geometry. There are no
c      body force driving terms
c
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_afftw
      use module_a6
      use module_a7
      use module_a9
      use module_gia9
      use module_a11
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a13
      use module_a14
      use module_a23
      use module_a24
      use module_a25
      use module_a26
c      common /fftw/ wxs(257), wys(257), tk(257), wx(257), wy(257),
c     1 wxc(257), wyc(257)
      use module_viscom
      use module_flow
      use module_slvelu
      real l, l2
      common /a8/ l2, l, vps, vts
      common /a10/ jcycle
      dimension sscalv(2), iindexv(2)
      dimension scalv(4), indexv(4), sdktmp(4)

#ifdef MPI
      include 'mpif.h'
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif

      nvisdim = ksx
      nvnudim = ksx
      nrdim   = kmx
      nzdim   = 514
      jcycle = icycle
      twopi = 2.*pimach(dumm)
      pi = pimach(dumm)
      if(ny .eq. 2) then
          jr4 = 1
      else
         jr4 = nyr+1
      endif
c
c     set body force to zero
c
      do 10 ll = 1,nz
      rr(ll) = zero
   10 continue

      open(unit=58,file='veloc_ts')
c
c     with the solid state disk the plate field array
c     has 1 for its last dimension
c
      if(ifssd .eq. 1)then
        rewind(50)
      endif
c
c     set up for 2 plates
c
c     surface geometry is defined in
c     routine SURFGEO called in mantle
c
c     loop through 2*nplate times to obtain
c     the 2*nplate fields for plate motion in the
c     two orthogonal direcions x & y.
c

      if(ifsavepl.eq.0)then
        if(myid .eq. 0) then
          write(6,*) '*******************************'
          write(6,*) '* ifsavepl=0, Saving memory on*'
          write(6,*) '* dynamic plate calculation   *'
          write(6,*) '* roughly doubling run time   *'
          write(6,*) '*******************************'
        endif
      endif

      do 99 k = 1,nplate 
      do 80 j = 1,nyr
      do 80 i = 1,nxr
      fftvx(i,j) = template2(i,j,k)
   80 continue
      k_fftv = 1
      i_fft = 1
      negi_fft = -1

      call ft2nrm (i_fft,lpu,nxu,mpu,nyu,k_fftv,iqx,jqx,fftvx)

      ifilter = 1 
      stopfq = xl*dfloat(nz)/(dfloat(nx)*dfloat(lith)) 
      if(ifilter.eq.1)
     & call filt(fftvx,iqx,jqx,k_fftv,nxu,nyu,k_fftv,zero,stopfq)
      call ft2nrm (negi_fft,lpu,nxu,mpu,nyu,k_fftv,iqx,jqx,fftvx)
c ******************
c       if(j3.gt.1)then
c       stopfq = yl*dfloat(nz)/(dfloat(ny)*dfloat(lith))
c       call ft2nrm (1,lpv,nxv,mpv,nyv,1,iqx,jqx,fftvx)
c       if(ifilter.eq.1)
c     & call filt(fftvx,iqx,jqx,ifilter,nxv,nyv,ifilter,zero,stopfq)
c       call ft2nrm (-1,lpv,nxv,mpv,nyv,1,iqx,jqx,fftvx)
c       endif
c 
c *******************
      do 95 j = 1,nyr
      do 95 i = 1,nxr
   95 template2(i,j,k) = fftvx(i,j)
   99 continue

      do 340 iip = 1,2*nplate

      if(ifssd .eq. 1)then
        ip = 1
      elseif(ifssd .eq. 0)then
        ip = iip
      endif

      call kinsurf(isurfv,iip)
c
c     solve twice to be sure scales are
c     correct when solving FDE's.
c
      do 330 loop = 1,2
c
c    solve 4 1st order ode's for primitive variables
c
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nx) ixstop =  nx
      if (iystop .gt. j3) iystop =  j3 
#else
      iystar=1
      iystop=j3
      ixstar=1
      ixstop=nx
#endif
      if (loop.eq.1) then
        do 110 k = 1,nz
        do 110 j = iystar,iystop
        do 110 i = ixstar,ixstop
c       do 110 j = j1,j3
c       do 110 i = 1,nx
        if(ifsavepl.eq.1)then
          vppl  (i,j,k,ip) = zero
          v3pl  (i,j,k,ip) = zero
          tauppl(i,j,k,ip) = zero
          tau3pl(i,j,k,ip) = zero
          vtfpl (i,j,k,ip) = zero
          tautpl(i,j,k,ip) = zero
        else
          vp  (i-ixstar+1,j-iystar+1,k) = zero
          v3  (i-ixstar+1,j-iystar+1,k) = zero
          taup(i-ixstar+1,j-iystar+1,k) = zero
          tau3(i-ixstar+1,j-iystar+1,k) = zero
          vtf (i-ixstar+1,j-iystar+1,k) = zero
          taut(i-ixstar+1,j-iystar+1,k) = zero
        endif
  110   continue
        conv = 1.e-10
        itmax = 50
        niterate = 10
        m = nz
        slowc = 1.e6
        scalv(1) = one
        scalv(2) = one
        scalv(3) = one
        scalv(4) = one
        ne = 4
        nyk = m
        nyj = ne
        nb = 2
        nci = ne
        ncj = ne-nb+1
        nck = m+1
        nsi = ne
        nsj = ne+ne+1
        
        ml = 5
        mu = 5
        lda = 4*kmx
        n = ne*m
        npt = ne
        
        if (ibcb.eq.2) then
          indexv(1) = 1
          indexv(2) = 2
          indexv(3) = 3
          indexv(4) = 4
        else
          indexv(1) = 3
          indexv(2) = 2
          indexv(3) = 1
          indexv(4) = 4
        endif
      elseif (loop.ne.1) then
        scalv(1) = .01
        scalv(2) = .01
        scalv(3) = .01
        scalv(4) = .01
        do 130 ll = 1,nz
        do 120 j = iystar,iystop
        do 120 i = ixstar,ixstop
c       do 120 j = j1,j3
c       do 120 i = 1,nx
        if(ifsavepl.eq.1)then
          scalv(1) = max(abs(vppl  (i,j,ll,ip)),scalv(1))
          scalv(2) = max(abs(v3pl  (i,j,ll,ip)),scalv(2))
          scalv(3) = max(abs(tauppl(i,j,ll,ip)),scalv(3))
          scalv(4) = max(abs(tau3pl(i,j,ll,ip)),scalv(4))
        else
          scalv(1) = max(abs(vp  (i-ixstar+1,j-iystar+1,ll)),scalv(1))
          scalv(2) = max(abs(v3  (i-ixstar+1,j-iystar+1,ll)),scalv(2))
          scalv(3) = max(abs(taup(i-ixstar+1,j-iystar+1,ll)),scalv(3))
          scalv(4) = max(abs(tau3(i-ixstar+1,j-iystar+1,ll)),scalv(4))
        endif
  120   continue
  130   continue
#ifdef MPI
      call MPI_ALLREDUCE(scalv,sdktmp,4,MPI_DOUBLE_PRECISION,MPI_MAX,
     &                MPI_COMM_WORLD,ierr)
      scalv(1) = sdktmp(1)
      scalv(2) = sdktmp(2)
      scalv(3) = sdktmp(3)
      scalv(4) = sdktmp(4)
#endif
        slowc = max(scalv(1),scalv(2),scalv(3),scalv(4))
      endif

      lmn = 0
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
c     do 180 j = 1,nyr
c     do 170 i = 1,nxr
      do 180 j = iystar,iystop
      do 170 i = ixstar,ixstop
      ijob = 0
c     if(ifssd .eq. 1)then
c       ijob = 2
c     endif
      lmn = lmn+1
      l = fl(i,j)
      l2 = l**2
c cg      if(ibct.eq.3) vps = vpb(i,j)
      vps = vpb(i,j)
c      if(((lbd .eq. 0) .and. (i .eq. nxr)) .and.
c     1   ((mbd .eq. 0) .and. (j .eq. nyr)) .or.
c     2    (abs(vps).lt.conv).or.(l.eq.0.0)) then
      if ((abs(vps).lt.conv).or.(l.eq.0.0)) then
c       write(6,*)i,j,lbd,mbd,nxr,nyr,l,abs(vps)
        do 140 ll = 1,nz
        if(ifsavepl.eq.1)then
          vppl  (i,j,ll,ip) = zero
          v3pl  (i,j,ll,ip) = zero
          tauppl(i,j,ll,ip) = zero
          tau3pl(i,j,ll,ip) = zero
        else
          vp  (i-ixstar+1,j-iystar+1,ll) = zero
          v3  (i-ixstar+1,j-iystar+1,ll) = zero
          taup(i-ixstar+1,j-iystar+1,ll) = zero
          tau3(i-ixstar+1,j-iystar+1,ll) = zero
        endif
  140   continue
      else
c
c     set initial guess to solution from last time step
c
        do 150 ll = 1,nz
        if(ifsavepl.eq.1)then
          y(1,ll) = vppl  (i,j,ll,ip)
          y(2,ll) = v3pl  (i,j,ll,ip)
          y(3,ll) = tauppl(i,j,ll,ip)
          y(4,ll) = tau3pl(i,j,ll,ip)
        else
          y(1,ll) = vp  (i-ixstar+1,j-iystar+1,ll)
          y(2,ll) = v3  (i-ixstar+1,j-iystar+1,ll)
          y(3,ll) = taup(i-ixstar+1,j-iystar+1,ll)
          y(4,ll) = tau3(i-ixstar+1,j-iystar+1,ll)
        endif
  150   continue
c
        npt = 4
          call solvlu(itmax,conv,slowc,scalv,indexv,ne,m,y,nyj,nyk
     1    ,abe(1,1,1),lda,n,b,ipvt(1,1),npt,ml,mu,lmn,ijob,
     2    l,l2,vps,vts,rr,nrdim,vis,nvisdim,vnu,nvnudim,
     3    z,nzdim,nz,ibcb,ibct,ivistype,
     4    r1,r2,r3,r4,ksl,i,j,icycle,niterate,ncabe,zwork)
       
        do 160 ll = 1,nz
        if(ifsavepl.eq.1)then
          vppl  (i,j,ll,ip) = y(1,ll)
          v3pl  (i,j,ll,ip) = y(2,ll)
          tauppl(i,j,ll,ip) = y(3,ll)
          tau3pl(i,j,ll,ip) = y(4,ll)
        else
          vp  (i-ixstar+1,j-iystar+1,ll) = y(1,ll)
          v3  (i-ixstar+1,j-iystar+1,ll) = y(2,ll)
          taup(i-ixstar+1,j-iystar+1,ll) = y(3,ll)
          tau3(i-ixstar+1,j-iystar+1,ll) = y(4,ll)
        endif
  160   continue
      endif
  170 continue
  180 continue
c
c     solve toroidal on both loops through plflow
c
      if (loop.eq.1) then
        cconv = conv
        iitmax = itmax
        sslowc = 1.e6
        sscalv(1) = 1.
        sscalv(2) = 1.
        nn = nz
        nne = 2
        nnb = 1
        nnyk = nn
        nnyj = nne
        nnci = nne
        nncj = nne-nnb+1
        nnck = nn+1
        nnsi = nne
        nnsj = 2*nne+1
        
        mml = 2
        mmu = 2
c        lda = 2*mml+mmu+1
        lda = 4*kmx
        n = nne*nn
        npt = nne
        
        if (ibcb.eq.2) then
          iindexv(1) = 1
          iindexv(2) = 2
        else
          iindexv(1) = 2
          iindexv(2) = 1
        endif
      elseif (loop.ne.1) then
        sscalv(1) = .01
        sscalv(2) = .01

c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
        do 190 ll = 1,nz
        do 190  j = iystar,iystop
        do 190  i = ixstar,ixstop
        if(ifsavepl.eq.1)then
          sscalv(1) = max(abs(vtfpl (i,j,ll,ip)),sscalv(1))
          sscalv(2) = max(abs(tautpl(i,j,ll,ip)),sscalv(2))
        else
          sscalv(1) = max(abs(vtf (i-ixstar+1,j-iystar+1,ll)),sscalv(1))
          sscalv(2) = max(abs(taut(i-ixstar+1,j-iystar+1,ll)),sscalv(2))
        endif
  190   continue
c MPI ALERT changed scalft to local scale and use mpi reduce
#ifdef MPI
      call MPI_ALLREDUCE(sscalv,sdktmp,2,MPI_DOUBLE_PRECISION,MPI_MAX,
     &                MPI_COMM_WORLD,ierr)
      sscalv(1) = sdktmp(1)
      sscalv(2) = sdktmp(2)
#endif
        sslowc = max(sscalv(1),sscalv(2))
 
      endif
c
      lmn = 0
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nx) ixstop =  nx
      if (iystop .gt. j3) iystop =  j3
#else
      iystar=1
      iystop=j3
      ixstar=1
      ixstop=nx
#endif
      do 240 j = iystar,iystop
      do 230 i = ixstar,ixstop
      lmn = lmn+1
      l = fl(i,j)
      l2 = l**2
      vts = vtb(i,j)
      if ((abs(vts).lt.cconv).or.(l.eq.0.0).or. (ny .le. 2)) then
        do 200 ll = 1,nz
        if(ifsavepl.eq.1)then
          vtfpl (i,j,ll,ip) = 0.
          tautpl(i,j,ll,ip) = 0.
        else
          vtf (i-ixstar+1,j-iystar+1,ll) = 0.
          taut(i-ixstar+1,j-iystar+1,ll) = 0.
        endif
  200   continue
      else
c
c     set initial guess to solution from last time step
c
        do 210 ll = 1,nz
        if(ifsavepl.eq.1)then
          yy(1,ll) = vtfpl (i,j,ll,ip)
          yy(2,ll) = tautpl(i,j,ll,ip)
        else
          yy(1,ll) = vtf (i-ixstar+1,j-iystar+1,ll)
          yy(2,ll) = taut(i-ixstar+1,j-iystar+1,ll)
        endif
  210   continue
        npt = 2
        ijob = 0
          call solvlu(iitmax,cconv,sslowc,sscalv,iindexv,nne,nn,yy,nnyj,
     1    nnyk,abe(1,1,1),lda,n,b,ipvt(1,1),npt,mml,mmu,lmn,ijob,
     2    l,l2,vps,vts,rr,nrdim,vis,nvisdim,vnu,nvnudim,
     3    z,nzdim,nz,ibcb,ibct,ivistype,
     4    r1,r2,r3,r4,ksl,i,j,icycle,niterate,ncabe,zwork)

        do 220 ll = 1,nz
        if(ifsavepl.eq.1)then
          vtfpl (i,j,ll,ip) = yy(1,ll)
          tautpl(i,j,ll,ip) = yy(2,ll)
        else
          vtf (i-ixstar+1,j-iystar+1,ll) = yy(1,ll)
          taut(i-ixstar+1,j-iystar+1,ll) = yy(2,ll)
        endif
  220   continue
      endif
  230 continue
  240 continue


      if (loop.eq.1) go to 330
c
      lithd = nz-lith
    
      do j = 1,nyr
      do i = 1,nxr
        tau13pl(i,j,iip) = zero
        tau23pl(i,j,iip) = zero
      enddo
      enddo

c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
      do 250 j = iystar,iystop
      do 250 i = ixstar,ixstop
      if(ifsavepl.eq.1)then
        tau13pl(i,j,iip) = fli(i,j)*tauppl(i,j,lithd,ip)+
     1                     flj(i,j)*tautpl(i,j,lithd,ip)
        tau23pl(i,j,iip) = flj(i,j)*tauppl(i,j,lithd,ip)-
     1                     fli(i,j)*tautpl(i,j,lithd,ip)
      else
        tau13pl(i,j,iip) = fli(i,j)*taup(i-ixstar+1,j-iystar+1,lithd)+
     1                     flj(i,j)*taut(i-ixstar+1,j-iystar+1,lithd)
        tau23pl(i,j,iip) = flj(i,j)*taup(i-ixstar+1,j-iystar+1,lithd)-
     1                     fli(i,j)*taut(i-ixstar+1,j-iystar+1,lithd)
      endif
  250 continue

      call mpiswitch(nx,j3,iip,tau13pl(1,1,1),iqx,jqx)
      call mpiswitch(nx,j3,iip,tau23pl(1,1,1),iqx,jqx)
      
      if(j3.gt.1)then
      ichvar=-1
      call chvary(tau13pl(1,1,iip),iqx,nxr,lbd,jqx,nyr,mbd,1,ichvar)
      call chvarx(tau23pl(1,1,iip),iqx,nxr,lbd,jqx,nyr,mbd,1,ichvar)
      endif
c
      call find00term(iip)
c
      call ft2nrm(-1,lpt13,nxt13,mpt13,nyt13,1,iqx,jqx,tau13pl(1,1,iip))
      call ft2nrm(-1,lpt23,nxt23,mpt23,nyt23,1,iqx,jqx,tau23pl(1,1,iip))

      if (lbd.eq.0) then
        do 290 i = 1,nxr
        tau13pl(i,jr4,iip) = tau13pl(i,1,iip)
        tau23pl(i,jr4,iip) = tau23pl(i,1,iip)
  290   continue
      elseif (lbd.eq.1) then
        do 300 i = 1,j3
        tau13pl(1,j,iip) = 0.
        tau13pl(nx,j,iip) = 0.
  300   continue
      endif
      if (mbd.eq.0) then
        do 310 j = 1,nyr
        tau13pl(nxr+1,j,iip) = tau13pl(1,j,iip)
        tau23pl(nxr+1,j,iip) = tau23pl(1,j,iip)
  310   continue
      elseif (mbd.eq.1) then
        do 320 i = 1,nx
        tau23pl(i,1,iip) = 0.
        tau23pl(i,j3,iip) = 0.
  320   continue
      endif
      if ((lbd.eq.0).and.(mbd.eq.0)) then
        tau13pl(nxr+1,jr4,iip) = tau13pl(1,1,iip)
        tau23pl(nxr+1,jr4,iip) = tau23pl(1,1,iip)
      endif
  330 continue

      if(ifssd .eq. 1)then
c
c     write velocity field to ssd here
c
      call rwssd(1,iip,iqx,jqx,kqx,npssd,
     1                 vppl,v3pl,vtfpl,tautpl,tauppl,tau3pl)
      endif
  340 continue

      return
c
      end
