c $Log:   /pvcs.config/mc3dvv/src/plt3dv.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:00 1997   pvcs
c 
c *************************************************************
c *   PLT3DV
c *************************************************************
      subroutine plt3dv
C************BEGIN PROLOGUE********************************
C   PROGRAM NAME  xxxxx
C   DATE WRITTEN   88????   (YYMMDD)
C   REVISION DATE  xxxxxx   (YYMMDD)
C   AUTHOR  Carl W. Gable   (Los Alamos National Laboratory)
C   PURPOSE  Write output files
C   DESCRIPTION/COMMENTS
c
c     this routine saves data for 3-d vector or scalar data 
c     if ivelp3 is not zero, the velocity components at
c     every interface are saved on tape 12.
c     if idot3 is not zero, the full 3-d temperature
c     field values are written onto tape11.
c
c     fields are converted to single precision before output
c
c     I don't use the sngl function because that makes transport
c     from 64 bit to 32 bit more of a pain.
c
C   MODIFICATIONS
c cwg 3/15/93 Add output of particle positions.
c cwg 3/16/93 Eliminate use of 1d equivelence arrays for output
c             Use DPTOSP to convert to single precision output array
c
C**********END PROLOGUE************************************
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_ac1
      use module_a2
      use module_gia3
      use module_a3
      use module_spwork
c      use module_fieldout
      use module_prtcl
      real*4 stime,sdt
      character*25 t11root, t12root, t13root, t14root
      character*25 t11tail, t12tail, t13tail, t14tail
      data lu11, lu12, lu13, lu14 / 11, 12, 13, 14 /
      data icall11, icall12, icall13, icall14 / 1, 1, 1, 1 /

      t11root = 'tape11_'
      t12root = 'tape12_'
      t13root = 'tape13_'
      t14root = 'tape14_'
      t11tail = ' '
      t12tail = ' '
      t13tail = ' '
      t14tail = ' '

c
c     use single precision output (iotype = 1) on 32 bit machines
c     use double precision output (iotype = 2) on 64 bit machines
c
      call mig_mach(3,'sun***',rdum,rdum,idum,iotype)

      stime=time
      sdt=dt
      if (ivelp3.ne.0) then
         call namefile2(icall12,lu12,1,t12root,t12tail)
         call wheader (lu12,1)
         icall12 = icall12 + 1
         if(iotype .eq. 2)then
c            write (lu12) time,dt
            write (lu12) (((u(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            write (lu12) (((v(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            write (lu12) (((w(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         elseif(iotype .eq. 1)then
            write (lu12) stime,sdt
            call dptosp(inx,jnx,knx,u,spwk,idum)
            write (lu12) (((spwk(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            call dptosp(inx,jnx,knx,v,spwk,idum)
            write (lu12) (((spwk(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
            call dptosp(inx,jnx,knx,w,spwk,idum)
            write (lu12) (((spwk(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         endif
         close(lu12)
      endif
      if ((idot3.ne.0).and. (idot3 .ne. 3)) then
         call namefile2(icall11,lu11,1,t11root,t11tail)
         call wheader (lu11,1)
         icall11 = icall11 + 1
         if(iotype .eq. 2)then
            write (lu11) time,dt
            write (lu11) (((t(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         elseif(iotype .eq. 1)then
            write (lu11) stime,sdt
            call dptosp(inx,jnx,knx,t,spwk,idum)
            write (lu11) (((spwk(i,j,k),i=1,inx),j=1,jnx),k=1,knx)
         endif
         close(lu11)
      endif
      if (icx .gt. 2) then
         call namefile2(icall13,lu13,1,t13root,t13tail)
         call wheader (lu13,1)
         icall13 = icall13 + 1
         if(iotype .eq. 2)then
            write (lu13) time,dt
            write (lu13) (((c(i,j,k,1),i=1,icx),j=1,jcx),k=1,kcx)
         elseif(iotype .eq. 1)then
            write (lu13) stime,sdt
            call dptosp(icx,jcx,kcx,c,spwk,idum)
            write (lu13) (((spwk(i,j,k),i=1,icx),j=1,jcx),k=1,kcx)
         endif
         close(lu13)
      endif
c
c     output particle positions, increment icall on every
c     call to maintain one to one correspondence with
c     temp and velocity, but only output particle positions
c     when there are particles present.
c
      if (nps .gt. 0)then
         call namefile2(icall14,lu14,2,t14root,t14tail)
         call wheader (lu14,2)
         icall14 = icall14 + 1
         write(14,802) nps,icall14,stime
      do 110 kp=1,nps
       write(14,803) ipf(kp),jpf(kp),kpf(kp)
  110 continue
802   format(2i5,f10.6)
803   format(3i5)
      close(lu14)
      else
         icall14 = icall14 + 1
      endif
       
      return
      end
