c $Log:   /pvcs.config/mc3dvv/src/pttouv.F_a  $
c
c   Rev 1.3   Fri Jul 30 11:49:54 1999   lowman
c  Added prnt_last to common to correct printing bug detected
c  by intel compiler
c
c   Rev 1.2   Tue Oct 06 16:55:00 1998   lowman
cAdded calls to chvarx and chvary to correctly order Cartesian velocities
cAdded calls to userout for poloidal and toroidal energies using
croutines modified by PvK.
c
c   Rev 1.0   Mon Jul 14 14:22:06 1997   pvcs
c 
c *************************************************************
c *   PTTOUV
c *************************************************************
      subroutine pttouv(ipttype,ijob)
      use module_precision
c
c      transform from poloidal/toroidal field
c      to velocity in u and v.  Superimpose
c      plate velocity. Final output is still in spectral
c      space. Must still transform with ft2nrm.f
c
c
c  ipttype  =  0   combine toroidal and poloidal fields
c
c  ipttype  =  1   set toroidal part of solution to zero
c      
c  ipttype  =  2   set poloidal part of solution to zero
c
c  ijob = 0 superimpose plate and body force stress fields (when present)
c
c  ijob = 1 set plate field to 0, only transform density driven field
c
c  ijob = 2 set density driven field to 0, only transform plate field
c
      use module_param
      use module_giparam
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_a11
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a13
      use module_a20
      use module_a24
      use module_a25
      use module_a26
      use module_a30
      use module_viscom
      use module_pttouv
      real l, l2
      common /start1/ restrt, initlt, istart
      common /a8/ l2, l, vps, vts
      common /ptouserout/ pfac,tfac
#ifdef MPI
      include 'mpif.h'
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
c      sfact scales the kinetic energy to eliminate
c      dependence on box dimension or number of terms
c      in the Fourier expansion.
      sfact = (xl*yl)/float(nxr*nyr)
      if(ipttype .eq. 0)then
        pfac = one
        tfac = one
      elseif(ipttype .eq. 1)then
        pfac = one
        tfac = zero
      elseif(ipttype .eq. 2)then
        pfac = zero
        tfac = one
       endif
c
      if ((ibct.eq.2).and.(isurfv.lt.0).and.(ifsavepl.eq.1)) then
c
        if(ijob .eq. 2)then
          ppfac = zero
          ttfac = zero
        else
          ppfac = pfac
          ttfac = tfac
        endif
c       ttfac = 0.0d0
c       tfac = 0.0d0
c
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              u(i,j,ll) = vp(i-ixstar+1,j-iystar+1,ll)*ppfac
              v(i,j,ll) = vtf(i-ixstar+1,j-iystar+1,ll)*ttfac
              w(i,j,ll) = v3(i-ixstar+1,j-iystar+1,ll)*ppfac
            enddo
          enddo
        enddo

        if(ijob .ne. 1)then 

          if(ifssd .eq. 1)then
             rewind(50)
          endif

          do 45 np = 1,nplate
            do 45 ixy = 1,2
              if(ixy .eq. 1)then
                im1 = 1
              else
                im1 = 0
              endif
              ifield = 2*np-im1
c
c       read from ssd here
c       with ssd irec is the record to read
c       without ssd it is the index of the superposition array
              if(ifssd .eq. 1)then
                irec = 1
                call rwssd(-2,ifield,iqx,jqx,kqx,npssd,
     1                 vppl,v3pl,vtfpl,tautpl,tauppl,tau3pl)
              elseif(ifssd .eq. 0)then
                irec = ifield
              endif
c
c       *****Superimpose fields for dynamic plate calculation*****
c
              do 40 ll = 1,nz
              do 40 j = iystar,iystop
              do 40 i = ixstar,ixstop
  40    u(i,j,ll) = u(i,j,ll)+vpl(ixy,np)*vppl(i,j,ll,irec)*pfac
              do 42 ll = 1,nz
              do 42 j = iystar,iystop
              do 42 i = ixstar,ixstop
  42    v(i,j,ll) = v(i,j,ll)+vpl(ixy,np)*vtfpl(i,j,ll,irec)*tfac
              do 290 ll = 1,nz
              do 290 j = iystar,iystop
              do 290 i = ixstar,ixstop
  290   w(i,j,ll) = w(i,j,ll)+vpl(ixy,np)*v3pl(i,j,ll,irec)*pfac
c
c       **********************************************************
c
  45        continue

          endif

c      calculate power spectrum for output
          call userout('pttouv-1')
c
c      convert pol-tor to Cartesian spectral
c
          do 50 ll = 1,nz
          do 50 j = iystar,iystop
          do 50 i = ixstar,ixstop
          t1 = u(i,j,ll)
          t2 = v(i,j,ll)
          u(i,j,ll) = fli(i,j)*t1+flj(i,j)*t2
  50      v(i,j,ll) = flj(i,j)*t1-fli(i,j)*t2
      else
c
c     not dynamic plate motion
c
          do 58 ll = 1,nz
          do 58 j = iystar,iystop
          do 58 i = ixstar,ixstop
   58     w(i,j,ll) = v3(i-ixstar+1,j-iystar+1,ll)

          call userout('pttouv-2')

          do 55 ll = 1,nz
          do 55 j = iystar,iystop
          do 55 i = ixstar,ixstop
          u(i,j,ll) = pfac*fli(i,j)*vp(i-ixstar+1,j-iystar+1,ll)+
     1                tfac*flj(i,j)*vtf(i-ixstar+1,j-iystar+1,ll)
          v(i,j,ll) = pfac*flj(i,j)*vp(i-ixstar+1,j-iystar+1,ll)-
     1                tfac*fli(i,j)*vtf(i-ixstar+1,j-iystar+1,ll)
   55     continue
      endif
c
c moved outside if/else block by s.d.k.
c first call mpicomm 
c
#ifdef MPI
      impi = 1
      call mpicomm(impi,nx,j3,nz,w,inx,jnx,knx)
#endif
c originally, there were two chvar calls within
c the above if then else.  I moved the chvar here
c and put the mpi call before it
      ichvar = 1  
      call chvar (w,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
c
c      With periodic b.c. one must account for the
c      l = 0 term in the fourier expansion. This
c      term is the average value of the velocity
c      aNd only occurs when the imposed
c      surface velocity has a non-zero
c      average.
c
c   this is not right for layered viscosity
c
      if (ibct.eq.3) then
        if (((lbd.eq.0).and.(mbd.eq.0)).and.((fftvx(1,1).ne.0).or.(fftvy
     1  (1,1).ne.0))) then
          if (ivistype.ne.0) then
            write (6,100)
            stop
          endif
          if (ibcb.eq.1) then
            do 65 ll = 1,nz
            u(1,1,ll) = fftvx(1,1)
            v(1,1,ll) = fftvy(1,1)
   65       continue
          elseif (ibcb.eq.2) then
            gradu = fftvx(1,1)/float(nz-1)
            gradv = fftvy(1,1)/float(nz-1)
            do 70 ll = 1,nz
            fll = float(ll-1)
            u(1,1,ll) = fll*gradu
            v(1,1,ll) = fll*gradv
   70       continue
          endif
        endif
      endif
c
c JPL 6/98
c
c  At this point all four matrices are
c  holding coefficients in an order analagous to temperature. For example, a CxCy 
c  temperature mode (at this point) appears to be
c  driving a CxCy u and v mode. However, the modes
c  should, in fact, correspond as follows. 
c
c
c  Temp    U      V      W
c
c  CxCy   SxCy   CxSy   CxCy
c
c  SxCy  -CxCy   SxSy   SxCy 
c
c  CxSy   SxSy  -CxCy   CxSy
c
c  SxSy  -CxSy  -SxCy   SxSy
c
c
c here be the other mpicomm call (used to be in flow)
#ifdef MPI
        impi = 1
        call mpicomm(impi,nx,j3,nz,u,inx,jnx,knx)
        if (j3.gt.1) call mpicomm(impi,nx,j3,nz,v,inx,jnx,knx)
#endif
      
      if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
        ichvar=-1 
        call chvary(u,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        call chvarx(v,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        do ll = 1,nz
        do  j = 2,nyr
        do  i = 2,nxr
         w(i,j,ll)     = -w(i,j,ll)     
        enddo
        enddo
        enddo
      endif

      return
c
   80 format (i8,e14.7,/,
     1"PT coupling fac.
     2   z        aket        akep       akephv    ake")
   90 format (11x,5(e10.3,2x))
  100 format 
     1 ("input error in pttouv: variable viscosity not set for plates")
299     format(i3,12e10.3)
      end
