c $Log:   /pvcs.config/mc3dvv/src/relax_nr.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:10 1997   pvcs
c 
c *************************************************************
c *   RELAX_NR
c * 
c *   Bunch of subroutines from numerical
c *   recipes to relax a 2-point boundary
c *   value problem...
c *************************************************************
      subroutine pinvs(ie1,ie2,je1,jsf,jc1,k,c,nci,ncj,nck,s,nsi,nsj)
      use module_precision
c
c     diagonalize the square subsection of the S matrix, and store
c     the recursion coefficients in C; used internally by SOLVDE.
c
      parameter(nmax=10)
      dimension c(nci,ncj,nck),s(nsi,nsj),pscl(nmax),indxr(nmax)
      je2=je1+ie2-ie1
      js1=je2+1
c
c     implicit pivoting
c
      do 12 i=ie1,ie2
        big=zero
        do 11 j=je1,je2
        big=max(abs(s(i,j)),big)
   11   continue
c cg        if(big.eq.zero) print 99
c cg   99   format('  singular matrix, row all 0')
        pscl(i)=one/big
        indxr(i)=0
   12 continue
      do 18 id=ie1,ie2
        piv=zero
        do 14 i=ie1,ie2
c
c     find pivot element
c
          if(indxr(i).eq.0) then
            big=zero
            do 13 j=je1,je2
              tmp=abs(s(i,j))
              if(tmp .gt. big)then
                  jp=j
                  big=tmp
              endif
   13       continue
            tmp=big*pscl(i)
            if(tmp.gt.piv) then
              ipiv=i
              jpiv=jp
              piv=tmp
            endif
          endif
   14   continue
c
c     in place reduction. save column ordering
c
        indxr(ipiv)=jpiv
        pivinv=one/s(ipiv,jpiv)
c
c     normalize pivot row
c
        do 15 j=je1,jsf
          s(ipiv,j)=s(ipiv,j)*pivinv
   15   continue
        s(ipiv,jpiv)=one
c
c     reduce nonpivot elements in column
c
        do 17 i=ie1,ie2
          if(indxr(i).ne.jpiv) then
            if(s(i,jpiv).ne.zero) then
              dum=s(i,jpiv)
              do 16 j=je1,jsf
                s(i,j)=s(i,j)-dum*s(ipiv,j)
   16         continue
              s(i,jpiv)=zero
            endif
          endif
   17   continue
   18 continue
c
c     sort and store unreduced coefficients
c
      jcoff=jc1-js1
      icoff=ie1-je1
      do 21 i=ie1,ie2
        irow=indxr(i)+icoff
        do 19 j=js1,jsf
          c(irow,j+jcoff,k)=s(i,j)
   19   continue
   21 continue
      return
      end
      subroutine red(iz1,iz2,jz1,jz2,jm1,jm2,jmf,ic1,jc1,jcf,kc,
     .                   c,nci,ncj,nck,s,nsi,nsj)
      use module_precision
c
c     reduce columns jz1-jz2 of the s matrix using previous results
c     as stored in the c matrix. only columns jm1-jm2,
c     jmf are affected by the prior results. red is used internally
c     by solvede
c
      dimension c(nci,ncj,nck),s(nsi,nsj)
      loff=jc1-jm1
      ic=ic1
c
c     loop over columns to be zeroed
c
      do 14 j=jz1,jz2
c
c    loop over columns altered
c
        do 12 l=jm1,jm2
          vx=c(ic,l+loff,kc)
c
c     loop over rows
c
          do 11 i=iz1,iz2
            s(i,l)=s(i,l)-s(i,j)*vx
   11     continue
   12   continue
        vx=c(ic,jcf,kc)
c
c     plus final element
c
        do 13 i=iz1,iz2
          s(i,jmf)=s(i,jmf)-s(i,j)*vx
   13   continue
        ic=ic+1
   14 continue
      return
      end
      subroutine pinvs4i(ie1,ie2,je1,jsf,jc1,k,c,nci,ncj,nck,s,nsi,nsj)
      use module_precision
c cg
c      special version only for interior points of poloidal solution
c      for this case je1=3 je2=6 ie1=1 ie2=4 jc1=1
c      jsf=9
c cg
c
c     diagonalize the square subsection of the S matrix, and store
c     the recursion coefficients in C; used internally by SOLVDE.
c
      parameter(nmax=10)
      dimension c(nci,ncj,nck),s(nsi,nsj),pscl(nmax),indxr(nmax)
c      dimension tmpv(4)
      je2=6
      js1=7
      jcoff=-6
      icoff=-2
c
c     implicit pivoting
c
      do 12 i=ie1,ie2
        big=zero
        big=max(abs(s(i,3)),abs(s(i,4)),abs(s(i,5)),abs(s(i,6)),big)
        pscl(i)=one/big
        indxr(i)=0
   12 continue
      do 18 id=ie1,ie2
        piv=zero
c
c     find pivot element
c
          if(indxr(1).eq.0) then
c
            big=zero
           tmp1=abs(s(1,3))
           tmp2=abs(s(1,4))
           tmp3=abs(s(1,5))
           tmp4=abs(s(1,6))
           big=max(tmp1,tmp2,tmp3,tmp4,big)
           if(big .eq. tmp4)jp=6
         if(big .eq. tmp3)jp=5
           if(big .eq. tmp2)jp=4
           if(big .eq. tmp1)jp=3
c
            tmp=big*pscl(1)
            if(tmp.gt.piv) then
              ipiv=1
              jpiv=jp
              piv=tmp
            endif
          endif
          if(indxr(2).eq.0) then
c
            big=zero
           tmp1=abs(s(2,3))
           tmp2=abs(s(2,4))
           tmp3=abs(s(2,5))
           tmp4=abs(s(2,6))
           big=max(tmp1,tmp2,tmp3,tmp4,big)
           if(big .eq. tmp4)jp=6
           if(big .eq. tmp3)jp=5
           if(big .eq. tmp2)jp=4
           if(big .eq. tmp1)jp=3
            tmp=big*pscl(2)
            if(tmp.gt.piv) then
              ipiv=2
              jpiv=jp
              piv=tmp
            endif
          endif
          if(indxr(3).eq.0) then
c
            big=zero
           tmp1=abs(s(3,3))
           tmp2=abs(s(3,4))
           tmp3=abs(s(3,5))
           tmp4=abs(s(3,6))
           big=max(tmp1,tmp2,tmp3,tmp4,big)
           if(big .eq. tmp4)jp=6
           if(big .eq. tmp3)jp=5
           if(big .eq. tmp2)jp=4
           if(big .eq. tmp1)jp=3
            tmp=big*pscl(3)
            if(tmp.gt.piv) then
              ipiv=3
              jpiv=jp
              piv=tmp
            endif
          endif
          if(indxr(4).eq.0) then
c
            big=zero
           tmp1=abs(s(4,3))
           tmp2=abs(s(4,4))
           tmp3=abs(s(4,5))
           tmp4=abs(s(4,6))
           big=max(tmp1,tmp2,tmp3,tmp4,big)
           if(big .eq. tmp4)jp=6
           if(big .eq. tmp3)jp=5
           if(big .eq. tmp2)jp=4
           if(big .eq. tmp1)jp=3
            tmp=big*pscl(4)
            if(tmp.gt.piv) then
              ipiv=4
              jpiv=jp
              piv=tmp
            endif
          endif
c
c     in place reduction. save column ordering
c
        indxr(ipiv)=jpiv
        pivinv=one/s(ipiv,jpiv)
c
c     normalize pivot row
c
          s(ipiv,3)=s(ipiv,3)*pivinv
          s(ipiv,4)=s(ipiv,4)*pivinv
          s(ipiv,5)=s(ipiv,5)*pivinv
          s(ipiv,6)=s(ipiv,6)*pivinv
          s(ipiv,7)=s(ipiv,7)*pivinv
          s(ipiv,8)=s(ipiv,8)*pivinv
          s(ipiv,9)=s(ipiv,9)*pivinv
        s(ipiv,jpiv)=one
c
c     reduce nonpivot elements in column
c
          if((indxr(1).ne.jpiv).and.(s(1,jpiv).ne.zero))then
              dum=s(1,jpiv)
                s(1,3)=s(1,3)-dum*s(ipiv,3)
                s(1,4)=s(1,4)-dum*s(ipiv,4)
                s(1,5)=s(1,5)-dum*s(ipiv,5)
                s(1,6)=s(1,6)-dum*s(ipiv,6)
                s(1,7)=s(1,7)-dum*s(ipiv,7)
                s(1,8)=s(1,8)-dum*s(ipiv,8)
                s(1,9)=s(1,9)-dum*s(ipiv,9)
              s(1,jpiv)=zero
          endif
          if((indxr(2).ne.jpiv).and.(s(2,jpiv).ne.zero))then
              dum=s(2,jpiv)
                s(2,3)=s(2,3)-dum*s(ipiv,3)
                s(2,4)=s(2,4)-dum*s(ipiv,4)
                s(2,5)=s(2,5)-dum*s(ipiv,5)
                s(2,6)=s(2,6)-dum*s(ipiv,6)
                s(2,7)=s(2,7)-dum*s(ipiv,7)
                s(2,8)=s(2,8)-dum*s(ipiv,8)
                s(2,9)=s(2,9)-dum*s(ipiv,9)
              s(2,jpiv)=zero
          endif
          if((indxr(3).ne.jpiv).and.(s(3,jpiv).ne.zero))then
              dum=s(3,jpiv)
                s(3,3)=s(3,3)-dum*s(ipiv,3)
                s(3,4)=s(3,4)-dum*s(ipiv,4)
                s(3,5)=s(3,5)-dum*s(ipiv,5)
                s(3,6)=s(3,6)-dum*s(ipiv,6)
                s(3,7)=s(3,7)-dum*s(ipiv,7)
                s(3,8)=s(3,8)-dum*s(ipiv,8)
                s(3,9)=s(3,9)-dum*s(ipiv,9)
              s(3,jpiv)=zero
          endif
          if((indxr(4).ne.jpiv).and.(s(4,jpiv).ne.zero)) then
              dum=s(4,jpiv)
                s(4,3)=s(4,3)-dum*s(ipiv,3)
                s(4,4)=s(4,4)-dum*s(ipiv,4)
                s(4,5)=s(4,5)-dum*s(ipiv,5)
                s(4,6)=s(4,6)-dum*s(ipiv,6)
                s(4,7)=s(4,7)-dum*s(ipiv,7)
                s(4,8)=s(4,8)-dum*s(ipiv,8)
                s(4,9)=s(4,9)-dum*s(ipiv,9)
              s(4,jpiv)=zero
          endif
   18 continue
c
c     sort and store unreduced coefficients
c
c
        irow=indxr(1)+icoff
          c(irow,1,k)=s(1,7)
          c(irow,2,k)=s(1,8)
          c(irow,3,k)=s(1,9)
        irow=indxr(2)+icoff
          c(irow,1,k)=s(2,7)
          c(irow,2,k)=s(2,8)
          c(irow,3,k)=s(2,9)
        irow=indxr(3)+icoff
          c(irow,1,k)=s(3,7)
          c(irow,2,k)=s(3,8)
          c(irow,3,k)=s(3,9)
        irow=indxr(4)+icoff
          c(irow,1,k)=s(4,7)
          c(irow,2,k)=s(4,8)
          c(irow,3,k)=s(4,9)
c
      return
      end
      subroutine red4i(iz1,iz2,jz1,jz2,jm1,jm2,jmf,ic1,jc1,jcf,kc,
     .                   c,nci,ncj,nck,s,nsi,nsj)
      use module_precision
c cg
c       special version of red for internal points of poloidal soln.
c
c       jc1=1, jm1=3, loff=-2, ic1=3, ic=3, jz1=1, jz2=2, jm1=3, jm2=4
c       iz1=1, iz2=4
c
c cg
c
c     reduce columns jz1-jz2 of the s matrix using previous results
c     as stored in the c matrix. only columns jm1-jm2,
c     jmf are affected by the prior results. red is used internally
c     by solvede
c
      dimension c(nci,ncj,nck),s(nsi,nsj)
      loff=-2
      ic=3
c
c
          vx1=c(3,1,kc)
          vx2=c(3,2,kc)
          vx3=c(3,jcf,kc)
c
            s(1,3)=s(1,3)-s(1,1)*vx1
            s(2,3)=s(2,3)-s(2,1)*vx1
            s(3,3)=s(3,3)-s(3,1)*vx1
            s(4,3)=s(4,3)-s(4,1)*vx1
c
c
            s(1,4)=s(1,4)-s(1,1)*vx2
            s(2,4)=s(2,4)-s(2,1)*vx2
            s(3,4)=s(3,4)-s(3,1)*vx2
            s(4,4)=s(4,4)-s(4,1)*vx2
c
          s(1,jmf)=s(1,jmf)-s(1,1)*vx3
          s(2,jmf)=s(2,jmf)-s(2,1)*vx3
          s(3,jmf)=s(3,jmf)-s(3,1)*vx3
          s(4,jmf)=s(4,jmf)-s(4,1)*vx3
c
          vx1=c(4,1,kc)
          vx2=c(4,2,kc)
          vx3=c(4,jcf,kc)
c
            s(1,3)=s(1,3)-s(1,2)*vx1
            s(2,3)=s(2,3)-s(2,2)*vx1
            s(3,3)=s(3,3)-s(3,2)*vx1
            s(4,3)=s(4,3)-s(4,2)*vx1
c
c
            s(1,4)=s(1,4)-s(1,2)*vx2
            s(2,4)=s(2,4)-s(2,2)*vx2
            s(3,4)=s(3,4)-s(3,2)*vx2
            s(4,4)=s(4,4)-s(4,2)*vx2
c
          s(1,jmf)=s(1,jmf)-s(1,2)*vx3
          s(2,jmf)=s(2,jmf)-s(2,2)*vx3
          s(3,jmf)=s(3,jmf)-s(3,2)*vx3
          s(4,jmf)=s(4,jmf)-s(4,2)*vx3
      return
      end
      subroutine bksub(ne,nb,jf,k1,k2,c,nci,ncj,nck)
      use module_precision
c
c     back substitution used by solvde
c
      dimension c(nci,ncj,nck)
      nbf=ne-nb
c
c     use recurrence relations to eliminate remaining dependences
c
      do 13 k=k2,k1,-1
        kp=k+1
        do 12 j=1,nbf
          xx=c(j,jf,kp)
          do 11 i=1,ne
            c(i,jf,k)=c(i,jf,k)-c(i,j,k)*xx
   11     continue
   12   continue
   13 continue
c
c     reorder corrections to be in column 1
c
      do 16 k=k1,k2
      kp=k+1
        do 14 i=1,nb
          c(i,1,k)=c(i+nbf,jf,k)
   14   continue
        do 15 i=1,nbf
          c(i+nb,1,k)=c(i,jf,kp)
   15   continue
   16 continue
      return
      end
      subroutine bksb4i(ne,nb,jf,k1,k2,c,nci,ncj,nck)
      use module_precision
c cg
c      special version for poloidal solution
c
c      ne=4, nb=2, jf=3, nci=4, ncj=3, nbf=2
c
c
c     back substitution used by solvde
c
      dimension c(nci,ncj,nck)
      nbf=ne-nb
c
c     use recurrence relations to eliminate remaining dependences
c
      do 13 k=k2,k1,-1
        kp=k+1
c cg          xx=c(1,3,kp)
            c(1,3,k)=c(1,3,k)-c(1,1,k)*c(1,3,kp)
            c(2,3,k)=c(2,3,k)-c(2,1,k)*c(1,3,kp)
            c(3,3,k)=c(3,3,k)-c(3,1,k)*c(1,3,kp)
            c(4,3,k)=c(4,3,k)-c(4,1,k)*c(1,3,kp)
c cg          xx=c(2,3,kp)
            c(1,3,k)=c(1,3,k)-c(1,2,k)*c(2,3,kp)
            c(2,3,k)=c(2,3,k)-c(2,2,k)*c(2,3,kp)
            c(3,3,k)=c(3,3,k)-c(3,2,k)*c(2,3,kp)
            c(4,3,k)=c(4,3,k)-c(4,2,k)*c(2,3,kp)
   13 continue
c
c     reorder corrections to be in column 1
c
      do 16 k=k1,k2
      kp=k+1
          c(1,1,k)=c(3,3,k)
          c(2,1,k)=c(4,3,k)
c
          c(3,1,k)=c(1,3,kp)
          c(4,1,k)=c(2,3,kp)
   16 continue
      return
      end
