c $Log:   /pvcs.config/mc3dvv/src/res.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:10 1997   pvcs
c 
c *************************************************************
c *   RES
c *
c *   Calculate residual formed by the estimate YPRIME to the
c *   differential equation F(YPRIME,Y,T) = 0 at time T.
c *
c *   PvK 950801
c *************************************************************
      subroutine res(tdaspk,y,yprime,cj,ddelta,ires,rpar,ipar)
      use module_precision
      use module_a2
      use module_a3
      use module_gia3
      use module_a77
      use module_param
      use module_giparam
      dimension y(*),yprime(*),ddelta(*),rpar(*),ipar(*)
      common /ijc/ ijcycle
      save ifirst,told,tcrash,tinc
      data ifirst,told/0,0d0/
      data tcrash,tinc/3600d0,3600d0/

c >>>> To keep things working in output!
c     write(6,'(''RES: '',3f12.3)') tdaspk,td2,time
c >>>>
      time = tdaspk
      norder = ipar(10)
      if (ifirst.eq.0.or.tdaspk.gt.told) then
         if (ifirst.eq.1) then
            icycle = icycle+1
            ijcycle = icycle
         endif
         call userout("heat")
         ifirst = 1
c        tznu = calnus(norder,1)
c        vrms = calvrms(1)

c        write(6,'(''RES '',2f12.5,f7.2,2f12.7)') 
c    v      tdaspk,told,seconds,tznu,vrms
c        *** Calculate velocity
         if (isolve .eq. 5) then
c          *** Define velocity using analytical expression
           call vofxyz
         else
           if (kchem .eq. 0)then
              call flow
           else
              call flow_layer
           endif
c          *** Average velocities to force divergence on cell faces to zero
c          *** (use advctd as a temporary work array)
           call velprm (u,v,advctd,inx,jnx,knx)
           call userout("flow")
         endif
         told = tdaspk
      endif

      if (ny.eq.2) then
c        *** 2-D ***
         call res2d(tdaspk,y,yprime,cj,ddelta,itx,jtx,ktx,rpar,
     v              u,v,w,inx,jnx,knx,norder)
      else 
c        *** 3-D ***
         call res3d(tdaspk,y,yprime,cj,ddelta,itx,jtx,ktx,rpar,
     v              u,v,w,inx,jnx,knx,norder)
      endif

      return
      end

