c $Log:   /pvcs.config/mc3dvv/src/res2d.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:12 1997   pvcs
c 
c *************************************************************
c *   RES2D
c *************************************************************
      subroutine res2d(t,y,yprime,cj,ddelta,itx,jtx,ktx,rpar,
     v           u,v,w,inx,jnx,knx,norder)
      use module_precision
      use module_gia3
      use module_a3
      dimension y(itx,jtx,ktx),yprime(itx,jtx,ktx),ddelta(itx,jtx,ktx)
      dimension rpar(*),u(inx,jnx,knx),v(inx,jnx,knx)
      dimension w(inx,jnx,knx)
c     *** First order derivatives (w1..)
      parameter(w121=0.5)
      parameter(w141=2d0/3d0,w142=-1d0/12d0)
      parameter(w161=3d0/4d0,w162=-3d0/20d0,w163=1d0/60d0)
      parameter(w181=4d0/5d0,w182=-1d0/5d0 ,w183=4d0/105d0,
     v                                      w184=-1d0/280d0)
c     *** Second order derivatives (w2..)
      parameter(w220=-2d0,       w221=1.0)
      parameter(w240=-5d0/2d0,   w241=4d0/3d0,w242=-1d0/12d0)
      parameter(w260=-49d0/18d0, w261=3d0/2d0,w262=-3d0/20d0
     v                                       ,w263=1d0/90d0)
      parameter(w280=-205d0/72d0,w281=8d0/5d0,w282=-1d0/5d0 ,
     v                                        w283=8d0/315d0,
     v                                        w284=-1d0/560d0)
    

      dx = xl/(nx-1)
      dz = 1d0/(nz-1)
      oneh2x = 1d0/(dx*dx)
      oneh2z = 1d0/(dz*dz)
      onehx = 1d0/dx
      onehz = 1d0/dz
      halfhx = 1d0/(2*dx)
      halfhz = 1d0/(2*dz)
      twelvehx = 1d0/(12d0*dx)
      twelvehz = 1d0/(12d0*dz)
      twelveh2x = 1d0/(12d0*dx*dx)
      twelveh2z = 1d0/(12d0*dz*dz)
      sixnhx    = 1d0/(60d0*dx)
      sixnhz    = 1d0/(60d0*dz)
      sixnh2x   = 1d0/(180d0*dx*dx)
      sixnh2z   = 1d0/(180d0*dz*dz)

c *************************************************************
c *   BOUNDARY CONDITIONS
c *************************************************************
      if (norder.eq.2) then
         do k=1,ktx
c           *** Neumann
            y(1,1,k) = y(3,1,k)
            y(itx,1,k) = y(itx-2,1,k)
         enddo
      else if (norder.eq.4) then
         do k=1,ktx
c           *** Neumann
            y(1,1,k) = y(5,1,k)
            y(2,1,k) = y(4,1,k)
            y(itx,1,k) = y(itx-4,1,k)
            y(itx-1,1,k) = y(itx-3,1,k)
         enddo
         do i=1,itx
c           *** Dirichlet
            y(i,1,1) = 2d0-y(i,1,3)
            y(i,1,ktx) = 0d0-y(i,1,ktx-2)
         enddo
      else if (norder.eq.6) then
         do k=1,ktx
c           *** Neumann
            y(1,1,k) = y(7,1,k)
            y(2,1,k) = y(6,1,k)
            y(3,1,k) = y(5,1,k)
            y(itx,1,k) = y(itx-6,1,k)
            y(itx-1,1,k) = y(itx-5,1,k)
            y(itx-2,1,k) = y(itx-4,1,k)
         enddo
         do i=1,itx
c           *** Dirichlet
            y(i,1,1) = 2d0-y(i,1,5)
            y(i,1,2) = 2d0-y(i,1,4)
            y(i,1,ktx) = 0d0-y(i,1,ktx-4)
            y(i,1,ktx-1) = 0d0-y(i,1,ktx-3)
         enddo
      else if (norder.eq.8) then
         do k=1,ktx
c           *** Neumann
            y(1,1,k) = y(9,1,k)
            y(2,1,k) = y(8,1,k)
            y(3,1,k) = y(7,1,k)
            y(4,1,k) = y(6,1,k)
            y(itx,1,k) = y(itx-8,1,k)
            y(itx-1,1,k) = y(itx-7,1,k)
            y(itx-2,1,k) = y(itx-6,1,k)
            y(itx-3,1,k) = y(itx-5,1,k)
         enddo
         do i=1,itx
c           *** Dirichlet
            y(i,1,1) = 2d0-y(i,1,7)
            y(i,1,2) = 2d0-y(i,1,6)
            y(i,1,3) = 2d0-y(i,1,5)
            y(i,1,ktx) = 0d0-y(i,1,ktx-6)
            y(i,1,ktx-1) = 0d0-y(i,1,ktx-5)
            y(i,1,ktx-2) = 0d0-y(i,1,ktx-4)
         enddo
      else
         write(6,*) 'PERROR(res2d): norder is not 2,4,6,8'
         write(6,*) '                   norder = ',norder
         stop
      endif

c *************************************************************
c *   *** Form residual
c *************************************************************
      jp = 1
      do k=1,ktx
         kp = k-norder/2+1
         do i=1,itx
            ip = i-norder/2
c           *** ORDER 2
            if (norder.eq.2) then
               if (k.eq.1.or.k.eq.ktx) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else if (i.eq.1.or.i.eq.itx) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else
                  d2tdx = y(i-1,1,k) - 2*y(i,1,k) + y(i+1,1,k)
                  d2tdx = d2tdx * oneh2x
                  d2tdz = y(i,1,k-1) - 2*y(i,1,k) + y(i,1,k+1)
                  d2tdz = d2tdz * oneh2z
                  dtdx  = y(i+1,1,k)-y(i-1,1,k)
                  dtdx  = halfhx*dtdx
                  dtdz  = y(i,1,k+1)-y(i,1,k-1)
                  dtdz  = halfhz*dtdz

                  tprime = d2tdx+d2tdz-u(ip,jp,kp)*dtdx-w(ip,jp,kp)*dtdz
                  ddelta(i,1,k) = yprime(i,1,k) - tprime
               endif

c           *** ORDER 4
            else if (norder.eq.4) then
               if (k.le.2.or.k.ge.ktx-1) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else if (i.le.2.or.i.ge.itx-1) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else
                 d2tdx = w242*y(i+2,1,k) + w241*y(i+1,1,k) + 
     v                   w240*y(i,1,k) +
     v                   w241*y(i-1,1,k) + w242*y(i-2,1,k)
                 d2tdx = d2tdx * oneh2x
                 d2tdz = w242*y(i,1,k+2) + w241*y(i,1,k+1) + 
     v                   w240*y(i,1,k) +
     v                   w241*y(i,1,k-1) + w242*y(i,1,k-2)
                 d2tdz = d2tdz * oneh2z

                 dtdx = w142*y(i+2,1,k)+w141*y(i+1,1,k)-w141*y(i-1,1,k)  
     v                  -w142*y(i-2,1,k)
                 dtdx = dtdx * onehx
                 dtdz = w142*y(i,1,k+2)+w141*y(i,1,k+1)-w141*y(i,1,k-1)
     v                  -w142*y(i,1,k-2)
                 dtdz = dtdz * onehz
                 tprime = d2tdx+d2tdz-u(ip,jp,kp)*dtdx-w(ip,jp,kp)*dtdz
                 ddelta(i,1,k) = yprime(i,1,k) - tprime
               endif

c           *** ORDER 6
            else if (norder.eq.6) then
               if (k.le.3.or.k.ge.ktx-2) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else if (i.le.3.or.i.ge.itx-2) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else
                 d2tdx = 2*y(i+3,1,k) -27*y(i+2,1,k) + 270*y(i+1,1,k) - 
     v            490*y(i,1,k)+270*y(i-1,1,k)-27*y(i-2,1,k)+2*y(i-3,1,k)
                 d2tdx = d2tdx * sixnh2x
                 d2tdz = 2*y(i,1,k+3) -27*y(i,1,k+2) + 270*y(i,1,k+1) -
     v            490*y(i,1,k)+270*y(i,1,k-1)-27*y(i,1,k-2)+2*y(i,1,k-3)
                 d2tdz = d2tdz * sixnh2z
                 dtdx=y(i+3,1,k)-9*y(i+2,1,k)+45*y(i+1,1,k)-
     v             45*y(i-1,1,k)+ 9*y(i-2,1,k) - y(i-3,1,k)
                 dtdz = y(i,1,k+3) -9*y(i,1,k+2) + 45*y(i,1,k+1) -
     v             45*y(i,1,k-1)+ 9*y(i,1,k-2) - y(i,1,k-3)
c                write(6,'(4f12.7)') dtdx,y(i+1,1,k)-y(i-1,1,k),dtdz,
c    v                    y(i,1,k+1)-y(i,1,k-1)

                 dtdx = dtdx * sixnhx
                 dtdz = dtdz * sixnhz

                 dtdxl = halfhx*(y(i+1,1,k)-y(i-1,1,k))
                 dtdzl = halfhz*(y(i,1,k+1)-y(i,1,k-1))
c                write(6,'(4f12.7)') dtdx,dtdxl,dtdz,dtdzl
                 d2tdxl = oneh2x*(y(i+1,1,k)-2d0*y(i,1,k)+y(i-1,1,k))
                 d2tdzl = oneh2z*(y(i,1,k+1)-2d0*y(i,1,k)+y(i,1,k-1))
                 tprime = d2tdx+d2tdz-u(ip,jp,kp)*dtdx-w(ip,jp,kp)*dtdz
c                write(6,100) i,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp),
c    v              dtdz*w(ip,jp,kp),dtdzl*w(ip,jp,kp),d2tdx,d2tdxl,
c    v              d2tdz,d2tdzl,u(ip,jp,kp),w(ip,jp,kp)

                 ddelta(i,1,k) = yprime(i,1,k) - tprime
c                write(6,*)

               endif

c          *** ORDER 8
           else if (norder.eq.8) then
               if (k.le.4.or.k.ge.ktx-3) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else if (i.le.4.or.i.ge.itx-3) then
                  ddelta(i,1,k) = yprime(i,1,k)
               else
                 d2tdx = w284*y(i+4,1,k) + w283*y(i+3,1,k)
     v             + w282*y(i+2,1,k) + w281*y(i+1,1,k) + w280*y(i,1,k)
     v             + w281*y(i-1,1,k) + w282*y(i-2,1,k) + w283*y(i-3,1,k)
     v             + w284*y(i-4,1,k)
                 d2tdx = d2tdx * oneh2x
                 d2tdz = w284*y(i,1,k+4) + w283*y(i,1,k+3)
     v            + w282*y(i,1,k+2)
     v            + w281*y(i,1,k+1) + w280*y(i,1,k)   + w281*y(i,1,k-1)
     v            + w282*y(i,1,k-2) + w283*y(i,1,k-3) + w284*y(i,1,k-4)
                 d2tdz = d2tdz * oneh2x

                 dtdx = w184*y(i+4,1,k) + w183*y(i+3,1,k)
     v             + w182*y(i+2,1,k)
     v             + w181*y(i+1,1,k) - w181*y(i-1,1,k) - w182*y(i-2,1,k)
     v             - w183*y(i-3,1,k) - w184*y(i-4,1,k)
                 dtdx = dtdx * onehx
                 dtdz = w184*y(i,1,k+4) + w183*y(i,1,k+3)
     v             + w182*y(i,1,k+2)
     v             + w181*y(i,1,k+1) - w181*y(i,1,k-1) - w182*y(i,1,k-2)
     v             - w183*y(i,1,k-3) - w184*y(i,1,k-4)
                 dtdz = dtdz * onehz

c                write(6,'(4f12.7)') dtdx,y(i+1,1,k)-y(i-1,1,k),dtdz,
c    v                    y(i,1,k+1)-y(i,1,k-1)
c                dtdxl = halfhx*(y(i+1,1,k)-y(i-1,1,k))
c                dtdzl = halfhz*(y(i,1,k+1)-y(i,1,k-1))
c                write(6,'(4f12.7)') dtdx,dtdxl,dtdz,dtdzl
c                d2tdxl=oneh2x*(y(i+1,1,k)-2d0*y(i,1,k)+y(i-1,1,k))
c                d2tdzl=oneh2z*(y(i,1,k+1)-2d0*y(i,1,k)+y(i,1,k-1))
c                write(6,100) i,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp),
c    v              dtdz*w(ip,jp,kp),
c    v              dtdzl*w(ip,jp,kp),d2tdx,d2tdxl,d2tdz,d2tdzl,
c    v              u(ip,jp,kp),w(ip,jp,kp)

                 tprime = d2tdx+d2tdz-u(ip,jp,kp)*dtdx-w(ip,jp,kp)*dtdz 
                 ddelta(i,1,k) = yprime(i,1,k) - tprime

               endif
            endif
         enddo
      enddo
100   format(2i5,5(2f12.7,2x))

      return
      end

