c $Log:   /pvcs.config/mc3dvv/src/res3d.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:12 1997   pvcs
c 
c *************************************************************
c *   RES3D
c *************************************************************
      subroutine res3d(t,y,yprime,cj,ddelta,itx,jtx,ktx,rpar,
     v           u,v,w,inx,jnx,knx,norder)
      use module_precision
      use module_gia3
      use module_a3
      dimension y(itx,jtx,ktx),yprime(itx,jtx,ktx),ddelta(itx,jtx,ktx)
      dimension rpar(*),u(inx,jnx,knx),v(inx,jnx,knx)
      dimension w(inx,jnx,knx)
c     *** First order derivatives (w1..)
      parameter(w121=0.5)
      parameter(w141=2d0/3d0,w142=-1d0/12d0)
      parameter(w161=3d0/4d0,w162=-3d0/20d0,w163=1d0/60d0)
      parameter(w181=4d0/5d0,w182=-1d0/5d0 ,w183=4d0/105d0,
     v                                      w184=-1d0/280d0)
c     *** Second order derivatives (w2..)
      parameter(w220=-2d0,       w221=1.0)
      parameter(w240=-5d0/2d0,   w241=4d0/3d0,w242=-1d0/12d0)
      parameter(w260=-49d0/18d0, w261=3d0/2d0,w262=-3d0/20d0
     v                                       ,w263=1d0/90d0)
      parameter(w280=-205d0/72d0,w281=8d0/5d0,w282=-1d0/5d0 ,
     v                                        w283=8d0/315d0,
     v                                        w284=-1d0/560d0)
    

      dx = xl/(nx-1)
      dy = yl/(ny-1)
      dz = 1d0/(nz-1)
      oneh2x = 1d0/(dx*dx)
      oneh2y = 1d0/(dy*dy)
      oneh2z = 1d0/(dz*dz)
      onehx = 1d0/dx
      onehy = 1d0/dy
      onehz = 1d0/dz
      halfhx = 1d0/(2*dx)
      halfhy = 1d0/(2*dy)
      halfhz = 1d0/(2*dz)
c     write(6,'(''dx,dy: '',7f6.3)') dx,dy,dz,xl,yl,halfhx,halfhy

c *************************************************************
c *   BOUNDARY CONDITIONS
c *************************************************************
      if (norder.eq.2) then
         do k=1,ktx
c           *** Neumann
            do j=1,jtx
               y(1,j,k) = y(3,j,k)
               y(itx,j,k) = y(itx-2,j,k)
            enddo
            do i=1,itx
               y(i,1,k) = y(i,3,k)
               y(i,jtx,k) = y(i,jtx-2,k)
            enddo
         enddo
      else if (norder.eq.4) then
         do k=1,ktx
c           *** Neumann
            do j=1,jtx
              y(1,j,k) = y(5,j,k)
              y(2,j,k) = y(4,j,k)
              y(itx,j,k) = y(itx-4,j,k)
              y(itx-1,j,k) = y(itx-3,j,k)
            enddo
            do i=1,itx
              y(i,1,k) = y(i,5,k)
              y(i,2,k) = y(i,4,k)
              y(i,jtx,k) = y(i,jtx-4,k)
              y(i,jtx-1,k) = y(i,jtx-3,k)
            enddo
         enddo
         do i=1,itx
c           *** Dirichlet
            do j=1,jtx
              y(i,j,1) = 2d0-y(i,j,3)
              y(i,j,ktx) = 0d0-y(i,j,ktx-2)
            enddo
         enddo
      else if (norder.eq.6) then
         do k=1,ktx
c           *** Neumann
            do j=1,jtx
              y(1,j,k) = y(7,j,k)
              y(2,j,k) = y(6,j,k)
              y(3,j,k) = y(5,j,k)
              y(itx,j,k) = y(itx-6,j,k)
              y(itx-1,j,k) = y(itx-5,j,k)
              y(itx-2,j,k) = y(itx-4,j,k)
            enddo
            do i=1,itx
              y(i,1,k) = y(i,7,k)
              y(i,2,k) = y(i,6,k)
              y(i,3,k) = y(i,5,k)
              y(i,jtx,k) = y(i,jtx-6,k)
              y(i,jtx-1,k) = y(i,jtx-5,k)
              y(i,jtx-2,k) = y(i,jtx-4,k)
            enddo
         enddo
         do j=1,jtx
           do i=1,itx
c            *** Dirichlet
             y(i,j,1) = 2d0-y(i,j,5)
             y(i,j,2) = 2d0-y(i,j,4)
             y(i,j,ktx) = 0d0-y(i,j,ktx-4)
             y(i,j,ktx-1) = 0d0-y(i,j,ktx-3)
           enddo
         enddo
      else if (norder.eq.8) then
         do k=1,ktx
c          *** Neumann
           do j=1,jtx
             y(1,j,k) = y(9,j,k)
             y(2,j,k) = y(8,j,k)
             y(3,j,k) = y(7,j,k)
             y(4,j,k) = y(6,j,k)
             y(itx,j,k) = y(itx-8,j,k)
             y(itx-1,j,k) = y(itx-7,j,k)
             y(itx-2,j,k) = y(itx-6,j,k)
             y(itx-3,j,k) = y(itx-5,j,k)
           enddo
           do i=1,itx
             y(i,1,k) = y(i,9,k)
             y(i,2,k) = y(i,8,k)
             y(i,3,k) = y(i,7,k)
             y(i,4,k) = y(i,6,k)
             y(i,jtx,k) = y(i,jtx-8,k)
             y(i,jtx-1,k) = y(i,jtx-7,k)
             y(i,jtx-2,k) = y(i,jtx-6,k)
             y(i,jtx-3,k) = y(i,jtx-5,k)
          enddo
        enddo
        do j=1,jtx
          do i=1,itx
c           *** Dirichlet
            y(i,j,1) = 2d0-y(i,j,7)
            y(i,j,2) = 2d0-y(i,j,6)
            y(i,j,3) = 2d0-y(i,j,5)
            y(i,j,ktx) = 0d0-y(i,j,ktx-6)
            y(i,j,ktx-1) = 0d0-y(i,j,ktx-5)
            y(i,j,ktx-2) = 0d0-y(i,j,ktx-4)
         enddo
        enddo
      else
         write(6,*) 'PERROR(res3d): norder is not 2,4,6,8'
         write(6,*) '                   norder = ',norder
         stop
      endif

c *************************************************************
c *   *** Form residual
c *************************************************************
c     *** ORDER 2
      if (norder.eq.2) then
        do k=1,ktx
          kp = k-norder/2+1
          do j=1,jtx
            jp = j-norder/2
            do i=1,itx
               ip = i-norder/2
               if (k.eq.1.or.k.eq.ktx) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (j.eq.1.or.j.eq.jtx) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (i.eq.1.or.i.eq.itx) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else
                  d2tdx = y(i-1,j,k) - 2*y(i,j,k) + y(i+1,j,k)
                  d2tdx = d2tdx * oneh2x
                  d2tdy = y(i,j-1,k) - 2*y(i,j,k) + y(i,j+1,k)
                  d2tdy = d2tdy * oneh2y
                  d2tdz = y(i,j,k-1) - 2*y(i,j,k) + y(i,j,k+1)
                  d2tdz = d2tdz * oneh2z
                  dtdx  = y(i+1,j,k)-y(i-1,j,k)
                  dtdx  = halfhx*dtdx
                  dtdy  = y(i,j+1,k)-y(i,j-1,k)
                  dtdy  = halfhy*dtdy
                  dtdz  = y(i,j,k+1)-y(i,j,k-1)
                  dtdz  = halfhz*dtdz
                  tprime = d2tdx + d2tdy + d2tdz
     v               -u(ip,jp,kp)*dtdx-v(ip,jp,kp)*dtdy-w(ip,jp,kp)*dtdz  
                  ddelta(i,j,k) = yprime(i,j,k) - tprime

c                dtdxl = halfhx*(y(i+1,j,k)-y(i-1,j,k))
c                dtdyl = halfhy*(y(i,j+1,k)-y(i,j-1,k))
c                dtdzl = halfhz*(y(i,j,k+1)-y(i,j,k-1))
c                d2tdxl=oneh2x*(y(i+1,j,k)-2d0*y(i,j,k)+y(i-1,j,k))
c                d2tdyl=oneh2y*(y(i,j+1,k)-2d0*y(i,j,k)+y(i,j-1,k))
c                d2tdzl=oneh2z*(y(i,j,k+1)-2d0*y(i,j,k)+y(i,j,k-1))
c                write(6,100) i,j,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp),
c    v                            dtdy*v(ip,jp,kp),dtdyl*v(ip,jp,kp),
c    v                            dtdz*w(ip,jp,kp),dtdzl*w(ip,jp,kp),
c    v              d2tdx,d2tdxl,d2tdy,d2tdyl,d2tdz,d2tdzl,
c    v            nint(u(ip,jp,kp)),nint(v(ip,jp,kp)),nint(w(ip,jp,kp))

               endif
            enddo
          enddo
        enddo
      else if (norder.eq.4) then
        do k=1,ktx
          kp = k-norder/2+1
          do j=1,jtx
            jp = j-norder/2
            do i=1,itx
               ip = i-norder/2
               if (k.le.2.or.k.ge.ktx-1) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (j.le.2.or.j.ge.jtx-1) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (i.le.2.or.i.ge.itx-1) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else
                 d2tdx = w242*y(i+2,j,k) + w241*y(i+1,j,k) +
     v                   w240*y(i,j,k) +
     v                   w241*y(i-1,j,k) + w242*y(i-2,j,k)
                 d2tdx = d2tdx * oneh2x
                 d2tdy = w242*y(i,j+2,k) + w241*y(i,j+1,k) +
     v                   w240*y(i,j,k) +
     v                   w241*y(i,j-1,k) + w242*y(i,j-2,k)
                 d2tdy = d2tdy * oneh2y
                 d2tdz = w242*y(i,j,k+2) + w241*y(i,j,k+1) +
     v                   w240*y(i,j,k) +
     v                   w241*y(i,j,k-1) + w242*y(i,j,k-2)
                 d2tdz = d2tdz * oneh2z

                 dtdx = w142*y(i+2,j,k)+w141*y(i+1,j,k)-w141*y(i-1,j,k)
     v                  -w142*y(i-2,j,k)
                 dtdx = dtdx * onehx
                 dtdy = w142*y(i,j+2,k)+w141*y(i,j+1,k)-w141*y(i,j-1,k)
     v                  -w142*y(i,j-2,k)
                 dtdy = dtdy * onehy
                 dtdz = w142*y(i,j,k+2)+w141*y(i,j,k+1)-w141*y(i,j,k-1) 
     v                  -w142*y(i,j,k-2)
                 dtdz = dtdz * onehz

c                dtdxl = halfhx*(y(i+1,j,k)-y(i-1,j,k))
c                dtdyl = halfhy*(y(i,j+1,k)-y(i,j-1,k))
c                dtdzl = halfhz*(y(i,j,k+1)-y(i,j,k-1))
c                d2tdxl=oneh2x*(y(i+1,j,k)-2d0*y(i,j,k)+y(i-1,j,k))
c                d2tdyl=oneh2y*(y(i,j+1,k)-2d0*y(i,j,k)+y(i,j-1,k))
c                d2tdzl=oneh2z*(y(i,j,k+1)-2d0*y(i,j,k)+y(i,j,k-1))
c                write(6,100) i,j,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp), 
c    v                            dtdy*v(ip,jp,kp),dtdyl*v(ip,jp,kp), 
c    v                            dtdz*w(ip,jp,kp),dtdzl*w(ip,jp,kp),
c    v              d2tdx,d2tdxl,d2tdy,d2tdyl,d2tdz,d2tdzl,
c    v            nint(u(ip,jp,kp)),nint(v(ip,jp,kp)),nint(w(ip,jp,kp))

                 tprime = d2tdx + d2tdy + d2tdz
     v               -u(ip,jp,kp)*dtdx-v(ip,jp,kp)*dtdy-w(ip,jp,kp)*dtdz  
                 ddelta(i,j,k) = yprime(i,j,k) - tprime
               endif
            enddo
          enddo
        enddo

c       *** ORDER 6
      else if (norder.eq.6) then
        do k=1,ktx
          kp = k-norder/2+1
          do j=1,jtx
            jp = j-norder/2
            do i=1,itx
               ip = i-norder/2
               if (k.le.3.or.k.ge.ktx-2) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (j.le.3.or.j.ge.jtx-2) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (i.le.3.or.i.ge.itx-2) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else
                 d2tdx = w263*y(i+3,j,k) + w262*y(i+2,j,k) + 
     v                   w261*y(i+1,j,k) + w260*y(i,j,k)   +
     v                   w261*y(i-1,j,k) + w262*y(i-2,j,k) + 
     v                   w263*y(i-3,j,k)
                 d2tdx = d2tdx * oneh2x
                 d2tdy = w263*y(i,j+3,k) + w262*y(i,j+2,k) + 
     v                   w261*y(i,j+1,k) + w260*y(i,j,k)   +
     v                   w261*y(i,j-1,k) + w262*y(i,j-2,k) + 
     v                   w263*y(i,j-3,k)
                 d2tdy = d2tdy * oneh2y
                 d2tdz = w263*y(i,j,k+3) + w262*y(i,j,k+2) + 
     v                   w261*y(i,j,k+1) + w260*y(i,j,k)   +
     v                   w261*y(i,j,k-1) + w262*y(i,j,k-2) +
     v                   w263*y(i,j,k-3)
                 d2tdz = d2tdz * oneh2z

                 dtdx=   w163*y(i+3,j,k) + w162*y(i+2,j,k) + 
     v                   w161*y(i+1,j,k) - w161*y(i-1,j,k) -
     v                   w162*y(i-2,j,k) - w163*y(i-3,j,k) 
                 dtdx = dtdx * onehx
                 dtdy=   w163*y(i,j+3,k) + w162*y(i,j+2,k) +
     v                   w161*y(i,j+1,k) - w161*y(i,j-1,k) -
     v                   w162*y(i,j-2,k) - w163*y(i,j-3,k) 
                 dtdy = dtdy * onehy
                 dtdz=   w163*y(i,j,k+3) + w162*y(i,j,k+2) +
     v                   w161*y(i,j,k+1) - w161*y(i,j,k-1) -
     v                   w162*y(i,j,k-2) - w163*y(i,j,k-3) 
                 dtdz = dtdz * onehz

                 tprime = d2tdx + d2tdy + d2tdz
     v               -u(ip,jp,kp)*dtdx-v(ip,jp,kp)*dtdy-w(ip,jp,kp)*dtdz  
                 ddelta(i,j,k) = yprime(i,j,k) - tprime

c                dtdxl = halfhx*(y(i+1,j,k)-y(i-1,j,k))
c                dtdyl = halfhy*(y(i,j+1,k)-y(i,j-1,k))
c                dtdzl = halfhz*(y(i,j,k+1)-y(i,j,k-1))
c                d2tdxl=oneh2x*(y(i+1,j,k)-2d0*y(i,j,k)+y(i-1,j,k))
c                d2tdyl=oneh2y*(y(i,j+1,k)-2d0*y(i,j,k)+y(i,j-1,k))
c                d2tdzl=oneh2z*(y(i,j,k+1)-2d0*y(i,j,k)+y(i,j,k-1))
c                write(6,100) i,j,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp), 
c    v                            dtdy*v(ip,jp,kp),dtdyl*v(ip,jp,kp), 
c    v                            dtdz*w(ip,jp,kp),dtdzl*w(ip,jp,kp),
c    v              d2tdx,d2tdxl,d2tdy,d2tdyl,d2tdz,d2tdzl,
c    v            nint(u(ip,jp,kp)),nint(v(ip,jp,kp)),nint(w(ip,jp,kp))

              endif

            enddo
          enddo
        enddo

c     **** ORDER 8
      else if (norder.eq.8) then
        do k=1,ktx
          kp = k-norder/2+1
          do j=1,jtx
            jp = j-norder/2
            do i=1,itx
               ip = i-norder/2
               if (k.le.4.or.k.ge.ktx-3) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (j.le.4.or.j.ge.jtx-3) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else if (i.le.4.or.i.ge.itx-3) then
                  ddelta(i,j,k) = yprime(i,j,k)
               else
                 d2tdx = w284*y(i+4,j,k) + w283*y(i+3,j,k)
     v                 + w282*y(i+2,j,k) + w281*y(i+1,j,k) 
     v                 + w280*y(i  ,j,k) + w281*y(i-1,j,k) 
     v                 + w282*y(i-2,j,k) + w283*y(i-3,j,k)
     v                 + w284*y(i-4,j,k)
                 d2tdx = d2tdx * oneh2x
                 d2tdy = w284*y(i,j+4,k) + w283*y(i,j+3,k)
     v                 + w282*y(i,j+2,k) + w281*y(i,j+1,k) 
     v                 + w280*y(i,j,  k) + w281*y(i,j-1,k) 
     v                 + w282*y(i,j-2,k) + w283*y(i,j-3,k)
     v                 + w284*y(i,j-4,k)
                 d2tdy = d2tdy * oneh2y
                 d2tdz = w284*y(i,j,k+4) + w283*y(i,j,k+3)
     v                 + w282*y(i,j,k+2) + w281*y(i,j,k+1) 
     v                 + w280*y(i,j,k)   + w281*y(i,j,k-1)
     v                 + w282*y(i,j,k-2) + w283*y(i,j,k-3) 
     v                 + w284*y(i,j,k-4)
                 d2tdz = d2tdz * oneh2z

                 dtdx = w184*y(i+4,j,k) + w183*y(i+3,j,k)
     v                + w182*y(i+2,j,k) + w181*y(i+1,j,k) 
     v                - w181*y(i-1,j,k) - w182*y(i-2,j,k)
     v                - w183*y(i-3,j,k) - w184*y(i-4,j,k)
                 dtdx = dtdx * onehx
                 dtdy = w184*y(i,j+4,k) + w183*y(i,j+3,k)
     v                + w182*y(i,j+2,k) + w181*y(i,j+1,k) 
     v                - w181*y(i,j-1,k) - w182*y(i,j-2,k)
     v                - w183*y(i,j-3,k) - w184*y(i,j-4,k)
                 dtdy = dtdy * onehy
                 dtdz = w184*y(i,j,k+4) + w183*y(i,j,k+3)
     v                + w182*y(i,j,k+2) + w181*y(i,j,k+1) 
     v                - w181*y(i,j,k-1) - w182*y(i,j,k-2)
     v                - w183*y(i,j,k-3) - w184*y(i,j,k-4)
                 dtdz = dtdz * onehz

                 tprime = d2tdx + d2tdy + d2tdz
     v               -u(ip,jp,kp)*dtdx-v(ip,jp,kp)*dtdy-w(ip,jp,kp)*dtdz  
                 ddelta(i,j,k) = yprime(i,j,k) - tprime

c                dtdxl = halfhx*(y(i+1,j,k)-y(i-1,j,k))
c                dtdyl = halfhy*(y(i,j+1,k)-y(i,j-1,k))
c                dtdzl = halfhz*(y(i,j,k+1)-y(i,j,k-1))
c                d2tdxl=oneh2x*(y(i+1,j,k)-2d0*y(i,j,k)+y(i-1,j,k))
c                d2tdyl=oneh2y*(y(i,j+1,k)-2d0*y(i,j,k)+y(i,j-1,k))
c                d2tdzl=oneh2z*(y(i,j,k+1)-2d0*y(i,j,k)+y(i,j,k-1))
c                write(6,100) i,j,k,dtdx*u(ip,jp,kp),dtdxl*u(ip,jp,kp), 
c    v                            dtdy*v(ip,jp,kp),dtdyl*v(ip,jp,kp), 
c    v                            dtdz*w(ip,jp,kp),dtdzl*w(ip,jp,kp),
c    v              d2tdx,d2tdxl,d2tdy,d2tdyl,d2tdz,d2tdzl,
c    v            nint(u(ip,jp,kp)),nint(v(ip,jp,kp)),nint(w(ip,jp,kp))

              endif
            enddo
          enddo
        enddo


      endif

100   format(3i3,2x,3(2f8.3,2x),2x,6f8.3,3i7)
 
      return
      end
