c $Log:   /pvcs.config/mc3dvv/src/ssrch.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:20 1997   pvcs
c 
c *************************************************************
c *   SSRCH
c *************************************************************
      subroutine ssrch (array,nl,nu,inci,value,indx,ibnd)
      use module_precision
c
c searches array between indices nl and nu inclusive, by inci
c to find value, such that array(indx).le.value.lt.array(indx+inci)
c if value .lt. array(nl) .or. value .gt. array(nu) then
c indx=nl or indx=nu and ibnd=type. if value within range, then
c ibnd=blank.
c
c input
c    array  - search array (must be in ascending order)
c    nl,nu  - lower, upper search index bounds
c    inci   - search increment through array
c    value  - search value
c    indx   - guess at approximate location of value
c    ibnd   - element type (ie,5hrho  ,5htrho ,5htrho1)
c             and search bounds flag
c
c output
c    indx    - lower indx location of value
c    ibnd    = 5h      -between indx and indx1
c            = 5htype  -outside range nl, nu
c s.w. hodsons, t-dot, 1979
c
      dimension array(*)
c
      ibnds=ibnd
      ibnd=5h
      if (indx.lt.nl) indx=nl
      if (indx.ge.nu) indx=nu-inci
c search loop starts
   10 inc=0
      if (indx.lt.nl.or.indx.ge.nu) go to 20
      if (value.ge.array(indx+inci)) inc=inci
      if (value.lt.array(indx)) inc=-inci
      if (inc.eq.0) return
      indx=indx+inc
      go to 10
c search loop ends
c extrapolation
   20 ibnd=ibnds
      if (indx.ge.nu) indx=nu-inci
      if (indx.lt.nl) indx=nl
      return
      end
