c $Log:   /pvcs.config/mc3dvv/src/subs.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:22 1997   pvcs
c 
c*****************************************************************************
c *   SUBS
c***********************************************************************
      subroutine diffxy(f,fdxy,idim1,ncx,idim2,ncy,idx,idy,
     . lpf,lpfdx,mpf,mpfdy,nxfdx,nyfdy,lbcx,mbcy)
c
c     	       carl w. gable
c************   12/12/87	************ 
c	call diffxy(work2,work4,isl,nxu,jsl,nyu,ksl,nz,idifx,idify  	!work4=u,xx
c     #	,lpu,lpw4,mpu,mpw4,nxw4,nyw4,lbd,mbd)
c
c     f, fdxy- input and output arrays
c     ncx,ncy,ncz= dimensions of input array (old version)
c     idim1,idim2,idim3- for dimension statements
c     idx,idy- differentiation flags
c     lpf,mpf- fft flags for input array
c     lpfdx,mpfdx- fft flags for output array
c     nxfdx,nyfdx- dimensions of output arrays
c     lbcx,mbcy-   side B.C. flags
c    
c     Modifications by G. Ito 3/93
c     1) Dimensions of fdxy (nxfdx,nyfdx) depend on boundary conditions
c       and ncx,ncy.   
c     2) Zeroed edges of array
c     3) deriv. of cos=sin and deriv. sin=-cos  -double check for 3-D
c   
c     Now only handles 2-D arrays		G. Ito 6/95
c===========================================================================
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_a11
      

      dimension f(idim1,idim2),fdxy(isl,jsl)	!G.Ito 5/95
      if (ncy.le.2) ncy=1		!possibly a temporary fix
					!so 2-d will work  G.Ito 3/93

      if ((idim1.lt.ncx.or.idim2.lt.ncy) .or.
     &  (isl.lt.ncx.or.jsl.lt.ncy))	then	!G. Ito 1/95
         print *, 'Dimension problems in diffxy'
	 stop
      endif

c-----------------------------------------------------------------------     
c     one derivative in the x direction
c     (hopefully chvar switches cos to sin and sin to -cos)
c-----------------------------------------------------------------------
      if((idx .eq. 1) .and. (idy .eq. 0))then
      if(lpf .eq. 1)then 			!if real
        lpfdx=lpf
        mpfdy=mpf
        nxfdx=ncx
        nyfdy=ncy
c        do 10 k=1,ncz
        do 10 j=1,ncy
        do 10 i=1,ncx
  10      fdxy(i,j)= wni(i)*f(i,j)

        call chvar(fdxy,isl,ncx,lbcx,jsl,ncy,mbcy,1,1)
      elseif(lpf .eq. 2)then			!if sin function
        lpfdx=4
        mpfdy=mpf
        nxfdx=ncx+2
        nyfdy=ncy
c        do 11 k=1,1		
        do 11 j=1,ncy
        do 11 i=1,ncx
  11      fdxy(i,j)= wni(i)*f(i,j)		!derivative of sin=cos
      elseif(lpf .eq. 4)then			!if cos function
        lpfdx=2	
        mpfdy=mpf
        nxfdx=ncx-2
        nyfdy=ncy
c	do 12 k=1,1
        do 12 j=1,ncy
        do 12 i=1,ncx
  12      fdxy(i,j)= -wni(i)*f(i,j)		!derivative of cos=-sin
      endif
c-----------------------------------------------------------------------      
c     second derivative in the x direction
c-----------------------------------------------------------------------
      elseif((idx .eq. 2) .and. (idy .eq. 0))then

c      do 20 k=1,ncz
        do 20 j=1,ncy
          do 20 i=1,ncx
  20        fdxy(i,j)=-wni(i)*wni(i)*f(i,j)
c  
      lpfdx=lpf
      mpfdy=mpf
      nxfdx=ncx
      nyfdy=ncy
c-----------------------------------------------------------------------  
c     first derivative in the x direction
c     first derivative in the y direction
c-----------------------------------------------------------------------
      elseif((idx .eq. 1) .and. (idy .eq. 1))then
      if((lpf .eq. 1) .and. (mpf .eq. 1))then
c	 do 30 k=1,ncz
         do 30 j=1,ncy
          twnj=wnj(j)
          do 30 i=1,ncx
   30       fdxy(i,j)=-wni(i)*twnj*f(i,j)
        call chvar(fdxy,isl,ncx,lbcx,jsl,ncy,mbcy,1,1)
        lpfdx=lpf
        mpfdy=mpf
        nxfdx=ncx
        nyfdy=ncy
      elseif((lpf .eq. 2) .and. (mpf .eq. 2))then
c         do 31 k=1,ncz
         do 31 j=1,ncy
          twnj=wnj(j)
          do 31 i=1,ncx
   31       fdxy(i,j)=wni(i)*twnj*f(i,j)	!derv. of sin=cos
        lpfdx=4
        nxfdx=ncx+2
        mpfdy=4
        nyfdy=ncy+2
      elseif((lpf .eq. 4) .and. (mpf .eq. 4))then
c	do 32 k=1,ncz
        do 32 j=1,ncy
          twnj=wnj(j)
          do 32 i=1,ncx
   32       fdxy(i,j)=wni(i)*twnj*f(i,j)	!derv. of cos=-sin
        lpfdx=2
        nxfdx=ncx-2
        mpfdy=2
        nyfdy=ncy-2
      elseif((lpf .eq. 2) .and. (mpf .eq. 4))then
c        do 33 k=1,ncz
        do 33 j=1,ncy
          twnj=wnj(j)
          do 33 i=1,ncx
   33       fdxy(i,j)=-wni(i)*twnj*f(i,j)	!derv. of cos=-sin
        lpfdx=4
        nxfdx=ncx+2
        mpfdy=2
        nyfdy=ncy-2
      elseif((lpf .eq. 4) .and. (mpf .eq. 2))then
c        do 34 k=1,ncz
         do 34 j=1,ncy
          twnj=wnj(j)
          do 34 i=1,ncx
   34       fdxy(i,j)=-wni(i)*twnj*f(i,j)	!derv. of cos=-sin

        lpfdx=2
        nxfdx=ncx-2
        mpfdy=4
        nyfdy=ncy+2
      endif
c-----------------------------------------------------------------------  
c     first derivative in the y direction
c-----------------------------------------------------------------------
      elseif((idx .eq. 0) .and. (idy .eq. 1))then
c
      
      if(mpf.eq. 1)then
c	do 40 k=1,ncz
        do 40 j=1,ncy
          twnj=wnj(j)
          do 40 i=1,ncx
   40       fdxy(i,j)= twnj*f(i,j)
        call chvar(fdxy,isl,ncx,lbcx,jsl,ncy,mbcy,1,1)
        lpfdx=lpf
        mpfdy=mpf
        nxfdx=ncx
        nyfdy=ncy
      elseif(mpf .eq. 2)then
c        do 41 k=1,ncz
        do 41 j=1,ncy
          twnj=wnj(j)
          do 41 i=1,ncx
   41       fdxy(i,j)= twnj*f(i,j)		!deriv. of sin=cos
        lpfdx=lpf
        mpfdy=4
        nxfdx=ncx
        nyfdy=ncy+2
      elseif(mpf .eq. 4)then
c	do 42 k=1,ncz
        do 42 j=1,ncy
          twnj=wnj(j)
          do 42 i=1,ncx
   42       fdxy(i,j)= -twnj*f(i,j)		!deriv. of cos =-sin
        lpfdx=lpf
        mpfdy=2
        nxfdx=ncx
        nyfdy=ncy-2
      endif
c-----------------------------------------------------------------------  
c    second derivative in the y direction
c-----------------------------------------------------------------------
      elseif((idx .eq. 0) .and. (idy .eq. 2))then
c
c      do 50 k=1,ncz
        do 50 j=1,ncy
        wny2=wnj(j)*wnj(j)
          do  50 i=1,ncx
  50        fdxy(i,j)=-wny2*f(i,j)
c  
      lpfdx=lpf
      mpfdy=mpf
      nxfdx=ncx
      nyfdy=ncy
c  
      else
      write(6,60)idx,idy
   60 format("invalid derivatives in diffxy",2i6)
      stop
      endif
c----------------------------------------------------------------------
c     The rest of fdxy=0.0.  Could have initialize fdxy but this
c      saves a little cpu.     G.Ito 3/93
c-----------------------------------------------------------------------
      if ((ncy.eq.idim2).and.(ncx.eq.idim1)) goto 100
      
c      do 90 k=1,ncz
        if (ncy.ne.jsl) then		!zero the y-edge at all y
          do 70 j=ncy+1,jsl		
            do 70 i=1,isl
 70           fdxy(i,j)= zero
	endif

	if (ncx.ne.isl) then		!zero the x-edge at all y
	  do 80 i=ncx+1,isl
	    do 80 j=1,jsl
 80	      fdxy(i,j)=zero
	endif
c 90   continue

100   return
      end

c
c*****************************************************************************
c==============================================================
	subroutine flagset(l1,n1,l2,n2,l3,n3)

c       Set's appropriate array dimensions and flags
c       for products of arrays.  (modified by G.Ito 3/93)
c      
c================================================================
c
c      f(cos+sin)f2(cos+sin)=f3(cos+sin)     {real*anything=real l3=1
c------------------------------------------------------------------
	if(l1.eq.1) then	
	  l3=l1		
	  n3=n1
	elseif(l2.eq.1) then		
	  l3=l2
	  n3=n2
c-------------------------------------------------------------------
c      cos(x)cos(y)=.5cos(x+y)+.5cos(x-y)    {even*even=even    l3=4
c      sin(x)sin(y)=-.5cos(x+y)+.5cos(x-y)    {odd*odd=even
c-------------------------------------------------------------------
	elseif(l1.eq.l2) then
	  if(l1.eq.4) then	
	    l3=l1			
	    n3=n1
	  else
	    l3=4
	    n3=n1+2
	  endif
	else
c------------------------------------------------------------------------
c       sin(x)cos(y)=.5sin(x+y)+.5sin(x-y)     {odd*even=odd  l3=2
c------------------------------------------------------------------------
	  if (l1.eq.2)then		
	    l3=l1			
	    n3=n1
	  else
	    l3=l2
	    n3=n2
          endif
	endif
c
	return
	end

c=======================================================================
      subroutine multadd(a,b,c,rc,idim1,idim2,idim3,iopt)
c
c     a=a+b*c*rc,  a,b,c are arrays, rc=scalar
c 
c     G.Ito 2/15/95
c=======================================================================
      use module_precision
      dimension a(idim1,idim2,idim3),b(idim1,idim2,idim3)
     &   ,c(idim1,idim2,idim3)

      do 50 k=1,idim3
        do 50 j=1,idim2
          do 50 i=1,idim1
            if (iopt.eq.1) then
              a(i,j,k)=a(i,j,k)+rc*b(i,j,k)*c(i,j,k)
	    elseif(iopt.eq.0)then
	      a(i,j,k)=rc*b(i,j,k)*c(i,j,k)
	    else
	      print *, 'iopt set incorrectly in multadd'
	      stop
            endif
   50 continue

      return
      end

c===================================================================
      subroutine setm(a,idima1,idima2,idima3,ida123,
     .b,idimb1,idimb2,idimb3,idb123)
c
c     set the array b to a
c     Eliminated 'itype' option.  G. Ito 3/93     
c===================================================================
      use module_precision
      dimension a(idima1,idima2,*),b(idimb1,idimb2,*)
c      dimension ae(ida123),be(idb123)
c      equivalence (a,ae),(b,be)
c--------------------------------------------------------------------
c     check for valid dimensions
c     b can't be bigger than a
c--------------------------------------------------------------------
      iflag=0
      if(idima1 .lt. idimb1)then
        iflag=1
        write(6,10)idima1,idimb1
	stop
      endif
      if(idima2 .lt. idimb2)then
        iflag=1
        write(6,20)idima2,idimb2
	stop
      endif
      if(idima3 .lt. idimb3)then
        iflag=1
        write(6,30)idima3,idimb3
	stop
      endif

      do 50 k=1,idimb3
        do 50 j=1,idimb2
          do 50 i=1,idimb1
            b(i,j,k)=a(i,j,k)
   50   continue

   10 format("error in setm; idima1 .ne. idimb1",2i5)
   20 format("error in setm; idima2 .ne. idimb2",2i5)
   30 format("error in setm; idima3 .ne. idimb3",2i5)

      
      return
      end


