c $Log:   /pvcs.config/mc3dvv/src/surfv.F_a  $
c
c   Rev 1.3   Fri Jul 30 11:45:20 1999   lowman
c  Added option for plates rotating around fixed point (King project)
c
c   Rev 1.1   Tue Oct 06 16:56:42 1998   lowman
cAdded xveloc and yveloc definitions
c
c   Rev 1.0   Mon Jul 14 14:22:24 1997   pvcs
c 
c *************************************************************
c *   SURFV
c *************************************************************
      subroutine surfv (v,n1,n2,template2,iplgeo)
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_a12
      use module_a30
c#include<a4.h>
      common /a4/ vsij(700)
      dimension template2(iqx,jqx,npla), iplgeo(iqx,jqx)
c
c     if ISURFV  .GE. 2, user supplies surface velocity components here
c       value of isurfv .ge. 2 determines which b.c. option to choose
c
c      isurfv=2   divergent center line
c            =3   divergent with transform
c            =4   oblique boundary
c            =5   strike slip boundary
c            =6   sin function in i & j direction
c
      dimension v(n1,n2,2)
c
      twopi=2.*pimach(dumm)
c   divergent top boundary (i.e. ridge)
c
      if(isurfv.lt.0)then
        do 1 j=1,nyr
        do 1 i=1,nxr
        v(i,j,1)=zero
1       v(i,j,2)=zero

        do 2 j=1,nyr
        do 2 i=1,nxr
        do 2 ipla=1,nplate
        v(i,j,1)=template2(i,j,ipla)*vpl(1,ipla)+v(i,j,1)
2       v(i,j,2)=template2(i,j,ipla)*vpl(2,ipla)+v(i,j,2)

c        do j=1,nyr
c        write(*,*) 'writing applied b.c.'
c        write(*,*) (v(iii,j,1),iii=1,nxr)
c        write(*,*) (v(iii,j,2),iii=1,nxr)
c        enddo

        if (nyr.eq.1) then
            v(nxr+1,1,1) = v(1,1,1)
            v(nxr+1,1,2) = v(1,1,2)
        else
            do 104 i = 1,nxr+1
            v(i,nyr+1,1) = v(i,1,1)
            v(i,nyr+1,2) = v(i,1,2)
104         continue
            do 106 j = 1,nyr+1
            v(nxr+1,j,1) = v(1,j,1)
            v(nxr+1,j,2) = v(1,j,2)
106         continue
        endif
      endif

      if (isurfv.eq.2) then
        do 10 j=1,j3
        do 10 i=1,n1
        if (i.le.nx/2) then
          v(i,j,1)=2000.
          v(i,j,2)=0.
        elseif (i.gt.(nx/2)+1) then
          v(i,j,1)=-2000.
          v(i,j,2)=0.
        else
          v(i,j,1)=0.
          v(i,j,2)=0.
        endif
        if((i.eq.1).or.(i.eq.nx))then
          v(i,j,1)=0.
          v(i,j,2)=0.
        endif
   10   continue

      elseif (isurfv.eq.410) then
        do 5110 i=1,nx
        if (i.le.5*nx/12) then
          v(i,1,1)=-1500.
          v(i,1,2)=0.
          goto 5110
        elseif(i.le.8*nx/12) then
          v(i,1,1)=2500.
          v(i,1,2)=0.
          goto 5110
        elseif(i.le.10*nx/12) then
          v(i,1,1)=-3000.
          v(i,1,2)=0.
          goto 5110
        else
          v(i,1,1)=3000.
          v(i,1,2)=0.
        endif
5110   continue
c
c      divergent top with transform
c
      elseif (isurfv.eq.3) then
       ishift=1
c
        j=1
        xveloc=17.
        yveloc=1.0
        do 3 i=1,n1
        if (i.lt.(3*n1/8)+ishift)then 
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
  3   continue
        do 4 j=j2,j3/2
        do 4 i=1,n1
        if (i.lt.(3*n1/8)+ishift)then 
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if (i.eq.(3*n1/8)+ishift) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(3*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   4   continue
        j=(j3/2)+1
        do 5 i=1,n1
        if (i.lt.(3*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   5   continue
        do 6 j=(j3/2)+2,j3-1
        do 6 i=1,n1
        if (i.lt.(5*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if (i.eq.(5*n1/8)+ishift) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   6   continue
        j=j3
        do 7 i=1,n1
        if (i.lt.(3*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   7   continue
        do 8 j=1,j3
        v(1,j,1)=0.
        v(1,j,2)=0.
        v(n1,j,1)=0.
        v(n1,j,2)=0.
   8   continue



c
c      divergent top oblique motion
c
      elseif (isurfv.eq.4) then
        do 30 j=1,n2
        do 30 i=1,n1
        if (i.le.3*n1/8) then
          v(i,j,1)=-10.
          v(i,j,2)=-10.
        else
          v(i,j,1)=10.
          v(i,j,2)=10.
        endif
   30   continue
        icount=0
        jcount=2
        do 50 j=1,n2
        if (jcount.le.4) then
          jcount=jcount+1
        else
          jcount=1
          icount=icount+1
        endif
        do 40 i=(3*n1/8),(5*n1/8)
        if (i.lt.(5*n1/8)-icount) v(i,j,1)=-10.
   40   continue
   50   continue
c
c      strike slip boundary
c
      elseif (isurfv.eq.5) then
        do 60 j=1,n2
        do 60 i=1,n1
        if (i.le.n1/2) then
          v(i,j,1)=0.
          v(i,j,2)=25.
        else
          v(i,j,1)=0.
          v(i,j,2)=-25.
        endif
   60   continue
c
c      sin functions in i and j direction
c
      elseif (isurfv.eq.6) then
        do 70 j=1,n2
        do 70 i=1,n1
        v(i,j,1)=sin(float(i-1)/float(n1-1)*twopi)
   70   v(i,j,2)=0.
c   70   v(i,j,2)=sin(float(j-1)/float(n2-1)*twopi)
      elseif (isurfv.eq.7) then
c
c   quick fix for test run
c
        open (unit=41,file='tape41')
        do 80 j=1,n2
        do 80 i=1,n1
        if ((i.ge.2).and.(i.le.16)) then
          v(i,j,1)=3.
          v(i,j,2)=0.
          write (41,200) i,j,v(i,j,1),v(i,j,2)
        elseif ((i.ge.18).and.(i.le.64)) then
          v(i,j,1)=-1.
          v(i,j,2)=0.
          write (41,200) i,j,v(i,j,1),v(i,j,2)
        else
          v(i,j,1)=1.
          v(i,j,2)=0.
          write (41,200) i,j,v(i,j,1),v(i,j,2)
        endif
   80   continue
        close (41)
c
      elseif ((isurfv.ge.8).and.(isurfv.le.49)) then
c cg      pi=acos(-1.)
        pi=pimach(dumm)
        pbt=pi/2.
      vfac=pbt*float(isurfv-8)/10.
      vx=cos(vfac)
      vy=sin(vfac)
        nplate=2
        ncell1=13
        ncell1=9
        ncell1=4
        ncell2=nx-(ncell1-1)
        j=1
        do 90 i=1,nx
        if (i.lt.ncell1) then
          v(i,j,1)=vx
          v(i,j,2)=vy
          iplgeo(i,j)=1
        endif
        if ((i.ge.ncell1).and.(i.le.ncell2)) then
          v(i,j,1)=0.
          v(i,j,2)=0.
          iplgeo(i,j)=0
        endif
        if (i.gt.ncell2) then
          v(i,j,1)=-vx
          v(i,j,2)=-vy
          iplgeo(i,j)=2
        endif
   90   continue
        do 100 j=j2,j3/2
        do 100 i=1,nx
        if (i.lt.ncell1) then
          v(i,j,1)=vx
          v(i,j,2)=vy
          iplgeo(i,j)=1
        endif
        if (i.eq.ncell1) then
          v(i,j,1)=0.
          v(i,j,2)=0.
          iplgeo(i,j)=0
        endif
        if (i.gt.ncell1) then
          v(i,j,1)=-vx
          v(i,j,2)=-vy
          iplgeo(i,j)=2
        endif
  100   continue
        j=(j3/2)+1
        do 110 i=1,nx
        if (i.lt.ncell1) then
          v(i,j,1)=vx
          v(i,j,2)=vy
          iplgeo(i,j)=1
        endif
        if ((i.ge.ncell1).and.(i.le.ncell2)) then
          v(i,j,1)=0.
          v(i,j,2)=0.
          iplgeo(i,j)=0
        endif
        if (i.gt.ncell2) then
          v(i,j,1)=-vx
          v(i,j,2)=-vy
          iplgeo(i,j)=2
        endif
  110   continue
        do 120 j=(j3/2)+2,j3-1
        do 120 i=1,nx
        if (i.lt.ncell2) then
          v(i,j,1)=vx
          v(i,j,2)=vy
          iplgeo(i,j)=1
        endif
        if (i.eq.ncell2) then
          v(i,j,1)=0.
          v(i,j,2)=0.
          iplgeo(i,j)=0
        endif
        if (i.gt.ncell2) then
          v(i,j,1)=-vx
          v(i,j,2)=-vy
          iplgeo(i,j)=2
        endif
  120   continue
        j=j3
        do 130 i=1,nx
        if (i.lt.ncell2) then
          v(i,j,1)=vx
          v(i,j,2)=vy
          iplgeo(i,j)=1
        endif
        if ((i.ge.ncell1).and.(i.le.ncell2)) then
          v(i,j,1)=0.
          v(i,j,2)=0.
          iplgeo(i,j)=0
        endif
        if (i.gt.ncell2) then
          v(i,j,1)=-vx
          v(i,j,2)=-vy
          iplgeo(i,j)=2
        endif
  130   continue
        do 140 j=1,j3
        v(1,j,1)=0.
        v(nx,j,1)=0.
        v(1,j,2)=0.
        v(nx,j,2)=0.
        iplgeo(1,j)=0
        iplgeo(nx,j)=0
  140   continue
c      do 141 j=1,j3
c      do 141 i=1,nx
c         v(i,j,1)=0.
c         v(i,j,2)=0.
c         iplgeo(i,j)=0
c  141 continue
c      do 142 j=1,j3
c      do 142 i=2,nx-1
c         if(i .lt. nx/2)then
c           v(i,j,1)=vx
c           v(i,j,2)=vy
c           iplgeo(i,j)=1
c         elseif(i .gt. nx/2)then
c           v(i,j,1)=-vx
c           v(i,j,2)=-vy
c           iplgeo(i,j)=2
c         endif
c  142 continue
        do 150 j=1,jqx
        write (6,210) (iplgeo(i,j),i=1,iqx)
  150   continue
c
c      divergent top oblique motion
c
      elseif (isurfv.eq.50) then
        nplate=2
        vx=10.
        vy=10.
        do 160 j=1,j3
        do 160 i=1,nx
        if (i.lt.j) then
          iplgeo(i,j)=1
          v(i,j,1)=-vx
          v(i,j,2)=-vy
        elseif (i.eq.j) then
          iplgeo(i,j)=0
          v(i,j,1)=0.
          v(i,j,2)=0.
        elseif (i.gt.j) then
          iplgeo(i,j)=2
          v(i,j,1)=vx
          v(i,j,2)=vy
        endif
  160   continue
        do 170 i=1,nx
        iplgeo(i,1)=0
        iplgeo(i,j3)=0
        v(i,1,1)=0.
        v(i,j3,1)=0.
        v(i,1,2)=0.
        v(i,j3,2)=0.
  170   continue
        do 180 j=1,j3
        iplgeo(1,j)=0
        iplgeo(nx,j)=0
        v(1,j,1)=0.
        v(nx,j,1)=0.
        v(1,j,2)=0.
        v(nx,j,2)=0.
  180   continue
c
c   divergent top y direction  boundary (i.e. ridge)
c
      elseif (isurfv.eq.60) then
        do 195 j=1,n2
        do 195 i=1,n1
        if (j.le.n2/2) then
          v(i,j,1)=0
          v(i,j,2)=-25.
        else
          v(i,j,1)=0.
          v(i,j,2)=25.
        endif
  195   continue
c
c
c   single plate with tapered end velocity
c
      elseif (isurfv.eq.70) then
        do 220 j=1,n2
        do 220 i=1,n1
         v(i,j,1)=1000.
         v(i,j,2)=0.
         if((i .eq. 1) .or. (i .eq. n1))v(i,j,1)=0.
         if((i .eq. 2) .or. (i .eq. n1-1))v(i,j,1)=125.
         if((i .eq. 3) .or. (i .eq. n1-2))v(i,j,1)=250.
         if((i .eq. 4) .or. (i .eq. n1-3))v(i,j,1)=375.
         if((i .eq. 5) .or. (i .eq. n1-4))v(i,j,1)=500.
         if((i .eq. 6) .or. (i .eq. n1-5))v(i,j,1)=625.
         if((i .eq. 7) .or. (i .eq. n1-6))v(i,j,1)=750.
         if((i .eq. 8) .or. (i .eq. n1-7))v(i,j,1)=875.
 220   continue
c
c   single plate without tapered end velocity
c
      elseif (isurfv.eq.80) then
        do 230 j=1,n2
        do 230 i=1,n1
         v(i,j,1)=10.
         v(i,j,2)=0.
         if((i .eq. 1) .or. (i .eq. n1))   v(i,j,1)=0.
 230   continue
      
      elseif (isurfv.eq.85) then
c
c     solid body rotation about (0,0) corner of box
c
        do 240 j=1,n2
        do 240 i=1,n1
c         xpos = (i-1)*dx - xl/2.
c         ypos = (j-1)*dy - yl/2.
         xpos = (i-1)*dx 
         ypos = (j-1)*dy 
         v(i,j,1)= -ypos 
         v(i,j,2)= xpos 
 240   continue
      
      elseif ((isurfv.ge.200) .and. (isurfv .lt. 300)) then
c
c     individual poloidal and toroidal surface modes are
c     input in flow
c      
      elseif (isurfv.eq.300) then
c     one plate, vx velocity given by vsij(1) in namelist input
c     for specification of net flow through the box. If reflecting
c     boundary conditions are used, the end points will be set to
c     zero in FLOW
c     
        do 300 j=1,n2
        do 300 i=1,n1
         v(i,j,1)=vsij(1)
         v(i,j,2)=0.
 300   continue
c      
      elseif (isurfv.eq.400) then
c
c     two equal size plates with velocity given by vsij(1-4)
c
        do 400 j=1,n2
        do 400 i=1,n1
        if (i.le.n1/2) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
  400   continue
      elseif (isurfv.eq.450) then
c
c     two equal plates with velocity given by vsij(1-4) and
c     plate boundary give by vsij(5) in nondimensional coordinates
c     (e.g. vsij(5) = .5 => 2 equal size plates regardless of xl.
c
        iboundary = int(float(nx)*vsij(5))
        do 450 j=1,n2
        do 450 i=1,n1
        if (i.le.iboundary) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
  450   continue
      elseif ((isurfv.ge.500) .and. (isurfv .le. 599)) then
c
c     migrating ridge; see migrate_ridge for description of input
c     velocity given by vsij(1-4)
c
      iflag = 1
      vp1 = vsij(1)
      vp2 = vsij(3)
      xridge = vsij(5)
      vridge = vsij(6)
      wplate = vsij(7)
      call migrate_ridge
     1     (iflag,n1,n2,vp1,vp2,xridge,vridge,wplate,v)

      elseif (isurfv.eq.600) then
      xc_1 =2.0d0
      xc_2 =2.0d0
      yc_1=8.0d0
      yc_2=8.0d0
      omega_1=87.0d0
      omega_2=-87.0d0

      do 655 j=1,n2
       do 655 i=1,n1
         v(i,j,1)=0.0
         v(i,j,2)=0.0
655   continue
 
      do 660 j=2,n2-1
       do 660 i=2,n1-1
        if(i.lt.nx1/2)then
         x1=dx*(i-1)
         y1=dy*(j-1)
         r=sqrt((xc_1-x1)**2+(yc_1-y1)**2)
         theta=atan((x1-xc_1)/(y1-yc_1))
         v(i,j,1)=omega_1*r*cos(theta)
         if(theta.gt.zero)v(i,j,1)=-v(i,j,1)
         v(i,j,2)=omega_1*r*sin(theta)
        elseif(i.gt.nx1/2)then
         x1=dx*(i-1)
         y1=dy*(j-1)
         r=sqrt((xc_2-x1)**2+(yc_2-y1)**2)
         theta=atan((x1-xc_2)/(y1-yc_2))
         v(i,j,1)=omega_2*r*cos(theta-pi*.5)
         if(theta.lt.zero)v(i,j,1)=-v(i,j,1)
         v(i,j,2)=omega_2*r*sin(theta)

c         r=dsqrt((xc_1-x1)**2+(yc_1-y1)**2)
c         theta=datan((x1-xc_1)/(y1-yc_1))
c         v(i,j,1)=omega_1*r*dcos(theta)
c         if(theta.gt.zero)v(i,j,1)=-v(i,j,1)
c         v(i,j,2)=omega_1*r*dsin(theta)
c        elseif(i.gt.nx1/2)then
c         x1=dx*(i-1)
c         y1=dy*(j-1)
c         r=dsqrt((xc_2-x1)**2+(yc_2-y1)**2)
c         theta=datan((x1-xc_2)/(y1-yc_2))
c         v(i,j,1)=omega_2*r*dcos(theta-pi*.5)
c         if(theta.lt.zero)v(i,j,1)=-v(i,j,1)
c         v(i,j,2)=omega_2*r*dsin(theta)

       endif
660   continue
      endif
c cg      open(unit=45, file="tape45")
c cg      write(45,97)nx,j3,isurfv,ncell1,ncell2
c cg   97 format(5i8)
c cg      do 98 j=1,j3
c cg      do 98 i=1,nx
c cg      vxy=sqrt((v(i,j,1)**2)+(v(i,j,2)**2))
c cg      write(45,99)i,j,v(i,j,1),v(i,j,2),vxy
c cg   99 format(i5,2x,i5,2x,3e15.5)
c cg   98 continue
c cg      close(45)
      return
c
  190 format (i5,3x,i5,3x,e12.3,2x,e12.3)
  200 format (i5,3x,i5,3x,e12.3,2x,e12.3)
  210 format (128i1)
      end
