      subroutine tempstats(ijob)

c $Log:   /pvcs.config/mc3dvv/src/tempstats.F_a  $
c   
c      Rev 1.1   Fri Jul 30 15:55:06 1999   lowman
c     Fixed temperature averaging bug resulting from double
c     averaging over endpoints for perriodic b.c. case and
c     made arrays allocatable.
c   
c      Rev 1.0   Tue Mar 23 16:52:00 1999   lowman
c   Initial revision.

      use module_precision
      use module_param
      use module_a1
      use module_a6
      use module_a3
      use module_ftcoef
      use module_tstats
      use module_slvelu
#ifdef MPI
      include 'mpif.h'
#endif

c      dimension havg_oft(512,10)
       dimension volavg_oft(10)
c      dimension yavg_oft(512,10,3)

      common/ctempstats/icall

      character*25 fileroot

#ifdef MPI
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif

      if(ijob.ne.1)then
        if(icycle.eq.1)icall=0
        icall=icall+1
        if (myid .eq. 0) then
        lunum=71
        iformat=2
        fileroot='havg_ofT'
        itail=0
        call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        lunum=72
        fileroot='centerT'
        call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        lunum=73
        fileroot='yavg_ofT1'
        call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        lunum=74
        fileroot='yavg_ofT2'
        call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        lunum=75
        fileroot='yavg_ofT3'
        call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        endif
      endif
      if(myid .eq. 0) then
        if(icycle.eq.1)then
          open(unit=70,file='volavg_ofT')
        endif
      endif
      dxdy = dx*dy
      qxy  = quarter*dxdy
      hqxy = half*qxy

      call ttoft

      do 15 ipla = 1,nplate+1
      do 10 k = 1,nz
      havg_oft(k,ipla) = zero
   10 continue
      do 12 idepth=1,3
      do 12 i = 1,nx
      yavg_oft(i,ipla,idepth) = zero
   12 continue
   15 continue
      do 25 idepth = 1,3
       if(idepth.eq.1)then
        jdepth=nz1-lith
       elseif(idepth.eq.2)then
        jdepth=nz1/2+1
       else
        jdepth=lith
       endif
      do 25 ipla = 1,nplate
        do 22 i = 1,nx
        template_jsum=zero
          do 20 j = 1,j3 
             yavg_oft(i,ipla,idepth)=
     1       template(i,j,ipla)*ft(i,j,jdepth)+yavg_oft(i,ipla,idepth)
             template_jsum=template_jsum+template(i,j,ipla)
             if(i.eq.nx.and.j.ne.j3)then
              yavg_oft(i,ipla,idepth)=
     1        template(1,j,ipla)*ft(i,j,jdepth)+yavg_oft(i,ipla,idepth)
              template_jsum=template_jsum+template(1,j,ipla)
             endif
             if(j.eq.j3)then
              yavg_oft(i,ipla,idepth)=
     1        template(i,1,ipla)*ft(i,j,jdepth)+yavg_oft(i,ipla,idepth)
              template_jsum=template_jsum+template(i,1,ipla)
             endif
 20       continue
        if(template_jsum.ne.zero)
     1   yavg_oft(i,ipla,idepth)=
     2   yavg_oft(i,ipla,idepth)/(template_jsum*rat) 
 22     continue
 25   continue

#ifdef MPI
      call mpilayer(nz,numprocs,myid,izstart,izstop)
#else
      izstart=1
      izstop=nz
#endif

      do 65 ipla = 1,nplate
c       do 61 k = 1,nz
        do 61 k=izstart,izstop
        template_sum=zero
          do 60 j = 1,j3
          do 60 i = 1,nx-1
            if ((j.eq.j3).and.(j3.gt.1))goto 60
             havg_oft(k,ipla) = 
     1       template(i,j,ipla)*ft(i,j,k)+havg_oft(k,ipla)
             template_sum=template_sum+template(i,j,ipla)
 60       continue
        havg_oft(k,ipla)=havg_oft(k,ipla)/(template_sum*rat)
 61     continue

#ifdef MPI
        call MPI_ALLREDUCE(havg_oft(1,ipla),zwork,nz,
     &        MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,ierr)

        do 62 kk=1,nz
          havg_oft(kk,ipla) = zwork(kk)
 62     continue
#endif

        volavg_oft(ipla)=zero
        do 63 k=1,nz
 63     volavg_oft(ipla)=havg_oft(k,ipla)/float(nz)+volavg_oft(ipla) 

 65   continue

c     do 68 k=1,nz
      do 68 k=izstart,izstop
       havg_oft(k,nplate+1)=zero
       template_sum=zero
       do 66 j=1,j3
       do 66 i=1,nx-1
        if((j.eq.j3).and.(j3.gt.1))go to 66
        havg_oft(k,nplate+1)=ft(i,j,k)+havg_oft(k,nplate+1)
        template_sum=template_sum+1.
 66    continue
       havg_oft(k,nplate+1)=havg_oft(k,nplate+1)/(rat*template_sum)
 68    continue
#ifdef MPI
        call MPI_ALLREDUCE(havg_oft(1,nplate+1),zwork,nz,
     &        MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,ierr)

        do 69 kk=1,nz
          havg_oft(kk,nplate+1) = zwork(kk)
 69     continue
#endif

       volavg_oft(nplate+1)=zero
       do 70 k=1,nz
 70    volavg_oft(nplate+1)=havg_oft(k,nplate+1)/float(nz)+
     & volavg_oft(nplate+1)

      dz=one/float(nz-1)
      sumdz=zero 
      if(myid .eq. 0) then
        if(ijob.eq.1)then
        write(70,100) time, (volavg_oft(ipla),ipla=1,nplate+1),
     & ((volavg_oft(jpla)-volavg_oft(nplate+1))
     & /volavg_oft(nplate+1),jpla=1,nplate)
        else
        write(70,100) time, (volavg_oft(ipla),ipla=1,nplate+1),
     & ((volavg_oft(jpla)-volavg_oft(nplate+1))
     & /volavg_oft(nplate+1),jpla=1,nplate)
        do 71 k = 1,nz
        if(k.ne.nz)then
        write(71,100) sumdz,(havg_oft(k,ipla),ipla=1,nplate+1),
     & ((havg_oft(k,ipla)-havg_oft(k,nplate+1))
     & /havg_oft(k,nplate+1),ipla=1,nplate)
        if(j3.ne.1)write(72,100) sumdz,ft(nx/2+1,j3/2,k),
     &  ft(nx/2+1,j3/2,k)/havg_oft(k,nplate+1)
        else
        write(71,100) sumdz,(havg_oft(k,ipla),ipla=1,nplate+1),
     & ((havg_oft(k,ipla)-havg_oft(k,nplate+1)),ipla=1,nplate)
        if(j3.ne.1)write(72,100) sumdz,ft(nx/2+1,j3/2,k)/rat,
     &  ft(nx/2+1,j3/2,k)/rat
        endif 
        sumdz=sumdz+dz
 71     continue
        sumdx=zero
        do 73 i = 1,nx
        write(73,100) sumdx,(yavg_oft(i,ipla,1),ipla=1,nplate),
     & (yavg_oft(i,jpla,1)/havg_oft(nz1-lith,nplate+1),jpla=1,nplate)
        write(74,100) sumdx,(yavg_oft(i,ipla,2),ipla=1,nplate),
     & (yavg_oft(i,jpla,2)/havg_oft(nz1-lith,nplate+1),jpla=1,nplate)
        write(75,100) sumdx,(yavg_oft(i,ipla,3),ipla=1,nplate),
     & (yavg_oft(i,jpla,3)/havg_oft(nz1-lith,nplate+1),jpla=1,nplate)
        sumdx=sumdx+dx 
 73     continue
        close(71)
        close(72)
        close(73)
        close(74)
        close(75)
        endif      
      endif      
      call flush(70)

100   format(13(e15.7,1x))

      end
