C $Log:   /pvcs.config/mc3dvv/src/userftaccess.F_a  $
c   
c      Rev 1.2   Fri Jul 30 15:29:48 1999   lowman
c     Added ifsym=2 option
c   
c      Rev 1.1   Tue Feb 09 14:38:04 1999   lowman
c   
c      Rev 1.0   Wed Oct 07 11:19:52 1998   lowman
c   Initial revision.

      subroutine userftaccess
      use module_precision
      use module_param
      use module_a3
      use module_a12
      use module_ftcoef

      common/csym/ ifsym

c     if ifsym = 1, force the solution to be symmetric 
c     about the solution space midplane parallel to y=0 
c     by suppressing the wave numbers for the
c     asymmetric solution. 
c
c     ifsym = 0 don't force symmetry
c     ifsym = 1 force symmetry
c
c MPI ALERT:
#ifdef MPI
      include 'mpif.h'
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )   
#else
      myid=0
#endif

      if(ifsym .eq. 0)return
c
c     write a warning message to tapeout
c

      if(ifsym .eq. 1)then

        if(icycle .eq. 1)then
           if(myid .eq. 0) then
             if(ny .eq. 2)then
               write(6,500)
             else
               write(6,500)
               write(6,502)
             endif
           endif
        endif
c
c     Below, force the temperature field to be symmetric
c     about the center of the box by suppressing the
c     sine terms in the temperature spectrum.
c
c     This can be used for comparison to one plate calculation
c     of other codes.
c
          do 125 k = 1,nz
          do 125 j = 1,nyr
          do 125 i = 3,nxr,2
            ft(i,j,k) = 0.0 
  125     continue

      elseif(ifsym .eq. 2) then

        if(icycle .eq. 1)then
          if(myid .eq. 0) write(6,600)
        endif

        do 135 k = nz-lith,nz
        do 135 j = 1,nyr
        do 135 i = 3,nxr,2
          ft(i,j,k) = 0.0
  135   continue
      endif

c
  500 format ("**********ifsym ifsym ifsym ifsym ifsym************",/,
     1        "**********ifsym ifsym ifsym ifsym ifsym************",/,
     2        "WARNING: warning ifsym = 1 forcing symmetric solution",/,
     3        "**********ifsym ifsym ifsym ifsym ifsym************",/,
     4        "**********ifsym ifsym ifsym ifsym ifsym************")
  502 format ("symmetric 3d solution specified, symmetric about xl/2")
  600 format ("**********ifsym ifsym ifsym ifsym ifsym************",/,
     1        "**********ifsym ifsym ifsym ifsym ifsym************",/,
     2        "WARNING: warning ifsym = 2 zeroing out plate forces",/,
     3        "**********ifsym ifsym ifsym ifsym ifsym************",/,
     4        "**********ifsym ifsym ifsym ifsym ifsym************")

      return
      end

 
