c $Log:   /pvcs.config/mc3dvv/src/vdifeqlu.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:34 1997   pvcs
c 
c *************************************************************
c *   VDIFEQLU
c *
c *   7/1/96: Correction in toroidal part for ibcb=ibct=1
c *           Make sure diagonal element for top stress b.c. 
c *           is one. (PvK)
c *************************************************************
c
c   Rev 1.1   12/21/93 16:57:44   llt
cadded log

      subroutine vdifeqlu (npt,indexv,abe,lda,n,b,y,nyj,nyk,luflag,
     2    l,l2,vps,vts,r,nrdim,vis,nvisdim,vnu,nvnudim,
     3    z,nzdim,nz,ibcb,ibct,ivistype,r1,r2,r3,r4,ksl,ncabe)
      use module_precision
c
c     user supplied routine to form the abe matrix and b vector
c     for 2 point boundary value solution via relaxation method
c
c     when luflag = 0 form b vector and abe matrix
c     when luflag = 1 only form b vector
c     when luflag = 4 only form abe matrix 
c
      real l, l2
c      use module_giparam
c      use module_param
c      use module_a3
c      common /a8/ l2, l, vps, vts
c      common /a9/ r(kmx)
c      common /viscom/ vis(ksx), vnu(ksx)
      dimension r(nrdim)
      dimension r1(ksl),r2(ksl),r3(ksl),r4(ksl)
      dimension vis(nvisdim), vnu(nvnudim)
      dimension abe(lda,ncabe), b(n), y(nyj,nyk), indexv(nyj)
      dimension z(nzdim)
      
      kz1=1
      kz2=nz
c
c      poloidal solution
c 
       if(npt .eq. 4)then
c       
c      calculate abe matrix if luflag = 0
c
      if((luflag .eq.  0) .or. (luflag .eq. 4))then
c
c      zero array
c
      do 5 k=1,ncabe
      do 5 i=1,lda
        abe(i,k) = zero
    5 continue
c
c     equations at bottom boundary
c
       if (ibcb.eq.2) then
         abe(1,5+indexv(1)) = one
         abe(2,4+indexv(2)) = one
       else
         abe(1,5+indexv(2)) = one
         abe(2,4+indexv(3)) = one
       endif
c
c     equations at top boundary
c
      k1=4*kz2-1
      k2=k1+1
        if (ibct.gt.1) then
          abe(k1,3+indexv(1)) = one
          abe(k2,2+indexv(2)) = one
        else
          abe(k1,3+indexv(2)) = one
          abe(k2,2+indexv(3)) = one
        endif
c
c     equations for interior points
c
        do 100 k = kz1+1, kz2
        km1=k-1
        dz=(z(k)-z(km1))*half
        dzl=l*dz
        dz4l=4.*l*dzl
        k1=4*(km1)-1
        k2=k1+1
        k3=k1+2
        k4=k1+3
 
        abe(k1,3+indexv(1)) = oneneg
        abe(k1,3+indexv(2)) = -dzl
        abe(k1,3+indexv(3)) = -dz*vnu(km1)
        abe(k1,3+indexv(4)) = zero
        abe(k1,7+indexv(1)) = one
        abe(k1,7+indexv(2)) = -dzl
        abe(k1,7+indexv(3)) = -dz*vnu(k)
        abe(k1,7+indexv(4)) = zero
        
        abe(k2,2+indexv(1)) = dzl
        abe(k2,2+indexv(2)) = oneneg
        abe(k2,2+indexv(3)) = zero
        abe(k2,2+indexv(4)) = zero
        abe(k2,6+indexv(1)) = dzl
        abe(k2,6+indexv(2)) = one
        abe(k2,6+indexv(3)) = zero
        abe(k2,6+indexv(4)) = zero
        
        abe(k3,1+indexv(1)) = -dz4l*vis(km1)
        abe(k3,1+indexv(2)) = zero
        abe(k3,1+indexv(3)) = oneneg
        abe(k3,1+indexv(4)) = -dzl
        abe(k3,5+indexv(1)) = -dz4l*vis(k)
        abe(k3,5+indexv(2)) = zero
        abe(k3,5+indexv(3)) = one
        abe(k3,5+indexv(4)) = -dzl
        
        abe(k4,  indexv(1)) = zero
        abe(k4,  indexv(2)) = zero
        abe(k4,  indexv(3)) = dzl
        abe(k4,  indexv(4)) = oneneg
        abe(k4,4+indexv(1)) = zero
        abe(k4,4+indexv(2)) = zero
        abe(k4,4+indexv(3)) = dzl
        abe(k4,4+indexv(4)) = one
  100 continue
c
      endif
c  
      if(luflag .ne. 4)then  
      
      do 190 k=1,npt*kz2
      b(k)=zero
  190 continue 
c
c     equations at bottom boundary
c
        if (ibcb.eq.2) then
          b(kz1  ) = y(1,1)
          b(kz1+1) = y(2,1)
        else
          b(kz1  ) = y(2,1)
          b(kz1+1) = y(3,1)
        endif
c
c     equations at top boundary
c
        if (ibct.gt.1) then
          b(4*kz2-1) = y(1,nz)-vps
          b(4*kz2  ) = y(2,nz)
        else
          b(4*kz2-1) = y(2,nz)
          b(4*kz2  ) = y(3,nz)
        endif
 
        do 200 k = kz1+1, kz2
          km1=k-1       
          dz=(z(k)-z(km1))*half
          dzl=l*dz
          dz4l=4.*l*dzl
          k1=4*(km1)-1
          k2=k1+1
          k3=k1+2
          k4=k1+3
          if(ivistype .lt. 0)then
            b(k1) = y(1,k)-y(1,km1)-dz*(l*(y(2,k)+y(2,km1))+
     1        (vnu(k)*y(3,k)+vnu(km1)*y(3,km1))+(r1(k)+r1(km1)))
            b(k2) = y(2,k)-y(2,km1)+dz*l*(y(1,k)+y(1,km1))
            b(k3) = y(3,k)-y(3,km1)-dz*(4.*l2*(vis(k)*y(1,k)+
     1        vis(km1)*y(1,km1))+l*(y(4,k)+y(4,km1))+(r2(k)+r2(km1)))
            b(k4) = y(4,k)-y(4,km1)+dz*(l*(y(3,k)+y(3,km1))-
     1              (r(k)+r(km1)))
          else
            b(k1) = y(1,k)-y(1,km1)-dz*(l*(y(2,k)+y(2,km1))+
     1       (vnu(k)*y(3,k)+vnu(km1)*y(3,km1)))
            b(k2) = y(2,k)-y(2,km1)+dz*l*(y(1,k)+y(1,km1))
            b(k3) = y(3,k)-y(3,km1)-dz*(4.*l2*(vis(k)*y(1,k)+
     1        vis(km1)*y(1,km1))+l*(y(4,k)+y(4,km1)))
            b(k4) = y(4,k)-y(4,km1)+dz*(l*(y(3,k)+y(3,km1))-
     1              (r(k)+r(km1)))
        endif
  200 continue
      endif
c*****************************************************************        
c     toroidal solution
c
      elseif(npt .eq. 2)then
c
      if((luflag .eq.  0) .or. (luflag .eq. 4))then
c
      do 260 k=1,ncabe
      do 260 i=1,lda
         abe(i,k) = zero
  260 continue
c
c     equations for bottom boundary
c
        if (ibcb.eq.2) then
          abe(1,2+indexv(1)) = one
        else
          abe(1,2+indexv(2)) = one
        endif
c
c     equations for top boundary
c
        if (ibct.gt.1) then
          abe(2*kz2,1+indexv(1)) = one
        else if (ibct.eq.1.and.ibcb.eq.2) then
          abe(2*kz2,1+indexv(2)) = one
        else
c  ********** Correction for ibcb=ibct=1
          abe(2*kz2,1+indexv(1)) = one
          abe(2*kz2,1+indexv(2)) = one
          b(2*kz2)=0
        endif
        
        do 300 k = kz1+1, kz2
          km1=k-1
          dz=(z(k)-z(km1))*half
          dzl2=dz*l2
          k1=2*(km1)
          k2=k1+1
          abe(k1,1+indexv(1)) = oneneg
          abe(k1,1+indexv(2)) = -dz*vnu(km1)
          abe(k1,3+indexv(1)) = one
          abe(k1,3+indexv(2)) = -dz*vnu(k)
          abe(k2,  indexv(1)) = -dzl2*vis(km1)
          abe(k2,  indexv(2)) = oneneg
          abe(k2,2+indexv(1)) = -dzl2*vis(k)
          abe(k2,2+indexv(2)) = one
  300   continue
      
      endif
c  
      if(luflag .ne. 4)then  
      do 390 k = 1,npt*kz2
      b(k) = zero
  390 continue 
c
c     equations for bottom boundary
c
        if (ibcb.eq.2) then
          b(kz1) = y(1,1)
        else
          b(kz1) = y(2,1)
        endif
c
c     equations for top boundary
c
        if (ibct.gt.1) then
          b(2*kz2) = y(1,nz)-vts
        else
          b(2*kz2) = y(2,nz)
        endif
c        
c     equations for interior points
c
       do 400 k = kz1+1, kz2
        km1=k-1
        dz=(z(k)-z(km1))*half
        dzl=l*dz
        k1=2*(km1)
        k2=k1+1
        if(ivistype .lt. 0)then
        b(k1) = 
     1   y(1,k)-y(1,km1)-dz*(vnu(k)*y(2,k)+vnu(km1)*y(2,km1)+	!changed -r3,r4 to +r3,r4
     2        (r3(k)+r3(km1)))
        b(k2) = 
     1   y(2,k)-y(2,km1)-dz*(l2*(vis(k)*y(1,k)+vis(km1)*y(1,km1))+
     2        (r4(k)+r4(km1)))					!corrected 1/12/95
        else
        b(k1) = 
     1   y(1,k)-y(1,km1)-dz*   (vnu(k)*y(2,k)+vnu(km1)*y(2,km1))
        b(k2) = 
     1   y(2,k)-y(2,km1)-dz*l2*(vis(k)*y(1,k)+vis(km1)*y(1,km1))
        endif
  400 continue
      endif
      
      endif
      return
      end
