      subroutine alpharatio
c
c ********************************************************************
c *  ALPHARATIO                                                      *
c ********************************************************************
c This subroutine is called from flow if ialphatype.ne.0 and returns 
c alpha(k).
c 
c     ialphatype = 0 = default. Constant alpha (no depth dependence)
c
c     ialphatype = 1 for depthdependence of alpha according to equation
c                    of Zhao & Yuen (87).
c        alphain = multiplicative factor for magnitude of the reduction 
c                  of alpha with depth for ialphatype = 1.
c                  
c     DN 8/04
c
c *********************************************************************
      use module_precision
      use module_param
      use module_depthdep
      use module_a3

      aconst = one/(one/alphain)**(one/three)
      bconst = aconst-one
      do k=1,kmx-1
        zed=real(k)/real(kmx-1)
        alpha(k)=(one/(-bconst*zed + aconst))**three
      enddo
      do k=kmx,2,-1
        alpha(k)=alpha(k-1)
      enddo
      alpha(1)=1.d0/alphain

      return
      end
