c $Log:   /pvcs.config/mc3dvv/src/bc.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:20:50 1997   pvcs
c 
c *************************************************************
c *   BC
c *   
c *   u,v,w i/o  Solution arrays, either describing velocity
c *              or stress
c *   idim1 i    x-Dimension of velocity arrays
c *
c *   lbcx  i    Indicates type of side boundary conditions
c *                = 0 for periodic
c *                = 1 for free slip sides
c *                = 2 for no slip sides
c *   idim2 i    y-Dimension of velocity arrays
c *   mbcy  i    See lbcx, but now for y direction.
c *   ijob  i    obsolete
c *************************************************************
c *   OUTPUT
c *   Boundary values in solution arrays may have been updated.
c *************************************************************
      subroutine bc_tau 
     1 (tau13,tau23,tauz,idim1,ncx,ndx,lbcx,idim2,ncy,ndy,mbcy,ncz,ijob)
      use module_precision
      dimension tau13(idim1,idim2,*), tau23(idim1,idim2,*), 
     &  tauz(idim1,idim2,*)

      if (ncy.eq.1) then
        ncyp1=1
      else
        ncyp1=ncy+1
      endif

      do 70 k=1,ncz
c        *** For each depth level

        if (lbcx.eq.0) then
c         *** Periodic in x
          do 10 i=1,ncx
            tau13(i,ncyp1,k)=tau13(i,1,k)
            tau23(i,ncyp1,k)=tau23(i,1,k)
            tauz(i,ncyp1,k)=tauz(i,1,k)
   10     continue
        endif
        if (mbcy.eq.0) then
c         *** Periodic in y
          do 20 j=1,ncy
            tau13(ncx+1,j,k)=tau13(1,j,k)
            tau23(ncx+1,j,k)=tau23(1,j,k)
            tauz(ncx+1,j,k)=tauz(1,j,k)
   20     continue
        endif
        if ((lbcx.eq.0).and.(mbcy.eq.0)) then
          tau13(ncx+1,ncyp1,k)=tau13(1,1,k)
          tau23(ncx+1,ncyp1,k)=tau23(1,1,k)
          tauz(ncx+1,ncyp1,k)=tauz(1,1,k)
        endif

c       *** Symmetry conditions
        if ((lbcx.eq.1).and.(ndy.ne.1)) then
          do 30 j=1,ndy
            tau13(1,j,k)=0.
            tau13(ndx,j,k)=0.
   30     continue
        endif
        if (mbcy.eq.1) then
          do 40 i=1,ndx
            tau23(i,1,k)=0.
            tau23(i,ndy,k)=0.
   40     continue
        endif

c       *** Rigid boundary conditions
        if (lbcx.eq.2) then
          do 50 j=1,ndy
            tau13(1,j,k)=0.
            tau13(ndx,j,k)=0.
            tau23(1,j,k)=0.
            tau23(ndx,j,k)=0.
            tauz(1,j,k)=0.
            tauz(ndx,j,k)=0.
   50     continue
        endif

        if (mbcy.eq.2) then
           do 60 i=1,ndx
              tau13(i,1,k)=0.
              tau13(i,ndy,k)=0.
              tau23(i,1,k)=0.
              tau23(i,ndy,k)=0.
              tauz(i,1,k)=0.
              tauz(i,ndy,k)=0.
   60      continue
        endif

   70 continue

      return
      end
