c $Log:   /pvcs.config/mc3dvv/src/chemflo.F_a  $
c
c   Rev 1.1   Fri Jul 30 15:04:28 1999   lowman
c  Added Nu.h includes
c
c   Rev 1.0   Mon Jul 14 14:20:56 1997   pvcs
c 
c *************************************************************
c *   CHEMFLO
c *************************************************************
      subroutine chemflo
      use module_precision
c
c     calculate chemical advection and diffusion
c     using weighted donor explicit scheme
c
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_ac1
      use module_a2
      use module_gia3
      use module_a3
      use module_nu
c      common /xxx/ tavrg(514), znu(514),tbar
      use module_a77

      dxdy   = dx*dy

      nchem = 1

      do 700 ichem = 1, nchem
      if(icycle .eq. 1)then
        do 710 k=1,nz1
        ci=1.-avz(k)
        do 710 j=1,j4
        do 710 i=1,nx1
        if(ci .lt. .4)then
          if(i .lt. nx/2)then
          c(i,j,k,ichem)=0.0
          else
          c(i,j,k,ichem)=0.25
          endif
        else
          if(i .lt. nx/2)then
          c(i,j,k,ichem)=0.5
          else
          c(i,j,k,ichem)=1.0
          endif
        endif
 710  continue
      endif
      
      call flux(c(1,1,1,ichem),dtensr,inx,jnx,knx)
c
      if (dwate.ne.0.0) call ctensr(c(1,1,1,ichem),dtensr,inx,jnx,knx)
c
c     compute heat transport
c
c
c     2-D problem
c
      if (ny.eq.2) then
        do 40 k = 2,nz
        dz = z(k)-z(k-1)
        voli = one/(dz*dx)
        do 40 i = 2,nx
        cn(i,1,k,ichem) = 
     1   c(i,1,k,ichem)+dt*((advctd(i,1,k)+dtensr(i,1,k)*dwate)*voli)
   40   continue
c
c     3-D problem
c
      else
        do 50 k = 2,nz
        dz = z(k)-z(k-1)
        voli = one/(dz*dxdy)
        do 50 j = 2,ny
        do 50 i = 2,nx
        cn(i,j,k,ichem) = c(i,j,k,ichem)+
     1   dt*((advctd(i,j,k)+dtensr(i,j,k)*dwate)*voli)
   50   continue
      endif
c
c  set value of side boundary ghost cell dependent on boundary
c    conditions
c
c      call meshbc
c     1  (cn(1,1,1,ichem),inx,jnx,knx,nx,ny,nz,j1,j2,j3,j4,lbd,mbd)
c
c
      if (lbd.eq.0) then
        do 60 k = 2,nz
        do 60 j = j2,j3
        cn(1,j,k,ichem) = cn(nx,j,k,ichem)
   60   cn(nx1,j,k,ichem) = cn(2,j,k,ichem)
      else
        do 70 k = 2,nz
        do 70 j = j2,j3
        cn(1,j,k,ichem) = cn(2,j,k,ichem)
   70   cn(nx1,j,k,ichem) = cn(nx,j,k,ichem)
      endif
      if (ny.ne.2) then
        if (mbd.eq.0) then
          do 80 k = 1,nz1
          do 80 i = 1,nx1
          cn(i,1,k,ichem) = cn(i,ny,k,ichem)
   80     cn(i,ny1,k,ichem) = cn(i,2,k,ichem)
        else
          do 90 k = 1,nz1
          do 90 i = 1,nx1
          cn(i,1,k,ichem) = cn(i,2,k,ichem)
   90     cn(i,ny1,k,ichem) = cn(i,ny,k,ichem)
        endif
      endif
c
      icbot = 1
      ictop = 1
      if (icbot.eq.1) then
        do 100 j = 1,j4
        do 100 i = 1,nx1
  100   cn(i,j,1,ichem) = cn(i,j,2,ichem)
      endif
      if (ictop.eq.1) then
        do 105 j = 1,j4
        do 105 i = 1,nx1
  105   cn(i,j,nz1,ichem) = cn(i,j,nz1-1,ichem)
      endif
c
c     no flux through top or bottom
c
      if (icbot.eq.1) then
        iz = 1
      else
        iz = 2
      endif
      if (ictop.eq.1) then
        niz = nz1
      else
        niz = nz1-1
      endif
c
      do 110 k = iz,niz
      do 110 j = 1,j4
      do 110 i = 1,nx1
  110 c(i,j,k,ichem) = cn(i,j,k,ichem)
c
  700 continue

      return
      end
