c $Log:   /pvcs.config/mc3dvv/src/dmantle.F_a  $
c
c   Rev 1.2   Fri Jul 30 15:34:02 1999   lowman
c  Added template2 argument to surfgeo call
c
c   Rev 1.0   Mon Jul 14 14:21:12 1997   pvcs
c 
c *************************************************************
c *   DMANTLE
c *
c *   Subroutine MANTLE adapted for use with DASPK
c *************************************************************
      subroutine dmantle
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_ac1
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_nu
c      common /xxx/ tavrg(514), znu(514), tbar
      use module_ftcoef
      use module_spwork
      use module_work1d
c      common /work2d/ wk3d(inx,knx)
c      common /work3d/ wk3d(inx,jnx,knx)
      use module_temp4
      use module_viscom
      use module_a6
      use module_a12
c      common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c     1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c     2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a30
      use module_a77
      use module_timeint
      use module_routput
      common /start1/ restrt, initlt, istart
      external res,djack,dpsol
      common /ijc/ ijcycle

      data nrestrt / 1 /
      data tcrash, tinc / 3600., 3600. /

c *************************************************************
c *   INITIALIZE
c *       Define initial temperature field
c *       Define plate geometry
c *       Check input for consistency
c *       Calculate instantaneous velocity
c *************************************************************
      istart=0
      ijcycle = 0
c     *** Initialize temperature and such
      call init
c     *** Determine plate geometry
      call surfgeo (template,iplgeo,template2)
c     *** Check for inconsistent input parameters
      call incheck(imx, jmx, kmx, nxyz, isx, jsx, ksx, nbdd,
     1  ijksx, iqx, jqx, kqx, ijkqx, inx, jnx, knx, mxmy, 
     2  ijknx, ijkmx,  ijksf, inxsf, jnxsf, knxsf, imxsf, jmxsf,
     3  kmxsf, npla, npssd, ncabe, nabe,icx,jcx,kcx,nspecies)
      call userout('init')

      icycle = icycle+1
      ijcycle = ijcycle

c     *** Calculate velocity at starting time
      if (isolve.eq.5) then
c        *** Define velocity using analytical expression
         call vofxyz
      else
         if (kchem.eq.0) then
            call flow
         else
            write(6,*) 'PWARN(dmantle): flow_layer not yet adapted' 
            write(6,*) '                for use with DASPK'
            call flow_layer
         endif
      endif
c     *** Average velocities to force divergence on cell faces to zero
c     *** (use advctd as a temporary work array)
      call velprm (u,v,advctd,inx,jnx,knx)
      call userout('flow')

      
      
c *************************************************************
c *   *** Information for DASPK
c *************************************************************
c     *** enable the code to initialize itself
      info(1) = 0
c     ** accuracy: use RTOL and ATOL both as scalars
      info(2) = 0
c     *** give solution only at TOUT (0) or at all intermediate steps (1)
      info(3) = 0
c     **** no restrictions on time t
      info(4) = 0
c     **** Direct method: Calculate partial derivs automatically
      info(5) = 0
c     **** Direct method: Forget about bandedness of dG/dY + CJ*dG/dYPRIME
      info(6) = 0
c     **** Code should decide on its maximum stepsize
      info(7) = 0
c     **** Code should decide on its initial stepsize
      info(8) = 0
c     rwork(3) = 0.00001
c     **** Maximum order is 5 by default
      info(9) = 0
c     **** No special nonnegativity constraints
      info(10) = 0
c     **** t,y and y' are consistent (0) or not (1)
      info(11) = 0
c     **** Use direct (0) or Krylov (1) method
c     info(12) = 0
      info(12) = 1
c     **** Default parameters for iteration
      info(13) = 0
c     **** Dummy parameter
      info(14) = 0
c     **** Provide external JACK function to update preconditioner periodically
c     **** (Use only if info(12)=1).
      info(15) = 1

      call detyprime(t,yprime,itx,jtx,ktx)

      ipar(1) = ijktx
c     *** These three are used in DJACK,DPRECO
      ipar(3) = mxml
      ipar(4) = mxmu
      ipar(5) = 0
c     *** Communicate norder to RES
      ipar(10) = norder

c     *** Some local counters/timers.
      noutstep = nint(time/dtout)
      tout_daspk = (noutstep+1)*dtout
      tout = tout_daspk
      nout = nint(tend/dtout)
      write(6,'(''START DASPK at time ..... '',f12.7)') time
      write(6,'(''START DASPK at step ..... '',i12  )') noutstep
      write(6,'(''Output every ............ '',f12.7)') dtout
      write(6,'(''Total number of steps ... '',i12)') nout
      write(6,'(''Number of equations ..... '',i12)') ijktx
      write(6,'(''Upper/lower bandwith .... '',2i12)') mxmu,mxml
c *************************************************************    
c *   *** MAIN LOOP: DDASPK is the driver. All the work happens
c *   ***            in external routine RES.
c *   ***            Most output is done in OUTPUT
c *************************************************************
      do iout = noutstep+1,nout
         write(6,'(''DASPK: '',i5,2f12.7)') iout,time,tout
         call ddaspk(res,ijktx,time,t,yprime,tout_daspk,info,rtol,atol,
     1        idid,rwork,nrwork,iiwork,niwork,rpar,ipar,djack,dpsol)
         hu = rwork(7)
         nqu = iiwork(8)
         nst = iiwork(11)
         nni = iiwork(19)
         nli = iiwork(12)
         gnus = calnus(norder,1)
         vrms1 = calvrms(1)
         vrms2 = calvrms(2)
         call mig_mach(1,'sun***',rdum,seconds,idum,idum)
         ihour = seconds/3600
         imin  = (seconds-(ihour*3600))/60
         isec  = seconds - ihour*3600 - imin*60
         write(6,101) time,ihour,imin,isec,gnus,vrms1,vrms2,
     v           nqu,hu,nst,nni,nli  
c        *** For now, tout is increased in output(7)
         tout_daspk = tout_daspk+dtout
c        call userout('heat')
101      format(f12.5,i4,':',i2.2,':',i2.2,3f12.5,i3,e10.1,i7,i7,i7) 
      enddo
c *************************************************************
c *   *** END OF MAIN LOOP
c *************************************************************

c     ***  Display some final statistics for the problem:
      nst = iiwork(11)
      nre = iiwork(12) + ipar(lnre)
      npe = iiwork(13)
      liw = iiwork(17)
      lrw = iiwork(18)
      nni = iiwork(19)
      nli = iiwork(20)
      nps = iiwork(21)
      if (nni .ne. 0) afps = dfloat(nli)/dfloat(nni)
      ncfn = iiwork(15)
      ncfl = iiwork(16)
      write (6,80) lrw,liw,nst,nre,npe,nps,nni,nli,afps,
     1               ncfn,ncfl
 80   format(//' final statistics for this run..'/
     1   ' rwork size =',i10,'   iwork size =',i10/
     1   ' number of time steps ................ =',i5/
     1   ' number of function evaluations ...... =',i5/
     1   ' number of preconditioner evaluations  =',i5/
     1   ' number of preconditioner solves ..... =',i5/
     1   ' number of nonlinear iterations ...... =',i5/
     1   ' number of linear iterations ......... =',i5/
     1   ' ave. Krylov dim. =',f8.4/
     1   i3,' nonlinear conv. failures,',i5,' linear conv. failures')

60    continue
c     *** The final one: 
      call userout('end')

      return
      end
