c $Log:   /pvcs.config/mc3dvv/src/find00term.F_a  $
c
c *****************************************************
c *   FIND00TERM                                      *
c******************************************************

      subroutine find00term(iip)

      use module_precision
      use module_param
      use module_a3
      use module_a13
      use module_a23
      use module_a26
      real gradu, gradv

cc
cc      With periodic b.c. one must account for the
cc      l = 0 term in the fourier expansion. This
cc      term is the average value of the velocity
cc      and only occurs when the imposed
cc      surface velocity has a non-zero
cc     average.
cc
      if (((lbd.eq.0).and.(mbd.eq.0)).and.((fftvx(1,1).ne.0).or.(fftvy(1
     1 ,1).ne.0))) then
        if (ibcb.eq.1) then
          do 260 ll = 1,nz
          upl1(ll,iip) = fftvx(1,1)
          vpl1(ll,iip) = fftvy(1,1)
c
c     this does not really give the (00) term of the stress. However,
c     by adding the (00) term of the velocity (which is proportional
c     to the average velocity, and also proportional to the length of
c     the plate) we have implicitly included the condition that the
c     sum of all the velocities (and/or stress) over the whole are must
c     be zero.
c
          tau13pl(1,1,iip) = fftvx(1,1)
          tau13pl1(ll,iip) = fftvx(1,1)
          tau23pl(1,1,iip) = fftvy(1,1)
          tau23pl1(ll,iip) = fftvy(1,1)
  260     continue
        elseif (ibcb.eq.2) then
          gradu = fftvx(1,1)/float(nz-1)
          gradv = fftvy(1,1)/float(nz-1)
          do 270 ll = 1,nz
          fll = float(ll-1)
          upl1(ll,iip) = fll*gradu
          vpl1(ll,iip) = fll*gradv
          tau13pl1(ll,iip) = gradu
          tau23pl1(ll,iip) = gradv
          tau13pl(1,1,iip) = gradu
          tau23pl(1,1,iip) = gradv
  270     continue
        endif
      else
        do 280 ll = 1,nz
        upl1(ll,iip) = 0.
        vpl1(ll,iip) = 0.
        tau13pl1(ll,iip) = 0.
        tau23pl1(ll,iip) = 0.
  280   continue
      endif

      return
      end
