c $Log:   /pvcs.config/mc3dvv/src/ft2nrm.F_a  $
c
c   Rev 1.1   Fri Jul 16 13:47:00 1999   lowman
cRemoved arrays with hardwired dimensions
c
c   Rev 1.0   Mon Jul 14 14:21:24 1997   pvcs
c 
      subroutine ft2nrm_spwk (jifwrd,lp,l,mp,m,n,ldimf,mdimf)
      use module_precision
      use module_param
      use module_afftw
      use module_spwork
#ifdef MPI
      use module_mpibuf
      include 'mpif.h'
#endif
c
      dimension t(513)
      lr=l
      mr=m 
      nr=n
#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
      call mpilayer(nr,numprocs,myid,izstart,izstop)
      izstart = izstart - 1
      izstop  = izstop + 1
      if (izstart .lt. 1) izstart = 1
      if (izstop .gt. nr) izstop = nr
#else
      izstart=1
      izstop=nr
      myid=0
      numprocs=1
#endif

      fsize=nr*ldimf*mdimf
c      write(6,*)jifwrd,lp,l,mp,m,n,ldimf,mdimf
      if (jifwrd.eq.1) then
c      forward transform space to frequency
        ifwrd=1
      elseif (jifwrd.eq.-1) then
c      reverse transform frequency to space
        ifwrd=2
      endif
c
      if (lp.eq.1) then
        scalx=float(lr)
        ione=1
      elseif (lp.eq.2) then
        scalx=float(2*(lr+1))
        ione=2
        lr=lr+1
      elseif (lp.eq.4) then
        scalx=float(2*(lr-1))
        ione=1
      endif
      if (mp.eq.1) then
        scaly=float(mr)
        jone=1
      elseif (mp.eq.2) then
        scaly=float(2*(mr+1))
        jone=2
        mr=mr+1
      elseif (mp.eq.4) then
        scaly=float(2*(mr-1))
        jone=1
      endif
c
c      fix for 2D runs
c
      if(scaly .eq. 0.)scaly=1.
c
      go to (10,180), ifwrd
   10 continue
c
c     transform x
c
c     do 160 k=1,nr
      do 160 k=izstart,izstop
      do 170 j=jone,mr
c
c     pass f directly as a pointer
c
      go to (30,60,70,100,110), lp
   30 go to (40,50), ifwrd
   40 call rfftf (lr,spwk(1,j,k),wx)
      go to 140
   50 call rfftb (lr,spwk(1,j,k),wx)
      go to 140
   60 call sint (lr-1,spwk(2,j,k),wxs)
      go to 140
   70 go to (80,90), ifwrd
   80 call sinqf (lr-1,spwk(2,j,k),wxs)
      go to 140
   90 call sinqb (lr-1,spwk(2,j,k),wxs)
      go to 140
  100 call cost (lr,spwk(1,j,k),wxc)
      go to 140
  110 go to (120,130), ifwrd
  120 call cosqf (lr,spwk(1,j,k),wxc)
      go to 140
  130 call cosqb (lr,spwk(1,j,k),wxc)
  140 continue
c
c     f returns as a pointer
c
  170 continue
  160 continue
      go to (180,360), ifwrd
c
c     transform y
c
  180 continue
c
c     skip if not a 3D run
c
      if(jone .ne. mr)then
c     do 330 k=1,nr
      do 330 k=izstart,izstop
      do 340 i=ione,lr
      do 190 j=jone,mr
      fft1d(j)=spwk(i,j,k)
c     write(6,*)3,i,j,k,f(i,j,k)
  190 continue
      go to (200,230,240,270,280), mp
  200 go to (210,220), ifwrd
  210 call rfftf (mr,fft1d,wy)
      go to 310
  220 call rfftb (mr,fft1d,wy)
      go to 310
  230 call sint (mr-1,fft1d(2),wys)
      go to 310
  240 go to (250,260), ifwrd
  250 call sinqf (mr-1,fft1d(2),wys)
      go to 310
  260 call sinqb (mr-1,fft1d(2),wys)
      go to 310
  270 call cost (mr,fft1d,wyc)
      go to 310
  280 go to (290,300), ifwrd
  290 call cosqf (mr,fft1d,wyc)
      go to 310
  300 call cosqb (mr,fft1d,wyc)
  310 continue
      do 320 j=jone,mr
      spwk(i,j,k)=fft1d(j)
c     write(6,*)4,ione,jone,lr,nr,mr,i,j,k,f(i,j,k),wy(j)
  320 continue
  340 continue
  330 continue
      endif
      go to (350,10), ifwrd
  350 continue
c
      go to (400,360), ifwrd
  360 continue
      scfac=1./(scalx*scaly)
c     do 390 k=1,nr
      do 390 k=izstart,izstop
      do 380 j=jone,mr
      do 370 i=ione,lr
      spwk(i,j,k)=spwk(i,j,k)*scfac
  370 continue
  380 continue
  390 continue
  400 continue
      return
      end
