c *************************************************************
c *   GLOBALT2LOCAL
c *
c *   At input T(inx,jnx,*) contains a full copy of the temperature
c *   on each processor. At output, each processor has shifted its
c *   corresponding part to the bottom layer.
c *   
c *   PvK 6/99
c *************************************************************
      subroutine globalT2local(t,inx,jnx,nz,numprocs,myid,ii,jj)
      implicit none
      integer inx,jnx,nz,numprocs,myid,i,j,ii,jj
      integer izstart,izstop,izzstart,izzstop,kold,knew
      real*8 t(ii,jj,*)

      if (myid.eq.0) then
c        *** We already have it in the right place
         return
      endif

      call mpilayer(nz,numprocs,myid,izstart,izstop)
      izzstart = izstart - 3
c     *** PvK 7/16/99 
c     izzstop  = izstop + 2
      izzstop  = izstop + 2
      if (izzstart .lt. 1) izzstart = 1
      if (izzstop .gt. nz+1) izzstop = nz+1

c     write(6,'(''globalT2local myid: '',3i5,2x,2i5)') 
c    v  myid,izzstart,izzstop,1,izzstop-izzstart+1


      do knew=1,izzstop-izzstart+1
         kold = knew + izzstart - 1
         do j=1,jnx
            do i=1,inx
               t(i,j,knew) = t(i,j,kold)
            enddo
         enddo
      enddo

      return
      end

 
      subroutine localT2global(t,inx,jnx,nz,numprocs,myid,ii,jj)
      implicit none
      integer inx,jnx,nz,numprocs,myid,i,j,ii,jj
      integer izstart,izstop,izzstart,izzstop,kold,knew
      real*8 t(ii,jj,*)

      if (myid.eq.0) then
c        *** We already have it in the right place
         return
      endif


      call mpilayer(nz,numprocs,myid,izstart,izstop)
      izzstart = izstart - 3
      izzstop  = izstop + 2
      if (izzstart .lt. 1) izzstart = 1
      if (izzstop .gt. nz+1) izzstop = nz+1

c     write(6,'(''localT2global myid: '',3i5,2x,2i5)') 
c    v  myid,izzstop,izzstart,izzstop-izzstart+1,1

      do kold=izzstop,izzstart,-1
         knew = kold - izzstart + 1
         do j=1,jnx
            do i=1,inx
               t(i,j,kold) = t(i,j,knew)
            enddo
         enddo
      enddo

      return
      end


 
