c $Log:   /pvcs.config/mc3dvv/src/viscos.F_a  $
c
c ********************************************************************
c *  IHEAT
c ********************************************************************
c This subroutine is called from heatflo and returns vratio(k): the
c volume of a shell at a depth k in a sphere normalised to the volume
c of a similar layer at the surface of a box. It is used to multiply H 
c (rah/rat) in the energy equation to account for the reduction of
c volumetric internal heating with depth that would occur in a sphere.
c
      subroutine iheat
      use module_precision
      use module_param
      use module_depthdep
      use module_a3
      
      if (iheattype.eq.0) then
c  Remember k=1 is bottom face, k=2 is bottom layer
          do 111, k=2, kmx
            vratio(k) = one
111      continue

      else if (iheattype.eq.1) then      
         dezed = one/(kmx-1)
         rsur = 6371.d0/2891.d0
         rcmb = 3480.d0/2891.d0
         do 222, k=2, kmx
            voltop = three*rsur*rsur
            volk = (rcmb+(k-1)*dezed)**3-(rcmb+(k-2)*dezed)**3
            vratio(k) = ((kmx-1)*volk)/voltop
222      continue

      else
        write(6,*)'iheattype=',iheattype,' in input.in is not supported'
        stop
      endif    
      return
      end
