c $Log:   /pvcs.config/mc3dvv/src/inittrac.F_a  $
c
c   Rev 1.1   Fri Jul 16 13:47:56 1999   lowman
cAdded a3.h includes
c
c   Rev 1.0   Mon Jul 14 14:21:30 1997   pvcs
c 
c *************************************************************
c *   INITTRAC
c *************************************************************
      subroutine inittrac
      use module_precision
      use module_param
      use module_a3
      use module_gia3
      use module_petracer
      use module_craster
      character*80 naampje

      if (itracoption.ne.1) then
         write(6,*) 'PERROR(inittrac): itracoption unequal to one' 
         return
      endif
      write(6,*) 'Number of tracer distributions: ',ndist

      if (irast.ne.0) then
         write(naampje,'(''tracers.'',i3.3)') irast
         open(unit=78,file=naampje,form='unformatted')
         rewind(78)
         idimtrac=2
         if (ny.gt.2) idimtrac = 3
         read(78) ndist,(ntrac(idist),idist=1,ndist),idimtrac
         write(6,*) 'Reading initial condition for tracers'
         write(6,*) 'from file: ',naampje(1:20)
         write(6,'(8i10:)') ndist,(ntrac(idist),idist=1,ndist)
         ip = 0
         do idist=1,ndist
           read(78) (coormark(ip+i),i=1,idimtrac*ntrac(idist))
           ip=ip+idimtrac*ntrac(idist)
         enddo
         close(78)
         return
      endif


      if (ny.ge.3) then
c       *** 3D
        ntot = 0
        do idist=1,ndist
           dxtr = x1tr(idist)-x0tr(idist)
           dytr = y1tr(idist)-y0tr(idist)
           dztr = z1tr(idist)-z0tr(idist)
           if (dxtr.eq.0.or.dytr.eq.0.or.dztr.eq.0) then
              write(6,*) 'PERROR(inittrac): dxtr, dytr or dztr == 0' 
              write(6,*) 'dxtr,dytr,dztr: ',dxtr,dytr,dztr
              stop 
           endif
           rl1tr = dxtr/dztr
           rl2tr = dytr/dztr
           nztr = (ntrac(idist)/(rl1tr*rl2tr))**(1d0/3)
           nxtr = rl1tr*(ntrac(idist)*1d0/(rl1tr*rl2tr))**(1d0/3)
           nytr = rl2tr*(ntrac(idist)*1d0/(rl1tr*rl2tr))**(1d0/3)
           dxntr = dxtr/nxtr
           dyntr = dytr/nytr
           dzntr = dztr/nztr
           ntrac(idist) = nxtr*nytr*nztr
           write(6,'(''INITTRAC: Distribute '',i5,'' by '',i5, 
     v        '' by '',i5)')
     v        nxtr,nytr,nztr
           write(6,'(''          uniformly between x= '',f8.3,
     v       '' and '',f8.3)') x0tr(idist),x1tr(idist)
           write(6,'(''                        and y= '',f8.3,
     v       '' and '',f8.3)') y0tr(idist),y1tr(idist)
           write(6,'(''                        and z= '',f8.3,
     v       '' and '',f8.3)') z0tr(idist),z1tr(idist)
           write(6,'(''               dxn, dyn, dzn = '',3f9.5)')
     v         dxntr,dyntr,dzntr
           write(6,'(''                 idist,ntrac = '',2i10)')
     v         idist,ntrac(idist)

           do k=1,nztr
              ztr = z0tr(idist) + (k-0.5)*dzntr
              do j=1,nytr
                 ip = ntot + (k-1)*nxtr*nytr + (j-1)*nxtr
                 ytr = y0tr(idist) + (j-0.5)*dyntr
                 do i=1,nxtr
                    xtr = x0tr(idist) + (i-0.5)*dxntr
                    coormark(3*(ip+i)-2) = xtr
                    coormark(3*(ip+i)-1) = ytr
                    coormark(3*(ip+i)) = ztr
                 enddo
              enddo
           enddo   
           ntot = ntot + ntrac(idist)
        enddo

      else
 
c       *** 2-D
        ntot = 0
        do idist=1,ndist
           dxtr = x1tr(idist)-x0tr(idist)
           dztr = z1tr(idist)-z0tr(idist)
           if (dxtr.eq.0.or.dztr.eq.0) then
              write(6,*) 'PERROR(inittrac): dx, dz == 0'
              stop 
           endif
           rl1tr = dxtr/dztr
           nxtr = sqrt(rl1tr*ntrac(idist))
           nztr = sqrt(1d0*ntrac(idist)/rl1tr)
           dxntr = dxtr/nxtr
           dzntr = dztr/nztr
           ntrac(idist) = nxtr*nztr
           write(6,'(''INITTRAC: Distribute '',i5,'' by '',i5)')
     v        nxtr,nztr
           write(6,'(''          uniformly between x= '',f8.3,
     v       '' and '',f8.3)') x0tr(idist),x1tr(idist)
           write(6,'(''                        and z= '',f8.3,
     v       '' and '',f8.3)') z0tr(idist),z1tr(idist)
           write(6,'(''                    dxn, dzn = '',2f9.5)')
     v         dxntr,dzntr
           write(6,'(''                 idist,ntrac = '',2i10)')
     v         idist,ntrac(idist)

           do k=1,nztr
              ztr = z0tr(idist) + (k-0.5)*dzntr
              ip = ntot + (k-1)*nxtr
              do i=1,nxtr
                 xtr = x0tr(idist) + (i-0.5)*dxntr
                 coormark(2*(ip+i)-1) = xtr
                 coormark(2*(ip+i)) = ztr
              enddo
           enddo
           ntot = ntot + ntrac(idist)
        enddo

      endif

      return
      end
