c $Log:   /pvcs.config/mc3dvv/src/inttauc.F_a  $
c
c   Rev 1.3   Tue Feb 09 15:01:44 1999   lowman
cRemoved hardwired value for lith
cAdded iholdstill option
c
c   Rev 1.2   Tue Oct 06 16:42:44 1998   lowman
cAdded calls to chvarx and chvary to fix tau13 and tau23 before calculating
cstresses due to buoyancy forces.
cAdded write of plate velocities to tapeout
c
c   Rev 1.1   Fri Jul 18 17:10:22 1997   hall
cCorrected call to tauout by adding second variable (nz-1)
c
c   Rev 1.0   Mon Jul 14 14:21:34 1997   pvcs
c 
c *************************************************************
c *   INTTAUC
c *************************************************************
      subroutine inttauc
      use module_precision
c
c     integrate stress on base of plate due to convection.
c
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_a22
      use module_a6
      use module_a11
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a20
      use module_a30
      use module_inttauc
      common/cinttaus/iholdstill
#ifdef MPI
      include 'mpif.h'
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
c
      imeth=1
c
      if (ny.eq.2) then
        jr4=1
      else
        jr4=nyr+1
      endif

      lithd=nz-lith

      if(iftau .eq. 0)then
         klithd = 1
      elseif(iftau.eq.1)then
         klithd = lithd
      else
         stop 'INTTAUC: IFTAU value must be either 0 or 1'
      endif
      
      do 10 j=iystar,iystop
      do 10 i=ixstar,ixstop
      tau13(i,j,klithd)=
     & fli(i,j)*taup(i-ixstar+1,j-iystar+1,lithd)
c     &+flj(i,j)*taut(i,j,lithd)
      tau23(i,j,klithd)=
     & flj(i,j)*taup(i-ixstar+1,j-iystar+1,lithd)
c     &-fli(i,j)*taut(i,j,lithd)
   10 continue
c
#ifdef MPI
      call mpiswitch(nx,j3,klithd,tau13(1,1,klithd),ixtau,jytau)
      call mpiswitch(nx,j3,klithd,tau23(1,1,klithd),ixtau,jytau)
#endif
c
c
      if(j3.gt.1)then
      ichvar=-1
      call chvary(tau13(1,1,klithd),iqx,nxr,lbd,jqx,nyr,mbd,1,ichvar)
      call chvarx(tau23(1,1,klithd),iqx,nxr,lbd,jqx,nyr,mbd,1,ichvar)
      endif
c
 
c
      call ft2nrm (-1,lpt13,nxt13,mpt13,nyt13,1,isx,jsx,
     & tau13(1,1,klithd))
      call ft2nrm (-1,lpt23,nxt23,mpt23,nyt23,1,isx,jsx,
     & tau23(1,1,klithd))
c
      if (ny.ne.2) then
        if (lbd.eq.0) then
          do 20 i=1,nxr
          tau13(i,nyr+1,klithd)=tau13(i,1,klithd)
          tau23(i,nyr+1,klithd)=tau23(i,1,klithd)
   20     continue
        elseif (lbd.eq.1) then
          do 30 i=1,nx
          tau13(i,1,klithd)=zero
          tau23(i,1,klithd)=zero
          tau13(i,ny,klithd)=zero
          tau23(i,ny,klithd)=zero
   30     continue
c     elseif(lbd .eq. 2)then any  stress
c
        endif
      endif
      if (mbd.eq.0) then
        do 40 j=1,nyr
        tau13(nxr+1,j,klithd)=tau13(1,j,klithd)
        tau23(nxr+1,j,klithd)=tau23(1,j,klithd)
   40   continue
      elseif (mbd.eq.1) then
        do 50 j=1,j3
        tau13(1,j,klithd)=zero
        tau23(1,j,klithd)=zero
        tau13(nx,j,klithd)=zero
        tau23(nx,j,klithd)=zero
   50   continue
        tau13(1,1,klithd)=zero
        tau23(1,1,klithd)=zero
      endif
      if ((lbd.eq.0).and.(mbd.eq.0)) then
        tau13(nxr+1,jr4,klithd)=tau13(1,1,klithd)
        tau23(nxr+1,jr4,klithd)=tau23(1,1,klithd)
      endif
c
      dxdy=dx*dy
      qxy=.25*dxdy
      hqxy=.5*qxy
      do 60 ipt=1,2*nplate
      tc(ipt)=zero
   60 continue
c
      do 70 ipla=1,nplate
      i2=2*ipla
      i2m1=i2-1
      do 90 j=1,ny-1
      do 90 i=1,nx-1
      tc(i2m1)=dxdy*template(i,j,ipla)*tau13(i,j,klithd)+tc(i2m1)
      tc(i2  )=dxdy*template(i,j,ipla)*tau23(i,j,klithd)+tc(i2)
   90 continue
 70   continue
c
c begin JPL test
         if(iholdstill.eq.1)then
            tc(3)=tc(5)
            tc(4)=tc(6)
            tc(5)=zero
            tc(6)=zero
           nplate_save=nplate
           nplate=2
         endif
c end JPL test        
c
      if (ny.eq.2) then
        do 100 np22=2,2*nplate,2
        tc(np22)=zero
  100   continue
      endif
c
c     output timeseries of max min mean stress
c
      call tauout(1,nz-1)
c
c     insert parameter which simulates collisional resistance by
c     reducing integrated shear stress by factor between 0 and 1
c
c platebm
c      write(6,*)tc
      if (resist.ne.1.0) then
      do 108 iresist = 1,2*nplate
c         tc(iresist) = float(iresist) * resist * tc(iresist)
         tc(iresist) =  resist * tc(iresist)
  108 continue
      endif
c
c     imeth=1 for numerical inversion using sgefs
c     imeth=2 for analytical inverse of 4x4  pc matrix
c
      iord=2
      if(ny .eq. 2)then
         iord=1
      endif
      if (imeth.eq.1) then
        do 110 j=1,iord*nplate
        do 110 i=1,iord*nplate
        a(i,j)=pc(i,j)
  110   continue
c
c      repack x vector for 2D calculations
c
        do 120 i=1,2*nplate
          if(ny .eq. 2)then
            x(i)=tc(2*i-1)
          else
            x(i)=tc(i)
          endif
  120   continue
c
       if (precis.eq.2) then
         call dgefs (a,npla,iord*nplate,x,1,ind,work,iwork)
       else 
         call sgefs (a,npla,iord*nplate,x,1,ind,work,iwork)
       endif
c
        if (ind.lt.4) then
          if (myid .eq. 0) then
            write (6,140) ind
          endif
        endif
c      write(6,51)(-x(i),i=1,2*nplate)
   51 format(32(e10.4,2x))
       if(ny .ne. 2)then
        do 130 np=1,nplate
        np2=2*np
        np2m1=np2-1
        vpl(1,np)=-x(np2m1)
        vpl(2,np)=-x(np2)
  130   continue
       else
        do 135 np=1,nplate
          vpl(1,np)=-x(np)
          vpl(2,np)=zero
  135   continue
        endif
c JPL add
         if(iholdstill.eq.1)then
          vpl(1,3)=vpl(1,2)
          vpl(2,3)=vpl(2,2)
          vpl(1,2)=zero
          vpl(2,2)=zero
          nplate=nplate_save
         endif
c JPL end

        if (myid .eq. 0) then
          write(58,137)time,(vpl(1,np),vpl(2,np),np=1,nplate)
          call flush(58)
        end if
  137   format(32(e15.7,2x))
c        vp1x=-x(1)
c        vp1y=-x(2)
c        vp2x=-x(3)
c        vp2y=-x(4)
      elseif (imeth.eq.2) then
c
c     only for two plate system
        if (nplate.gt.2) then
          if (myid .eq. 0) then
            write (6,150)
          endif
#ifdef MPI
          call MPI_FINALIZE(rc)
          stop
#endif
        endif
c
        if (itst.ne.1) then
c     only invert on first pass
c
          c11=pc(1,1)
          c12=pc(1,2)
          c13=pc(1,3)
          c14=pc(1,4)
          c21=pc(2,1)
          c22=pc(2,2)
          c23=pc(2,3)
          c24=pc(2,4)
          c31=pc(3,1)
          c32=pc(3,2)
          c33=pc(3,3)
          c34=pc(3,4)
          c41=pc(4,1)
          c42=pc(4,2)
          c43=pc(4,3)
          c44=pc(4,4)
c
          det=(((c11*c22-c12*c21)*c33+(c13*c21-c11*c23)*c32+(c12*c23-c13
     1    *c22)*c31)*c44+((c12*c21-c11*c22)*c34+(c11*c24-c14*c21)*c32+
     2    (c14*c22-c12*c24)*c31)*c43+((c11*c23-c13*c21)*c34+(c14*c21-c11
     3    *c24)*c33+(c13*c24-c14*c23)*c31)*c42+((c13*c22-c12*c23)*c34+
     4    (c12*c24-c14*c22)*c33+(c14*c23-c13*c24)*c32)*c41)
     
          deti=1./det
c
          if (myid .eq. 0) then
            write (6,160) det
          endif
c
          a11=((c22*c33-c23*c32)*c44+(c24*c32-c22*c34)*c43+(c23*c34-c24
     1    *c33)*c42)
          a12=-((c12*c33-c13*c32)*c44+(c14*c32-c12*c34)*c43+(c13*c34-c14
     1    *c33)*c42)
          a13=((c12*c23-c13*c22)*c44+(c14*c22-c12*c24)*c43+(c13*c24-c14
     1    *c23)*c42)
          a14=-((c12*c23-c13*c22)*c34+(c14*c22-c12*c24)*c33+(c13*c24-c14
     1    *c23)*c32)
          a21=-((c21*c33-c23*c31)*c44+(c24*c31-c21*c34)*c43+(c23*c34-c24
     1    *c33)*c41)
          a22=((c11*c33-c13*c31)*c44+(c14*c31-c11*c34)*c43+(c13*c34-c14
     1    *c33)*c41)
          a23=-((c11*c23-c13*c21)*c44+(c14*c21-c11*c24)*c43+(c13*c24-c14
     1    *c23)*c41)
          a24=((c11*c23-c13*c21)*c34+(c14*c21-c11*c24)*c33+(c13*c24-c14
     1    *c23)*c31)
          a31=((c21*c32-c22*c31)*c44+(c24*c31-c21*c34)*c42+(c22*c34-c24
     1    *c32)*c41)
          a32=-((c11*c32-c12*c31)*c44+(c14*c31-c11*c34)*c42+(c12*c34-c14
     1    *c32)*c41)
          a33=((c11*c22-c12*c21)*c44+(c14*c21-c11*c24)*c42+(c12*c24-c14
     1    *c22)*c41)
          a34=-((c11*c22-c12*c21)*c34+(c14*c21-c11*c24)*c32+(c12*c24-c14
     1    *c22)*c31)
          a41=-((c21*c32-c22*c31)*c43+(c23*c31-c21*c33)*c42+(c22*c33-c23
     1    *c32)*c41)
          a42=((c11*c32-c12*c31)*c43+(c13*c31-c11*c33)*c42+(c12*c33-c13
     1    *c32)*c41)
          a43=-((c11*c22-c12*c21)*c43+(c13*c21-c11*c23)*c42+(c12*c23-c13
     1    *c22)*c41)
          a44=((c11*c22-c12*c21)*c33+(c13*c21-c11*c23)*c32+(c12*c23-c13
     1    *c22)*c31)
c
          a11=a11*deti
          a12=a12*deti
          a13=a13*deti
          a14=a14*deti
          a21=a21*deti
          a22=a22*deti
          a23=a23*deti
          a24=a24*deti
          a31=a31*deti
          a32=a32*deti
          a33=a33*deti
          a34=a34*deti
          a41=a41*deti
          a42=a42*deti
          a43=a43*deti
          a44=a44*deti
c
          itst=1
        endif
c
        vpl(1,1)=-(a11*tc(1)+a12*tc(2)+a13*tc(3)+a14*tc(4))
        vpl(2,1)=-(a21*tc(1)+a22*tc(2)+a23*tc(3)+a24*tc(4))
        vpl(1,2)=-(a31*tc(1)+a32*tc(2)+a33*tc(3)+a34*tc(4))
        vpl(2,2)=-(a41*tc(1)+a42*tc(2)+a43*tc(3)+a44*tc(4))
c
      endif
c
      return
c
  140 format ("from matrix inversion in SGEFS ind= ",i5)
  150 format ("***************************************",/,"error nplate
     1.gt. 2 .and. imeth .eq. 2 ",/,"***********************************
     2****")
  160 format ("determinent of pc=",e10.4)
      end
