c $Log:   /pvcs.config/mc3dvv/src/inttaup.F_a  $
c
c   Rev 1.1   Tue Feb 09 14:43:32 1999   lowman
cremoved hardwired value for lith
cIntroduced reshuffling of pc matrix for stationary central plate option
c
c   Rev 1.0   Mon Jul 14 14:21:36 1997   pvcs
c 
c *************************************************************
c *   INTTAUP
c *************************************************************
      subroutine inttaup
      use module_precision
c     sum stress on the base of plate
c
c      plate interaction coefficients
c
c      the pc matrix is only a function of the
c      geometry of the system and quantifies the
c      interaction of the plates.
c
c      integrate shear stress on the base of plates 
c      for motion of plates in orthogonal directions
c
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_a22
      use module_a6
      use module_a23
      use module_a30
#ifdef MPI
      include 'mpif.h'
#endif 


      common/cinttaus/iholdstill

#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
#else
      myid = 0
#endif 
c      lith = 7 
      dxdy = dx*dy
      qxy  = quarter*dxdy
      hqxy = half*qxy
      do 10 ipv = 1,2*nplate
      do 10 ipt = 1,2*nplate
      pc(ipt,ipv) = zero
   10 continue
      do 65 ipla = 1,nplate
        i2 = 2*ipla
        i2m1 = i2-1
        do 65 np2 = 1,2*nplate
          do 60 j = 1,ny-1
          do 60 i = 1,nx-1
             pc(i2m1,np2) = 
     1       dxdy*template(i,j,ipla)*tau13pl(i,j,np2)+pc(i2m1,np2)
             pc(i2,np2) = 
     1       dxdy*template(i,j,ipla)*tau23pl(i,j,np2)+pc(i2,np2)
 60       continue
 65       continue


c JPL test
c template represents the plate that the stress is being calculated on.
c tau13pl represents stress exerted on the plates by moving a plate in the
c x and y directions (2*nplate).
c we want tau13pl and tau23pl resulting from plate 2 to be zero.
c
         if(iholdstill.eq.1)then
           do 85 kpla=1,2*nplate
            pc(3,kpla)=pc(5,kpla)
 85         pc(4,kpla)=pc(6,kpla)
           do 86 ipla=1,2*nplate
            pc(ipla,3)=pc(ipla,5)
 86         pc(ipla,4)=pc(ipla,6)
           do 87 ipla=1,2*nplate
            do 87 kpla=1,2*nplate
             if((ipla.gt.4).or.(kpla.gt.4))then
               pc(ipla,kpla)=zero
             endif
 87        continue
         endif
c JPL test
c
c     with 2D calculations set pc's for motion in y direction to zero
c     repack pc matrix for 2D
c
      msize = 2*nplate
      if (ny.eq.2) then
        msize = nplate
        do 75 ipla = 1,nplate
          i2m1 = 2*ipla-1
          do 75 kpla = 1,nplate
            k2m1 = 2*kpla-1
            pc(ipla,kpla) = pc(i2m1,k2m1)
   75   continue
        do 76 ipla = 1,2*nplate
        do 76 kpla = 1,2*nplate
         if((ipla .gt. nplate) .or. (kpla .gt. nplate))then
           pc(ipla,kpla) = zero
         endif
   76   continue 
      endif
        
      if (myid .eq. 0) then
        do 80 j = 1,msize
          write (6,100) (pc(i,j),i = 1,msize)
   80   continue
      endif
      return
  100 format ("pc matrix",32(2x,e14.7))
  110 format (128i1)
      end
