c $Log:   /pvcs.config/mc3dvv/src/inverse.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:38 1997   pvcs
c 
c *************************************************************
c *   INVERSE
c *************************************************************
      subroutine inverse(isize,a,idim)
      use module_precision
      dimension a(idim,*)

      
      write(6,33)
      do 10 j = 1,isize
         write(6,30)(a(i,j),i=1,isize)
   10 continue
   30 format(10(e12.5,2x))
   33 format(' ************** Input Matrix ************** ')


      if(isize .eq. 2)then
       a11 = a(1,1)
       a12 = a(1,2)
       a21 = a(2,1)
       a22 = a(2,2)

       deti = 1.0/(a11*a22-a12*a21)

       a(1,1) = a22 * deti
       a(1,2) = a12 * deti
       a(2,1) = a21 * deti
       a(2,2) = a11 * deti

       elseif(isize .eq. 3)then

       a11 = a(1,1)
       a12 = a(1,2)
       a13 = a(1,3)
       a21 = a(2,1)
       a22 = a(2,2)
       a23 = a(2,3)
       a31 = a(3,1)
       a32 = a(3,2)
       a33 = a(3,3)

       det = ( -a13*a22*a31 + a12*a23*a31 + 
     1          a13*a21*a32 - a11*a23*a32 - 
     2          a12*a21*a33 + a11*a22*a33)
       deti = 1.0d0/det

       a(1,1) = (-a23*a32 + a22*a33) * deti
       a(1,2) = ( a13*a32 - a12*a33) * deti
       a(1,3) = (-a13*a22 + a12*a23) * deti
       a(2,1) = ( a23*a31 - a21*a33) * deti
       a(2,2) = (-a13*a31 + a11*a33) * deti
       a(2,3) = ( a13*a21 - a11*a23) * deti
       a(3,1) = (-a22*a31 + a21*a32) * deti
       a(3,2) = ( a12*a31 - a11*a32) * deti
       a(3,3) = (-a12*a21 + a11*a22) * deti


       elseif(isize .eq. 4)then
c
          a11 = a(1,1)
          a12 = a(1,2)
          a13 = a(1,3)
          a14 = a(1,4)
          a21 = a(2,1)
          a22 = a(2,2)
          a23 = a(2,3)
          a24 = a(2,4)
          a31 = a(3,1)
          a32 = a(3,2)
          a33 = a(3,3)
          a34 = a(3,4)
          a41 = a(4,1)
          a42 = a(4,2)
          a43 = a(4,3)
          a44 = a(4,4)
c
          det=(((a11*a22-a12*a21)*a33+(a13*a21-a11*a23)*a32+(a12*a23-a13
     1    *a22)*a31)*a44+((a12*a21-a11*a22)*a34+(a11*a24-a14*a21)*a32+
     2    (a14*a22-a12*a24)*a31)*a43+((a11*a23-a13*a21)*a34+(a14*a21-a11
     3    *a24)*a33+(a13*a24-a14*a23)*a31)*a42+((a13*a22-a12*a23)*a34+
     4    (a12*a24-a14*a22)*a33+(a14*a23-a13*a24)*a32)*a41)
     
          deti=1./det
c
          c11=((a22*a33-a23*a32)*a44+(a24*a32-a22*a34)*a43+(a23*a34-a24
     1    *a33)*a42)
          c12=-((a12*a33-a13*a32)*a44+(a14*a32-a12*a34)*a43+(a13*a34-a14
     1    *a33)*a42)
          c13=((a12*a23-a13*a22)*a44+(a14*a22-a12*a24)*a43+(a13*a24-a14
     1    *a23)*a42)
          c14=-((a12*a23-a13*a22)*a34+(a14*a22-a12*a24)*a33+(a13*a24-a14
     1    *a23)*a32)
          c21=-((a21*a33-a23*a31)*a44+(a24*a31-a21*a34)*a43+(a23*a34-a24
     1    *a33)*a41)
          c22=((a11*a33-a13*a31)*a44+(a14*a31-a11*a34)*a43+(a13*a34-a14
     1    *a33)*a41)
          c23=-((a11*a23-a13*a21)*a44+(a14*a21-a11*a24)*a43+(a13*a24-a14
     1    *a23)*a41)
          c24=((a11*a23-a13*a21)*a34+(a14*a21-a11*a24)*a33+(a13*a24-a14
     1    *a23)*a31)
          c31=((a21*a32-a22*a31)*a44+(a24*a31-a21*a34)*a42+(a22*a34-a24
     1    *a32)*a41)
          c32=-((a11*a32-a12*a31)*a44+(a14*a31-a11*a34)*a42+(a12*a34-a14
     1    *a32)*a41)
          c33=((a11*a22-a12*a21)*a44+(a14*a21-a11*a24)*a42+(a12*a24-a14
     1    *a22)*a41)
          c34=-((a11*a22-a12*a21)*a34+(a14*a21-a11*a24)*a32+(a12*a24-a14
     1    *a22)*a31)
          c41=-((a21*a32-a22*a31)*a43+(a23*a31-a21*a33)*a42+(a22*a33-a23
     1    *a32)*a41)
          c42=((a11*a32-a12*a31)*a43+(a13*a31-a11*a33)*a42+(a12*a33-a13
     1    *a32)*a41)
          c43=-((a11*a22-a12*a21)*a43+(a13*a21-a11*a23)*a42+(a12*a23-a13
     1    *a22)*a41)
          c44=((a11*a22-a12*a21)*a33+(a13*a21-a11*a23)*a32+(a12*a23-a13
     1    *a22)*a31)
c
          a(1,1) = c11*deti
          a(1,2) = c12*deti
          a(1,3) = c13*deti
          a(1,4) = c14*deti
          a(2,1) = c21*deti
          a(2,2) = c22*deti
          a(2,3) = c23*deti
          a(2,4) = c24*deti
          a(3,1) = c31*deti
          a(3,2) = c32*deti
          a(3,3) = c33*deti
          a(3,4) = c34*deti
          a(4,1) = c41*deti
          a(4,2) = c42*deti
          a(4,3) = c43*deti
          a(4,4) = c44*deti
c
      elseif(isize .eq. 5)then
c
c          a11 = a(1,1)
c          a12 = a(1,2)
c          a13 = a(1,3)
c          a14 = a(1,4)
c          a15 = a(1,5)
c          a21 = a(2,1)
c          a22 = a(2,2)
c          a23 = a(2,3)
c          a24 = a(2,4)
c          a25 = a(2,5)
c          a31 = a(3,1)
c          a32 = a(3,2)
c          a33 = a(3,3)
c          a34 = a(3,4)
c          a35 = a(3,5)
c          a41 = a(4,1)
c          a42 = a(4,2)
c          a43 = a(4,3)
c          a44 = a(4,4)
c          a45 = a(4,5)
c          a51 = a(5,1)
c          a52 = a(5,2)
c          a53 = a(5,3)
c          a54 = a(5,4)
c          a55 = a(5,5)
c

c      det1=a15*a24*a33*a42*a51-a14*a25*a33*a42*a51-a15*a23*a34*a42*a51
c     1 +a13*a25*a34*a42*a51+a14*a23*a35*a42*a51-a13*a24*a35*a42*a51-a15
c     2 *a24*a32*a43*a51+a14*a25*a32*a43*a51+a15*a22*a34*a43*a51-a12*a25
c     3 *a34*a43*a51-a14*a22*a35*a43*a51+a12*a24*a35*a43*a51+a15*a23*a32
c     4 *a44*a51-a13*a25*a32*a44*a51-a15*a22*a33*a44*a51+a12*a25*a33*a44
c     5 *a51+a13*a22*a35*a44*a51-a12*a23*a35*a44*a51-a14*a23*a32*a45*a51
c     6 +a13*a24*a32*a45*a51+a14*a22*a33*a45*a51-a12*a24*a33*a45*a51-a13
c     7 *a22*a34*a45*a51+a12*a23*a34*a45*a51
c      det2=-a15*a24*a33*a41*a52+a14*a25*a33*a41*a52+a15*a23*a34*a41*a52
c     1 -a13*a25*a34*a41*a52-a14*a23*a35*a41*a52+a13*a24*a35*a41*a52+a15
c     2 *a24*a31*a43*a52-a14*a25*a31*a43*a52-a15*a21*a34*a43*a52+a11*a25
c     3 *a34*a43*a52+a14*a21*a35*a43*a52-a11*a24*a35*a43*a52-a15*a23*a31
c     4 *a44*a52+a13*a25*a31*a44*a52+a15*a21*a33*a44*a52-a11*a25*a33*a44
c     5 *a52-a13*a21*a35*a44*a52+a11*a23*a35*a44*a52+a14*a23*a31*a45*a52
c     6 -a13*a24*a31*a45*a52-a14*a21*a33*a45*a52+a11*a24*a33*a45*a52+a13
c     7 *a21*a34*a45*a52-a11*a23*a34*a45*a52
c      det3=a15*a24*a32*a41*a53-a14*a25*a32*a41*a53-a15*a22*a34*a41*a53
c     1 +a12*a25*a34*a41*a53+a14*a22*a35*a41*a53-a12*a24*a35*a41*a53-a15
c     2 *a24*a31*a42*a53+a14*a25*a31*a42*a53+a15*a21*a34*a42*a53-a11*a25
c     3 *a34*a42*a53-a14*a21*a35*a42*a53+a11*a24*a35*a42*a53+a15*a22*a31
c     4 *a44*a53-a12*a25*a31*a44*a53-a15*a21*a32*a44*a53+a11*a25*a32*a44
c     5 *a53+a12*a21*a35*a44*a53-a11*a22*a35*a44*a53-a14*a22*a31*a45*a53
c     6 +a12*a24*a31*a45*a53+a14*a21*a32*a45*a53-a11*a24*a32*a45*a53-a12
c     7 *a21*a34*a45*a53+a11*a22*a34*a45*a53
c      det4=-a15*a23*a32*a41*a54+a13*a25*a32*a41*a54+a15*a22*a33*a41*a54
c     1 -a12*a25*a33*a41*a54-a13*a22*a35*a41*a54+a12*a23*a35*a41*a54+a15
c     2 *a23*a31*a42*a54-a13*a25*a31*a42*a54-a15*a21*a33*a42*a54+a11*a25
c     3 *a33*a42*a54+a13*a21*a35*a42*a54-a11*a23*a35*a42*a54-a15*a22*a31
c     4 *a43*a54+a12*a25*a31*a43*a54+a15*a21*a32*a43*a54-a11*a25*a32*a43
c     5 *a54-a12*a21*a35*a43*a54+a11*a22*a35*a43*a54+a13*a22*a31*a45*a54
c     6 -a12*a23*a31*a45*a54-a13*a21*a32*a45*a54+a11*a23*a32*a45*a54+a12
c     7 *a21*a33*a45*a54-a11*a22*a33*a45*a54
c      det5=a14*a23*a32*a41*a55-a13*a24*a32*a41*a55-a14*a22*a33*a41*a55
c     1 +a12*a24*a33*a41*a55+a13*a22*a34*a41*a55-a12*a23*a34*a41*a55-a14
c     2 *a23*a31*a42*a55+a13*a24*a31*a42*a55+a14*a21*a33*a42*a55-a11*a24
c     3 *a33*a42*a55-a13*a21*a34*a42*a55+a11*a23*a34*a42*a55+a14*a22*a31
c     4 *a43*a55-a12*a24*a31*a43*a55-a14*a21*a32*a43*a55+a11*a24*a32*a43
c     5 *a55+a12*a21*a34*a43*a55-a11*a22*a34*a43*a55-a13*a22*a31*a44*a55
c     6 +a12*a23*a31*a44*a55+a13*a21*a32*a44*a55-a11*a23*a32*a44*a55-a12
c     7 *a21*a33*a44*a55+a11*a22*a33*a44*a55
c
c      det=det1+det2+det3+det4+det5
c
c      deti=1.0/det
c
c      a(1,1)=(a25*a34*a43*a52-a24*a35*a43*a52-a25*a33*a44*a52+a23*a35
c     1 *a44*a52+a24*a33*a45*a52-a23*a34*a45*a52-a25*a34*a42*a53+a24*a35
c     2 *a42*a53+a25*a32*a44*a53-a22*a35*a44*a53-a24*a32*a45*a53+a22*a34
c     3 *a45*a53+a25*a33*a42*a54-a23*a35*a42*a54-a25*a32*a43*a54+a22*a35
c     4 *a43*a54+a23*a32*a45*a54-a22*a33*a45*a54-a24*a33*a42*a55+a23*a34
c     5 *a42*a55+a24*a32*a43*a55-a22*a34*a43*a55-a23*a32*a44*a55+a22*a33
c     6 *a44*a55)
c      a(1,2)=(-(a15*a34*a43*a52)+a14*a35*a43*a52+a15*a33*a44*a52-a13*a35
c     1 *a44*a52-a14*a33*a45*a52+a13*a34*a45*a52+a15*a34*a42*a53-a14*a35
c     2 *a42*a53-a15*a32*a44*a53+a12*a35*a44*a53+a14*a32*a45*a53-a12*a34
c     3 *a45*a53-a15*a33*a42*a54+a13*a35*a42*a54+a15*a32*a43*a54-a12*a35
c     4 *a43*a54-a13*a32*a45*a54+a12*a33*a45*a54+a14*a33*a42*a55-a13*a34
c     5 *a42*a55-a14*a32*a43*a55+a12*a34*a43*a55+a13*a32*a44*a55-a12*a33
c     6 *a44*a55)
c      a(1,3)=(a15*a24*a43*a52-a14*a25*a43*a52-a15*a23*a44*a52+a13*a25
c     1 *a44*a52+a14*a23*a45*a52-a13*a24*a45*a52-a15*a24*a42*a53+a14*a25
c     2 *a42*a53+a15*a22*a44*a53-a12*a25*a44*a53-a14*a22*a45*a53+a12*a24
c     3 *a45*a53+a15*a23*a42*a54-a13*a25*a42*a54-a15*a22*a43*a54+a12*a25
c     4 *a43*a54+a13*a22*a45*a54-a12*a23*a45*a54-a14*a23*a42*a55+a13*a24
c     5 *a42*a55+a14*a22*a43*a55-a12*a24*a43*a55-a13*a22*a44*a55+a12*a23
c     6 *a44*a55)
c      a(1,4)=(-(a15*a24*a33*a52)+a14*a25*a33*a52+a15*a23*a34*a52-a13*a25
c     1 *a34*a52-a14*a23*a35*a52+a13*a24*a35*a52+a15*a24*a32*a53-a14*a25
c     2 *a32*a53-a15*a22*a34*a53+a12*a25*a34*a53+a14*a22*a35*a53-a12*a24
c     3 *a35*a53-a15*a23*a32*a54+a13*a25*a32*a54+a15*a22*a33*a54-a12*a25
c     4 *a33*a54-a13*a22*a35*a54+a12*a23*a35*a54+a14*a23*a32*a55-a13*a24
c     5 *a32*a55-a14*a22*a33*a55+a12*a24*a33*a55+a13*a22*a34*a55-a12*a23
c     6 *a34*a55)
c      a(1,5)=(a15*a24*a33*a42-a14*a25*a33*a42-a15*a23*a34*a42+a13*a25
c     1 *a34*a42+a14*a23*a35*a42-a13*a24*a35*a42-a15*a24*a32*a43+a14*a25
c     2 *a32*a43+a15*a22*a34*a43-a12*a25*a34*a43-a14*a22*a35*a43+a12*a24
c     3 *a35*a43+a15*a23*a32*a44-a13*a25*a32*a44-a15*a22*a33*a44+a12*a25
c     4 *a33*a44+a13*a22*a35*a44-a12*a23*a35*a44-a14*a23*a32*a45+a13*a24
c     5 *a32*a45+a14*a22*a33*a45-a12*a24*a33*a45-a13*a22*a34*a45+a12*a23
c     6 *a34*a45)
c      a(2,1)=(-(a25*a34*a43*a51)+a24*a35*a43*a51+a25*a33*a44*a51-a23*a35
c     1 *a44*a51-a24*a33*a45*a51+a23*a34*a45*a51+a25*a34*a41*a53-a24*a35
c     2 *a41*a53-a25*a31*a44*a53+a21*a35*a44*a53+a24*a31*a45*a53-a21*a34
c     3 *a45*a53-a25*a33*a41*a54+a23*a35*a41*a54+a25*a31*a43*a54-a21*a35
c     4 *a43*a54-a23*a31*a45*a54+a21*a33*a45*a54+a24*a33*a41*a55-a23*a34
c     5 *a41*a55-a24*a31*a43*a55+a21*a34*a43*a55+a23*a31*a44*a55-a21*a33
c     6 *a44*a55)
c      a(2,2)=(a15*a34*a43*a51-a14*a35*a43*a51-a15*a33*a44*a51+a13*a35
c     1 *a44*a51+a14*a33*a45*a51-a13*a34*a45*a51-a15*a34*a41*a53+a14*a35
c     2 *a41*a53+a15*a31*a44*a53-a11*a35*a44*a53-a14*a31*a45*a53+a11*a34
c     3 *a45*a53+a15*a33*a41*a54-a13*a35*a41*a54-a15*a31*a43*a54+a11*a35
c     4 *a43*a54+a13*a31*a45*a54-a11*a33*a45*a54-a14*a33*a41*a55+a13*a34
c     5 *a41*a55+a14*a31*a43*a55-a11*a34*a43*a55-a13*a31*a44*a55+a11*a33
c     6 *a44*a55)
c      a(2,3)=(-(a15*a24*a43*a51)+a14*a25*a43*a51+a15*a23*a44*a51-a13*a25
c     1 *a44*a51-a14*a23*a45*a51+a13*a24*a45*a51+a15*a24*a41*a53-a14*a25
c     2 *a41*a53-a15*a21*a44*a53+a11*a25*a44*a53+a14*a21*a45*a53-a11*a24
c     3 *a45*a53-a15*a23*a41*a54+a13*a25*a41*a54+a15*a21*a43*a54-a11*a25
c     4 *a43*a54-a13*a21*a45*a54+a11*a23*a45*a54+a14*a23*a41*a55-a13*a24
c     5 *a41*a55-a14*a21*a43*a55+a11*a24*a43*a55+a13*a21*a44*a55-a11*a23
c     6 *a44*a55)
c      a(2,4)=(a15*a24*a33*a51-a14*a25*a33*a51-a15*a23*a34*a51+a13*a25
c     1 *a34*a51+a14*a23*a35*a51-a13*a24*a35*a51-a15*a24*a31*a53+a14*a25
c     2 *a31*a53+a15*a21*a34*a53-a11*a25*a34*a53-a14*a21*a35*a53+a11*a24
c     3 *a35*a53+a15*a23*a31*a54-a13*a25*a31*a54-a15*a21*a33*a54+a11*a25
c     4 *a33*a54+a13*a21*a35*a54-a11*a23*a35*a54-a14*a23*a31*a55+a13*a24
c     5 *a31*a55+a14*a21*a33*a55-a11*a24*a33*a55-a13*a21*a34*a55+a11*a23
c     6 *a34*a55)
c      a(2,5)=(-(a15*a24*a33*a41)+a14*a25*a33*a41+a15*a23*a34*a41-a13*a25
c     1 *a34*a41-a14*a23*a35*a41+a13*a24*a35*a41+a15*a24*a31*a43-a14*a25
c     2 *a31*a43-a15*a21*a34*a43+a11*a25*a34*a43+a14*a21*a35*a43-a11*a24
c     3 *a35*a43-a15*a23*a31*a44+a13*a25*a31*a44+a15*a21*a33*a44-a11*a25
c     4 *a33*a44-a13*a21*a35*a44+a11*a23*a35*a44+a14*a23*a31*a45-a13*a24
c     5 *a31*a45-a14*a21*a33*a45+a11*a24*a33*a45+a13*a21*a34*a45-a11*a23
c     6 *a34*a45)
c      a(3,1)=(a25*a34*a42*a51-a24*a35*a42*a51-a25*a32*a44*a51+a22*a35
c     1 *a44*a51+a24*a32*a45*a51-a22*a34*a45*a51-a25*a34*a41*a52+a24*a35
c     2 *a41*a52+a25*a31*a44*a52-a21*a35*a44*a52-a24*a31*a45*a52+a21*a34
c     3 *a45*a52+a25*a32*a41*a54-a22*a35*a41*a54-a25*a31*a42*a54+a21*a35
c     4 *a42*a54+a22*a31*a45*a54-a21*a32*a45*a54-a24*a32*a41*a55+a22*a34
c     5 *a41*a55+a24*a31*a42*a55-a21*a34*a42*a55-a22*a31*a44*a55+a21*a32
c     6 *a44*a55)
c      a(3,2)=(-(a15*a34*a42*a51)+a14*a35*a42*a51+a15*a32*a44*a51-a12*a35
c     1 *a44*a51-a14*a32*a45*a51+a12*a34*a45*a51+a15*a34*a41*a52-a14*a35
c     2 *a41*a52-a15*a31*a44*a52+a11*a35*a44*a52+a14*a31*a45*a52-a11*a34
c     3 *a45*a52-a15*a32*a41*a54+a12*a35*a41*a54+a15*a31*a42*a54-a11*a35
c     4 *a42*a54-a12*a31*a45*a54+a11*a32*a45*a54+a14*a32*a41*a55-a12*a34
c     5 *a41*a55-a14*a31*a42*a55+a11*a34*a42*a55+a12*a31*a44*a55-a11*a32
c     6 *a44*a55)
c      a(3,3)=(a15*a24*a42*a51-a14*a25*a42*a51-a15*a22*a44*a51+a12*a25
c     1 *a44*a51+a14*a22*a45*a51-a12*a24*a45*a51-a15*a24*a41*a52+a14*a25
c     2 *a41*a52+a15*a21*a44*a52-a11*a25*a44*a52-a14*a21*a45*a52+a11*a24
c     3 *a45*a52+a15*a22*a41*a54-a12*a25*a41*a54-a15*a21*a42*a54+a11*a25
c     4 *a42*a54+a12*a21*a45*a54-a11*a22*a45*a54-a14*a22*a41*a55+a12*a24
c     5 *a41*a55+a14*a21*a42*a55-a11*a24*a42*a55-a12*a21*a44*a55+a11*a22
c     6 *a44*a55)
c      a(3,4)=(-(a15*a24*a32*a51)+a14*a25*a32*a51+a15*a22*a34*a51-a12*a25
c     1 *a34*a51-a14*a22*a35*a51+a12*a24*a35*a51+a15*a24*a31*a52-a14*a25
c     2 *a31*a52-a15*a21*a34*a52+a11*a25*a34*a52+a14*a21*a35*a52-a11*a24
c     3 *a35*a52-a15*a22*a31*a54+a12*a25*a31*a54+a15*a21*a32*a54-a11*a25
c     4 *a32*a54-a12*a21*a35*a54+a11*a22*a35*a54+a14*a22*a31*a55-a12*a24
c     5 *a31*a55-a14*a21*a32*a55+a11*a24*a32*a55+a12*a21*a34*a55-a11*a22
c     6 *a34*a55)
c      a(3,5)=(a15*a24*a32*a41-a14*a25*a32*a41-a15*a22*a34*a41+a12*a25
c     1 *a34*a41+a14*a22*a35*a41-a12*a24*a35*a41-a15*a24*a31*a42+a14*a25
c     2 *a31*a42+a15*a21*a34*a42-a11*a25*a34*a42-a14*a21*a35*a42+a11*a24
c     3 *a35*a42+a15*a22*a31*a44-a12*a25*a31*a44-a15*a21*a32*a44+a11*a25
c     4 *a32*a44+a12*a21*a35*a44-a11*a22*a35*a44-a14*a22*a31*a45+a12*a24
c     5 *a31*a45+a14*a21*a32*a45-a11*a24*a32*a45-a12*a21*a34*a45+a11*a22
c     6 *a34*a45)
c      a(4,1)=(-(a25*a33*a42*a51)+a23*a35*a42*a51+a25*a32*a43*a51-a22*a35
c     1 *a43*a51-a23*a32*a45*a51+a22*a33*a45*a51+a25*a33*a41*a52-a23*a35
c     2 *a41*a52-a25*a31*a43*a52+a21*a35*a43*a52+a23*a31*a45*a52-a21*a33
c     3 *a45*a52-a25*a32*a41*a53+a22*a35*a41*a53+a25*a31*a42*a53-a21*a35
c     4 *a42*a53-a22*a31*a45*a53+a21*a32*a45*a53+a23*a32*a41*a55-a22*a33
c     5 *a41*a55-a23*a31*a42*a55+a21*a33*a42*a55+a22*a31*a43*a55-a21*a32
c     6 *a43*a55)
c      a(4,2)=(a15*a33*a42*a51-a13*a35*a42*a51-a15*a32*a43*a51+a12*a35
c     1 *a43*a51+a13*a32*a45*a51-a12*a33*a45*a51-a15*a33*a41*a52+a13*a35
c     2 *a41*a52+a15*a31*a43*a52-a11*a35*a43*a52-a13*a31*a45*a52+a11*a33
c     3 *a45*a52+a15*a32*a41*a53-a12*a35*a41*a53-a15*a31*a42*a53+a11*a35
c     4 *a42*a53+a12*a31*a45*a53-a11*a32*a45*a53-a13*a32*a41*a55+a12*a33
c     5 *a41*a55+a13*a31*a42*a55-a11*a33*a42*a55-a12*a31*a43*a55+a11*a32
c     6 *a43*a55)
c      a(4,3)=(-(a15*a23*a42*a51)+a13*a25*a42*a51+a15*a22*a43*a51-a12*a25
c     1 *a43*a51-a13*a22*a45*a51+a12*a23*a45*a51+a15*a23*a41*a52-a13*a25
c     2 *a41*a52-a15*a21*a43*a52+a11*a25*a43*a52+a13*a21*a45*a52-a11*a23
c     3 *a45*a52-a15*a22*a41*a53+a12*a25*a41*a53+a15*a21*a42*a53-a11*a25
c     4 *a42*a53-a12*a21*a45*a53+a11*a22*a45*a53+a13*a22*a41*a55-a12*a23
c     5 *a41*a55-a13*a21*a42*a55+a11*a23*a42*a55+a12*a21*a43*a55-a11*a22
c     6 *a43*a55)
c      a(4,4)=(a15*a23*a32*a51-a13*a25*a32*a51-a15*a22*a33*a51+a12*a25
c     1 *a33*a51+a13*a22*a35*a51-a12*a23*a35*a51-a15*a23*a31*a52+a13*a25
c     2 *a31*a52+a15*a21*a33*a52-a11*a25*a33*a52-a13*a21*a35*a52+a11*a23
c     3 *a35*a52+a15*a22*a31*a53-a12*a25*a31*a53-a15*a21*a32*a53+a11*a25
c     4 *a32*a53+a12*a21*a35*a53-a11*a22*a35*a53-a13*a22*a31*a55+a12*a23
c     5 *a31*a55+a13*a21*a32*a55-a11*a23*a32*a55-a12*a21*a33*a55+a11*a22
c     6 *a33*a55)
c      a(4,5)=(-(a15*a23*a32*a41)+a13*a25*a32*a41+a15*a22*a33*a41-a12*a25
c     1 *a33*a41-a13*a22*a35*a41+a12*a23*a35*a41+a15*a23*a31*a42-a13*a25
c     2 *a31*a42-a15*a21*a33*a42+a11*a25*a33*a42+a13*a21*a35*a42-a11*a23
c     3 *a35*a42-a15*a22*a31*a43+a12*a25*a31*a43+a15*a21*a32*a43-a11*a25
c     4 *a32*a43-a12*a21*a35*a43+a11*a22*a35*a43+a13*a22*a31*a45-a12*a23
c     5 *a31*a45-a13*a21*a32*a45+a11*a23*a32*a45+a12*a21*a33*a45-a11*a22
c     6 *a33*a45)
c      a(5,1)=(a24*a33*a42*a51-a23*a34*a42*a51-a24*a32*a43*a51+a22*a34
c     1 *a43*a51+a23*a32*a44*a51-a22*a33*a44*a51-a24*a33*a41*a52+a23*a34
c     2 *a41*a52+a24*a31*a43*a52-a21*a34*a43*a52-a23*a31*a44*a52+a21*a33
c     3 *a44*a52+a24*a32*a41*a53-a22*a34*a41*a53-a24*a31*a42*a53+a21*a34
c     4 *a42*a53+a22*a31*a44*a53-a21*a32*a44*a53-a23*a32*a41*a54+a22*a33
c     5 *a41*a54+a23*a31*a42*a54-a21*a33*a42*a54-a22*a31*a43*a54+a21*a32
c     6 *a43*a54)
c      a(5,2)=(-(a14*a33*a42*a51)+a13*a34*a42*a51+a14*a32*a43*a51-a12*a34
c     1 *a43*a51-a13*a32*a44*a51+a12*a33*a44*a51+a14*a33*a41*a52-a13*a34
c     2 *a41*a52-a14*a31*a43*a52+a11*a34*a43*a52+a13*a31*a44*a52-a11*a33
c     3 *a44*a52-a14*a32*a41*a53+a12*a34*a41*a53+a14*a31*a42*a53-a11*a34
c     4 *a42*a53-a12*a31*a44*a53+a11*a32*a44*a53+a13*a32*a41*a54-a12*a33
c     5 *a41*a54-a13*a31*a42*a54+a11*a33*a42*a54+a12*a31*a43*a54-a11*a32
c     6 *a43*a54)
c      a(5,3)=(a14*a23*a42*a51-a13*a24*a42*a51-a14*a22*a43*a51+a12*a24
c     1 *a43*a51+a13*a22*a44*a51-a12*a23*a44*a51-a14*a23*a41*a52+a13*a24
c     2 *a41*a52+a14*a21*a43*a52-a11*a24*a43*a52-a13*a21*a44*a52+a11*a23
c     3 *a44*a52+a14*a22*a41*a53-a12*a24*a41*a53-a14*a21*a42*a53+a11*a24
c     4 *a42*a53+a12*a21*a44*a53-a11*a22*a44*a53-a13*a22*a41*a54+a12*a23
c     5 *a41*a54+a13*a21*a42*a54-a11*a23*a42*a54-a12*a21*a43*a54+a11*a22
c     6 *a43*a54)
c      a(5,4)=(-(a14*a23*a32*a51)+a13*a24*a32*a51+a14*a22*a33*a51-a12*a24
c     1 *a33*a51-a13*a22*a34*a51+a12*a23*a34*a51+a14*a23*a31*a52-a13*a24
c     2 *a31*a52-a14*a21*a33*a52+a11*a24*a33*a52+a13*a21*a34*a52-a11*a23
c     3 *a34*a52-a14*a22*a31*a53+a12*a24*a31*a53+a14*a21*a32*a53-a11*a24
c     4 *a32*a53-a12*a21*a34*a53+a11*a22*a34*a53+a13*a22*a31*a54-a12*a23
c     5 *a31*a54-a13*a21*a32*a54+a11*a23*a32*a54+a12*a21*a33*a54-a11*a22
c     6 *a33*a54)
c      a(5,5)=(a14*a23*a32*a41-a13*a24*a32*a41-a14*a22*a33*a41+a12*a24
c     1 *a33*a41+a13*a22*a34*a41-a12*a23*a34*a41-a14*a23*a31*a42+a13*a24
c     2 *a31*a42+a14*a21*a33*a42-a11*a24*a33*a42-a13*a21*a34*a42+a11*a23
c     3 *a34*a42+a14*a22*a31*a43-a12*a24*a31*a43-a14*a21*a32*a43+a11*a24
c     4 *a32*a43+a12*a21*a34*a43-a11*a22*a34*a43-a13*a22*a31*a44+a12*a23
c     5 *a31*a44+a13*a21*a32*a44-a11*a23*a32*a44-a12*a21*a33*a44+a11*a22
c     6 *a33*a44)
c
c          a(1,1) = a(1,1) * deti
c          a(1,2) = a(1,2) * deti
c          a(1,3) = a(1,3) * deti
c          a(1,4) = a(1,4) * deti
c          a(1,5) = a(1,5) * deti
c          a(2,1) = a(2,1) * deti
c          a(2,2) = a(2,2) * deti
c          a(2,3) = a(2,3) * deti
c          a(2,4) = a(2,4) * deti
c          a(2,5) = a(2,5) * deti
c          a(3,1) = a(3,1) * deti
c          a(3,2) = a(3,2) * deti
c          a(3,3) = a(3,3) * deti
c          a(3,4) = a(3,4) * deti
c          a(3,5) = a(3,5) * deti
c          a(4,1) = a(4,1) * deti
c          a(4,2) = a(4,2) * deti
c          a(4,3) = a(4,3) * deti
c          a(4,4) = a(4,4) * deti
c          a(4,5) = a(4,5) * deti
c          a(5,1) = a(5,1) * deti
c          a(5,2) = a(5,2) * deti
c          a(5,3) = a(5,3) * deti
c          a(5,4) = a(5,4) * deti
c          a(5,5) = a(5,5) * deti
       endif
      write(6,43)
      do 40 j = 1,isize
         write(6,30)(a(i,j),i=1,isize)
   40 continue
   43 format(' ************** Inverse Matrix ************** ')

       return
       end
