c $Log:   /pvcs.config/mc3dvv/src/kinsurf.F_a  $
c
c *************************************************************
c *   KINSURF 
c *
c *************************************************************
c***begin prologue kinsurf 
c***date written   000515   (yymmdd)
c***category no.  ????
c***keywords
c***description
c***routines called chvarx, chvary, filt, ft2nrm, surfv 
c
c     this routine computes the Fourier poloidal and toroidal
c     components of a specified surface velocity field
c
      subroutine kinsurf(ijob,iip) 
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_afftw
c#include<a4.h>
      use module_a6
      use module_a7
      use module_a9
      use module_gia9
      use module_a11
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a13
      use module_a14
      use module_a20
      use module_a26
      use module_a30
      use module_viscom
c lu
      use module_flow
      use module_ftcoef
      use module_slvelu
      real l, l2
      common /start1/ restrt, initlt, istart
      common /a4/ vsij(700)
      common /a8/ l2, l, vps, vts
      common /a10/ jcycle


c JPL add
       common/cinttaus/iholdstill

       if(ijob.lt.0)then
         jsave=j1
       else
         jsave=1
       endif

c**********************************************************
c* calculate surface velocity for specified velocity b.c. *
c**********************************************************
          do 10 j = jsave,j3
          do 10 i = 1,nx
          vsurf(i,j,1) = zero
   10     vsurf(i,j,2) = zero

c
c      Is the surface rigid?
c
          if (isurfv.ne.0) then
c
c      Is this a kinematic b.c. job?
c      iip is set .lt.0 for memory saving dynamic plates
c      
           if((ijob.ge.0).or.(iip.lt.0))then

            if (isurfv.eq.1) then
c *************************************************
c
c     get surface velocity from input table vsij
c
              ll = 1
   20         i1 = int(vsij(ll))
              i2 = int(vsij(ll+1))
              jj1 = int(vsij(ll+2))
              jj2 = int(vsij(ll+3))
              uxs = vsij(ll+4)
              vys = vsij(ll+5)
              if (i1.eq.0) go to 210
              do 30 j = jj1,jj2
              do 30 i = i1,i2
              vsurf(i,j,1) = uxs
   30         vsurf(i,j,2) = vys
              ll = ll+6
              if (ll+6.lt.700) then
                  go to 20
              else
                 write(6,*) 'PWARN(flow): vsij(ll) in endless loop'
              endif
c *************************************************

            else 
c
c     get surface velocity from user supplied function in
c     sub surfv or dynamic plates with memory savings
c
              call surfv (vsurf,nx,j3,template2,iplgeo)
            endif

           else
c
c     case of dynamic plates with no mempry savings
c     (i.e. superposition algorithm, plflow, run)
c
            do 35 ipla = 1,nplate
              i2 = 2*ipla
              i2m1 = i2-1
              if(iip .eq. i2m1)then
                do 32 j = 1,nyr
                do 32 i = 1,nxr
                vsurf(i,j,1) = template2(i,j,ipla)
 32             continue
              elseif(iip .eq. i2)then
                do 33 j = 1,nyr
                do 33 i = 1,nxr
                 vsurf(i,j,2) = template2(i,j,ipla)
 33             continue
              endif
 35         continue
           endif
c
c     insure that imposed velocity agrees with side b.c.
c     only on 3D calculations
c
            if (ny.ne.2) then
              if (lbd.eq.0) then
                do 40 i = 1,nxr+1
                vsurf(i,nyr+1,1) = vsurf(i,1,1)
                vsurf(i,nyr+1,2) = vsurf(i,1,2)
   40           continue
              elseif ((lbd.eq.1).or.(lbd.eq.2)) then
                do 50 j = 1,ny
                vsurf(1,j,1) = 0.
                vsurf(nx,j,1) = 0.
   50           continue
              endif
              if (mbd.eq.0) then
                do 60 j = 1,nyr+1
                vsurf(nxr+1,j,1) = vsurf(1,j,1)
                vsurf(nxr+1,j,2) = vsurf(1,j,2)
   60           continue
              elseif ((mbd.eq.1).or.(mbd.eq.2)) then
                do 70 i = 1,nx
                vsurf(i,1,2) = 0.
                vsurf(i,ny,2) = 0.
70              continue
              endif
            endif

            if (isolve.gt.2) then
c
c     calculate fft of surface velocity and calculate  vp, vt
c

              do 80 j = jsave,j3
              do 80 i = 1,nx
              fftvx(i,j) = vsurf(i,j,1)
   80         continue
              do 90 j = 1,j3
              do 90 i = 1,nx
              fftvy(i,j) = vsurf(i,j,2)
   90         continue

              k_fftv = 1
              i_fft = 1
              call ft2nrm (i_fft,lpu,nxu,mpu,nyu,k_fftv,iqx,jqx,fftvx)
              call ft2nrm (i_fft,lpv,nxv,mpv,nyv,k_fftv,iqx,jqx,fftvy)

c              if(ijob.lt.0) then
c                ifilter = 1
c                stopfq = xl*dfloat(nz)/(dfloat(nx)*dfloat(lith)) 
c                if(ifilter.eq.1)
c     & call filt(fftvx,iqx,jqx,ifilter,nxu,nyu,ifilter,zero,stopfq)
c                if(ifilter.eq.1)
c     & call filt(fftvy,iqx,jqx,ifilter,nxv,nyv,ifilter,zero,stopfq)
c              endif

              if((j3.gt.1).and.
     1        (((lbd.eq.0).and.
     2        (mbd.eq.0)).or.
     3        (ijob.ge.0))) then
              ichvar=1
              k_fftv=1 
              call chvary(fftvx,iqx,nxr,lbd,jqx,nyr,mbd,k_fftv,ichvar)
              call chvarx(fftvy,iqx,nxr,lbd,jqx,nyr,mbd,k_fftv,ichvar)
              endif     
     
              do j = 1,nyr
              do i = 1,nxr
                vpb(i,j) = zero
                vtb(i,j) = zero
              enddo
              enddo

              do 100 j = 1,nyr
              do 100 i = 1,nxr
              vpb(i,j) = fli(i,j)*fftvx(i,j)+flj(i,j)*fftvy(i,j)
              vtb(i,j) = flj(i,j)*fftvx(i,j)-fli(i,j)*fftvy(i,j)
  100         continue
            endif

      if(ijob.ge.0)then
c
      if ((isurfv.ge.200) .and. (isurfv .lt. 300)) then
c
c ****    set individual modes to non-zero value
c ****    this could be changed to use namelist vsij as
c ****    input for if_pol_tor, imode, jmode, mag


         do 105 j = 1,nyr
         do 105 i = 1,nxr
         vpb(i,j) = zero
         vtb(i,j) = zero
  105    continue

c         nmodes=int(vsij(1))
c         do 103 nm=1,nmodes
c            if_pol_tor = int(vsij(nm))
c            imode = int(vsij(nm+1))
c            jmode = int(vsij(nm+2))
c            mag   =     vsij(nm+3)
c            if(if_pol_tor .eq. 1)vpb(imode,jmode)=mag
c            if(if_pol_tor .eq. 2)vtb(imode,jmode)=mag
c  103    continue

         open (unit = 46, file='input.modes')
         read (46,*)nmodes
         do 108 nm = 1,nmodes
         read (46,*) if_pol_tor, imode, jmode, mag
         if(if_pol_tor .eq. 1)vpb(imode,jmode)=mag
         if(if_pol_tor .eq. 2)vtb(imode,jmode)=mag
  108    continue
         close (46)
c
       endif
      endif

      endif
  210       continue

      return
      end
