c $Log:   /pvcs.config/mc3dvv/src/laser.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:38 1997   pvcs
c 
c *************************************************************
c *   LASER
c *************************************************************
      subroutine laser(c1,c2,indx,t,inx,jnx,knx)
      use module_precision
      use module_gia3
      use module_a3
      dimension t(inx,jnx,knx)
c
c  calculate deflection of a laser beam passed through convecting fluid
c     i.e.      c1 = x, c2 =z, indx =2
c     returns   d(x,z) = int (dt/dz) dy
c
c     indx = 1 integration along x direction, c1 = y cord, c2 = z cord
c     indx = 2 integration along y direction, c1 = x cord, c2 = z cord
c     indx = 3 integration along z direction, c1 = x cord, c2 = y cord
c
c     determine the grid index that brackets c1 and c2
c
      if(indx .ne. 2)then
c       error condition
        write(6,999)c1,c2,indx
        return
      endif
      
      xpos= zero
      ypos= zero
      
      if((indx .eq. 1) .or. (indx .eq. 2))then
        do 10 k=1,nz1
          if ((z(k) .le. c2) .and. (z(k+1) .ge. c2))  icz=k
   10   continue
      endif
      if((indx .eq. 2) .or. (indx .eq. 3))then
        do 20 i=1,nx1  
          if ((xpos .le. c1) .and. (xpos+dx .ge. c1)) icx=i
          xpos=xpos+dx
   20   continue
      endif
      if((indx .eq. 1) .or. (indx .eq. 3))then
       if(indx .eq. 1)then
         c12=c1
        else
         c12=c2
        endif
        do 30 j=1,ny1
          ypos=ypos+dy
          if ((ypos .le. c12) .and. (ypos+dy .ge. c12)) icy=j
          ypos=ypos+dy
   30   continue
      endif
c
c     integrate vertical temperature gradiant along y direction
c
      txz=zero
      do 40 j = 1,ny1
c
c     use linear interpolation to find temperate and gradient
c
        slopex1 = (t(icx+1,j,icz)-  t(icx,j,icz))  /dx
        slopex2 = (t(icx+1,j,icz+1)-t(icx,j,icz+1))/dx
        bvalx1  = t(icx,j,icz)-  slopex1*(icx-1)*dx
        bvalx2  = t(icx,j,icz+1)-slopex2*(icx-1)*dx
        tx1 = slopex1*xpos+bvalx1
        tx2 = slopex2*xpos+bvalx2
        dtdz=(tx2-tx1)/(z(icz+1)-z(icz))
        txz = txz + dtdz
   40 continue
  
  999 format('Error in subroutine laser',2f14.7,i5)
      return
      end
