c $Log:   /pvcs.config/mc3dvv/src/mantle.F_a  $

c   Rev 1.4   Fri Jul 30 15:34:54 1999   lowman
c  Added template2 argument to surfgeo call
c
c   Rev 1.2   Tue Feb 09 14:32:52 1999   lowman
c
c   Rev 1.1   Tue Oct 06 16:43:58 1998   lowman
cAdded calls to userout
cRemoved hardwired arguments in call pttouv
c
c   Rev 1.0   Mon Jul 14 14:21:40 1997   pvcs
c 
c *************************************************************
c *   MANTLE
c *************************************************************
      subroutine mantle
      use module_precision
      use module_giparam
      use module_param
      use module_gia1
      use module_a1
      use module_ac1
      use module_a2
      use module_a3
      use module_gia3
      use module_a22
      use module_nu
      use module_ftcoef
      use module_work1d
      use module_temp4
      use module_viscom
      use module_a6
      use module_a12
      use module_a30
      use module_a77
      use module_timeint
      use module_routput
      use module_petracer
      use module_userout
      use module_spwork   !+DaN
      use module_mytime
      common /start1/ restrt, initlt, istart

#ifdef MPI
      include 'mpif.h'
#endif
      common /ijc/ ijcycle
      nrestrt=1
      tcrash=3600.
      tinc=3600.

#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr ) 
#else
      myid = 0
#endif
c      btime = MPI_WTIME()

      istart=0
      ijcycle = 0
      tout = dtout
      call init
      call surfgeo (template,iplgeo,template2)
     

      call incheck(imx, jmx, kmx, nxyz, isx, jsx, ksx, nbdd,
     1  ijksx, iqx, jqx, kqx, ijkqx, inx, jnx, knx, mxmy, 
     2  ijknx, ijkmx,  ijksf, inxsf, jnxsf, knxsf, imxsf, jmxsf,
     3  kmxsf, npla, npssd, ncabe, nabe,icx,jcx,kcx,nspecies)

      call userout("init")

c      ftime = MPI_WTIME()
      settime = settime + ftime-btime

   10 icycle=icycle+1
      ijcycle=ijcycle+1
      if (isolve .eq. 5) then
        call vofxyz
      else
        if (icycle .eq. 1 .or.
     1     mod(icycle,mcycle) .eq. 0 .or.
     2     restrt .ne. 0.0) then
           if (kchem .eq. 0)then
             call flow
           else
             call flow_layer
           endif
c         *** use advctd as a temporary work array
c              btime = MPI_WTIME()
           call velprm (advctd)
c              ftime = MPI_WTIME()
              settime = settime + ftime-btime
        else
           ijob_pttouv=0
           ipttype_pttouv=0
           call pttouv(ipttype_pttouv,ijob_pttouv)
           call ft2nrm_uvw (-1,lpu,nxu,mpu,nyu,nz,inx,jnx,u)    !DaN
           call ft2nrm_uvw (-1,lpv,nxv,mpv,nyv,nz,inx,jnx,v)    !DaN
           call ft2nrm_uvw (-1,lpw,nxw,mpw,nyw,nz,inx,jnx,w)    !DaN
           call netflow(nx,ny,inx,jnx,u,v,vis,wk1d,netflo)
           call bc (inx,nxr,nx,lbd,jnx,nyr,ny,mbd,nz,1)         !DaN
           call velprm (advctd)
        endif
      endif
#ifdef MPI
      impi = -1
      if(io_ft.eq.1) then
        if((icycle.eq.1).or.((time-prnt_last).gt.prntflds))then
          call mpiprint(impi,nx,j3,nz,t,itx,jtx,ktx)
        endif
      endif
#endif

c      btime = MPI_WTIME()

      call userout("vstats") 
      call userout("tstats")
      call userout("flow")
c     call userout("geoid")
c     call userout("topo")
c     call userout("tau")
      call userout("printout")      

c      ftime = MPI_WTIME()
      settime = settime + ftime-btime

      restrt=0.
      if (iptrac .gt. 0) call prtcl

c     write(6,*) 'mantle itracoption: ',itracoption,dt
      if (itracoption.eq.1) call movetracers
      
      call heatflo
      time=time+dt
c      btime = MPI_WTIME()

c +DaN+ ---- to correct bug in tape7_restart ---- +DaN+
#ifdef MPI
      if (mod(icycle,500).eq.0) then
        impi = -1
        call mpiprint(impi,nx,j3,nz,t,itx,jtx,ktx)
      endif
#endif
c +DaN+ ---------------------------------------- +DaN+
     
      call userout("heat")
 
c      ftime = MPI_WTIME()
      settime = settime + ftime-btime

      call mig_mach(2,'sun***',rdum,rtr,idum,idum)
      if ((time.lt.tend).and.
     1    (rtr.gt.120.0).and.
     2    (energk.lt.1.e15)) go to 10

      if (myid .eq. 0) then
        write(6,*) 'stopped because: '
        write(6,*) 'time.lt.tend: ',time.lt.tend,time,tend
        write(6,*) 'rtr.gt.120: ',rtr.gt.120,rtr
        write(6,*) 'energk.lt.1.e15',energk.lt.1.e15,energk
      endif

#ifdef MPI
      impi = -1
      call mpiprint(impi,nx,j3,nz,t,itx,jtx,ktx)
#endif

c      btime = MPI_WTIME()
      call userout("end")
c      ftime = MPI_WTIME()
      settime = settime + ftime-btime

      return
      end
