c $Log:   /pvcs.config/mc3dvv/src/mc3d.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:42 1997   pvcs
c 
c *************************************************************
c *   MC3D
c *
c *   Version 50  960701 
c *      PvK  Add option itimechoice=-1 for steady state iteration
c *           See smantle for details.
c *************************************************************
      subroutine mc3d
c***begin prologue  main_sub
c***date written   1/1/93   (yymmdd)
c***revision date  7/27/93   (yymmdd)
c***category no.  ????
c***keywords
c             type=???? precision
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose
c***description
c***references (none)
c***routines called  inputs, allocmem, mantle
c***modifications (yymmdd) modification
c***end prologue  mc3d
c
      use module_precision
      use module_param
      use module_giparam
      use module_timeint
      use module_mytime
#ifdef MPI
      use module_mpibuf
      include 'mpif.h'
#endif
      real percent

      settime = 0.0
      heattime = 0.0
      flowtime = 0.0
      flow1time = 0.0
      flow2time = 0.0
      flow3time = 0.0
      fluxtime = 0.0
      ctentime = 0.0
      ffttime  = 0.0
      commtime = 0.0
      tottime = 0.0
      time240 = 0.0
      time270 = 0.0
      time300 = 0.0
#ifdef MPI
c      btime = MPI_WTIME()
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
#else
      myid=0
#endif
c     call MPE_INIT_LOG()
c     if (myid .eq. 0) then
c       call MPE_DESCRIBE_STATE(1,2,"Flow", "red:vlines3")
c       call MPE_DESCRIBE_STATE(3,4,"Heatflo", "blue:gray3")
c       call MPE_DESCRIBE_STATE(5,6,"Communication","yellow:gray")
c     endif
      if (myid .eq. 0) then
         write(6,*) '************************************'
         write(6,*) '*            MC3D                  *'
         write(6,*) '************************************'
      endif
      call inputs
      call allocmem
c      ftime = MPI_WTIME()
      settime = ftime - btime
      if (itimechoice.eq.-1) then
c        *** Steady state iteration
         call smantle
      else if (itimechoice.eq.0) then
c        *** Regular time integration (ctensr/flux)
         call mantle
      else 
c        *** Time-integration through DASPK
         call dmantle
      endif
#ifdef MPI
c      endtime = MPI_WTIME()
      tottime = endtime - btime
      percent = 100.0*commtime/tottime
      if (myid .eq. 0) then
        write(6,*) "Total time (wall):            ", tottime
        write(6,*) "Set time (wall):              ", settime
        write(6,*) "Flow time (wall):             ", flowtime
        write(6,*) "Flow1 time (wall):            ", flow1time
        write(6,*) "Flow2 time (wall):            ", flow2time
        write(6,*) "Flow3 time (wall):            ", flow3time
        write(6,*) "Heatflow time (wall):         ", heattime
        write(6,*) "Flux time (wall):             ", fluxtime
        write(6,*) "240 time (wall):              ", time240
        write(6,*) "270 time (wall):              ", time270
        write(6,*) "300 time (wall):              ", time300
        write(6,*) "Ctenser time (wall):          ", ctentime
        write(6,*) "FFT time (wall):              ", ffttime
        write(6,*) "Communication time (wall):    ", commtime
        write(6,*) "Subtotal (wall):              ", 
     &   settime+flowtime+heattime+ffttime+commtime
        write(6,*) "Percent time in comm routines:", percent
      end if
c     call MPE_FINISH_LOG("pmc3d")
#endif

      return

      end

