      subroutine mpiexchange(nx,ny,nz,temp,ii,jj)
c
c  This elliminates the need for global communication
c
c  Written S.D.K 4/14/99-5/25/99
c
c  Tested S.D.K. 5/25/99 on Sun cluster (mpich) and SGI
c
      use module_precision
      use module_mpibuf
#ifdef MPI
      include 'mpif.h'
      integer stat(MPI_STATUS_SIZE)
#endif
c
      dimension temp(ii,jj,*) 
      real*4 endtime, tarray(2)
#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
c      btime = etime(tarray)
      if (numprocs .eq. 1) return

      knz = 2
      kny = ny
c
c calculate the z values that need to be sent
c
      call mpilayer(nz,numprocs,myid,izstart,izstop)
      index = 0
      do 200 k=izstop-1,izstop
        index = index + 1
        do 100 i=1,nx
        do 100 j=1,ny
          sbuff(index+knz*((j-1)+kny*(i-1)))=temp(i,j,k)
 100    continue
 200  continue
c
      ito = myid+1
      ifrom = myid -1
      if (ito .ge. numprocs) ito = MPI_PROC_NULL
      if (ifrom .lt. 0) ifrom = MPI_PROC_NULL
      isize = 2+knz*(ny-1 + ny*(nx-1))
      if (isize .gt. ibuff) then
      write(6,*) "WARNING POSSIBLE PROBLEM WITH MPI BUFFERS"
      write(6,*) "in mpiexchange", isize,ibuff,myid
      endif
      call MPI_SENDRECV(
     &    sbuff,isize,MPI_DOUBLE_PRECISION,ito,0,
     &    rbuff,isize,MPI_DOUBLE_PRECISION,ifrom,0,
     &    MPI_COMM_WORLD,stat,ierr)
c
c unpack message from the receive buff into temp array
c
      if (ifrom .ge. 0) then
        call mpilayer(nz,numprocs,ifrom,izstart,izstop)
        index = 0
        do 400 k=izstop-1,izstop
          index = index+1
          do 300 i=1,nx
            do 300 j=1,ny
              temp(i,j,k)=rbuff(index+knz*((j-1)+kny*(i-1))) 
 300        continue
 400    continue
      endif
c
c calculate the z values that need to be sent
c
      call mpilayer(nz,numprocs,myid,izstart,izstop)
c
c pack send buffer with the data to be sent to processor below
c
      index = 0
      do 600 k=izstart,izstart+1
        index = index + 1
        do 500 i=1,nx
        do 500 j=1,ny
          sbuff(index+knz*((j-1)+kny*(i-1)))=temp(i,j,k)
 500    continue
 600  continue
c
      ito = myid-1
      ifrom = myid+1
      if (ifrom .ge. numprocs) ifrom = MPI_PROC_NULL
      if (ito .lt. 0) ito = MPI_PROC_NULL
c
c handle the top correctly
c
      call MPI_SENDRECV(
     &    sbuff,isize,MPI_DOUBLE_PRECISION,ito,1,
     &    rbuff,isize,MPI_DOUBLE_PRECISION,ifrom,1,
     &    MPI_COMM_WORLD,stat,ierr)
c
c unpack message from the receive buff into temp array
c
      if (ifrom .ge. 0) then
      call mpilayer(nz,numprocs,ifrom,izstart,izstop)
      index = 0
      do 800 k=izstart,izstart+1
        index = index+1
        do 700 i=1,nx
          do 700 j=1,ny
           temp(i,j,k) = rbuff(index+knz*((j-1)+kny*(i-1))) 
 700      continue
 800    continue
      end if
c      endtime = etime(tarray)
      commtime = commtime + endtime -btime
#endif
c
c return
c
      return
      end
