c $Log:   /pvcs.config/mc3dvv/src/patch.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:56 1997   pvcs
c 
c *************************************************************
c *   PATCH
c *************************************************************
      subroutine patch
c***begin prologue  patch
c***date written   910201   (yymmdd)
c***revision date  ??????   (yymmdd)
c***category no.  ????
c***keywords  hot patch plume initiation
c             type=???? precision
c***author   Chris Kincaid   (URI)
c***purpose  routine to give additional buoyancy
c***purpose  to a patch of elements in D"
c***description
c***references (none)
c***routines called  ttoft wheader
c***modifications (yymmdd) modification
crk version t1-t7
crk 3/92 from patch.f_current_t1-t5.  changes made at lanl
crk during CM visist.  
crk version from 10/91.  attempt to reduce size of tape36
crk   by tracking temps at 5 times.
crk 10/91 added t(y) profile output
c
crk-cg 1/91 patch chars input thru vsij
c
c cwg 3/15/93 Implement dynamic memory management
c             Move call to particle tracker to MANTLE
c
c cwg 930422 Calculate and save i,j,k index of patch center 
c            in vsij(17)=i, vsij(18)=j, vsij(19)=k
c
c***end prologue  patch
 
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_ftcoef
      use module_patch

       common /a4/ vsij(700)
       common /ppjunkr/ tstar
       common /ppjunki/ np1,np2,np3,np4
       character*1 cma
       cma=','
       

crk works only for initial runs where tstart=0
c
       tstart=0.0
       dz=z(2)-z(1)
       delt=tend-tstart
       tstar=(time-tstart)/delt
       pi=pimach(dum)
       c1=dt/(dx*dy*dz)
       c1=c1/rat
       pfreq=abs(vsij(21))
       modcyc=int(vsij(22))
       kpulse=int(tstar*pfreq+0.9999)
       kpulse=kpulse-1
       tsin=0.0
       c2=pi*pfreq*tstar
       if(vsij(21).lt.0.) then
       tsin=1.0
       else
       if(mod(kpulse,modcyc).eq.0) tsin=abs(sin(c2))
       endif
       
       ifoutput=0
crk 4/91  check to see if output for tape36, 4 outputs per pulse
crk       or 4*pfreq
c      p36chk=tstar*pfreq*4.0
crk changed 6/17/91
       p36chk=tstar*pfreq*12.
c      tsin=abs(sin(c2))
c
c     on first iteration vsij(23) is set less than 0
c     program will calculate patch size, numpp, etc
c     and not have to generate np1-np4, etc again.
c     vsij(23) is reset to  numpp at end of routine after first iteration.
c
       numpp=int(vsij(23))
       if (numpp.lt.0) then
c
c note: if use old method of calculating patch will have
c       problem with partcl routine

        if(vsij(24) .ge. 0)then
           xmin=vsij(24)
           xmax=vsij(25)
           ymin=vsij(26)
           ymax=vsij(27)
           np1=xmin*nx
           np2=xmax*nx
           np3=ymin*ny
           np4=ymax*ny
        else
           np1=int(abs(vsij(24)))
           np2=int(abs(vsij(25)))
           np3=int(abs(vsij(26)))
           np4=int(abs(vsij(27)))
        endif
        zmag=vsij(28)
        if(ny.eq.2) then
         np3=1
         np4=1
        endif
        ivs=29
        numpp=0
        do 5 ij=np3,np4
         do 5 ii=np1,np2
         vsij(ivs)=float(ii)
         vsij(ivs+1)=float(ij)
         vsij(ivs+2)=zmag
         ivs=ivs+3
         numpp = numpp + 1
5       continue
        if(numpp .gt. 225)then
           write(6,*)'*********error: patch size too large **********'
           write(6,*)'*********job stopped in sub patch.f **********'
        stop
        endif
crk ivs1@1st i&j;ivs2@1sti,lastj;ivs3@lasti,1stj;ivs4@last i&j
         npytot=np4-np3+1
         npxtot=np2-np1+1
         ivs1=28+3
         ivs2=28+((npytot-1)*npxtot*3)+3
         ivs3=28+(npxtot*3)
         ivs4=28+(npxtot*npytot*3)
crk if picture x-y plane vertically then
crk loop (20) = bottom; (30) = top; (40) = left; 50=right
         if(ny .eq. 2)then
           vsij(ivs1)=vsij(ivs1)*tenth
           vsij(ivs3)=vsij(ivs3)*tenth
         else
         do 20 iv=ivs1,ivs3,3
         vsij(iv)=vsij(iv)*tenth
20       continue
         do 30 iv=ivs2,ivs4,3
         vsij(iv)=vsij(iv)*tenth
30       continue
         ivinc=3*npxtot
         do 40 iv=ivs1,ivs2,ivinc
         vsij(iv)=vsij(iv)*tenth
40       continue
         do 50 iv=ivs3,ivs4,ivinc
         vsij(iv)=vsij(iv)*tenth
50       continue
         endif
         ivflag=1
         numpp=abs(numpp)
         write(6,*) 'i,j,rahp generated patch values; subroutine patch'
c     time series information on max temperature
         open (unit=36,file='tape36',form='formatted')
         call wheader(36,2)
         open (unit=44,file='tape44',form='formatted')
c calc center of patch for time series output
         ipinit=(np1+np2)/2+1
         jpinit=(np3+np4)/2
         vsij(17) = float(ipinit)
         vsij(18) = float(jpinit)
c
c       store temp and vertical velocity of initial conditions
c
         call ttoft
c      define z levels for output and check for max min temperatures
c
       nk = 6
       kave(1) = 2
       kave(2) = nz/8
       kave(3) = nz/4
       kave(4) = nz/2
       kave(5) = float(nz)/1.25
       kave(6) = nz-1

c
         jby2  = j3/2
         if(jby2 .lt. 2)jby2=1
         write(36,*)jby2,(kave(k),k=1,nk)
          do 70  k=1,nk
          xposition = zero
          do 70  i=1,nx
           wave(i,k) = w(i,jby2,kave(k))
           tave(i,k) = ft(i,jby2,kave(k))/rat
           write(36,72)i,kave(k), k,xposition,
     1       wave(i,k),
     2       tave(i,k)
   72       format(3i4,5e12.4)
            xposition = xposition + dx
   70    continue
         endif
c
c      ivflag = 0 when all cords. of patch are in input file
c      ivflag = 1 when the cords. are calculates from four corner values.
c
         if(ivflag.ne.1) then
          itt=24
         else
          itt=29
         endif
  
ccccc
ccccc add izptch for z level of patch
c cg  10/15/92
c      set default value to 2
c      or allow izptch set from input file using negative 
c      values of vsij(23) .lt. 100
c      izptch = abs(vsij(23))-100
c      e.g. vsij(23) = -116  => izptch = 16
c
       if(vsij(23).lt.0.)then
       if(vsij(23) .lt. -100)then
        izptch = int(abs(vsij(23)))-100
       else
        izptch = 2
       endif
        vsij(19) = float(izptch)
       endif
       tnpav=0.
       do 10 it=1,numpp
        i=int(vsij(itt))
        j=int(vsij(itt+1))
        rahp=vsij(itt+2)
        tn(i,j,izptch)=tn(i,j,izptch)+c1*rahp*tsin
c
c      Logic below forces there to be no downward heat flow only
c      when the patch is on the base of the box. Otherwise
c      there can be downward conduction.
c
       if(izptch .eq. 2)then
        if(tn(i,j,izptch) .gt. one)then
           tn(i,j,1)=tn(i,j,izptch)
        else
           tn(i,j,1)=one
        endif
       endif
c       use above so that no conversion is needed from 64 bit to 32 bit

       itt=itt+3
       if(vsij(23).lt.0.) write(6,*)  i,j,izptch,rahp
       tnpav=tnpav+tn(i,j,izptch)
10     continue 
       tnpav=tnpav/float(numpp)

c cg 11/1       vsij(23)=abs(vsij(23))
       if(vsij(23).lt.0.)vsij(23)=numpp
c
c     write output to tape36
c
      call ttoft
c
c output time series info and then go to prtcl to track pp's

      if(mod(icycle,8).eq.0) then
       write(44,11) time,cma,tstar,cma,ft(ipinit,jpinit,2)/rat,cma,tnpav
      endif
11    format(f7.4,a1,f6.2,a1,f6.2,a1,f6.2)


       return
       end

