c $Log:   /pvcs.config/mc3dvv/src/prtcl.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:04 1997   pvcs
c 
c *************************************************************
c *   PRTCL
c *************************************************************
      subroutine prtcl
      use module_precision
crk logic added 1/5/93 by kincaid
crk extract logic for partical tracking from art codes
crk  replace 3d logic and adapt to track and trigger output
crk  for plumes thermal fields in x and y as prtcl passes
crk  certain z levels.  also make so output of full 3d thermal
crk  field is triggered from this routine also.
c
c cwg 3/15/93 Impliment dynamic memory management.
c cwg 3/16/93 Add error check so one does not create too many particles.
c

      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_a2
      use module_gia3
      use module_a3
      use module_prtcl
      use module_ftcoef
      common /ppjunkr/ tstar
      common /ppjunki/ np1,np2,np3,np4
       
      real*8 plev(6), tlev(6) 
      integer klev(10)

      real*8 xlm, ylm, xrm, yrm, tmax, tmax0, zbtm, ztopm

c plev=z values for output; tlev=time to start new pps
      data plev/0.01,0.25,0.5,0.75,0.9,2.0/
      data tlev/0.10,0.20,0.3,0.4,0.5,1.6/
c
      if(icycle.eq.1) then
       itt1=1
       do 30 k=1,10
        klev(k)=1
  30  continue
      endif

      nxny2=(nx-1)*(ny-1)
      nx2=nx-1
      ny2=ny-1
      nz2=nz-1
      dzp=1.0/nz2
c     atime=0.
c     jcycle=0
      itcyc=2
      dtp=dt/float(itcyc)
c ikstep&itstep handle initialization during 1st pass ONLY
c      if(itstep.eq.0) itt1=1
c
c logic to calc first and subsequent pp positions
c calc center of patch
      if(tstar.ge.tlev(itt1)) then
      if(nps + 1 .le. nparticle)then
      nps=nps+1
      itstep=1
      itt1=itt1+1
      ipp=(np2+np1)/2+1
      jpp=(np4+np3)/2
      kpp=2
c     xpi(nps)=ipp*dx+0.1*dx
c     ypi(nps)=jpp*dy+0.1*dy
      xpi(nps)=ipp*dx-0.1*dx
      ypi(nps)=jpp*dy-0.1*dy
      zpi(nps)=dzp+0.1*dzp
      ijkc=(kpp-1)*nxny2+(jpp-1)*nx2+ipp
      locp(nps)=ijkc
      write(6,*) 'time for new pp;cycle,nps',icycle,nps 
      else 
      write(6,*)'WARNING ********* Subroutine PRTCL *******' 
      write(6,*)'Particle addition failed; icycle=',icycle,' time= ',time 
      write(6,*)'Max number of particles set in namelist =',nparticle 
      write(6,*)'Number of particles presently released  =',nps 
      write(6,*)'Calculation will continue without adding particle' 
      write(6,*)'Increase iptrac on input to increase max # particles' 
      write(6,*)' ********* Subroutine PRTCL ***************' 
      endif
      endif

      if (nps.eq.0) return
c
      dxi=1.0/dx
      dyi=1./dy
      dzi=1.0/dzp
      ztopm=1.0-1.e-3*dzp
      zbtm=1.e-3*dzp
      xlm=1.e-3*dx
      ylm=1.e-3*dy
      xrm=xl-1.e-3*dx
      yrm=yl-1.e-3*dy
c
      do 100 iic=1,itcyc
c
      do 70 ii=1,nps

c      if(ikstep.eq.0) klev(ii)=1
c
      ijkc=locp(ii)
      kp=(ijkc-1)/nxny2+1
      jp=(ijkc-(kp-1)*nxny2-1)/nx2+1
      ip=ijkc-(kp-1)*nxny2-(jp-1)*nx2
      ipedg=nx-1
      jpedg=ny-1
      kpedg=nz-1
      if(ip.gt.ipedg) ip=ipedg
      if(jp.gt.jpedg) jp=jpedg
      if(kp.gt.kpedg) kp=kpedg
      if(xpi(ii).lt.zero) xpi(ii)=xlm
      if(ypi(ii).lt.zero) ypi(ii)=ylm
      if(zpi(ii).lt.zero) zpi(ii)=zbtm
      if(xpi(ii).gt.xl) xpi(ii)=xrm
      if(ypi(ii).gt.yl) ypi(ii)=yrm
      if(zpi(ii).gt.1.0) zpi(ii)=ztopm
      xp=xpi(ii)*dxi-float(ip-1)
      yp=ypi(ii)*dyi-float(jp-1)
      zp=zpi(ii)*dzi-float(kp-1)
      xli=float(ip-1)*dx
      xri=xli+dx
      yli=float(jp-1)*dy
      yri=yli+dy
      zli=float(kp-1)*dzp
      zri=zli+dzp
crk 
crk  calc vel's at given xp,yp,zp within 3d element
crk    1st calc shape functions for 8 corner nodes
crk 1-4 define bottom, 5-8 define top. #'ing is count clockwise
       chi1=(1.-xp)*(1.-yp)*(1.-zp)
       chi2=xp*(1.-yp)*(1.-zp)
       chi3=xp*yp*(1.-zp)
       chi4=(1.-xp)*yp*(1.-zp)
       chi5=(1.-xp)*(1.-yp)*zp
       chi6=xp*(1.-yp)*zp
       chi7=xp*yp*zp
       chi8=(1.-xp)*yp*zp
        uquad=u(ip,jp,kp)*chi1+u(ip+1,jp,kp)*chi2
     1 +u(ip+1,jp+1,kp)*chi3+u(ip,jp+1,kp)*chi4
     2 +u(ip,jp,kp+1)*chi5+u(ip+1,jp,kp+1)*chi6 
     3 +u(ip+1,jp+1,kp+1)*chi7+u(ip,jp+1,kp+1)*chi8
        vquad=v(ip,jp,kp)*chi1+v(ip+1,jp,kp)*chi2
     1 +v(ip+1,jp+1,kp)*chi3+v(ip,jp+1,kp)*chi4
     2 +v(ip,jp,kp+1)*chi5+v(ip+1,jp,kp+1)*chi6 
     3 +v(ip+1,jp+1,kp+1)*chi7+v(ip,jp+1,kp+1)*chi8
        wquad=w(ip,jp,kp)*chi1+w(ip+1,jp,kp)*chi2
     1 +w(ip+1,jp+1,kp)*chi3+w(ip,jp+1,kp)*chi4
     2 +w(ip,jp,kp+1)*chi5+w(ip+1,jp,kp+1)*chi6 
     3 +w(ip+1,jp+1,kp+1)*chi7+w(ip,jp+1,kp+1)*chi8
         
c
c     move particles to new position
c
       xpi(ii)=xpi(ii)+dtp*uquad
       ypi(ii)=ypi(ii)+dtp*vquad
       zpi(ii)=zpi(ii)+dtp*wquad

c      xpi(ii)=xpi(ii)+dtp*(xp*(u(ip,jp-1,kp-1)+yp*(u(ip,jp,kp-1)-
c    . u(ip,jp-1,kp-1))+zp*(u(ip,jp-1,kp)-u(ip,jp-1,kp-1))+yp*zp*(
c    . u(ip,jp,kp)+u(ip,jp-1,kp-1)-u(ip,jp,kp-1)-u(ip,jp-1,kp)))+
c    . (1.-xp)*(u(ip-1,jp-1,kp-1)+yp*(u(ip-1,jp,kp-1)-
c    . u(ip-1,jp-1,kp-1))+zp*(u(ip-1,jp-1,kp)-u(ip-1,jp-1,kp-1))+
c    . yp*zp*(u(ip-1,jp,kp)+u(ip-1,jp-1,kp-1)-
c    . u(ip-1,jp,kp-1)-u(ip,jp-1,kp))))
c
c      ypi(ii)=ypi(ii)+dtp*(yp*(v(ip-1,jp,kp-1)+xp*(v(ip,jp,kp-1)-
c    . v(ip-1,jp,kp-1))+zp*(v(ip-1,jp,kp)-v(ip-1,jp,kp-1))+
c    . xp*zp*(v(ip,jp,kp)+v(ip-1,jp,kp-1)-v(ip,jp,kp-1)-
c    . v(ip-1,jp,kp)))+(1.-yp)*(v(ip-1,jp-1,kp-1)+xp*(v(ip,jp-1,kp-1)
c    . -v(ip-1,jp-1,kp-1))+zp*(v(ip-1,jp-1,kp)-v(ip-1,jp-1,kp-1))+
c    . xp*zp*(v(ip,jp-1,kp)+v(ip-1,jp-1,kp-1)-v(ip,jp-1,kp-1)-
c    .  v(ip-1,jp-1,kp))))
c
c      zpi(ii)=zpi(ii)+dtp*(zp*(w(ip-1,jp-1,kp)+xp*(w(ip,jp-1,kp)
c    . -w(ip-1,jp-1,kp))+yp*(w(ip-1,jp,kp)-w(ip-1,jp-1,kp))+
c    . xp*yp*(w(ip,jp,kp)+w(ip-1,jp-1,kp)-w(ip,jp-1,kp)-
c    . w(ip-1,jp,kp)))+(1.-zp)*(w(ip-1,jp-1,kp-1)+xp*(w(ip,jp-1,kp-1)
c    . -w(ip-1,jp-1,kp-1))+yp*(w(ip-1,jp,kp-1)-w(ip-1,jp-1,kp-1))+
c    . xp*yp*(w(ip,jp,kp-1)+w(ip-1,jp-1,kp-1)-w(ip,jp-1,kp-1)-
c    . w(ip-1,jp,kp-1))))
c
c     check if particle has gone through mesh boundaries
c
      zpi(ii)=dmin1(ztopm,dmax1(zbtm,zpi(ii)))
crk   if(ip.eq.2.or.ip.eq.nx2-1) then
        if(lbd.eq.1) then
          xpi(ii)=dmin1(xrm,dmax1(xlm,xpi(ii)))
        else
          if(lbd.eq.0) then
            if(xpi(ii).gt.xl.or.xpi(ii).lt.zero) then
              xpi(ii)=xpi(ii)-xl*sign(one,xpi(ii))
              xli=float(int(xpi(ii)*dxi))*dx
              xri=xli+dx
            endif
          endif
        endif
crk   endif
c      if(jp.eq.2.or.jp.eq.ny2-1) then
        if(mbd.eq.1) then
          ypi(ii)=dmin1(yrm,dmax1(ylm,ypi(ii)))
        else
          if(mbd.eq.0) then
            if(ypi(ii).gt.yl.or.ypi(ii).lt.zero) then
              ypi(ii)=ypi(ii)-yl*sign(one,ypi(ii))
              yli=float(int(ypi(ii)*dyi))*dy
              yri=yli+dy
            endif
          endif
        endif
c      endif
c
c
c      determine what cell particle is now in. assuming here
c     that particle will not move more than (dx,dy,dz) in one timestep.
c
      ip=ip+int((xpi(ii)-xli)*dxi)+int((xpi(ii)-xri)*dxi)
      jp=jp+int((ypi(ii)-yli)*dyi)+int((ypi(ii)-yri)*dyi)
      kp=kp+int((zpi(ii)-zli)*dzi)+int((zpi(ii)-zri)*dzi)
      ijkc=(kp-1)*nxny2+(jp-1)*nx2+ip
      locp(ii)=ijkc
c store positions for output to rastemp.f
            ipf(ii)=-ip
            jpf(ii)=-jp
            kpf(ii)=-kp
c
c add logic to check height of particle and output t,w profiles
c******************
c  if split time step into many cycles output on last only
       if(mod(iic,itcyc).eq.0) then
c 1st locate max temp of 8 surrounding nodes
       ipk1=klev(ii)
       if (zpi(ii).ge.plev(ipk1)) then
        ikstep=1
        klev(ii)=klev(ii)+1
        tmax0=0.
        tmax=0.
        do 50 k=kp,kp+1
         do 45 j=jp,jp+1
          do 40 i=ip,ip+1
           tmax=dmax1(tmax0,ft(i,j,k)/rat)
           if(tmax.ne.tmax0) then
            ipf(ii)=i
            jpf(ii)=j
            kpf(ii)=k
            tmax0=tmax
           endif
   40     continue
   45    continue
   50   continue
 
       write(36,71) ii,klev(ii)-1,plev(klev(ii)-1),ipf(ii)
     1  ,jpf(ii),kpf(ii),icycle,time
       write(36,73) xpi(ii),ypi(ii),zpi(ii)
       jk=0
       do 55 i=1,nx
        jk=jk+1
c       if(i.gt.j3) jk=j3
        if(i.gt.j3) then
         tyout=0.0
         wyout=0.0
        else
         tyout=ft(ipf(ii),jk,kpf(ii))/rat 
         wyout=w(ipf(ii),jk,kpf(ii))
        endif
        write(36,72) ft(i,jpf(ii),kpf(ii))/rat,
     1  w(i,jpf(ii),kpf(ii)),tyout,wyout
   55  continue

       endif
       endif
c******************

   70 continue
  100 continue

   71  format(2i5,2x,f4.2,4i5,f7.4)
   72  format(f5.2,f8.1,5x,f5.2,f8.1)
   73  format(3f5.2)
c

       return
       end

