c $Log:   /pvcs.config/mc3dvv/src/pttotau.F_a  $
c
c   Rev 1.2   Tue Feb 09 15:00:02 1999   lowman
cremoved hardwired value for lith
c
c   Rev 1.1   Tue Oct 06 16:53:44 1998   lowman
cAdded calls to chvarx and chvary to obtain correct tau13 and tau23 fields.
c
c   Rev 1.0   Mon Jul 14 14:22:04 1997   pvcs
c 
c *************************************************************
c *   PTTOTAU
c *************************************************************
      subroutine pttotau(ipttype,iijob)
      use module_precision
c
c      transform from poloidal/toroidal field
c      to stress in x and y.  Superimpose
c      plate stress
c
c     iptype = 0 transform toroidal and poloidal fields
c
c     iptype = 1 set toroidal part of solution to zero
c      
c     iptype = 2 set poloidal part of solution to zero
c
c     ijob = 0 superimpose plate & body force stress fields (when present)
c
c     ijob = 1 set plate field to 0, only transform density driven field
c
c     ijob = 2 set density driven field to 0, only transform plate field
c
c     ijob = 3 calculate integrated stress on base of plate
c
c     ijob = 4 set plate field to zero, 
c                  calculate ratio (int(tau))/int(abs(tau)
c
c     ijob = 6 superimpose solutions from flow and plate 
c                  but do not transform back to space domaine
c
c     Now filters tau13, tau23 in spectral space for output
c      to Xlambda for VV case
c     G. Ito 2/11/95
c=========================================================
      use module_param
      use module_giparam
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_a6
      use module_a11
      use module_a12
      use module_a13
      use module_a20
      use module_a24
      use module_a25
      use module_a26
      use module_a30
      use module_viscom
      dimension ti(20), ati(20)
      real l, l2
      common /start1/ restrt, initlt, istart
      common /a8/ l2, l, vps, vts

c      dimension kp(10)
c
#ifdef MPI
      include 'mpif.h'
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif

      ijob = iijob
      if(ipttype .eq. 0)then
        pfac = one
        tfac = one
      elseif(ipttype .eq. 1)then
        pfac = one
        tfac = zero
      elseif(ipttype .eq. 2)then
        pfac = zero
        tfac = one
       endif
c
      inttau=0
      if(ijob .eq. 3)then
         ijob = 0
         inttau = 1
      endif
      if ((ibct.eq.2).and.(isurfv.lt.0)) then
c
        if(ijob .eq. 2)then
          ppfac = zero
          ttfac = zero
        else
          ppfac = pfac
          ttfac = tfac
        endif
c
        do 30 k = 1,nz
        do 30 j = iystar,iystop 
        do 30 i = ixstar,ixstop
   30   tau13(i,j,k) = taup(i-ixstar+1,j-iystar+1,k)*ppfac
        do 32 k = 1,nz
        do 32 j = iystar,iystop
        do 32 i = ixstar,ixstop
   32   tau23(i,j,k) = taut(i-ixstar+1,j-iystar+1,k)*ttfac
        do 280 k = 1,nz
        do 280 j = iystar,iystop
        do 280 i = ixstar,ixstop
  280   tauz(i,j,k) = tau3(i-ixstar+1,j-iystar+1,k)*ppfac
 
        if(ifssd .eq. 1)then
           rewind(50)
        endif

        if((ijob .ne. 1) .and. (ijob .ne. 4))then 
c
c     include stress due to plate driven flow
c
        do 45 np = 1,nplate
        do 45 ixy = 1,2
        if(ixy .eq. 1)then
           im1 = 1
        else
           im1 = 0
        endif
        ifield = 2*np-im1
c
c       read from ssd here
c       with ssd irec is the record to read
c       without ssd it is the index of the superposition array
      if(ifssd .eq. 1)then
        irec = 1
        call rwssd(-3,ifield,iqx,jqx,kqx,npssd,
     1                 vppl,v3pl,vtfpl,tautpl,tauppl,tau3pl)
      elseif(ifssd .eq. 0)then
        irec=ifield
      endif
c
        do 40 k = 1,nz
        do 40 j = iystar,iystop
        do 40 i = ixstar,ixstop
c       do 40 j = 1,nyr
c       do 40 i = 1,nxr
  40    tau13(i,j,k)=tau13(i,j,k)+vpl(ixy,np)*tauppl(i,j,k,irec)*pfac
        do 42 k = 1,nz
        do 42 j = iystar,iystop
        do 42 i = ixstar,ixstop
c       do 42 j = 1,nyr
c       do 42 i = 1,nxr
  42    tau23(i,j,k)=tau23(i,j,k)+vpl(ixy,np)*tautpl(i,j,k,irec)*tfac
        do 290 k = 1,nz
c       do 290 j = 1,nyr
c       do 290 i = 1,nxr
        do 290 j = iystar,iystop
        do 290 i = ixstar,ixstop
  290   tauz(i,j,k) = tauz(i,j,k)+vpl(ixy,np)*tau3pl(i,j,k,irec)*pfac

  45    continue
        endif
  
        ichvar = 1  
        call chvar (tauz,isx,nxr,lbd,jsx,nyr,mbd,nz,ichvar)
  
        do 50 k = 1,nz
c       do 50 j = 1,nyr
c       do 50 i = 1,nxr
        do 50 j = iystar,iystop
        do 50 i = ixstar,ixstop
        t1 = tau13(i,j,k)
        t2 = tau23(i,j,k)
        tau13(i,j,k) = fli(i,j)*t1+flj(i,j)*t2
  50    tau23(i,j,k) = flj(i,j)*t1-fli(i,j)*t2
      else
c
c     not dynamic plate motion
c
        do 58 k = 1,nz
        do 58 j = iystar,iystop
        do 58 i = ixstar,ixstop
   58   tauz(i,j,k)=tau3(i-ixstar+1,j-iystar+1,k)
        call chvar (tauz,isx,nxr,lbd,jsx,nyr,mbd,nz,1)
        do 60 k = 1,nz
        do 55 j = iystar,iystop
        do 55 i = ixstar,ixstop
        tau13(i,j,k) = fli(i,j)*taup(i-ixstar+1,j-iystar+1,k)
     &                +flj(i,j)*taut(i-ixstar+1,j-iystar+1,k)
        tau23(i,j,k) = flj(i,j)*taup(i-ixstar+1,j-iystar+1,k)
     &                -fli(i,j)*taut(i-ixstar+1,j-iystar+1,k)
   55   continue
   60   continue
      endif
c JPL add
      if(j3.gt.1)then
      ichvar=-1
      call chvary(tau13,iqx,nxr,lbd,jqx,nyr,mbd,nz,ichvar)
      call chvarx(tau23,iqx,nxr,lbd,jqx,nyr,mbd,nz,ichvar)
      endif
c JPL end

c
c     stop here when ijob = 6
      if (ijob .eq. 6) return

c     >>>>>>>>>> FILTER    G.Ito /2/11/95
      if (ivistype.lt.0.and.xf1.ne.xf2) then
        call filt(tau13,isx,jsx,nz,nxt13,nyt13,nz,xf1,xf2)      !FILTER
        call filt(tau23,isx,jsx,nz,nxt23,nyt23,nz,xf1,xf2)      !G.Ito 2/11/95
      endif

      call ft2nrm (-1,lpt13,nxt13,mpt13,nyt13,nz,isx,jsx,tau13)
      call ft2nrm (-1,lpt23,nxt23,mpt23,nyt23,nz,isx,jsx,tau23)
      call ft2nrm (-1,lpt33,nxt33,mpt33,nyt33,nz,isx,jsx,tauz)
c
      call bc_tau   
     1   (tau13,tau23,tauz,isx,nxr,nx,lbd,jsx,nyr,j3,mbd,nz,1)  !DaN
c
      dxdy=dx*dy
c      lith = 1
      lithd=nz-lith

 
      if((inttau .eq. 1) .or. (ijob .eq. 4))then
c        *** calculate integrated stress on plate due to convection

         do ipt = 1,2*nplate
            ti(ipt)= zero
         enddo
 
         write(6,222)ijob
         do ipla=1,nplate
            i2=2*ipla
            i2m1=i2-1
            do j=1,ny-1
               do i=1,nx-1
                  ti(i2m1) = dxdy*template(i,j,ipla)*
     v                  tau13(i,j,lithd)+ti(i2m1)
                  ti(i2)   = dxdy*template(i,j,ipla)*
     v                  tau23(i,j,lithd)+ti(i2)
               enddo
            enddo
            write(6,*)ipla,ti(i2m1),ti(i2)
         enddo
      
      endif

      if (ijob .eq. 4) then
c       *** calculate integrated absolute value of stress
c
         do ipt = 1,2*nplate
            ati(ipt) = zero
         enddo
c
         write(6,322)ijob
         do ipla=1,nplate
            i2=2*ipla
            i2m1=i2-1
            do j=1,ny-1
              do i=1,nx-1
                 ati(i2m1) = 
     1  dxdy*template(i,j,ipla)*abs(tau13(i,j,lithd))+ati(i2m1)
                 ati(i2)   = 
     1  dxdy*template(i,j,ipla)*abs(tau23(i,j,lithd))+ati(i2)
              enddo
            enddo
            write(6,*)ipla,ati(i2m1),ati(i2)
         enddo
         write(6,382)ijob
         sumx = zero
         sumy = zero
         do ipla = 1,nplate
            i2 = 2*ipla
            i2m1 = i2-1
            ati(i2m1) = abs(ti(i2m1)/ati(i2m1))
            ati(i2)   = abs(ti(i2)  /ati(i2))
            sumx = ati(i2m1)+sumx
            sumy = ati(i2)+sumy
         enddo
         sumx = sumx/float(nplate)
         sumy = sumy/float(nplate)
         write(6,400)nplate,sumx
         write(6,410)(ati(ii),ii = 1,2*nplate,2)
      endif

 222  format('in PTTOTAU integrated stress ijob=',i3)
 322  format('in PTTOTAU integrated abs(stress) ijob=',i3)
 382  format('in PTTOTAU integrated stress ratio ijob=',i3)
 400  format(i5,e14.7)
 410  format(30e14.7)

      return
      end
