c $Log:   /pvcs.config/mc3dvv/src/pttouv.F_a  $
c
c   Rev 1.3   Fri Jul 30 11:49:54 1999   lowman
c  Added prnt_last to common to correct printing bug detected
c  by intel compiler
c
c   Rev 1.2   Tue Oct 06 16:55:00 1998   lowman
cAdded calls to chvarx and chvary to correctly order Cartesian velocities
cAdded calls to userout for poloidal and toroidal energies using
croutines modified by PvK.
c
c   Rev 1.0   Mon Jul 14 14:22:06 1997   pvcs
c 
c *************************************************************
c *   PTTOUV
c *************************************************************
      subroutine pttouv(ipttype,ijob)
      use module_precision
c
c      transform from poloidal/toroidal field
c      to velocity in u and v.  Superimpose
c      plate velocity. Final output is still in spectral
c      space. Must still transform with ft2nrm.f
c
c
c  ipttype  =  0   combine toroidal and poloidal fields
c
c  ipttype  =  1   set toroidal part of solution to zero
c      
c  ipttype  =  2   set poloidal part of solution to zero
c
c  ijob = 0 superimpose plate and body force stress fields (when present)
c
c  ijob = 1 set plate field to 0, only transform density driven field
c
c  ijob = 2 set density driven field to 0, only transform plate field
c
      use module_param
      use module_giparam
      use module_a2
      use module_gia3
      use module_a3
      use module_a22
      use module_a11
      use module_a12
      use module_a13
      use module_a20
      use module_a24
      use module_a25
      use module_a26
      use module_a30
      use module_viscom
      use module_spwork
      use module_pttouv
      real l, l2
      common /start1/ restrt, initlt, istart
      common /a8/ l2, l, vps, vts
      common /ptouserout/ pfac,tfac
c       real tempV(ixxmpi,iyympi,nz)        !+DaN - added to pttouv.h

#ifdef MPI
      include 'mpif.h'
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif
c MPI ALERT: changed loop indices
#ifdef MPI
      call mpiblock(nx,j3,numprocs,myid,
     &             ixstar,ixstop,iystar,iystop)
      if (ixstop .gt. nxr) ixstop =  nxr
      if (iystop .gt. nyr) iystop =  nyr
#else
      iystar=1
      iystop=nyr
      ixstar=1
      ixstop=nxr
#endif
c      sfact scales the kinetic energy to eliminate
c      dependence on box dimension or number of terms
c      in the Fourier expansion.
      sfact = (xl*yl)/float(nxr*nyr)
      if(ipttype .eq. 0)then
        pfac = one
        tfac = one
      elseif(ipttype .eq. 1)then
        pfac = one
        tfac = zero
      elseif(ipttype .eq. 2)then
        pfac = zero
        tfac = one
       endif

***********************************************************************
      if ((ibct.eq.2).and.(isurfv.lt.0).and.(ifsavepl.eq.1)) then
c  Solve using superposition
***********************************************************************  
        if(ijob .eq. 2)then
          ppfac = zero
          ttfac = zero
        else
          ppfac = pfac
          ttfac = tfac
        endif
c
cwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
c
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              spwk(i,j,ll) = v3(i-ixstar+1,j-iystar+1,ll)*ppfac
            enddo
          enddo
        enddo

        if(ijob .ne. 1)then 

          do 45 np = 1,nplate
            do 45 ixy = 1,2
              if(ixy .eq. 1)then
                im1 = 1
              else
                im1 = 0
              endif
              ifield = 2*np-im1
c
c       *****Superimpose fields for dynamic plate calculation*****
c
              do 290 ll = 1,nz
              do 290 j = iystar,iystop
              do 290 i = ixstar,ixstop
  290   spwk(i,j,ll) = spwk(i,j,ll)+vpl(ixy,np)*v3pl(i,j,ll,ifield)*pfac
c
c       **********************************************************
c
  45      continue

        endif

#ifdef MPI
        impi = 1
        call mpicomm(impi,nx,j3,nz,spwk,inx,jnx,knx)
#endif
        ichvar = 1
        call chvar (spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)

        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          do ll = 1,nz
            do  j = 2,nyr
              do  i = 2,nxr
                spwk(i,j,ll)     = -spwk(i,j,ll)
              enddo
            enddo
          enddo
        endif

#ifdef MPI
        call mpilayer(nz,numprocs,myid,izstart,izstop)
        izstart=max(izstart - 2, 1)
        izstop =min(izstop + 2, nz)
#else
        izstart=1
        izstop =nz
#endif

        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
              w(i,j,ll-izstart+1) = spwk(i,j,ll)       
            enddo
          enddo
        enddo

cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              tempv(i-ixstar+1,j-iystar+1,ll) 
     &                             = vtf(i-ixstar+1,j-iystar+1,ll)*ttfac
            enddo
          enddo
        enddo

        if(ijob .ne. 1)then

          do 46 np = 1,nplate
            do 46 ixy = 1,2
              if(ixy .eq. 1)then
                im1 = 1
              else
                im1 = 0
              endif
              ifield = 2*np-im1
c
c       *****Superimpose fields for dynamic plate calculation*****
              do 42 ll = 1,nz
              do 42 j = iystar,iystop
              do 42 i = ixstar,ixstop
  42    tempv(i-ixstar+1,j-iystar+1,ll)= tempv(i-ixstar+1,j-iystar+1,ll)
     &                           + vpl(ixy,np)*vtfpl(i,j,ll,ifield)*tfac
c       **********************************************************
c
  46      continue

        endif
c
c      convert pol-tor to Cartesian spectral
c
c        do ll = 1,nz
c          do j = iystar,iystop
c            do i = ixstar,ixstop
c              tempv(i-ixstar+1,j-iystar+1,ll) = spwk(i,j,ll)
c            enddo
c          enddo
c        enddo

cuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              spwk(i,j,ll) = vp(i-ixstar+1,j-iystar+1,ll)*ppfac
            enddo
          enddo
        enddo

        if(ijob .ne. 1)then

          do 47 np = 1,nplate
            do 47 ixy = 1,2
              if(ixy .eq. 1)then
                im1 = 1
              else
                im1 = 0
              endif
              ifield = 2*np-im1
c
c       *****Superimpose fields for dynamic plate calculation*****
              do 41 ll = 1,nz
              do 41 j = iystar,iystop
              do 41 i = ixstar,ixstop
  41    spwk(i,j,ll) = spwk(i,j,ll)+vpl(ixy,np)*vppl(i,j,ll,ifield)*pfac
c       **********************************************************
c
  47      continue

        endif

c      calculate power spectrum for output
c        call userout('pttouv-1')    !DaN - won't work with reduced u&v 

c      convert pol-tor to Cartesian spectral
c
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              t1 =  spwk(i,j,ll)
              t2 = tempv(i-ixstar+1,j-iystar+1,ll)
              spwk (i,j,ll) = fli(i,j)*t1+flj(i,j)*t2
              tempv(i-ixstar+1,j-iystar+1,ll) 
     &                      = flj(i,j)*t1-fli(i,j)*t2
            enddo
          enddo
        enddo

#ifdef MPI
        call mpicomm(1,nx,j3,nz,spwk,inx,jnx,knx)
#endif    
    
        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          ichvar=-1
          call chvary(spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        endif

        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
              u(i,j,ll-izstart+1) = spwk(i,j,ll)
            enddo
          enddo
        enddo

c finish off vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

        do ll = 1,nz
          do j = iystar,iystop
           do i = ixstar,ixstop
              spwk(i,j,ll)=tempv(i-ixstar+1,j-iystar+1,ll)
           enddo
         enddo
       enddo

#ifdef MPI
        if (j3.gt.1) call mpicomm(1,nx,j3,nz,spwk,inx,jnx,knx)
#endif

        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          ichvar=-1
          call chvarx(spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        endif

        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
              v(i,j,ll-izstart+1) = spwk(i,j,ll)
            enddo
          enddo
        enddo

***********************************************************************
      else
c    not a solution involving superposition
***********************************************************************
c
cwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww

        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              spwk(i,j,ll) = v3(i-ixstar+1,j-iystar+1,ll)
            enddo
          enddo
        enddo

#ifdef MPI
        impi = 1
        call mpicomm(impi,nx,j3,nz,spwk,inx,jnx,knx)
#endif
        ichvar = 1
        call chvar(spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)

        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          do ll = 1,nz
            do  j = 2,nyr
              do  i = 2,nxr
                spwk(i,j,ll) = -spwk(i,j,ll)
              enddo
            enddo
          enddo
        endif

#ifdef MPI
        call mpilayer(nz,numprocs,myid,izstart,izstop)
        izstart=max(izstart - 2,1)
        izstop =min(izstop + 2, nz)
#else
        izstart=1
        izstop =nz
#endif

        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
                w(i,j,ll-izstart+1) = spwk(i,j,ll)
            enddo
          enddo
        enddo

c        call userout('pttouv-2')    !DaN - won't work with reduced w 
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
          
        do ll = 1,nz
          do  j = iystar,iystop
            do  i = ixstar,ixstop
              spwk(i,j,ll) = pfac*flj(i,j)* vp(i-ixstar+1,j-iystar+1,ll)
     1                     - tfac*fli(i,j)*vtf(i-ixstar+1,j-iystar+1,ll)
            enddo
          enddo
        enddo  

c      With periodic b.c. one must account for the
c      l = 0 term in the fourier expansion. This
c      term is the average value of the velocity
c      and only occurs when the imposed
c      surface velocity has a non-zero
c      average.
c
c   this is not right for layered viscosity
c
        if (ibct.eq.3) then
          if (((lbd.eq.0).and.(mbd.eq.0)).and.
     1        ((fftvx(1,1).ne.0).or.(fftvy(1,1).ne.0))) then
            if (ivistype.ne.0) then
              write (6,100)
              stop
            endif
            if (ibcb.eq.1) then
              do ll = 1,nz
                spwk(1,1,ll) = fftvy(1,1)
              enddo
            elseif (ibcb.eq.2) then
              gradv = fftvy(1,1)/float(nz-1)
              do ll = 1,nz
                fll = float(ll-1)
                spwk(1,1,ll) = fll*gradv
              enddo
            endif
          endif
        endif

#ifdef MPI
        impi = 1
        if (j3.gt.1) call mpicomm(impi,nx,j3,nz,spwk,inx,jnx,knx)
#endif
      
        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          ichvar=-1 
          call chvarx(spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        endif

        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
              v(i,j,ll-izstart+1) = spwk(i,j,ll)
            enddo
          enddo
        enddo

cuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu
        do ll = 1,nz
          do j = iystar,iystop
            do i = ixstar,ixstop
              spwk(i,j,ll) = pfac*fli(i,j)*vp(i-ixstar+1,j-iystar+1,ll)+
     1                       tfac*flj(i,j)*vtf(i-ixstar+1,j-iystar+1,ll)
             enddo
          enddo
        enddo

c      With periodic b.c. one must account for the
c      l = 0 term in the fourier expansion. This
c      term is the average value of the velocity
c      and only occurs when the imposed
c      surface velocity has a non-zero
c      average.
c
c   this is not right for layered viscosity
c
        if (ibct.eq.3) then
          if (((lbd.eq.0).and.(mbd.eq.0)).and.
     1        ((fftvx(1,1).ne.0).or.(fftvy(1,1).ne.0))) then
            if (ivistype.ne.0) then
              write (6,100)
              stop
            endif
            if (ibcb.eq.1) then
              do ll = 1,nz
                spwk(1,1,ll) = fftvx(1,1)
              enddo
            elseif (ibcb.eq.2) then
              gradu = fftvx(1,1)/float(nz-1)
              do ll = 1,nz
                fll = float(ll-1)
                spwk(1,1,ll) = fll*gradu
              enddo
            endif
          endif
        endif

#ifdef MPI
        impi = 1
        call mpicomm(impi,nx,j3,nz,spwk,inx,jnx,knx)
#endif
      
        if ((j3.gt.1).and.((lbd.eq.0).and.(mbd.eq.0)))then
          ichvar=-1 
          call chvary(spwk,inx,nxr,lbd,jnx,nyr,mbd,nz,ichvar)
        endif
      
        do ll = izstart,izstop
          do j = 1,nyr
            do i = 1,nxr
              u(i,j,ll-izstart+1) = spwk(i,j,ll)
            enddo
          enddo
        enddo

      endif
***********************************************************************
c
c JPL 6/98
c
c  At this point all four matrices are
c  holding coefficients in an order analagous to temperature. For example, a CxCy 
c  temperature mode (at this point) appears to be
c  driving a CxCy u and v mode. However, the modes
c  should, in fact, correspond as follows. 
c
c
c  Temp    U      V      W
c
c  CxCy   SxCy   CxSy   CxCy
c
c  SxCy  -CxCy   SxSy   SxCy 
c
c  CxSy   SxSy  -CxCy   CxSy
c
c  SxSy  -CxSy  -SxCy   SxSy
c
c

      return
c
   80 format (i8,e14.7,/,
     1"PT coupling fac.
     2   z        aket        akep       akephv    ake")
   90 format (11x,5(e10.3,2x))
  100 format 
     1 ("input error in pttouv: variable viscosity not set for plates")
299     format(i3,12e10.3)
      end
