c $Log:   /pvcs.config/mc3dvv/src/surfgeo.F_a  $
c
c   Rev 1.4   Fri Jul 30 15:30:56 1999   lowman
c  Added template2 argument to surfgeo call
c
c   Rev 1.2   Tue Mar 23 14:21:08 1999   lowman
c
c   Rev 1.1   Tue Feb 09 14:48:34 1999   lowman
cIntroduced and genearlized options -320,-325 and -330.
c
c   Rev 1.0   Mon Jul 14 14:22:22 1997   pvcs
c 
c *************************************************************
c *   SURFGEO
c *************************************************************
      subroutine surfgeo (template,iplgeo,template2)
      use module_precision
      use module_param
      use module_gia3
      use module_a3
      use module_a7
      use module_a12
      use module_a13
      use module_nu
#ifdef MPI
      include 'mpif.h'
#endif 
      dimension template(iqx,jqx,npla)
      dimension template2(iqx,jqx,npla)
      dimension   iplgeo(iqx,jqx)
      dimension ib(10),jb(10)
c      common /xxx/ tavrg(514), znu(514), tbar
      dimension xpos(5000), ypos(5000)
c      equivalence (tavrg,xpos), (znu,ypos)
      namelist /setup3/ nib, ib
      namelist /geometry/ npoly, ib, xpos, ypos
#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
#else
      myid = 0
#endif 
c
c     if ISURFV  .LE.-2, user supplies plate geometry here
c       value of isurfv .le. -2 determines which b.c. option to choose
c
c      isurfv=-2   split down the center
c            =-3   transform (left side is smaller)
c            =-4   oblique boundary
c            =-5   strike slip boundary
c            =-6   one plate
c            =-7   off center break
c            < 300 indicates there are 3 plates
c

      nplate=0
      twopi=2.*pimach(dumm)
      if(isurfv .ge. 0)then
         nplate=0
         return
      endif

      if((inx.gt.5000).or.(jnx.gt.5000))then
        if (myid .eq. 0) then
          write(*,*) '************************'
          write(*,*) '     STOPING BECAUSE    '
          write(*,*) ' The size of xpos(nx+2) '
          write(*,*) 'and ypos(ny+2) must be  '
          write(*,*) 'increased in surfgeo.F  '
          write(*,*) ' Present limit for the  '
          write(*,*) 'size of these arrays is ' 
          write(*,*) 'nx=5000 and ny=5000.    '
          write(*,*) '************************'    
        endif
      endif

c   divergent top boundary (i.e. ridge)
c
      if (isurfv.eq.-2) then
        ishift=0
        nplate=2
        do 10 j=1,j3
        do 10 i=1,nx
        if (i.le.(nx/2+ishift)) then
          iplgeo(i,j)=1
        elseif (i.eq.((nx/2)+1+ishift)) then
          iplgeo(i,j)=0
        else
          iplgeo(i,j)=2
        endif
   10   continue
        do 20 j=1,j3
        do 20 i=1,nx
        if ((i.eq.1).or.(i.eq.nx)) iplgeo(i,j)=0
   20   continue
c
c      divergent top with transform
c
      elseif (isurfv.eq.-3) then
c     ishift moves boundary left ishift cells when < 0
c                           right   "     "    "   > 0
c     does nothing if =0
c     ishift=1 gives symmetric plates (at least for 32*32 case)
c
        ishift=1
c
        nplate=2
        j=1
        do 30 i=1,nx
        if (i.lt.(3*nx/8)+ishift) iplgeo(i,j)=1
        if ((i.ge.(3*nx/8)+ishift).and.(i.le.(5*nx/8)+ishift)) iplgeo(i
     1  ,j)=0
        if (i.gt.(5*nx/8)+ishift) iplgeo(i,j)=2
   30   continue
        do 40 j=j2,j3/2
        do 40 i=1,nx
        if (i.lt.(3*nx/8)+ishift) iplgeo(i,j)=1
        if (i.eq.(3*nx/8)+ishift) iplgeo(i,j)=0
        if (i.gt.(3*nx/8)+ishift) iplgeo(i,j)=2
   40   continue
        j=(j3/2)+1
        do 50 i=1,nx
        if (i.lt.(3*nx/8)+ishift) iplgeo(i,j)=1
        if ((i.ge.(3*nx/8)+ishift).and.(i.le.(5*nx/8)+ishift)) iplgeo(i
     1  ,j)=0
        if (i.gt.(5*nx/8)+ishift) iplgeo(i,j)=2
   50   continue
        do 60 j=(j3/2)+2,j3-1
        do 60 i=1,nx
        if (i.lt.(5*nx/8)+ishift) iplgeo(i,j)=1
        if (i.eq.(5*nx/8)+ishift) iplgeo(i,j)=0
        if (i.gt.(5*nx/8)+ishift) iplgeo(i,j)=2
   60   continue
        j=j3
        do 70 i=1,nx
        if (i.lt.(3*nx/8)+ishift) iplgeo(i,j)=1
        if ((i.ge.(3*nx/8)+ishift).and.(i.le.(5*nx/8)+ishift)) iplgeo(i
     1  ,j)=0
        if (i.gt.(5*nx/8)+ishift) iplgeo(i,j)=2
   70   continue
        do 80 j=1,j3
        iplgeo(1,j)=0
        iplgeo(nx,j)=0
   80   continue
c
c      divergent top oblique motion
c
      elseif (isurfv.eq.-4) then
        nplate=2
        do 90 j=1,j3
        do 90 i=1,nx
        if (i.lt.j) then
          iplgeo(i,j)=1
        elseif (i.eq.j) then
          iplgeo(i,j)=0
        elseif (i.gt.j) then
          iplgeo(i,j)=2
        endif
   90   continue
        do 100 i=1,nx
        iplgeo(i,1)=0
        iplgeo(i,j3)=0
  100   continue
        do 110 j=1,j3
        iplgeo(1,j)=0
        iplgeo(nx,j)=0
  110   continue
c
c      strike slip boundary
c
      elseif (isurfv.eq.-5) then
        nplate=2
        do 120 j=1,j3
        do 120 i=1,nx
        if (i.le.nx/2) then
          iplgeo(i,j)=2
        else
          iplgeo(i,j)=1
        endif
  120   continue
c
c      sin functions in i and j direction
c
      elseif (isurfv.eq.-6) then
        nplate=1
        do 130 j=1,j3
        do 130 i=1,nx
  130   iplgeo(i,j)=1
      endif
c
c      off center break
c
      if ((isurfv.le.-7).and.(isurfv.gt.-200)) then
c
c     note: the input below assumes the box
c            will have 64 grid spaces horizontally
c
        if (isurfv.eq.-7) then
          ibreak=32
        elseif (isurfv.eq.-8) then
          ibreak=28
        elseif (isurfv.eq.-9) then
          ibreak=24
        elseif (isurfv.eq.-10) then
          ibreak=20
        elseif (isurfv.eq.-11) then
          ibreak=16
        elseif (isurfv.eq.-12) then
          ibreak=12
        elseif (isurfv.eq.-13) then
          ibreak=8
        elseif (isurfv.eq.-14) then
          ibreak=4
        endif
        nplate=2
        do 140 j=1,j3
        do 140 i=1,nx
c     if(i .le. nx/4)then
        if (i.le.ibreak) then
          iplgeo(i,j)=1
c     elseif(i .eq. (nx/4)+1)then
        elseif (i.eq.(ibreak)+1) then
          iplgeo(i,j)=0
        else
          iplgeo(i,j)=2
        endif
  140   continue
        do 150 j=1,j3
        do 150 i=1,nx
        if ((i.eq.1).or.(i.eq.nx)) iplgeo(i,j)=0
  150   continue
      elseif((isurfv .le. -200).and.(isurfv .ge. -299))then
c
c     two plates with transform defined by
c     ltrans=length of transform
c     ishift=shift from x center line
c     jshift=shift from y center line
c
      nplate=2
      ltrans=abs(isurfv)-200
      ishift=0
      jshift=0
      ktrans=0
      if(ltrans .ne. 0)ktrans=ltrans-1
      if(ltrans .lt. 0)ktrans=ltrans+1
      x11=2
      y11=1
      x14=(nx/2)-((ktrans)/2)+ishift
      y14=ny
      x21=x14+2
      y21=2
      x24=x21+ktrans-1
      x24=x21+ktrans-1
      y24=(ny/2)+jshift
      x31=x21-1
      y31=y24+2
      x34=x31+ktrans-1
      y34=ny-1
      x41=x24+1
      y41=1
      x44=nx-1
      y44=ny
c
      do 152 j=1,ny
      do 152 i=1,nx
         iplgeo(i,j)=0
  152 continue
      do 153 j=y11,y14
      do 153 i=x11,x14
        iplgeo(i,j)=1
  153 continue
      do 154 j=y21,y24
      do 154 i=x21,x24
        iplgeo(i,j)=2
  154 continue
      do 155 j=y31,y34
      do 155 i=x31,x34
        iplgeo(i,j)=1
  155 continue
      do 156 j=y41,y44
      do 156 i=x41,x44
        iplgeo(i,j)=2
  156 continue
      if (myid .eq. 0) then
       write(6,158)isurfv,ltrans,ishift,jshift
      endif
c
      elseif (isurfv.eq.-310) then
c
c     2D plates with boundaries defined by ib1 ib2
c
      do 157 i=1,10
       ib(i)=1000000
  157 continue
      ib(1)=16
      ib(2)=33
      ib(3)=40
      nplate=0
      do 159 ii=1,10
      if(ib(ii) .ge. nx)then
         jb(ii)=nx
      else
         jb(ii)=ib(ii)
      endif
  159 continue
      do 160 j=1,j3
      do 160 i=1,nx
      do 160 ii=10,1,-1
      if(i .le. jb(ii))then
          iplgeo(i,j)=ii
      endif
  160 continue
 
      do 163 j=1,j3
      do 163 i=1,nx
         if(i .eq. nx)iplgeo(i,j)=1
         nplate=max0(nplate,iplgeo(i,j))
  163 continue
      elseif (isurfv.eq.-320) then
c
c     three plates
c
        nplate=3
        do 170 j=1,j3
        do 170 i=1,nx
        iplgeo(i,j)=0
  170   continue
        do 200 j=1,j3
        do 180 i=2,(nx-1)/4
        iplgeo(i,j)=1
  180   continue
        do 190 i=(nx-1)/4+2,3*(nx-1)/4
        iplgeo(i,j)=2
  190   continue
  200   continue
        do 210 j=1,j3
        do 210 i=3*(nx-1)/4+2,nx-1
        iplgeo(i,j)=3
  210   continue

      elseif (isurfv.eq.-325) then
c
c     three plates with ragged edges
c
        ijshift=5
        nplate=3
        do 1170 j=1,j3
        do 1170 i=1,nx
        iplgeo(i,j)=0
 1170   continue
        do 1200 j=1,j3
         do 1180 i=2,(nx-1)/4+ijshift
         iplgeo(i,j)=1
 1180   continue
         do 1190 i=(nx-1)/4+1+ijshift,3*(nx-1)/4+1+ijshift
         iplgeo(i,j)=2
 1190   continue
         do 1210 i=3*(nx-1)/4+2+ijshift,nx-1
         iplgeo(i,j)=3
 1210   continue
 1200  continue
        do 1215 j=1,(ny-1)/16
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1215  iplgeo(3*(nx-1)/4+2+ijshift,j)=0 
        do 1220 j=(ny-1)/16,(ny-1)/9
        iplgeo((nx-1)/4+ijshift,j)=0
 1220  iplgeo(3*(nx-1)/4+1+ijshift,j)=0
        do 1225 j=(ny-1)/9,(ny-1)/6
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1225  iplgeo(3*(nx-1)/4+2+ijshift,j)=0 
        do 1230 j=(ny-1)/6,(ny-1)/5
        iplgeo((nx-1)/4+ijshift,j)=0
 1230  iplgeo(3*(nx-1)/4+1+ijshift,j)=0 
        do 1235 j=(ny-1)/5,(ny-1)/3
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1235  iplgeo(3*(nx-1)/4+2+ijshift,j)=0
        do 1240 j=(ny-1)/3,(ny-1)/2
        iplgeo((nx-1)/4+ijshift,j)=0
 1240  iplgeo(3*(nx-1)/4+1+ijshift,j)=0 
        do 1245 j=(ny-1)/2,3*(ny-1)/4
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1245  iplgeo(3*(nx-1)/4+2+ijshift,j)=0 
        do 1250 j=3*(ny-1)/4,4*(ny-1)/5
        iplgeo((nx-1)/4+ijshift,j)=0
 1250  iplgeo(3*(nx-1)/4+1+ijshift,j)=0 
        do 1255 j=4*(ny-1)/5,5*(ny-1)/6
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1255  iplgeo(3*(nx-1)/4+2+ijshift,j)=0
        do 1260 j=5*(ny-1)/6,11*(ny-1)/12
        iplgeo((nx-1)/4+ijshift,j)=0
 1260  iplgeo(3*(nx-1)/4+1+ijshift,j)=0
        do 1265 j=11*(ny-1)/12,j3
        iplgeo((nx-1)/4+1+ijshift,j)=0
 1265  iplgeo(3*(nx-1)/4+2+ijshift,j)=0

      elseif (isurfv.eq.-330) then
c
c     three plates
c
       ishift=5
        nplate=3
        do 171 j=1,j3
        do 171 i=1,nx
        iplgeo(i,j)=0
  171   continue
        do 181 j=1,j3
        do 181 i=2,(nx-1)/4+ishift
        iplgeo(i,j)=1
  181   continue
        do 191 i=(nx-1)/4+1+ishift,(nx-1)/2
        do 187 j=1,(ny-1)/4         
  187   iplgeo(i,j)=1
        do 189 j=3*(ny-1)/4+2,j3
  189   iplgeo(i,j)=1
  191   continue
        do 193 i=(nx-1)/4+2+ishift,3*(nx-1)/4+ishift
        do 193 j=(ny-1)/4+2,3*(ny-1)/4
  193   iplgeo(i,j)=2
c   introduce a kink
        do 194 j=(ny-1)/4+1,(ny-1)/2-3
        if(j.ne.(ny-1)/2-3)iplgeo((ny-1)/4+1+ishift,j)=1
  194   iplgeo((ny-1)/4+2+ishift,j)=0
c
        do 192 i=(nx-1)/2+2,3*(nx-1)/4+1+ishift
        do 188 j=1,(ny-1)/4         
  188   iplgeo(i,j)=3
        do 197 j=3*(ny-1)/4+2,j3
  197  iplgeo(i,j)=3
  192   continue
        do 211 j=1,j3
        do 211 i=3*(nx-1)/4+2+ishift,nx-1
        iplgeo(i,j)=3
  211   continue

      elseif (isurfv.eq.-410) then
c
c     four plates with boundaries defined by ib1 ib2 ib3
c
        nplate=4
        ib1=854
        ib2=1365
        ib3=1707
        do 220 j=1,j3
        do 220 i=1,nx
        if ((i.lt.ib1).and.(i.gt.1)) then
          iplgeo(i,j)=1
        elseif ((i.gt.ib1).and.(i.lt.ib2)) then
          iplgeo(i,j)=2
        elseif ((i.gt.ib2).and.(i.lt.ib3)) then
          iplgeo(i,j)=3
        elseif ((i.gt.ib3).and.(i.lt.nx)) then
          iplgeo(i,j)=4
        else
          iplgeo(i,j)=0
        endif
  220   continue
      elseif (isurfv.eq.-500) then
c
c      plates with boundaries defined by ib(1), ib(2) ... in namelist
c      /setup3/ 
c
c
c     2D plates with boundaries defined by ib1 ib2
c
      do 357 i=1,10
       ib(i)=1000000
  357 continue

      read (3,setup3)

      do 359 ii=1,10
      if(ib(ii) .ge. nx)then
         jb(ii)=nx
      else
         jb(ii)=ib(ii)
      endif
  359 continue
      do 360 j=1,j3
      do 360 i=1,nx
      do 360 ii=10,1,-1
      if(i .le. jb(ii))then
          iplgeo(i,j)=ii
      endif
  360 continue
 
      do 363 j=1,j3
      do 363 i=1,nx
         if(i .eq. nx)iplgeo(i,j)=1
         nplate=max0(nplate,iplgeo(i,j))
  363 continue
      elseif (isurfv.eq.-600) then
c
c     define plate geometry by n+1 points for an n sided polygon.
c     geometry is defined in  dimensionless x y z coordinates
c     errors will occur if geometry is not closed or if the
c     entire surface area is not defined.
c
c     see example input files in subroutine plategeo
c
      open (unit=4,file='geometry.in',status='old',form='formatted')
      read (4,geometry)
      close(4)
c
c     error check for dimensions in param
c
      ifac=2
      if(ny .lt. 3)ifac=1
      if(npla .lt. ifac*npoly)then
c     fatal error condition
        if (myid .eq. 0) then
          write(6,998)npoly, npla
        endif
        stop
      endif
c
c     convert to computational coordinates
      do 605 i=1,100
       xpos(i)=xpos(i)*xl
       ypos(i)=ypos(i)*yl
  605 continue
      ifirst=1
      if(ib(npoly) .eq. -99)then
c     when flag ib(npoly) is set to -99 then
c     by default left over area is assigned to plate #npoly
      do 608 j=1,j3
      do 608 i=1,nx
         iplgeo(i,j)=npoly
  608 continue
      npoly = npoly-1
      endif
c
c     initialize values of iplgeo
c
      do 610 nply=1,npoly
      call plategeo(xpos(ifirst),ypos(ifirst),ib(nply),nply,
     1              xl,yl,nx,ny,nz,iplgeo,iqx,jqx)
      ifirst=ifirst+ib(nply)
  610 continue
c
c     enforce periodic boundary conditions
c
      do 620 i=1,nx
      iplgeo(i,j3)=iplgeo(i,1)
  620 continue
      do 630 j=1,j3
      iplgeo(nx,j)=iplgeo(1,j)
  630 continue
c     count the number of plates 
      do 663 j=1,j3
      do 663 i=1,nx
         nplate=max0(nplate,iplgeo(i,j))
  663 continue
      do 665 i=1,514
        xpos(i)=zero
        ypos(i)=zero
  665 continue
      endif
c
c     the definition of template below assumes periodic boundaries
c
      do 500 npl=1,nplate
      do 500 j=1,j3
      jm1=j-1
      if(j .eq. 1)then
         if(j3 .eq. 1)then
            jm1=1
         else
            jm1=j3-1
         endif
      endif
      jp1=j+1
      if(j .eq. j3)then
        if(j3 .eq. 1)then
          jp1=1
        else
          jp1=2
        endif
      endif
      do 500 i=1,nx
      im1=i-1
      if(i .eq. 1)im1=nx-1
      ip1=i+1
      if(i .eq. nx)ip1=2
 
      icount=0
c
c     set interior points template to one
c
      if(iplgeo(i,j) .eq. npl)then
         template(i,j,npl)=1.0
      elseif(iplgeo(i,j) .eq. 0)then
         if(iplgeo(im1,jm1) .eq. npl)icount=icount+1
         if(iplgeo(im1,  j) .eq. npl)icount=icount+1
         if(iplgeo(im1,jp1) .eq. npl)icount=icount+1
         if(iplgeo(  i,jm1) .eq. npl)icount=icount+1
         if(iplgeo(  i,jp1) .eq. npl)icount=icount+1
         if(iplgeo(ip1,jm1) .eq. npl)icount=icount+1
         if(iplgeo(ip1,  j) .eq. npl)icount=icount+1
         if(iplgeo(ip1,jp1) .eq. npl)icount=icount+1
 
c
c      set boundary points to fractional values depending on the
c      geometry of the boundary
c
         if(icount .eq. 0)template(i,j,npl)=0.
         if(icount .eq. 1)template(i,j,npl)=0.25
         if(icount .eq. 2)template(i,j,npl)=0.50
         if(icount .eq. 3)template(i,j,npl)=0.50
         if(icount .eq. 4)template(i,j,npl)=0.75
         if(icount .eq. 5)template(i,j,npl)=0.75
      else
         template(i,j,npl)=0.0
      endif
      template2(i,j,npl)=template(i,j,npl)
  500 continue

c
c      test for valid template
c      template should sum to one
c
      iflag=0
      do 600 j=j1,j3
      do 600 i=1,nx
      test=0.0
      do 598 npl=1,nplate
      test=test+template(i,j,npl)
  598 continue
      if((test .gt. 1.01) .or. (test .lt. .99))then
         iflag=1
         if (myid .eq. 0) then
           write(6,*)i,j,test
         endif
      endif
  600 continue
      if(nplate .gt. nplai)then
         if (myid .eq. 0) then
           write(6,992)nplate, nplai, npssdi
         endif
         stop
      endif
      if(iflag .eq. 1)then
         if (myid .eq. 0) then
          write(6,599)
  599     format(
     1'in surfgeo:template err, check definition of iplgeo')
         endif
         stop
      endif

c JPL add

1001  continue 

c JPL end

c
c     write plate geometry to output file
c
         if (myid .eq. 0) then
            write (6,909)jqx ,iqx,jqx
            do 915 j=jqx,1,-1
              write (6,910) (iplgeo(i,j),i=1,iqx)
  915       continue
            write (6,919)iqx
         endif
  909 format ('1',i3,'.......................',i3,',',i3)
  910 format (128i1)
  919 format ('1,1..........................',i3,',1')
  158 format
     1 ('isurfv=',i5,' ltrans=',i5,' ishift=',i5,' jshift=',i5)
  992 format('Error in SURFGEO.F   ',/,' nplate   = ', i5,/,
     1                                 ' nplai    = ', i5,/,
     2                                 ' nplssdi  = ', i5)
  998 format('Error in SURFGEO.f   ',/,' npla in param set to ',i5,
     1 ' npoly in geometry.in is set to ', i5,/,
     2 'For 2D runs npla must be .ge. npoly',/,
     3 'For 3d runs npla must be .ge. 2*npoly')
      return
      end
