c $Log:   /pvcs.config/mc3dvv/src/surfv.F_a  $
c
c   Rev 1.3   Fri Jul 30 11:45:20 1999   lowman
c  Added option for plates rotating around fixed point (King project)
c
c   Rev 1.1   Tue Oct 06 16:56:42 1998   lowman
cAdded xveloc and yveloc definitions
c
c   Rev 1.0   Mon Jul 14 14:22:24 1997   pvcs
c 
c *************************************************************
c *   SURFV
c *************************************************************
      subroutine surfv (v,n1,n2,template2,iplgeo)
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_a12
      use module_a30
c#include<a4.h>
      common /a4/ vsij(700)
      dimension template2(iqx,jqx,npla), iplgeo(iqx,jqx)
c
c     if ISURFV  .GE. 2, user supplies surface velocity components here
c       value of isurfv .ge. 2 determines which b.c. option to choose
c
c      isurfv=2   divergent center line
c            =3   divergent with transform
c            =4   oblique boundary
c            =5   strike slip boundary
c            =6   sin function in i & j direction
c
      dimension v(n1,n2,2)
c
      twopi=2.*pimach(dumm)
c   divergent top boundary (i.e. ridge)
c
      if(isurfv.lt.0)then
        do 1 j=1,nyr
        do 1 i=1,nxr
        v(i,j,1)=zero
1       v(i,j,2)=zero

        do 2 j=1,nyr
        do 2 i=1,nxr
        do 2 ipla=1,nplate
        v(i,j,1)=template2(i,j,ipla)*vpl(1,ipla)+v(i,j,1)
2       v(i,j,2)=template2(i,j,ipla)*vpl(2,ipla)+v(i,j,2)

c        do j=1,nyr
c        write(*,*) 'writing applied b.c.'
c        write(*,*) (v(iii,j,1),iii=1,nxr)
c        write(*,*) (v(iii,j,2),iii=1,nxr)
c        enddo

        if (nyr.eq.1) then
            v(nxr+1,1,1) = v(1,1,1)
            v(nxr+1,1,2) = v(1,1,2)
        else
            do 104 i = 1,nxr+1
            v(i,nyr+1,1) = v(i,1,1)
            v(i,nyr+1,2) = v(i,1,2)
104         continue
            do 106 j = 1,nyr+1
            v(nxr+1,j,1) = v(1,j,1)
            v(nxr+1,j,2) = v(1,j,2)
106         continue
        endif
      endif

      if (isurfv.eq.2) then
        do 10 j=1,j3
        do 10 i=1,n1
        if (i.le.nx/2) then
          v(i,j,1)=2000.
          v(i,j,2)=0.
        elseif (i.gt.(nx/2)+1) then
          v(i,j,1)=-2000.
          v(i,j,2)=0.
        else
          v(i,j,1)=0.
          v(i,j,2)=0.
        endif
        if((i.eq.1).or.(i.eq.nx))then
          v(i,j,1)=0.
          v(i,j,2)=0.
        endif
   10   continue
c
c      divergent top with transform
c
      elseif (isurfv.eq.3) then
       ishift=1
c
        j=1
        xveloc=17.
        yveloc=1.0
        do 3 i=1,n1
        if (i.lt.(3*n1/8)+ishift)then 
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
  3   continue
        do 4 j=j2,j3/2
        do 4 i=1,n1
        if (i.lt.(3*n1/8)+ishift)then 
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if (i.eq.(3*n1/8)+ishift) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(3*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   4   continue
        j=(j3/2)+1
        do 5 i=1,n1
        if (i.lt.(3*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   5   continue
        do 6 j=(j3/2)+2,j3-1
        do 6 i=1,n1
        if (i.lt.(5*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if (i.eq.(5*n1/8)+ishift) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   6   continue
        j=j3
        do 7 i=1,n1
        if (i.lt.(3*n1/8)+ishift) then
          v(i,j,1)=-xveloc
          v(i,j,2)=-yveloc
        endif
        if ((i.ge.(3*n1/8)+ishift).and.(i.le.(5*n1/8)+ishift)) then
          v(i,j,1)=.0
          v(i,j,2)=.0
        endif
        if (i.gt.(5*n1/8)+ishift) then
          v(i,j,1)=xveloc
          v(i,j,2)=yveloc
        endif
   7   continue
        do 8 j=1,j3
        v(1,j,1)=0.
        v(1,j,2)=0.
        v(n1,j,1)=0.
        v(n1,j,2)=0.
   8   continue
c
c      divergent top oblique motion
c
      elseif (isurfv.eq.4) then
        do 30 j=1,n2
        do 30 i=1,n1
        if (i.le.3*n1/8) then
          v(i,j,1)=-10.
          v(i,j,2)=-10.
        else
          v(i,j,1)=10.
          v(i,j,2)=10.
        endif
   30   continue
        icount=0
        jcount=2
        do 50 j=1,n2
        if (jcount.le.4) then
          jcount=jcount+1
        else
          jcount=1
          icount=icount+1
        endif
        do 40 i=(3*n1/8),(5*n1/8)
        if (i.lt.(5*n1/8)-icount) v(i,j,1)=-10.
   40   continue
   50   continue
c
c      strike slip boundary
c
      elseif (isurfv.eq.5) then
        do 60 j=1,n2
        do 60 i=1,n1
        if (i.le.n1/2) then
          v(i,j,1)=0.
          v(i,j,2)=25.
        else
          v(i,j,1)=0.
          v(i,j,2)=-25.
        endif
   60   continue
c
      elseif (isurfv.eq.400) then
c
c     two equal size plates with velocity given by vsij(1-4)
c
        do 400 j=1,n2
        do 400 i=1,n1
        if (i.le.n1/2) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
400   continue
c
      elseif (isurfv.eq.401) then
c
c       DaN's thesis - 2 plates with a 1/2 unit offset 
c       for a 512x512 (4x4) grid
c       velocity given by vsij(1-4)
c
        do 401 j=1,n2
        do 401 i=1,n1
        if ( ((i.gt.64) .and. (i.le.320) .and. (j.le.256)) 
     &  .or. ((i.le.256) .and. (j.gt.256)) ) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
401     continue
c
      elseif (isurfv.eq.402) then
c
c       DaN's thesis - 2 plates with a unit offset
c       for a 512x512 (4x4) grid
c       velocity given by vsij(1-4)
c
        do 402 j=1,n2
        do 402 i=1,n1
        if ( ((i.gt.128) .and. (i.le.384) .and. (j.le.256))
     &  .or. ((i.le.256) .and. (j.gt.256)) ) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
402     continue
c
      elseif (isurfv.eq.404) then
c
c     DaN's thesis - 4 equally sized plates with half the 
c                    length and width of the box.
c     Velocities are given by vsij(1-8)
c
      do 404 j=1,n2
      do 404 i=1,n1
        if ((i.le.n1/2) .and. (j.le.n2/2)) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)      
        elseif ((i.gt.n1/2) .and. (j.le.n2/2)) then
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        elseif ((i.le.n1/2) .and. (j.gt.n2/2)) then
          v(i,j,1)=vsij(5)
          v(i,j,2)=vsij(6)
        else
          v(i,j,1)=vsij(7)
          v(i,j,2)=vsij(8)
        endif
404   continue
c
      elseif (isurfv.eq.412) then
c
c     DaN's SEDI and transfer work - for a 649x244 box
c     two equally sized plates with a 45deg boundary velocities 
c     given by vsij(1-4)
c
      do 412 j=1,n2
      do 412 i=1,n1
        if (i.le.202+j) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
412   continue
c
      elseif (isurfv.eq.414) then
c
c     DaN's SEDI and transfer work - for a 649x244 box
c     two equally sized plates. One boundary is at 45deg to the box
c     the other is offset  
c     velocities given by vsij(1-4)
c
      do 414 j=1,n2
      do 414 i=1,n1

        if (i.le.202+j) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif

        if ((i.ge.567).and.(j.gt.122)) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        elseif ((i.le.82).and.(j.lt.122)) then
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        elseif (j.eq.122) then
          v(i,j,1)=0.0
          v(i,j,2)=0.0
        endif

414   continue
c
      elseif (isurfv.eq.415) then
c
c     DaN's SEDI and transfer work - for a 649x244 box
c
c     As above but the offset boundary is flipped 
c     velocities given by vsij(1-4)
c
      do 415 j=1,n2
      do 415 i=1,n1

        if (i.le.202+j) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif

        if ((i.ge.567).and.(j.lt.122)) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        elseif ((i.le.82).and.(j.gt.122)) then
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        elseif (j.eq.122) then
          v(i,j,1)=0.0
          v(i,j,2)=0.0
        endif

415   continue
c
      elseif (isurfv.eq.450) then
c
c     two equal plates with velocity given by vsij(1-4) and
c     plate boundary give by vsij(5) in nondimensional coordinates
c     (e.g. vsij(5) = .5 => 2 equal size plates regardless of xl.
c
        iboundary = int(float(nx)*vsij(5))
        do 450 j=1,n2
        do 450 i=1,n1
        if (i.le.iboundary) then
          v(i,j,1)=vsij(1)
          v(i,j,2)=vsij(2)
        else
          v(i,j,1)=vsij(3)
          v(i,j,2)=vsij(4)
        endif
  450   continue

      endif
      return
c
  190 format (i5,3x,i5,3x,e12.3,2x,e12.3)
  200 format (i5,3x,i5,3x,e12.3,2x,e12.3)
  210 format (128i1)
      end
