c $Log:   /pvcs.config/mc3dvv/src/tauout.F_a  $
c
c   Rev 1.1   Tue Feb 09 15:00:50 1999   lowman
cremoved hardwired value for lith
c
c   Rev 1.0   Mon Jul 14 14:22:24 1997   pvcs
c 
c *************************************************************
c *   TAUOUT
c *************************************************************
      subroutine tauout(ijob,levelz)
c***begin prologue  tauout
c***date written   890101   (yymmdd)
c***revision date  930804   (yymmdd)
c***category no.  ????
c***keywords
c***author   Carl W. Gable   (Los Alamos National Laboratory)
c***purpose Calculate and output stress
c***description
c
c     find average stress on a plate and the value and position
c     of the peak stress. Only works in 2D.
c
c     ijob = 1 		no action
c     ijob = 2		output tau13 tau23 tauxx to tape33
c     ijob = 3          output tau33 calculated from dw/dz
c
c***references (none)
c***routines called  inverse
c***modifications (yymmdd) modification
c***modifications (930804) [cwg] Get rid of tau11 array and use advctd
c                          as a work array to calculate tau11.
c***end prologue  tauout
      use module_precision
      use module_param
      use module_giparam
      use module_a2
      use module_gia3
      use module_a3
      use module_a6
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_a20
      use module_a77
      use module_tauout
      common /start1/ restrt, initlt, istart
      dimension awork(5,5)
c
c use advctd as a work array to calculate tau11 from velocity gradient
c
      if((ny.gt.2).or.(iftau.eq.0).or.(ifsavepl.eq.0))return
c
c      lith=1
      lithd=nz-lith
      lithd=nz
      lithd=levelz
      
      if(ijob .eq. 1)then
      return
            
      do 80 ipla=1,nplate
        ttmax(ipla)=-1.e20
        tmin(ipla)= 1.e20
        tmean(ipla)=0.
        area=0.
        i2=2*ipla
        i2m1=i2-1
        do 70 j=1,ny-1
        do 70 i=1,nx-1
          area=template(i,j,ipla)+area
          t13=template(i,j,ipla)*tau13(i,j,lithd)
          t23=template(i,j,ipla)*tau23(i,j,lithd)
          if(t13 .gt. ttmax(ipla))then
             ttmax(ipla)=t13
             xmax(ipla)=float(i)
          endif
          if(t13 .lt. tmin(ipla))then
             tmin(ipla)=t13
             xmin(ipla)=float(i)
          endif
          tmean(ipla)=t13+tmean(ipla)
   70 continue
      tmean(ipla)=tmean(ipla)/area
   80 continue
      
      write(33,90)icycle,time,(ttmax(i) , i = 1, nplate),
     1                        (tmin(i) , i = 1, nplate),
     2                        (tmean(i), i = 1, nplate),
     3                        (xmax(i) , i = 1, nplate),
     4                        (xmin(i) , i = 1, nplate)
   90 format(i8,10(8e14.7,/))
      
      elseif(ijob .eq. 2)then
c
c     calculate tauxx from du/dx
      dxi=one/dx
      do 105 j=1,j3
      do 105 i=1,nx
      im1=i-1
      ip1=i+1
      if(i .eq. 1)im1=nx-1
      if(i .eq. nx)ip1=2
      u1=u(im1,j,lithd)
      u2=u(i  ,j,lithd)
      u3=u(ip1,j,lithd)
      advctd(i,j,1)=(half*(u2-u1)+half*(u3-u2))*dxi
  105 continue

      ncy=ny
      nfield=4
      if(ny .eq. 2)then
         ncy=ny-1
         nfield=3
      endif      
      write(32,110)nfield,icycle,time
      id=1
      idi=1
      idj=3
      write(32,115)id,idi,idj,lithd
      write(32,120)((tau13(i,j,lithd),i=1,nx),j=1,ncy)
      if(ny .ne. 2)then
        id=2
        idi=2
        idj=3
        write(32,115)id,idi,idj,lithd
        write(32,120)((tau23(i,j,lithd),i=1,nx),j=1,ncy)
      endif
      id=3
      idi=3
      idj=3
      write(32,115)id,idi,idj,lithd
      write(32,120)((tauz (i,j,lithd),i=1,nx),j=1,ncy)
c
c     calculate tau11 from du/dx and store in advctd array; see above
c
      id=4
      idi=1
      idj=1
      write(32,115)id,idi,idj,lithd
      write(32,120)((advctd(i,j,1),i=1,nx),j=1,ncy)
  110 format(2i8,e14.7)
  115 format(4i8)
c  120 format(1000000e14.7)
  120 format(13000(10e12.5,/))
      
      elseif(ijob .eq. 3)then
      if(levelz .lt. 3)then
         write(6,990)levelz
         stop
      endif
      nfield = 3
      write(32,110)nfield,icycle,time
c
c     output normal stress with shear stress tau13 label for plotting
      id=1
      idi=1
      idj=3
      write(32,115)id,idi,idj,lithd
      write(32,120)((tauz (i,j,lithd),i=1,nx),j=1,ncy)
c
c     calculate tauzz from gradient in vertical velocity
c
c     v(z) = az**2 + bz + c
c
c     tauzz(z) = dw/dz = 2az + b
c
      dz = one/float(nz-1)
      lzm1 = levelz - 1
      lzm2 = levelz - 2
      do 202 k = 1,3
         zcord = float(levelz-k)*dz
         awork(1,k) = zcord**2
         awork(2,k) = zcord
         awork(3,k) = one
  202 continue
      call inverse(3,awork,5)
      do 205 j=1,j3
      do 205 i=1,nx
         a = awork(1,1)*w(i,j,levelz) + awork(1,2)*w(i,j,lzm1) + 
     1       awork(1,3)*w(i,j,lzm2)
         b = awork(2,1)*w(i,j,levelz) + awork(2,2)*w(i,j,lzm1) + 
     1       awork(2,3)*w(i,j,lzm2)
         c = awork(3,1)*w(i,j,levelz) + awork(3,2)*w(i,j,lzm1) + 
     1       awork(3,3)*w(i,j,lzm2)
         tauz (i,j,lithd) = 2.0*a*float(levelz-1)*dz+ b
         advctd(i,j,1) = 2.0*a*float(levelz-2)*dz+ b
c         write(6,*)i,j,b,w(i,j,levelz-1),w(i,j,levelz-2)
  205 continue
      id=4
      idi=1
      idj=1
      write(32,115)id,idi,idj,lithd
      write(32,120)((advctd(i,j,1),i=1,nx),j=1,ncy)
      id=3
      idi=3
      idj=3
      write(32,115)id,idi,idj,lithd
      write(32,120)((tauz (i,j,lithd),i=1,nx),j=1,ncy)
c
      endif
  990 format('Invalid call to TAUOUT: levelz .lt. 3: levelz = ',i5)
      return
      end
