      subroutine tempstats(ijob)

c $Log:   /pvcs.config/mc3dvv/src/tempstats.F_a  $
c   
c      Rev 1.1   Fri Jul 30 15:55:06 1999   lowman
c     Fixed temperature averaging bug resulting from double
c     averaging over endpoints for perriodic b.c. case and
c     made arrays allocatable.
c   
c      Rev 1.0   Tue Mar 23 16:52:00 1999   lowman
c   Initial revision.

      use module_precision
      use module_param
      use module_a1
      use module_a6
      use module_a3
      use module_ftcoef
      use module_tstats
      use module_slvelu
      use module_spwork    !+DaN
#ifdef MPI
      include 'mpif.h'
#endif

c      dimension havg_oft(512,10)
       dimension volavg_oft(10)
c      dimension yavg_oft(512,10,3)

      common/ctempstats/icall

      character*25 fileroot
      character*60 fname

#ifdef MPI
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif

      if(myid .eq. 0) then
        if(icycle.eq.1)then
          open(unit=70,file='volavg_ofT')
        endif
      endif

      if(ijob.ne.1)then
        if(icycle.eq.1)icall=0
        icall=icall+1
        if (myid .eq. 0) then
         lunum=71
         iformat=2
         fileroot='havg_ofT'
         itail=0
         call namefile1(icall,lunum,iformat,fileroot,itail,fname)
        endif
      endif 

      dxdy = dx*dy
      qxy  = quarter*dxdy
      hqxy = half*qxy

c DaN: ttoft now returns spwk (due to reduced size of ft)
c DaN: therefore have replaced all following references to ft with spwk
      call ttoft_spwk

      do 15 ipla = 1,nplate+1
      do 10 k = 1,nz
      havg_oft(k,ipla) = zero
   10 continue
   15 continue

#ifdef MPI
      call mpilayer(nz,numprocs,myid,izstart,izstop)
#else
      izstart=1
      izstop=nz
#endif

      do 65 ipla = 1,nplate
        do 61 k=izstart,izstop
        template_sum=zero
          do 60 j = 1,j3
          do 60 i = 1,nx-1
            if ((j.eq.j3).and.(j3.gt.1))goto 60
             havg_oft(k,ipla) = 
     1       template(i,j,ipla)*spwk(i,j,k)+havg_oft(k,ipla)
             template_sum=template_sum+template(i,j,ipla)
 60       continue
        havg_oft(k,ipla)=havg_oft(k,ipla)/(template_sum*rat)
 61     continue

#ifdef MPI
        call MPI_ALLREDUCE(havg_oft(1,ipla),zwork,nz,
     &        MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,ierr)

        do 62 kk=1,nz
          havg_oft(kk,ipla) = zwork(kk)
 62     continue
#endif

        volavg_oft(ipla)=zero
        do 63 k=1,nz
 63     volavg_oft(ipla)=havg_oft(k,ipla)/float(nz)+volavg_oft(ipla) 

 65   continue

c     do 68 k=1,nz
      do 68 k=izstart,izstop
       havg_oft(k,nplate+1)=zero
       template_sum=zero
       do 66 j=1,j3
       do 66 i=1,nx-1
        if((j.eq.j3).and.(j3.gt.1))go to 66
        havg_oft(k,nplate+1)=spwk(i,j,k)+havg_oft(k,nplate+1)
        template_sum=template_sum+1.
 66    continue
       havg_oft(k,nplate+1)=havg_oft(k,nplate+1)/(rat*template_sum)
 68    continue
#ifdef MPI
        call MPI_ALLREDUCE(havg_oft(1,nplate+1),zwork,nz,
     &        MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,ierr)

        do 69 kk=1,nz
          havg_oft(kk,nplate+1) = zwork(kk)
 69     continue
#endif

       volavg_oft(nplate+1)=zero
       do 70 k=1,nz
 70    volavg_oft(nplate+1)=havg_oft(k,nplate+1)/float(nz)+
     & volavg_oft(nplate+1)
      dz=one/float(nz-1)
      sumdz=zero

      if(myid .eq. 0) then
      write(70,100) time, (volavg_oft(ipla),ipla=1,nplate+1),
     & ((volavg_oft(jpla)-volavg_oft(nplate+1))
     & /volavg_oft(nplate+1),jpla=1,nplate)
        if(ijob.ne.1)then
        do 71 k = 1,nz
        if(k.ne.nz)then
        write(71,100) sumdz,(havg_oft(k,ipla),ipla=1,nplate+1),
     & ((havg_oft(k,ipla)-havg_oft(k,nplate+1))
     & /havg_oft(k,nplate+1),ipla=1,nplate)
        if(j3.ne.1)write(72,100) sumdz,spwk(nx/2+1,j3/2,k),
     &  spwk(nx/2+1,j3/2,k)/havg_oft(k,nplate+1)
        else
        write(71,100) sumdz,(havg_oft(k,ipla),ipla=1,nplate+1),
     & ((havg_oft(k,ipla)-havg_oft(k,nplate+1)),ipla=1,nplate)
        if(j3.ne.1)write(72,100) sumdz,spwk(nx/2+1,j3/2,k)/rat,
     &  spwk(nx/2+1,j3/2,k)/rat
        endif 
        sumdz=sumdz+dz
 71     continue
        sumdx=zero
        close(71)
        close(72)
        endif      
      endif      
      call flush(70)

100   format(13(e15.7,1x))

      end
