c $Log:   /pvcs.config/mc3dvv/src/ttoft.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:32 1997   pvcs
c 
c *************************************************************
c *   TTOFT
c *
c *   Convert temperature at cell centers to cell corners
c *
c *   Modified  for DASPK method. (PvK 950803)
c *************************************************************
      subroutine ttoft
      use module_precision
      use module_param
      use module_giparam
      use module_a1
      use module_gia1
      use module_gia3
      use module_a3
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_ftcoef
      use module_timeint

      if (itimechoice.eq.1.or.itimechoice.eq.-1) then

c *************************************************************
c *      *** DASPK *** 
c *      *** Temperature is alreay at cell corners.
c *      *** Copy values from tt to ft and multiply by rat.
c *************************************************************
         if (ny.ge.3) then
            ioff = norder/2
            joff = norder/2
            koff = norder/2 - 1
            do k=1,nz
               do j=1,j3
                  do i=1,nx
                     ft(i,j,k) = rat*t(i+ioff,j+joff,k+koff)
                  enddo
               enddo
            enddo
         else
            ioff = norder/2
            koff = norder/2 - 1
            do k=1,nz
               do i=1,nx
                  ft(i,1,k) = rat*t(i+ioff,1,k+koff)
               enddo
            enddo
         endif

      else

c *************************************************************
c *      *** Default method, unchanged..
c *************************************************************

        do k=1,nz
          do j=1,j3
            do i=1,nx
               ft(i,j,k)=0.
            enddo
          enddo
        enddo
 
        if ((lbd.eq.0).and.(mbd.eq.0)) then
c *************************************************************
c *        PERIODIC BOUNDARIES
c *        nxr = nx-1
c *        nyr = ny-1
c *************************************************************
          if (ny.eq.2) then
c           *** 2-D
            do k=2,nz-1
              do i=1,nxr+1
                ft(i,1,k)=rat*.25*(t(i,1,k)+t(i+1,1,k)+
     v               t(i,1,k+1)+t(i+1,1,k+1))
              enddo
            enddo
            do i=1,nxr+1
               ft(i,1,1)=rat*0.5*(t(i,1,1)+t(i+1,1,1))
               ft(i,1,nz)=rat*0.5*(t(i,1,nz1)+t(i+1,1,nz1))
            enddo
 
          else
 
            do k=2,nz-1
              do j=1,nyr+1
                do i=1,nxr+1
                  ft(i,j,k)=rat*.125*(t(i,j,k)+t(i+1,j,k)+
     v                      t(i,j+1,k)+t(i+1,j+1,k)+
     v                      t(i,j,k+1)+t(i+1,j,k+1)+
     v                      t(i,j+1,k+1)+t(i+1,j+1,k+1))
                enddo
              enddo
            enddo
            do j=1,nyr+1
               do i=1,nxr+1
                  ft(i,j,1)=rat*0.25*(t(i,j,1)+t(i+1,j,1)+
     v                t(i,j+1,1)+t(i+1,j+1,1))
                  ft(i,j,nz)=rat*0.25*(t(i,j,nz1)+
     v               t(i+1,j,nz1)+t(i,j+1,nz1)+t(i+1,j+1,nz1)) 
               enddo
            enddo
          endif
 
        elseif ((lbd.eq.1).and.(mbd.eq.1)) then
c *************************************************************
c *        REFLECTING BOUNDARIES
c *************************************************************
          if (ny.eq.2) then
c           *** Interior points of top and bottom row
            do i=2,nx-1
              ft(i,1,1)=rat*0.5*(t(i,1,1)+t(i+1,1,1))
              ft(i,1,nz)=rat*0.5*(t(i,1,nz1)+t(i+1,1,nz1))
            enddo
c           *** Fully interior points
            do k=2,nz-1
               do i=2,nx-1
                ft(i,1,k)=rat*0.25*(t(i,1,k)+t(i+1,1,k)+
     v               t(i,1,k+1)+t(i+1,1,k+1))
               enddo
            enddo
c           *** Seeing double! (PvK 960701)
c           do i=2,nx-1
c              ft(i,1,1)=rat*0.5*(t(i,1,1)+t(i+1,1,1))
c              ft(i,1,nz)=rat*.5*(t(i,1,nz1)+t(i+1,1,nz1))
c           enddo
c           *** Interior points at vertical boundaries
            do k=2,nz-1
               ft(1,1,k)=rat*0.5*(t(1,1,k)+t(1,1,k+1))
               ft(nx,1,k)=rat*0.5*(t(nx1,1,k)+t(nx1,1,k+1))
            enddo
c           do k=2,nz-1
c              ft(1,1,k)=rat*0.5*(t(1,1,k)+t(1,1,k+1))
c              ft(nx,1,k)=rat*0.5*(t(nx1,1,k)+t(nx1,1,k+1))
c           enddo
c           *** Corner nodal points
            ft(1,1,1)=rat*t(1,1,1)
            ft(1,1,nz)=rat*t(1,1,nz1)
            ft(nx,1,1)=rat*t(nx1,1,1)
            ft(nx,1,nz)=rat*t(nx1,1,nz1)
          else
c           *** 3-D
c           *** Fully interior points
            do k=2,nz-1
              do j=2,ny-1
                do i=2,nx-1
                   ft(i,j,k)=rat*0.125*(t(i,j,k)+t(i+1,j,k)+
     v                t(i,j+1,k)+t(i+1,j+1,k)+t(i,j,k+1)+
     v                t(i+1,j,k+1)+t(i,j+1,k+1)+t(i+1,j+1,k+1))  
                enddo
              enddo
            enddo
c           *** Top and bottom plane
            do j=2,ny-1
              do i=2,nx-1
                 ft(i,j,1)=rat*0.25*(t(i,j,1)+t(i+1,j,1)+
     v               t(i,j+1,1)+t(i+1,j+1,1))
                 ft(i,j,nz)=rat*0.25*(t(i,j,nz1)+t(i+1,j,nz1)+
     v               t(i,j+1,nz1)+t(i+1,j+1,nz1))
              enddo
            enddo
c           *** Front and back plane
            do k=2,nz-1
               do i=2,nx-1
                 ft(i,1,k)=rat*0.25*(t(i,1,k)+t(i+1,1,k)+
     v               t(i,1,k+1)+t(i+1,1,k+1))
                 ft(i,ny,k)=rat*0.25*(t(i,ny1,k)+t(i+1,ny1,k)+
     v              t(i,ny1,k+1)+t(i+1,ny1,k+1))
               enddo
            enddo

c           *** Left and right plane
            do k=2,nz-1
              do j=2,ny-1
                 ft(1,j,k)=rat*0.25*(t(1,j,k)+t(1,j+1,k)+
     v              t(1,j,k+1)+t(1,j+1,k+1))
                 ft(nx,j,k)=rat*0.25*(t(nx1,j,k)+t(nx1,j+1,k)+
     v              t(nx1,j,k+1)+t(nx1,j+1,k+1))
              enddo
            enddo
            do i=2,nx-1
               ft(i,1,1)=rat*0.5*(t(i,1,1)+t(i+1,1,1))
               ft(i,1,nz)=rat*0.5*(t(i,1,nz1)+t(i+1,1,nz1))
               ft(i,ny,1)=rat*0.5*(t(i,ny1,1)+t(i+1,ny1,1))
               ft(i,ny,nz)=rat*.5*(t(i,ny1,nz1)+t(i+1,ny1,nz1))
            enddo
            do j=2,ny-1
               ft(1,j,1)=rat*0.5*(t(1,j,1)+t(1,j+1,1))
               ft(1,j,nz)=rat*0.5*(t(1,j,nz1)+t(1,j+1,nz1))
               ft(nx,j,1)=rat*0.5*(t(nx1,j,1)+t(nx1,j+1,1))
               ft(nx,j,nz)=rat*0.5*(t(nx1,j,nz1)+t(nx1,j+1,nz1))
            enddo
            do k=2,nz-1
               ft(1,1,k)=rat*0.5*(t(1,1,k)+t(1,1,k+1))
               ft(1,ny,k)=rat*0.5*(t(1,ny1,k)+t(1,ny1,k+1))
               ft(nx,1,k)=rat*0.5*(t(nx1,1,k)+t(nx1,1,k+1))
               ft(nx,ny,k)=rat*0.5*(t(nx1,ny1,k)+t(nx1,ny1,k+1))
            enddo
            ft(1,1,1)=rat*t(1,1,1)
            ft(1,1,nz)=rat*t(1,1,nz1)
            ft(1,ny,1)=rat*t(1,ny1,1)
            ft(1,ny,nz)=rat*t(1,ny1,nz1)
            ft(nx,1,1)=rat*t(nx1,1,1)
            ft(nx,1,nz)=rat*t(nx1,1,nz1)
            ft(nx,ny,1)=rat*t(nx1,ny1,1)
            ft(nx,ny,nz)=rat*t(nx1,ny1,nz1)
          endif
        else
c           *** not set up for mixed b.c.
            write(6,*) 'PERROR(ttoft): Not set up for mixed boundary'
            write(6,*) '  conditions. Use lbd=mbd=0 or lbd=mbd=1    '
            stop
        endif
  
      endif
  
      return
      end
