c $Log:   /pvcs.config/mc3dvv/src/velprm.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:36 1997   pvcs
c 
c *************************************************************
c *   VELPRM
c *************************************************************
      subroutine velprm(temp)
      use module_precision
c
c     primitive variable approach gives velocities at cell corners.
c     this routine performs an averaging on the velocities to
c     force divergence over cell faces to be zero.
c
      use module_gia3
      use module_param !+DaN
      use module_a2    !+DaN
      use module_a3
      use module_a11
c      dimension u(inx,jnx,knx), v(inx,jnx,knx)  !DaN added a2.h above
      dimension temp(inx,jnx)
c DaN ---------------------------------------------------------------DaN
#ifdef MPI
      include 'mpif.h'
        call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
        call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
        call mpilayer(nz,numprocs,myid,izstart,izstop)
        izstart=max(izstart - 2, 1)
        izstop =min(izstop + 2, nz)
#else
        izstart=1
        izstop =nz
#endif
c DaN----------------------------------------------------------------DaN
      if (ny.eq.2) then
        j3m1 = 1
      else
        j3m1 = ny-1
      endif
c      do k = 1,nz
      do k = 1,izstop-izstart+1          !DaN
        do j = 1,j3
          do i = 2,nx-1
            temp(i,j) = quarter*(u(i-1,j,k)+two*u(i,j,k)+u(i+1,j,k))
          enddo
        enddo
        if (lbd.eq.0) then
          do j = 1,j3
            temp(1,j)  = quarter*(u(nx-1,j,k)+two*u(1,j,k)+u(2,j,k))
            temp(nx,j) = temp(1,j)
          enddo
        else
          do j = 1,j3
            temp(1,j)  = zero
            temp(nx,j) = zero
          enddo
        endif
        do j = 1,j3
          do i = 1,nx
            u(i,j,k) = temp(i,j)
          enddo
        enddo
      enddo
c
c     *** Added if-statement GI 8/24/95
      if (ny.gt.2) then
c        do k = 1,nz                       !DaN
        do k = 1,izstop-izstart+1
          do j = j2,j3m1
            do i = 1,nx
              temp(i,j) = quarter*(v(i,j-1,k)+two*v(i,j,k)+
     v             v(i,j+1,k))
            enddo
          enddo
          if (mbd.eq.0) then
            do i = 1,nx
               temp(i,1)  = quarter*(v(i,j3m1,k)+two*v(i,1,k)+
     v        v(i,2,k))
               temp(i,j3) = temp(i,1)
            enddo
          else
            do i = 1,nx
               temp(i,1)  = zero
               temp(i,j3) = zero
            enddo
          endif
          do j = 1,j3
            do i = 1,nx
               v(i,j,k) = temp(i,j)
            enddo
          enddo
        enddo
      else
c        do 81 k = 1,nz          !Not sure whether v is already zero
        do 81 k = 1,izstop-izstart+1  !DaN
        do 81 j = 1,j3          !or whether program needs temp which
        do 81 i = 1,nx          !is pass to mantle as advctd
          temp(i,j)=zero
   81     v(i,j,k) = zero
      endif
      
      return
      end
