      subroutine velstats

      use module_precision
      use module_param
      use module_a1
      use module_a2
      use module_a3
      use module_a6
      use module_ftcoef
      use module_vstats
      use module_slvelu
#ifdef MPI
      include 'mpif.h'
#endif

      real*8 V_m(8)

      character*25 filert

#ifdef MPI
       call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
       call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
#else
       myid=0
       numprocs=1
#endif

        if(icycle.eq.1)then
          if (myid .eq. 0) then
            open(unit=88,file='avg_V_horiz',form='unformatted')
          endif
        endif

       do 62 k=1,nz
62     avg_V_horiz(k)=zero

 
#ifdef MPI
      call mpilayer(nz,numprocs,myid,izstart,izstop)
      if (izstart.eq.1) then         !+DaN
        iadd=1                       !+DaN
      else                           !+DaN
        iadd=3                       !+DaN
      endif                          !+DaN
#else
      izstart=1
      izstop=nz
      iadd=1                         !+DaN
#endif


c     This calculates the global mean horizontal velocity profile

      do 68 k=izstart,izstop
        kw=k-izstart+iadd            !+DaN
        template_sum=zero
        avg_V_horiz(k) = zero 
        do 66 j=1,j3
        do 66 i=1,nx-1
          if((j.eq.j3).and.(j3.gt.1))go to 66

          avg_V_horiz(k)=dsqrt(u(i,j,kw)*u(i,j,kw)+
     1    v(i,j,kw)*v(i,j,kw))+avg_V_horiz(k)     !DaN
          template_sum=template_sum+1.

 66     continue
        avg_V_horiz(k)=avg_V_horiz(k)/(template_sum)  
 68   continue

#ifdef MPI
      call MPI_ALLREDUCE(avg_V_horiz(1),zwork,nz,
     &         MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,ierr)

        do 69 kk=1,nz
          avg_V_horiz(kk) = zwork(kk)
 69     continue
#endif

      if(myid .eq. 0) then
        write(88) (avg_V_horiz(k),k=1,nz)
      endif


      do 80 ipla=1,nplate

      lunum=50+ipla
      if((icycle.eq.1).and.(myid .eq. 0))then
      jformat=2
      filert='vstats'
      itail=0
      call namefile1(ipla,lunum,jformat,filert,itail,fname) 
      endif

      vstats(1)=-1.d20
      vstats(2)=-1.d20
      vstats(3)=-1.d20
      vstats(4)=-1.d20
      vstats(5)=-1.d20
      vstats(6)=-1.d20
      vstats(7)=-1.d20
      vstats(8)=-1.d20

      do 78 k=izstart,izstop
       do 76 j=1,j3
       do 76 i=1,nx-1

        if(k.eq.nz/5+1)then 
         if(w(i,j,k)*template(i,j,ipla).gt.vstats(1))then
          vstats(1)=w(i,j,k)
          vstats(2)=real(i)
          vstats(3)=real(j)
          vstats(4)=sqrt(u(i,j,k)**2+v(i,j,k)**2)
         endif
        elseif(k.eq.nz/5*4+1)then
         if(w(i,j,k)*template(i,j,ipla).gt.vstats(5))then
          vstats(5)=w(i,j,k)
          vstats(6)=real(i)
          vstats(7)=real(j)
          vstats(8)=sqrt(u(i,j,k)**2+v(i,j,k)**2)
         endif
        endif

 76    continue
 78    continue

#ifdef MPI

      call MPI_ALLREDUCE(vstats(1),V_m(1),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(2),V_m(2),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(3),V_m(3),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(4),V_m(4),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(5),V_m(5),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(6),V_m(6),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(7),V_m(7),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)
      call MPI_ALLREDUCE(vstats(8),V_m(8),1,MPI_DOUBLE_PRECISION,
     &                MPI_MAX,MPI_COMM_WORLD,ierr)

#else

#endif


      if(myid .eq. 0) then
       write(lunum,100) time, V_m(1),V_m(2),
     & V_m(3),V_m(4),V_m(5),V_m(6),V_m(7),V_m(8) 
      
      endif

      call flush(lunum)

 80   continue

      call flush(88)

100   format(2(e15.9,2x),2(e10.4,2x),2(e15.9,2x),2(e10.4,2x),e15.9)

      end
