c $Log:   /pvcs.config/mc3dvv/src/vinitflow.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:38 1997   pvcs
c 
c *************************************************************
c *   VINITFLOW
c *************************************************************
c
c   Rev 1.1   12/21/93 16:58:28   llt
cadded log

      subroutine vinitflow
      use module_precision
c
c     initialize wave numbers, viscosity coef. etc. for
c     sub flow and plflow
c
      use module_param
      use module_giparam
      use module_a3
      use module_gia3
      use module_afftw
      use module_a11
      use module_spwork
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_viscom
      use module_gia9
      use module_a9
c
      itst=0
      jcycle=icycle
      twopi=2.*pimach(dumm)
      pi=pimach(dumm)
      if (ivistype.ge.0) cv2=1e-10	!high accuracy solution for const visc.
c
c     obtain coefficients for depth dependent viscosity
c     This is only for position dependent viscosity.
c     For temperature dependent viscosity VISCOS is called every
c     time step.

      if (ivistype.ge.0) then
        call vviscos 			!Initialize for Const Visc
      endif
c
      do 3 i = 1,inx
  3   wni(i) = zero
      do 4 j = 1,jnx
  4   wnj(j) = zero
c
c      for periodic side boundary conditions
c      x direction
c
      if (lbd.eq.0) then
        lpu =   1
        lpv =   1
        lpw =   1
        lpt13 = 1
        lpt23 = 1
        lpt33 = 1
        lpft =  1
        nxu =   nx-1
        nxv =   nx-1
        nxw =   nx-1
        nxt13 = nx-1
        nxt23 = nx-1
        nxt33 = nx-1
        nxft =  nx-1
        nxr =   nx-1
        call rffti (nxr,wx)
c
c   calculate wave number to index relation for rfft*
c
        wni(1)=0.
c        wni(nxr)=(2.*float(nxr))
c        wni(nxr)=float(nxr)
        wni(nxr)=((2.*float(nxr))/xl)*sin(float(nxr)*pi/(2.*float(nxr)))
        do 10 i=3,nxr,2
        wni(i-1)=((2.*float(nxr))/xl)*sin(float(i-1)*pi/(2.*float(nxr)))
        wni(i)=wni(i-1)
   10   continue
c
c      for reflecting (free slip) side boundary conditions
c      x direction
c
      elseif (lbd.eq.1) then
        xxl=pi/xl
        ddx=dx/2.
        do 20 i=1,nx
   20   wni(i)=sin(xxl*float(i-1)*ddx)/ddx
        lpu=2
        lpv=4
        lpw=4
        lpt13=2
        lpt23=4
        lpt33=4
        lpft=4
        nxu=nx-2
        nxv=nx
        nxw=nx
        nxt13=nx-2
        nxt23=nx
        nxt33=nx
        nxft=nx
        nxr=nx
        call costi (nx,wxc)
        call sinti (nx-2,wxs)
c
c      for no slip side boundary conditions
c      x direction
c
      elseif (lbd.eq.2) then
        xxl=pi/xl
        do 30 i=1,nx
   30   wni(i)=sin(xxl*float(i-1)*dx)/dx
        lpu=2
        lpv=2
        lpw=2
        lpt13=4
        lpt23=4
        lpt33=4
        lpft=2
        nxu=nx-2
        nxv=nx-2
        nxw=nx-2
        nxt13=nx
        nxt23=nx
        nxt33=nx
        nxft=nx-2
c
        nxr=nx
c
c  ?
c
        call costi (nx,wxc)
        call sinti (nx-2,wxs)
      endif
c
c      for periodic side boundary conditions
c      y direction
c
      if (mbd.eq.0) then
        mpu   = 1
        mpv   = 1
        mpw   = 1
        mpt13 = 1
        mpt23 = 1
        mpt33 = 1
        mpft  = 1
        nyu   = ny-1
        nyv   = ny-1
        nyw   = ny-1
        nyt13 = ny-1
        nyt23 = ny-1
        nyt33 = ny-1
        nyft  = ny-1
        nyr   = ny-1
        call rffti (nyr,wy)
c
c   calculate wave number to index relation for rfft*
c
        wnj(1)=0.
        if (ny.ne.2) then
c          wnj(nyr)=(2.*float(nyr))
          wnj(nyr)=(2.*float(nyr)/yl)*sin(float(nyr)*pi/(2.*float(nyr)))
          do 40 j=3,nyr,2
          wnj(j-1)=(2.*float(nyr)/yl)*sin(float(j-1)*pi/(2.*float(nyr)))
          wnj(j)=wnj(j-1)
   40     continue
        endif
        if (nyr.eq.1) wnj(1)=0.
c
c      for reflecting (free slip) side boundary conditions
c      y direction
c
      elseif (mbd.eq.1) then
        yyl=pi/yl
        ddy=dy/2.
        do 50 j=1,j3
   50   wnj(j)=sin(yyl*float(j-1)*ddy)/ddy
        mpu=4
        mpv=2
        mpw=4
        mpt13=4
        mpt23=2
        mpt33=4
        mpft=4
        nyu=j3
        nyv=ny-2
        nyw=j3
        nyt13=j3
        nyt23=ny-2
        nyt33=j3
        nyft=j3
        nyr=j3
        call costi (ny,wyc)
        call sinti (ny-2,wys)
c
c     two dimensional case
        if ((ny.eq.2).and.(jnx.gt.1)) wnj(2)=0.
c
c      for no slip side boundary
c      y direction
c
      elseif (mbd.eq.2) then
        yyl=pi/yl
        do 60 j=j1,j3
   60   wnj(j)=sin(yyl*float(j-1)*dy)/dy
        mpu=2
        mpv=2
        mpw=2
        mpt13=4
        mpt23=4
        mpt33=4
        mpft=2
        nyu=ny-2
        nyv=ny-2
        nyw=ny-2
        nyt13=ny
        nyt23=ny
        nyt33=ny
        nyft=ny-2
c
c  ?
        nyr=ny
c
        call costi (ny,wyc)
        call sinti (ny-2,wys)
      endif
c      write(6,*)xl,yl,nx,ny,lbd,mbd
      do 70 j=1,j3
      do 70 i=1,nx
         fl(i,j)=sqrt(wni(i)**2+wnj(j)**2)
         if (fl(i,j).ne.0.0) then
           fli(i,j)=wni(i)/fl(i,j)
           flj(i,j)=wnj(j)/fl(i,j)
         else
           fli(i,j)=0.
           flj(i,j)=0.
         endif
c        write(6,*)i,j,fli(i,j),flj(i,j),fl(i,j),wni(i),wnj(j)
c        spwk(i,j,1) = wni(i)
   70 continue

c     *** Added GI 8/24/95
      do k=1,ksl
         r1(k) = zero
         r2(k) = zero
         r3(k) = zero
         r4(k) = zero
      enddo

c     call opngks
c     call ezy(spwk,nx,'dum')
c     call clsgks 
      return
      end
