c $Log:   /pvcs.config/mc3dvv/src/vofxyz.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:40 1997   pvcs
c 
c *************************************************************
c *   VOFXYZ
c *
c *   Use analytical expression for velocity (isolve=5)
c *************************************************************
      subroutine vofxyz
      use module_precision
      use module_param
      use module_giparam
      use module_a2
      use module_gia3
      use module_a3
      parameter(pi=3.1415926)
      
      if (ny.ge.3) then
c        *** 3-D
         dx = 1d0/(nx-1)
         dy = 1d0/(ny-1)
         dz = 1d0/(nz-1)
         do k = 1,nz
           do j = 1,j3
             do i = 1,nx
                x = (i-1)*dx
                y = (j-1)*dy
                zz = (k-1)*dz
                u(i,j,k) = -100*sin(pi*x)*cos(pi*y)*cos(pi*zz)
                v(i,j,k) =   50*cos(pi*x)*sin(pi*y)*cos(pi*zz)
                w(i,j,k) =   50*cos(pi*x)*cos(pi*y)*sin(pi*zz)
             enddo 
           enddo
         enddo
      else
c        *** 2-D
         dxvof = 1d0/(nx-1)
         dyvof = 0
         dzvof = 1d0/(nz-1)
         do k = 1,nz
           do j = 1,j3
             do i = 1,nx
                x = (i-1)*dxvof
                zz = (k-1)*dzvof
                u(i,j,k) = -100*sin(pi*x)*cos(pi*zz)
                v(i,j,k) =    0
                w(i,j,k) =  100*cos(pi*x)*sin(pi*zz)
             enddo 
           enddo
         enddo
      endif
 
      return
      end

