c $Log:   /pvcs.config/mc3dvv/src/vviscos.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:42 1997   pvcs
c 
c *************************************************************
c *   VVISCOS
c *
c *   Calculates viscosity vector. Called from FLOW.
c    * Now filters visc and vnuc between frequencies xk1, xk2
c    * REMOVE CALL TO FT2NRM(..ft) and moved to flow 3/4/95
c *   CG/GI 9507
c *
c *   Rewritten to make use of general viscosity function FUNCVIS
c *   PvK 950811
c *************************************************************
      subroutine vviscos
      use module_precision
      use module_param		
      use module_ac1			
      use module_a1
      use module_gia1
      use module_gia3
      use module_a3
      use module_viscom
      use module_ftcoef
      use module_timeint
      use module_giparam
      use module_a12

      common /start1/ restrt, initlt, istart
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      common /cviscos/ vis1, vis2, vis3, vis4, vis5,
     1     kdepth1, kdepth2, kdepth3, kdepth4, kdepth5
      data enact,rgas,vol,rhog /1.9e+5, 8.3144d0, 4.e-6, 3.23e+4/
 

      dz = 1d0/(nz-1)

      if (ivistype.eq.-1) then 
         write(6,*) 'PERROR(vvisco): mean field viscosity is obsolete'
         write(6,*) '   option of vvisco: ivistype = ',ivistype
         stop 
      endif

      if (ivistype.lt.0) then

         secinv = 0
         do k=1,nz		
            zvisc = (k-1)*dz
            do j=1,j3
               yvisc = (j-1)*dy
               do i=1,nx
                   xvisc = (i-1)*dx
                   tvisc = ft(i,j,k)/rat
                   visc(i,j,k) = funcvis(ivistype,i,j,k,
     v                xvisc,yvisc,zvisc,tvisc,secinv) 
	           vnuc(i,j,k)=1d0/visc(i,j,k)
               enddo
            enddo
         enddo
 
      else if (ivistype.eq.0) then

         do k=1,nz
            vis(k) = 1d0
            vnu(k) = 1d0
         enddo

      else if (ivistype.gt.0) then
 
         do k=1,nz
            zvisc = (k-1)*dz
            vis(k) = 
     v         funcvis(ivistype,i,j,k,xvisc,yvisc,zvisc,tvisc,secinv) 
            vnu(k) = 1d0/vis(k)
         enddo

      endif

c---------------------------------------------------
c     Provide output opportunity 
c---------------------------------------------------
      call userout('visc')

      if (ivistype.le.-2) then
	  do k=1,nz
	    vmin=1.e36
	    vmax=-1.e36
	    do j=1,j3
	      do i=1,nx
	        if (visc(i,j,k).lt.vmin) vmin=visc(i,j,k)
	        if (visc(i,j,k).gt.vmax) vmax=visc(i,j,k)
              enddo
            enddo
c----------------------------------------------------
c  first icycle solve for mean visc case 
c G. Ito 1/95
c-------------------------------------------------------
	    vis(k)=vmin+half*(vmax-vmin)
            if (vis(k).gt.0) then
               vnu(k)=one/vmax+half*(one/vmin - one/vmax)	
            else
               write(6,*) 'PERROR(vviscos): problems!'
               write(6,*) 'vis(k): ',k,vis(k)
               stop
	    endif
          enddo

	  do k=1,nz
	    do j=1,j3
	      do i=1,nx
	        visc(i,j,k)=(visc(i,j,k)-vis(k))	
	        vnuc(i,j,k)=(vnuc(i,j,k)-vnu(k))		
              enddo
            enddo
          enddo

c-------------------------------------------------------------
c     Anti-Alias filtering of viscosity
c------------------------------------------------------------
c >>>>> 12/22/95: commented out to conform with GI's current version
c        call ft2nrm(1,lpft,nxft,mpft,nyft,nz,isl,jsl,visc)	
c        call ft2nrm(1,lpft,nxft,mpft,nyft,nz,isl,jsl,vnuc)	
c        call filt(visc,isl,jsl,ksl,nxft,nyft,nz,xf1,xf2)	!FILTER
c        call filt(vnuc,isl,jsl,ksl,nxft,nyft,nz,xf1,xf2)	!FILTER
c        call ft2nrm(-1,lpft,nxft,mpft,nyft,nz,isl,jsl,visc)	
c        call ft2nrm(-1,lpft,nxft,mpft,nyft,nz,isl,jsl,vnuc)
      endif	

c >>>
c     call printvisc(visc,vnuc,isl,jsl,ksl)
c >>>




  180 format ("viscosity type is ivistype=  ",i4)
  181 format ("***Call to Viscos:  icycle,time=",i4,e14.4)
  190 format ("kdepth= ",5i7)
  192 format ("vis1,2,3 4 5= ",5e14.4)
 1100 format (i5,2x,4(e10.4,2x))
 1111 format (17f8.2)
  970 format ("**************Input error in viscos ************",/, 
     1        " kdepth= ",5i7)

      return
      end


