c $Log:   /pvcs.config/mc3dvv/src/wavsfield.F_a  $
c   
c      Rev 1.3   Fri Jul 30 15:46:22 1999   lowman
c     Added options to control output of topography and geoid
c   
c      Rev 1.2   Tue Feb 09 14:32:08 1999   lowman
c   
c      Rev 1.1   Tue Oct 06 17:10:36 1998   lowman
c   Complete overhaul of entire routine.
c   Introduced options for temperature, velocity and stress field output
c   
c      Rev 1.0   Fri Aug 22 13:35:06 1997   hall
c   Initial revision.
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c	WAVSFIELD
c~~~begin prologue 	wavsfield
c~~~date written   	970724		(yymmdd)
c~~~revision date	xxxxxx		(yymmdd)
c~~~category no.   	??????
c~~~keywords	   	write AVS
c~~~author	   	Paul Hall
c~~~purpose	   	Write field data in format amenable to AVS
c~~~description
c
c
c~~~references     	(none)
c~~~routines called	namefile1 	avsheader	avs_xyzcoord	
c			dptosp		ttoft
c~~~modifications	(none)
c~~~end prologue	wavsfield
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      subroutine wavsfield(fieldname)
c
c	INCLUDES
c
c	ALL *.h FILES ARE STATED EXPLICITLY FOR NOW
c
      use module_precision
      use module_param
      use module_giparam
      use module_gia1
      use module_gia3
      use module_gia9
      use module_a1
      use module_a11
      use module_a12
      use module_a13
      use module_a14
      use module_a2
      use module_a20
      use module_a22
      use module_a23
      use module_a24
      use module_a25
      use module_a26
      use module_a3
      use module_a30
      use module_a6
      use module_a7
      use module_a77
      use module_a9
      use module_ac1
      use module_afftw
      use module_alam
      use module_cgeoid
      use module_craster
      use module_ctensr
      use module_ctoft
      use module_cvrms
      use module_fieldout
      use module_flow
      use module_fnames
      use module_ftcoef
      use module_intfac
      use module_inttauc
      use module_machine
      use module_output
      use module_patch
      use module_petracer
      use module_prtcl
      use module_pttouv
      use module_routput
      use module_spwork
      use module_tauout
      use module_temp4
      use module_timeint
      use module_viscom
      use module_work1d
c
c	REAL VARIABLES
c
      real*4 sptime, sdt
      real*8 adx,ady,adz
      real*8 scal(2)
      integer iscal(2)
c
c	CHARACTER STRINGS FOR FIELDNAME
c
      integer fieldname, iformat
c
c	CHARACTER STRINGS FOR FILE NAMES
c
      character*25 temp 
c
c	CHARACTER STRINGS FOR AVS FIELD LABELS
c
      character*25 tttemp
c
c	CHARACTER STRINGS FOR AVS FIELD UNITS
c
      character*25 utemp
c
c	MISCELLANEOUS CHARACTER STRINGS
c      
      character*60 fname
      character*60 fname_header
c
c    	THIS SUBROUTINE USES io unit = 55 FOR ALL FILES
c

      common/wavs_data/icall_io,lu_out,lastwrite

      if(icycle.eq.0)then
      icall_io=1
      lu_out=55 
      icalltemp=0
      lastwrite=0
      endif
c
      sptime=time
      sdt=dt
      if((icycle.ne.lastwrite).and.(icycle.ne.1))then
       icalltemp=icalltemp+1
       lastwrite=icycle
      endif
c
      if (abs(fieldname) .eq. 1) then
        if(fieldname .eq. 1)then
           temp = 'ft'
           tttemp = 'temperature'
           io_type = 1
        elseif(fieldname .eq. -1)then
           temp = 'ft_byte'
           tttemp = 'temperature_byte'
           io_type = 2
           ifscal = 1
           scal(1) = 0.0
           scal(2) = 1.1
           iscal(1) = 0
           iscal(2) = 255
        endif
      elseif(fieldname.eq.2)then
        temp = 'vx'
        tttemp = 'u_velocity'
        io_type = 1
      elseif(fieldname.eq.3)then
        temp = 'vy'
        tttemp = 'v_velocity'
        io_type = 1
      elseif(fieldname.eq.4)then
        temp = 'vz'
        tttemp = 'w_velocity'
        io_type = 1
      elseif(fieldname.eq.5)then
        temp = 'v3'
        tttemp = 'v_vector'
        io_type = 1
      elseif(fieldname.eq.9)then
        temp = 'vis'
        tttemp = 'viscosity' 
        io_type = 1
      elseif(fieldname.eq.12)then
        temp = 'Pu'
        tttemp = 'u_power'
        io_type = 1
      elseif(fieldname.eq.13)then
        temp = 'Pv'
        tttemp = 'v_power'
        io_type = 1
      elseif(fieldname.eq.14)then
        temp = 'Pw'
        tttemp = 'w_power'
        io_type = 1
      elseif(fieldname.eq.25)then
        temp = 'xz'
        tttemp = 'tau_xz'
        io_type = 1
      elseif(fieldname.eq.26)then
        temp = 'yz'
        tttemp = 'tau_yz'
        io_type = 1
      elseif(fieldname.eq.37)then
        temp = 'gd_AVS'
        tttemp = 'geoid'
        io_type = 1
      elseif(fieldname.eq.38)then
        temp = 'topo_AVS'
        tttemp = 'topo'
        io_type = 1
      endif
c
       itail=1
       itail=0
c
      utemp = 'dimensionless'
c
c
      if (icall_io .eq. 1) then
        adx=xl/float(nx-1)
        ady=yl/float(ny-1)
        adz=1./float(nz-1)

        write(6,*) 'nx = ',nx
        write(6,*) 'ny = ',ny
        write(6,*) 'nz = ',nz
c       call avs_xyzcoord(lu_out,nx,ny,nz,adx,ady,adz)
c
       endif
      icall_io = icall_io + 1
c
c   	A LAYER WITH 3 NODES IN Y DIRECTION
c
      if(jnx .eq. 0)then
        jnx1=2
        jnx2=2
        jnx3=1
        jmx1=2
        jmx2=2
        jmx3=1
      else
        jnx1 = 1
        jnx2 = jnx
        jnx3 = jnx
        jmx1 = 1
        jmx2 = jmx
        jmx3 = jmx
      endif
c
      if(abs(fieldname) .eq. 1) then
      if(icycle.eq.0) icalltemp=icalltemp+1
        nxr_save=nxr
        nyr_save=nyr
        nxr=nx-1
        nyr=ny-1
        call ttoft
        nxr=nxr_save
        nyr=nyr_save
        
        do k = 1,kmx
           do j = 1,jmx
              do i = 1,imx
                 ft(i,j,k) = ft(i,j,k)/rat
              enddo
           enddo
        enddo
        
        itail =0 
        iformat = 1
        if(io_type .eq. 1)then
c
c   Temperature Output
c
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
c        call dptosp(imx,jmx,kmx,ft,spwk,idum) 
c        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        write(lu_out) 
     & ((((real(ft(i,j,k),kind=4)),i=1,imx), j=1,jmx), k=1,kmx) 
        close(lu_out)
        write(6,*) '********** 32 bit temperatures **********'
c        iformat = 2
c        itail = 1
c        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
c        call avsheader
c     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
c        close(lu_out)
c
       elseif(io_type .eq. 2)then
            iformat = 2
            itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
c
c           Create a character string in fname which is the the name
c           used by the peras3 routine.
c
            itail = 0
            call setname(icalltemp,temp,itail,fname)
c
c    Write the file descriptor
            call avsheader_scale
     1      (lu_out,io_type,nx,j3,nz,sptime,icalltemp,fname,
     2       ifscal,iscal,scal)
       close(lu_out)
c
c    Output byte (0-255) values.
c
            call peras3(icalltemp,isx,jsx,ksx,nx,j3,nz,ft,ifscal,
     v                  iscal,scal,temp)
        endif
c
      elseif(fieldname.eq.2)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
c        call dptosp(inx,jnx,knx,u,dum,idum)
c        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        write(lu_out)
     & ((((real(u(i,j,k),kind=4)),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********  u-velocity  **********'
c        iformat = 2
c        itail = 1
c        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
c        call avsheader
c     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
c        close(lu_out)
      elseif(fieldname.eq.3)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
c        call dptosp(inx,jnx,knx,v,dum,idum)
c        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        write(lu_out)
     & ((((real(v(i,j,k),kind=4)),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********  v-velocity  **********'
c        iformat = 2
c        itail = 1
c        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
c        call avsheader
c     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
c        close(lu_out)
      elseif(fieldname.eq.4)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
c        call dptosp(inx,jnx,knx,w,dum,idum)
c        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        write(lu_out)
     & ((((real(w(i,j,k),kind=4)),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********  w-velocity  **********'
c        iformat = 2
c        itail = 1
c        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
c        call avsheader
c     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
c        close(lu_out)
      elseif(fieldname.eq.5)then
c        iformat = 2
c        itail = 1
c        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
c        call avsheader
c     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
c        close(lu_out)
      elseif(fieldname.eq.9)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(isl,jsl,ksl,visc,spwk,idum)
        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   viscosity  **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.12)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(inx,jnx,knx,u,dum,idum)
        write(lu_out) (((spwk(i,j,k)**2,i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   u-power   **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.13)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(inx,jnx,knx,v,dum,idum)
        write(lu_out) (((spwk(i,j,k)**2,i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   v-power   **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.14)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(inx,jnx,knx,w,dum,idum)
        write(lu_out) (((spwk(i,j,k)**2,i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   w-power   **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.25)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(imx,jmx,kmx,tau13,spwk,idum)
        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   tau_xz    **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.26)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(imx,jmx,kmx,tau23,spwk,idum)
        write(lu_out) (((spwk(i,j,k),i=1,imx), j=1,jmx), k=1,kmx)
        close(lu_out)
        write(*,*) '**********   tau_yz    **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.37)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(imx,jmx,1,gd,spwk,idum)
        write(lu_out) ((spwk(i,j,1),i=1,imx), j=1,jmx)
        close(lu_out)
        write(*,*) '**********   geoid    **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        kmx_dummy=1
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx_dummy,sptime,icalltemp,fname)
        close(lu_out)
      elseif(fieldname.eq.38)then
        iformat = 1
        itail = 0
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname)
        call dptosp(imx,jmx,1,gd,spwk,idum)
        write(lu_out) ((spwk(i,j,1),i=1,imx), j=1,jmx)
        close(lu_out)
        write(*,*) '********** topography **********'
        iformat = 2
        itail = 1
        call namefile1(icalltemp,lu_out,iformat,temp,itail,fname_header)
        kmx_dummy=1
        call avsheader
     1  (lu_out,io_type,imx,jmx,kmx_dummy,sptime,icalltemp,fname)
        close(lu_out)
      else
	print*,'PERROR(wavsfield): AVS is not implemented.'
      endif 
      return
      end
c
      subroutine dptosp(idim1,idim2,idim3,dp,xx,iflag)
c************BEGIN PROLOGUE********************************
c   PROGRAM NAME	dptosp
c   DATE WRITTEN	930316	(yymmdd)
c   REVISION DATE	xxxxxx  (yymmdd)
c   AUTHOR		Carl W. Gable (Los Alamos National Laboratory)
c   PURPOSE		write a double precision array into a single
c			precision array
c   DESCRIPTION/
c       COMMENTS
c   MODIFICATIONS
c************END PROLOGUE**********************************
      use module_param
      use module_spwork
      real*8 dp(idim1,idim2,idim3)

      do k = 1, idim3
	do j = 1, idim2
	  do i = 1, idim1
	    if(abs(dp(i,j,k)) .lt. 1.e-20)dp(i,j,k)=0.0d0
	    spwk(i,j,k)=dp(i,j,k)
   	    enddo
	  enddo
	enddo
      return
      end
c
      subroutine namefile1(icall,lund,iformat,root,itail,fname)
c
c
c     icall= the number of times this routine has been called.
c	     This value is used in putting a suffix on the output
c	     file.  The file names will have sequential suffixes.  Suffix
c	     is between 10001 and 99999 if ical .gt. 0 and .lt. 89999.
c	     You are on your own if you want more than 90000 files!
c
c     lund = logical unit number of file to be opened.
c
c     root = file's name root to which suffix will be added.
c
c     itail = file's name tail will be added to the end of the file name.
c
c     iformat = 1 unformatted file is opened
c		2 formatted file is opened
c
c
      character*60 fname
      character*25 root
      character*25 tail
      character*5 ch5
      fname='							'
c	     12345678901234567890123456789012345678901234567890
c
c	NAME OUTPUT FILE
c
      if(itail.eq.1)then
       tail = '.fld'
      else
       tail = ' ' 
      endif

      do 91 i=1,25
      if(tail(i:i).eq.' ') goto 2
   91 continue

    2 nchar_tail=i-1
c	if(iformat .eq. 2) then
c	  print *,root,tail,i
c	  endif

      do 95 i=1,25
	if(root(i:i).eq.' ') goto 3
   95 continue

    3 nchar_root=i-1

      ncall=icall+10000
      write(ch5,5) ncall
    5 format (i5)
      do 96 i=1,nchar_root
    	fname(i:i)=root(i:i)
   96 continue
      do 97 i=1,5
 	fname(nchar_root+i:nchar_root+i)=ch5(i:i)
   97 continue
      do 98 i=1,nchar_tail
        fname(nchar_root+5+i:nchar_root+5+i)=tail(i:i)
   98 continue
c
c 	OPEN TO OUTPUT FILE
c
      if (iformat .eq. 1) then
      open(unit=lund, file=fname, form='unformatted')
      elseif (iformat .eq. 2) then
      open(unit=lund, file=fname, form='formatted')
      else
      continue
      endif
c
      return
      end

c
      subroutine avsheader(lu,io_type,nx,ny,nz,sptime,icall,fname)
c
c	WRITE HEADER FILE FOR AVS READ_FIELD MODULE
c
      character*60 fname
      character*25 temp
      real*4 sptime
      iheader = 0
      nspace = 3
      ndim = 3
      if(ichar(fname(2:2)).eq.ichar('3'))then
       ivlen = 3
      else
       ivlen = 1
      endif

      write(lu,10)
      write(lu,20)
      write(lu,30)
      write(lu,40) icall, sptime
      write(lu,50) ndim
      write(lu,60) nspace
      write(lu,70) ivlen
      if(io_type .eq. 1)then
         write(lu,80) nx
      elseif(io_type .eq. 2)then
         write(lu,80) nx
      endif
      if    ((io_type .eq. 1).or.  (ny .eq. 1))then
         write(lu,90) ny
      elseif((io_type .eq. 2).and. (ny .gt. 2))then
         write(lu,90) ny
      endif
      write(lu,100) nz
      if(io_type .eq. 1)then
         write(lu,110)
         write(lu,120)
      elseif(io_type .eq. 2)then
         write(lu,115)
         write(lu,125)
      endif
      write(lu,130)
      write(lu,140)
      write(lu,150)
      write(lu,160)
       icount = 1
      if(ivlen.ne.3)then
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
      else
       itail = 0 
       iformat = 3 
       lu_dummy = 99
       temp = 'vx'
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname)
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
       temp = 'vy'
       icount = icount + 1
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname) 
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
       temp = 'vz'
       icount = icount + 1
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname) 
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
      endif

   10 format ('# AVS field file')
   20 format ('# use the AVS3 READ FIELD module to read the named file')
   30 format ('#')
   40 format ('# MC3DVV field file',/,
     1 '# icall = ',i10,/,'# time =',e14.7)
   50 format ('ndim   = ' ,i10, '       # dimensionality of the data')
   60 format ('nspace = ' ,i10, '       # physical space of the data')
   70 format ('veclen = ' ,i10, '       # number of scalar fields')
   80 format ('dim1   = ' ,i10, '       # first dimension')
   90 format ('dim2   = ' ,i10, '       # second dimension')
  100 format ('dim3   = ' ,i10, '       # third dimension')
  110 format ('data   = float           # type of data')
  115 format ('data   = byte            # type of data')
  120 format ('field  = rectilinear     # type of field')
  125 format ('field  = uniform         # type of field')
  130 format ('#')
  140 format ('coord 1 file = ./xcoord  filetype=ascii')
  150 format ('coord 2 file = ./ycoord  filetype=ascii')
  160 format ('coord 3 file = ./zcoord  filetype=ascii')
  200 format ('variable ',i1,' file
     1  = ./',a60,' filetype=unformatted skip = ',i10)
  205 format ('variable ',i1,' file
     1  = ./',a60,' filetype=binary skip = ',i10)

      return
      end
      subroutine avsheader_scale(lu,io_type,nx,ny,nz,sptime,icall,fname,
     1                           ifscal,iscal,scal)
c
c	WRITE HEADER FILE FOR AVS READ_FIELD MODULE
c
      character*60 fname
      character*25 temp
      real*4 sptime
      integer ifscal
      integer iscal(2)
      real*8 scal(2)
      iheader = 0
      nspace = 3
      ndim = 3
      if(ichar(fname(2:2)).eq.ichar('3'))then
       ivlen = 3
      else
       ivlen = 1
      endif

      write(lu,10)
      write(lu,20)
      write(lu,30)
      write(lu,40) icall, sptime
      write(lu,42) ifscal
      write(lu,43) iscal(1)
      write(lu,44) iscal(2)
      write(lu,45)  scal(1)
      write(lu,46)  scal(2)
      write(lu,50) ndim
      write(lu,60) nspace
      write(lu,70) ivlen
      if(io_type .eq. 1)then
         write(lu,80) nx
      elseif(io_type .eq. 2)then
         write(lu,80) nx
      endif
      if    ((io_type .eq. 1).or.  (ny .eq. 1))then
         write(lu,90) ny
      elseif((io_type .eq. 2).and. (ny .gt. 2))then
         write(lu,90) ny
      endif
      write(lu,100) nz
      if(io_type .eq. 1)then
         write(lu,110)
         write(lu,120)
      elseif(io_type .eq. 2)then
         write(lu,115)
         write(lu,125)
      endif
      write(lu,130)
      write(lu,140)
      write(lu,150)
      write(lu,160)
       icount = 1
      if(ivlen.ne.3)then
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
      else
       itail = 0 
       iformat = 3 
       lu_dummy = 99
       temp = 'vx'
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname)
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
       temp = 'vy'
       icount = icount + 1
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname) 
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
       temp = 'vz'
       icount = icount + 1
       call namefile1(icall,lu_dummy,iformat,temp,itail,fname) 
      if(io_type .eq. 1)then
       write(lu,200) icount, fname, iheader
      elseif(io_type .eq. 2)then
       write(lu,205) icount, fname, 0
      endif
      endif

   10 format ('# AVS field file')
   20 format ('# use the AVS3 READ FIELD module to read the named file')
   30 format ('#')
   40 format ('# MC3DVV field file',/,
     1 '# icall = ',i10,/,'# time =',e14.7)
   42 format ('# ifscal   =  ' ,i10)
   43 format ('# iscal(1) =  ' ,i10)
   44 format ('# iscal(2) =  ' ,i10)
   45 format ('#  scal(1) =  ' ,e14.7)
   46 format ('#  scal(2) =  ' ,e14.7)
   50 format ('ndim   = ' ,i10, '       # dimensionality of the data')
   60 format ('nspace = ' ,i10, '       # physical space of the data')
   70 format ('veclen = ' ,i10, '       # number of scalar fields')
   80 format ('dim1   = ' ,i10, '       # first dimension')
   90 format ('dim2   = ' ,i10, '       # second dimension')
  100 format ('dim3   = ' ,i10, '       # third dimension')
  110 format ('data   = float           # type of data')
  115 format ('data   = byte            # type of data')
  120 format ('field  = rectilinear     # type of field')
  125 format ('field  = uniform         # type of field')
  130 format ('#')
  140 format ('coord 1 file = ./xcoord  filetype=ascii')
  150 format ('coord 2 file = ./ycoord  filetype=ascii')
  160 format ('coord 3 file = ./zcoord  filetype=ascii')
  200 format ('variable ',i1,' file
     1  = ./',a60,' filetype=unformatted skip = ',i10)
  205 format ('variable ',i1,' file
     1  = ./',a60,' filetype=binary skip = ',i10)

      return
      end
c
      subroutine avs_xyzcoord(lu,nx,ny,nz,dx,dy,dz)
c
c	WRITE X, Y, Z, COORD FILES, ONLY ONCE
c
      implicit real*8(a-h,o-z)

      open (unit = lu, file = 'xcoord', form = 'formatted')
      write(lu,10) ((i-1)*dx, i = 1, nx)
      close (lu)

      open (unit = lu, file = 'ycoord', form = 'formatted')
      write(lu,10) ((i-1)*dy, i = 1, ny)
      close (lu)

      open (unit = lu, file = 'zcoord', form = 'formatted')
      write(lu,10) ((i-1)*dz, i = 1,nz)
      close (lu)

   10 format(10e14.7)

      return
      end
      subroutine setname(icall,root,itail,fname)
c
c     Similar to the namefile routine but it does not
c     open a file. It just creates a character string
c     from the root file name and the icall number.
c
c     icall= the number of times this routine has been called.
c	     This value is used in putting a suffix on the output
c	     file.  The file names will have sequential suffixes.  Suffix
c	     is between 10001 and 99999 if ical .gt. 0 and .lt. 89999.
c	     You are on your own if you want more than 90000 files!
c
c     root = file's name root to which suffix will be added.
c
c     itail = file's name tail will be added to the end of the file name.
c         0 = No tail
c         1 = Append .fld
c
c     fname = output, this is the character string created from the
c             root file name and the icall number. There is also the
c             option of adding a trail to the character string.
      character*60 fname
      character*25 root
      character*25 tail
      character*5 ch5
      fname='							'
c	     12345678901234567890123456789012345678901234567890
c
c	NAME OUTPUT FILE
c
      if(itail.eq.1)then
       tail = '.fld'
      else
       tail = ' ' 
      endif

      do 91 i=1,25
	if(tail(i:i).eq.' ') goto 2
   91 continue

    2 nchar_tail=i-1
c	if(iformat .eq. 2) then
c	  print *,root,tail,i
c	  endif

      do 95 i=1,25
	if(root(i:i).eq.' ') goto 3
   95 continue

    3 nchar_root=i-1

      ncall=icall+10000
      write(ch5,5) ncall
    5 format (i5)
      do 96 i=1,nchar_root
    	fname(i:i)=root(i:i)
   96 continue
      do 97 i=1,5
 	fname(nchar_root+i:nchar_root+i)=ch5(i:i)
   97 continue
      do 98 i=1,nchar_tail
        fname(nchar_root+5+i:nchar_root+5+i)=tail(i:i)
   98 continue
c
      return
      end
