c $Log:   /pvcs.config/mc3dvv/src/xyzijk.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:46 1997   pvcs
c 
c *************************************************************
c *   XYZIJK
c *************************************************************
      subroutine xyzijk(x,y,z,xl,yl,zl,i,j,k,nx,ny,nz,ijob,avx,avy,avz)
      use module_precision
      dimension avx(*), avy(*), avz(*)
c     
c     For grid on cell corners (u,v,w,ft)
c     ijob =  1 >> convert x,y,z to i,j,k (rounds to nearest grid node)
c     ijob = -1 >> convert i,j,k to x,y,z (exact conversion)
c
c     
c     For staggered grid on cell centers (T)
c     ijob =  2 >> convert x,y,z to i,j,k (rounds to nearest grid node)
c     ijob = -2 >> convert i,j,k to x,y,z (exact conversion)
c
      if(ijob .eq. -1)then
         dx = xl/float(nx-1)
         dy = yl/float(ny-1)
         dz = zl/float(nz-1)
         x = float(i-1)*dx
         y = float(j-1)*dy
         z = float(k-1)*dz
      elseif(ijob .eq. 1)then
         dxi = float(nx-1)/xl
         dyi = float(ny-1)/yl
         dzi = float(nz-1)/zl
         i = nint(x*dxi)+1
         j = nint(y*dyi)+1
         k = nint(z*dzi)+1
      endif
      if(ijob .eq. -2)then
         x = avx(i)
         y = avy(j)
         z = avz(k)
      elseif(ijob .eq. 2)then
         dx = xl/float(nx-1)
         dy = yl/float(ny-1)
         dz = zl/float(nz-1)
         i = nint((x/dx)+0.5)+1
         j = nint((y/dy)+0.5)+1
         k = nint((z/dz)+0.5)+1
      endif
      
      
      return
      end
