c *************************************************************
c *   FUNCPER
c *
c *   Called from INIT if AMP != 0 to define perturbation
c *   to initial condition (see INIT.F). 
c *   Default version: cosinusoidal perturbation in x and y
c *   with wavelengths ALFX and ALFY resp. and a sinusoidal
c *   taper in the vertical.
c *************************************************************
      function funcper(xper,yper,zper)
      use module_precision 
      use module_param
      use module_a3

      real*4 ran2
      parameter(pi=3.1415926)

      open(unit=57,file='input.jpl',iostat=iopen)
      if(iopen.ne.0)then
        write(*,*) 'file input.jpl does not exist.' 
	write(*,*) 'Cannot define funcper mc3dvv is therefore stopping.'
      stop
      endif
      rewind 57 
      read(57,*) ifuncper
      if (ifuncper.eq.1) then
       funcper = amp*cos(pi*alfx*xper)*cos(pi*alfy*yper)*sin(pi*zper) 
      elseif(ifuncper.eq.2) then
       funcper = amp*cos(pi*alfx*xper)*sin(pi*alfy*yper)*sin(pi*zper)
      elseif(ifuncper.eq.3) then
       funcper = amp*sin(pi*alfx*xper)*cos(pi*alfy*yper)*sin(pi*zper)
      elseif(ifuncper.eq.4) then
       funcper = amp*sin(pi*alfx*xper)*sin(pi*alfy*yper)*sin(pi*zper)
      endif
      if (ifuncper.eq.5) then
       funcper = amp*(cos(pi*xper/alfx)+cos(pi*yper/alfy))*sin(pi*zper)
      endif
      if (ifuncper.eq.6) then
       funcper = amp*(cos(alfx*pi*xper+alfy*pi*yper))*sin(pi*zper)
      endif
      if (ifuncper.eq.7) then
       funcper = amp*(sin(pi*xper/alfx)+sin(pi*yper/alfy))*sin(pi*zper)
      endif
      if (ifuncper.eq.8) then
       funcper = amp
      endif
      if (ifuncper.eq.9) then
       funcper = 0.0 
      endif
      if (ifuncper.eq.10) then
       dummy=nx*xper+ny*yper+nz*zper
       idummy=-int(dummy)
       funcper = amp*(ran2(idummy)-.5)
      endif 
      if (ifuncper.eq.11) then
       if (((xper.gt.3.9).and.(xper.lt.4.1)).and.
     & ((zper.lt..75).and.(zper.gt..25)))then
        funcper = amp 
       else
        funcper = 0.0
       endif
      endif 
      if (ivistype.eq.-20) then
c        *** Special case for Busse var vis
c        *** Such to create one single upwelling at (x,y)=(0,0)
c        if (xper.lt.0.4.and.yper.lt.0.4) then
c           funcper= amp*sin(pi*zper)
c        else
c           funcper = -amp*sin(pi*zper)
c        endif
         funcper = 0.25*amp*(1+cos(pi*alfx*xper))*
     v        (1+cos(pi*alfy*yper))*sin(zper*pi)
c           write(6,'(''F: '',4f15.7)') xper,yper,zper,funcper
      endif

      return
      end

