      module module_timeint

c *   *** /timeint/     parameters controlling time integration
c *   *** itimechoice - type of time-integration: 
c *   ***               0 = anti-diffusion, first order
c *   ***               1 = DASPK with maximum temporal order MXORD
c *   *** norder        Order of spatial FD scheme used with DASPK
c *   *** mxord         Maximum order of temporal integration
c *   *** maxl          I'll look that up
c *   *** mxml          Lower bandwidth of preconditioner for DASPK
c *   *** mxmu          Upper bandwidth of preconditioner for DASPK
c *   *** atol          Absolute tolerance for time integration
c *   *** rtol          Relative tolerance for time integration

      integer itimechoice,norder,mxord,maxl,mxml,mxmu,ipar,info
      integer niwork,nrwork
      common /itimeint/ itimechoice,norder,mxord,maxl,mxml,mxmu,
     v                  ipar(20),info(20),niwork,nrwork
      real*8 atol,rtol,rpar
      common /rtimeint/ atol,rtol,rpar(20)

      common /timeint/ ipyprime,ipiiwork,iprwork

      real*8, allocatable :: yprime(:,:,:)
      integer, allocatable :: iiwork(:)
      real*8, allocatable :: rwork(:)
      end module module_timeint
