/* this collection of functions defines the interaction with*/
/* FITS formatted helioseismic data.*/

#define NBUF 300000 /* number of bytes in each solar image*/
#define PMODE 0666  /* rw for me, rw for others*/
#include <stdio.h>

static char buf[NBUF];

errorr(s1,s2)
char *s1,*s2;
{	printf(s1,s2);
	printf("\n");
}


/*************************************************************
   Versions for those loaders needing an underscore at the end of
   the function name: 
*************************************************************/

creadr_(fd_ptr,buf_ptr,nbytes_ptr,ierr_ptr,buf_len)
/*reads nbytes from device fd into char array buf*/

int *fd_ptr,*nbytes_ptr,buf_len,*ierr_ptr;
char *buf_ptr;
{
	int fd,nbytes,n_read,i;
	fd = *fd_ptr;
	nbytes = *nbytes_ptr;
	*ierr_ptr = 0;

	n_read=read(fd,buf,nbytes);
	if(n_read != nbytes) *ierr_ptr = 1;

	for(i=0;i<=(nbytes-1);++i) 
	 *(buf_ptr)++ = buf[i];

	buf_len=nbytes;
}


cwriter_(fd_ptr,buf_ptr,nbytes_ptr,buf_len)
/*writes nbytes_ptr into char array buf_ptr into device fd_ptr*/

int *fd_ptr,*nbytes_ptr,buf_len;
char *buf_ptr;
{
	int fd,nbytes,n_write,i;
	fd= *fd_ptr;
	nbytes= *nbytes_ptr;

	for(i=0;i<=(nbytes-1);++i) 
	 buf[i] = *(buf_ptr)++;

	n_write=write(fd,buf,nbytes);

	buf_len=nbytes;

}

copenr_(fd_ptr,istat_ptr,name_ptr,nbytes_ptr,name_len)
/* opens a file with descriptor fd_ptr. if file does not*/
/* already istat_ptr=1, if exists istat_ptr=0. currently value of*/
/* istat_ptr must be passed explicitly.*/
/* note: if try to create old file, the file will be deleted!!!*/
/* returns file name:name to calling routine */

int *fd_ptr,*istat_ptr,name_len,*nbytes_ptr;
char *name_ptr;
{
	char c;
	char name[80];
	int i,j,fd,istat,nbytes;

	istat = *istat_ptr;
	nbytes = *nbytes_ptr;
	for(i=0;i<=(nbytes-1);++i) {
	 name[i] = *(name_ptr)++;
	}
	 name[nbytes]='\0';

	if(istat != 1)   /*open to read already existing file*/
	{
	 if((fd = open(name,0)) == -1)   /*0 means read only*/
	  errorr("can't open %s",name);
	}
	else          /*create and open new file for writing*/
	{
	 if((fd = creat(name,PMODE)) ==-1)
	  errorr("can't create %s",name);
	}
	*fd_ptr = fd;
	name_len = nbytes;
}


ccloser_(fd_ptr)
int *fd_ptr;
{
	int fd;
	fd = *fd_ptr;
	close(fd);
}

/*************************************************************
   Versions without the underscore, lower case
 ************************************************************/

creadr(fd_ptr,buf_ptr,nbytes_ptr,ierr_ptr,buf_len)
/*reads nbytes from device fd into char array buf*/

int *fd_ptr,*nbytes_ptr,buf_len,*ierr_ptr;
char *buf_ptr;
{
	int fd,nbytes,n_read,i;
	fd = *fd_ptr;
	nbytes = *nbytes_ptr;
	*ierr_ptr = 0;

	n_read=read(fd,buf,nbytes);
	if(n_read != nbytes) *ierr_ptr = 1;

	for(i=0;i<=(nbytes-1);++i) 
	 *(buf_ptr)++ = buf[i];

	buf_len=nbytes;
}


cwriter(fd_ptr,buf_ptr,nbytes_ptr,buf_len)
/*writes nbytes_ptr into char array buf_ptr into device fd_ptr*/

int *fd_ptr,*nbytes_ptr,buf_len;
char *buf_ptr;
{
	int fd,nbytes,n_write,i;
	fd= *fd_ptr;
	nbytes= *nbytes_ptr;

	for(i=0;i<=(nbytes-1);++i) 
	 buf[i] = *(buf_ptr)++;

	n_write=write(fd,buf,nbytes);

	buf_len=nbytes;

}

copenr(fd_ptr,istat_ptr,name_ptr,nbytes_ptr,name_len)
/* opens a file with descriptor fd_ptr. if file does not*/
/* already istat_ptr=1, if exists istat_ptr=0. currently value of*/
/* istat_ptr must be passed explicitly.*/
/* note: if try to create old file, the file will be deleted!!!*/
/* returns file name:name to calling routine */

int *fd_ptr,*istat_ptr,name_len,*nbytes_ptr;
char *name_ptr;
{
	char c;
	char name[80];
	int i,j,fd,istat,nbytes;

	istat = *istat_ptr;
	nbytes = *nbytes_ptr;
	for(i=0;i<=(nbytes-1);++i) {
	 name[i] = *(name_ptr)++;
	}
	 name[nbytes]='\0';

	if(istat != 1)   /*open to read already existing file*/
	{
	 if((fd = open(name,0)) == -1)   /*0 means read only*/
	  errorr("can't open %s",name);
	}
	else          /*create and open new file for writing*/
	{
	 if((fd = creat(name,PMODE)) ==-1)
	  errorr("can't create %s",name);
	}
	*fd_ptr = fd;
	name_len = nbytes;
}


ccloser(fd_ptr)
int *fd_ptr;
{
	int fd;
	fd = *fd_ptr;
	close(fd);
}

/*************************************************************
   Versions without the underscore, upper case
 ************************************************************/

CREADR(fd_ptr,buf_ptr,nbytes_ptr,ierr_ptr,buf_len)
/*reads nbytes from device fd into char array buf*/

int *fd_ptr,*nbytes_ptr,buf_len,*ierr_ptr;
char *buf_ptr;
{
	int fd,nbytes,n_read,i;
	fd = *fd_ptr;
	nbytes = *nbytes_ptr;
	*ierr_ptr = 0;

	n_read=read(fd,buf,nbytes);
	if(n_read != nbytes) *ierr_ptr = 1;

	for(i=0;i<=(nbytes-1);++i) 
	 *(buf_ptr)++ = buf[i];

	buf_len=nbytes;
}


CWRITER(fd_ptr,buf_ptr,nbytes_ptr,buf_len)
/*writes nbytes_ptr into char array buf_ptr into device fd_ptr*/

int *fd_ptr,*nbytes_ptr,buf_len;
char *buf_ptr;
{
	int fd,nbytes,n_write,i;
	fd= *fd_ptr;
	nbytes= *nbytes_ptr;

	for(i=0;i<=(nbytes-1);++i) 
	 buf[i] = *(buf_ptr)++;

	n_write=write(fd,buf,nbytes);

	buf_len=nbytes;

}

COPENR(fd_ptr,istat_ptr,name_ptr,nbytes_ptr,name_len)
/* opens a file with descriptor fd_ptr. if file does not*/
/* already istat_ptr=1, if exists istat_ptr=0. currently value of*/
/* istat_ptr must be passed explicitly.*/
/* note: if try to create old file, the file will be deleted!!!*/
/* returns file name:name to calling routine */

int *fd_ptr,*istat_ptr,name_len,*nbytes_ptr;
char *name_ptr;
{
	char c;
	char name[80];
	int i,j,fd,istat,nbytes;

	istat = *istat_ptr;
	nbytes = *nbytes_ptr;
	for(i=0;i<=(nbytes-1);++i) {
	 name[i] = *(name_ptr)++;
	}
	 name[nbytes]='\0';

	if(istat != 1)   /*open to read already existing file*/
	{
	 if((fd = open(name,0)) == -1)   /*0 means read only*/
	  errorr("can't open %s",name);
	}
	else          /*create and open new file for writing*/
	{
	 if((fd = creat(name,PMODE)) ==-1)
	  errorr("can't create %s",name);
	}
	*fd_ptr = fd;
	name_len = nbytes;
}


CCLOSER(fd_ptr)
int *fd_ptr;
{
	int fd;
	fd = *fd_ptr;
	close(fd);
}
