      program test
c     This is a demo program for producing raster output files
c     using subroutine RASTER.
c
c     Additional subroutines are in
c       /r/suibhne/usr2/gable/raster/rio.f (fortran which calls C programs)
c                                   /cior.c(C io programs)
c
c
      parameter(inx=200, knx=200)
      dimension t(inx,knx)
      character*72 root
      root='new'
     
      pi=acos(-1.)
      scal=1./(2.*float(inx*knx))
      do 10 k=1,knx
         do 10 i=1,inx
             t(i,k)=(float(i*k)*scal)
             if(t(i,k) .le. 1./254.)t(i,k)=1./253.
   10 continue
      call raster(1,inx,knx,t,root)
      do 20 k=1,knx
      z=(float(k)/float(knx))
         do 20 i=1,inx
            t(i,k)=z*(cos(pi*(float(i)/float(inx))))**2
   20 continue
      call raster(2,inx,knx,t,root)
      stop
      end
    
      subroutine raster(icall,inx,knx,t,root)
c
c     Each call to RASTER will produce an output file.
c
c     icall= the number of times this routine has been called.
c            This value is used in putting a suffix on the output
c            file. The file names will have sequential suffixes so they can
c            be easily read by imagetool in animate mode. Suffix will
c            be between 101 and 999 if icall .gt. 0 and .lt. 899.
c            You are on your own if you want more than 900 files!
c
c     t=    two dimensional array of real numbers to be
c           sent to a raster file for input into imagetool.
c           This routine assumes you have scaled the array
c           to have values between 0 and 1. 
c
c     inx=  first dimension of array t
c
c     knx=  second dimension of array t   (note: knx not nec = inx)
c
c     root=raster file's name root to which suffix will be added.
c          must be declared as character*72 on MAIN.
c
c     The maximum size is 256x256=65536 data(note: knx not nec = inx). 
c     This may be changed in
c     the parameter statement below however the dimension of BUF in
c     C program cior.c must also be changed.
c
      parameter(max=65536)
      dimension t(inx,knx)
      integer*4 lu
      integer*2 itemp
      character*1 a1(2), a2(max)
      character*80 fname
      character*72 root
      character*3 ch3
      common/name0/fname
      equivalence (a1,itemp)
c
c     cheak range of input
c 
      rmax=-1.e20
      rmin=1.e20     
      do 80 k=1,knx
        do 80 i=1,inx
           rmax=amax1(rmax,t(i,k))
           rmin=amin1(rmin,t(i,k))
   80 continue
      if(rmax .gt. 1. .or. rmin .lt. 0.)then
      print *,'invalid range for t array, rmax=',rmax,' rmin=',rmin
      endif
c
c     scale as integer between 1 and 255
c     write into a2 as 8 bit integer
c
      icount=1
      do 90 k=1,knx
         do 90 i=1,inx
           itemp=int(254.*t(i,k))+1
           a2(icount)=a1(2)
           icount=icount+1
   90 continue
      nbyte=icount-1
c
c     name output file
c
      do 95 i=1,72
        if(root(i:i).eq.' ') goto 3
 95     continue
 3      namlen=i-1
      ncall=icall+100
      write(ch3,5)ncall
    5 format(i3)
      do 96 i=1,namlen
       fname(i:i)=root(i:i)
  96  continue
      do 97 i=1,3
       fname(namlen+i:namlen+i)=ch3(i:i)
   97 continue
c
c     write to output file
c
      call ropen(lu,1)
      call rwrite(lu,a2,max,nbyte)
      call rclose(lu)
c
      return
      end
