/*
 * get palette name from user input
 */
get_palname(palfile) 
char *palfile;
{
	extern char default_pal[];
	char **fn, *s;

	/* resolve palette name typed in */
	strncpy(palfile, (char *)panel_get_value(pal_board), MAXNAMELEN-5);
	if(strlen(palfile) == 0) {
	    if(strlen(default_pal) != 0)
	   	strncpy(palfile, default_pal, MAXNAMELEN-1);
	   else {
		msg_write("Warning: no palette name given (no default)\r\n");
		return(-1);
	   }
	}
	
	/* looking for a '.' */
	s = (char *)rindex(palfile,'.');
	if(s == NULL || strcmp(s,".pal") != 0) 
	    strcat(palfile, ".pal");

	/* get palette name and open */
	fn = wildcard(palfile);
	if (fn[0] == NULL) { /* not exist */
	    err_msg(E_NOFILE, palfile);
	    return(-1);
	}
	else if (fn[1] != NULL) { /* ambiguous */
	    err_msg(E_MULFILE, palfile);
	    return(-1);
	}

	strncpy(palfile, fn[0], MAXNAMELEN-1);
	if(fn[0] != NULL) free(fn);
	return(0);
}

