/*
 * loading a palette
 */
load_pal()
{
	char palfile[MAXNAMELEN];

	clear_request = 0;

	if(get_palname(palfile) == -1)
	    return;
	if(set_pal(palfile) != -1) {
	    strncpy(last_pal, curr_pal, MAXNAMELEN-1);
	    strncpy(curr_pal, palfile, MAXNAMELEN-1);
	}
}

set_pal(palfile)
char palfile[];
{
	unsigned char rmap[256],bmap[256],gmap[256];
	FILE *fp;
	register i;

	/* open and read palette file */
	if((fp=fopen(palfile, "r")) == NULL) {
	    err_msg(E_NOFOPEN, palfile);
	    return(-1);
	}

	for(i=0;i<256;i++) {
            fread(rmap,1,color_index,fp);
            fread(gmap,1,color_index,fp);
            fread(bmap,1,color_index,fp);
	}
	fclose(fp);

	/* load the same colormap to three imagetool windows */
	pw_putcolormap((Pixwin *) window_get(base, WIN_PIXWIN),
			1,color_index-4,rmap+1,gmap+1,bmap+1); 
	pw_putcolormap((Pixwin *) window_get(panel, WIN_PIXWIN),
			1,color_index-4,rmap+1,gmap+1,bmap+1); 
	pw_putcolormap((Pixwin *) window_get(menu_panel, WIN_PIXWIN),
			1,color_index-4,rmap+1,gmap+1,bmap+1); 
	pw_putcolormap((Pixwin *) canvas_pixwin(canvas),
			1,color_index-4,rmap+1,gmap+1,bmap+1); 
	pw_putcolormap((Pixwin *) window_get(ttysw, WIN_PIXWIN),
			1,color_index-4,rmap+1,gmap+1,bmap+1); 
	if(color_edit_mode == CEDIT_FIDDLE)
	    pw_getcolormap(pw,0,color_index,red1,green1,blue1); 

	panel_set_value(pal_board, palfile);
	return(0);
}
