      subroutine rast3dat
     1 (icall,time,inx,jnx,knx,nx,ny,nz,t,ifscal,iscal,scal,root,lu)
c
c     Each call to RASTER will produce an output file.
c     This routine records the output parameters for the file
c     written by raster3.
c
c     icall= the number of times this routine has been called.
c            This value is used in putting a suffix on the output
c            file. The file names will have sequential suffixes so they can
c            be easily read by imagetool in animate mode. Suffix will
c            be between 101 and 999 if icall .gt. 0 and .lt. 899.
c            You are on your own if you want more than 900 files!
c
c     t=    two dimensional array of real numbers to be
c           sent to a raster file for input into imagetool.
c           This routine assumes you have scaled the array
c           to have values between 0 and 1. 
c
c     inx=  first dimension of array t
c
c     jnx=  second dimension of array t   (note: knx not nec = inx)
c
c     knx=  third dimension of array t   (note: knx not nec = inx)
c
c     nx= number of data in x direction
c
c     ny= number of data in x direction
c
c     nz= number of data in z direction
c
c     ifscal = 0 auto scale of input values
c            = 1 max min scale is set in 2D aray scal, values
c              outside of scale will clip
c
c     scal   = 2d array with min and max values
c    
c
c     root=raster file's name root to which suffix is added.
c          must be declared as character*72 on MAIN.
c
      dimension iscal(2)
      dimension scal(2)
      character*80 fname
      character*72 root
      character*5 ch5
      common/name0/fname

      if(icall .eq. 1)then      
c
c     name  and open output file
c
      do 95 i=1,72
        if(root(i:i).eq.' ') goto 3
 95     continue
 3      namlen=i-1
      ncall=icall+10000
      write(ch5,5)ncall
    5 format(i5)
      fname(1:1)='0'
      do 96 i=1,namlen
       fname(i+1:i+1)=root(i:i)
  96  continue

      open(lu,file=fname)
      write(lu,290)inx,jnx,knx,nx,ny,nz
      
      endif  
c
c     write to output file
c
      write(lu,300)
     1  icall,time,ifscal,iscal(1),iscal(2),scal(1),scal(2)
  290 format(6i5)
  300 format(i5,e14.7,3i5,2e14.7)
c
      return
      end
