      subroutine raster(icall,inx,knx,t,root)
c
c     Each call to RASTER will produce an output file.
c
c     icall= the number of times this routine has been called.
c            This value is used in putting a suffix on the output
c            file. The file names will have sequential suffixes so they can
c            be easily read by imagetool in animate mode. Suffix will
c            be between 101 and 999 if icall .gt. 0 and .lt. 899.
c            You are on your own if you want more than 900 files!
c
c     t=    two dimensional array of real numbers to be
c           sent to a raster file for input into imagetool.
c           This routine assumes you have scaled the array
c           to have values between 0 and 1. 
c
c     inx=  first dimension of array t
c
c     knx=  second dimension of array t   (note: knx not nec = inx)
c
c     root=raster file's name root to which suffix will be added.
c          must be declared as character*72 on MAIN.
c
c     The maximum size is 256x256=65536 data(note: knx not nec = inx). 
c               now set to 516x129=66564
c     This may be changed in
c     the parameter statement below however the dimension of BUF in
c     C program cior.c must also be changed.
c
      parameter(max=66564)
      dimension t(inx,knx)
      integer*4 lu
      integer*2 itemp
      character*1 a1(2), a2(max)
      character*80 fname
      character*72 root
      character*4 ch4
      common/name0/fname
      equivalence (a1,itemp)
c
c     cheak range of input
c 
      rmax=-1.e20
      rmin=1.e20     
      do 80 k=1,knx
        do 80 i=1,inx
           rmax=amax1(rmax,t(i,k))
           rmin=amin1(rmin,t(i,k))
   80 continue
      if(rmax .gt. 1. .or. rmin .lt. 0.)then
      print *,'invalid range for t array, rmax=',rmax,' rmin=',rmin
      endif
c
c     scale as integer between 1 and 251
c     write into a2 as 8 bit integer
c
      icount=1
      do 90 k=1,knx
         do 90 i=1,inx
           itemp=int(250.*t(i,k))+1
           a2(icount)=a1(2)
           icount=icount+1
   90 continue
      nbyte=icount-1
c
c     name output file
c
      do 95 i=1,72
        if(root(i:i).eq.' ') goto 3
 95     continue
 3      namlen=i-1
      ncall=icall+1000
      write(ch4,5)ncall
    5 format(i4)
      do 96 i=1,namlen
       fname(i:i)=root(i:i)
  96  continue
      do 97 i=1,4
       fname(namlen+i:namlen+i)=ch4(i:i)
   97 continue
c
c     write to output file
c
      call ropen(lu,1)
      call rwrite(lu,a2,max,nbyte)
      call rclose(lu)
c
      return
      end
