      subroutine rastread
     1 (icall,inx,jnx,knx,nx,ny,nz,t,ifscal,iscal,scal,root)
c
c     Each call to RASTER will produce an output file.
c
c     icall= the number of times this routine has been called.
c            This value is used in putting a suffix on the output
c            file. The file names will have sequential suffixes so they can
c            be easily read by imagetool in animate mode. Suffix will
c            be between 101 and 999 if icall .gt. 0 and .lt. 899.
c            You are on your own if you want more than 900 files!
c
c     t=    two dimensional array of real numbers to be
c           sent to a raster file for input into imagetool.
c           This routine assumes you have scaled the array
c           to have values between 0 and 1. 
c
c     inx=  first dimension of array t
c
c     jnx=  second dimension of array t   (note: knx not nec = inx)
c
c     knx=  third dimension of array t   (note: knx not nec = inx)
c
c     nx= number of data in x direction
c
c     ny= number of data in y direction
c
c     nz= number of data in z direction
c
c     ifscal = 0 auto scale of input values
c            = 1 max min scale is set in 2D aray scal, values
c              outside of scale will clip
c
c     scal   = 2d array with min and max values
c    
c
c     root=raster file's name root to which suffix will be added.
c          must be declared as character*72 on MAIN.
c
c     The maximum size is 256x256=65536 data(note: knx not nec = inx). 
c     32x32x32 apx = 32000  
c               now set to 516x129=66564
c     This may be changed in
c     the parameter statement below however the dimension of BUF in
c     C program cior.c must also be changed.
c
      parameter(max=66564)
      dimension t(inx,jnx,knx)
      dimension iscal(2)
      dimension scal(2)
      integer*4 lu
      integer*2 itemp
      character*1 a1, a2
      common /a1a2/ a1(2), a2(max)
      character*80 fname
      character*72 root
      character*5 ch5
      common/name0/fname
      equivalence (a1,itemp)

      if(ifscal .ne. 1)then
      return
      endif      
c
c     name output file
c
      do 95 i=1,72
        if(root(i:i).eq.' ') goto 3
 95     continue
 3      namlen=i-1
      ncall=icall+10000
      write(ch5,5)ncall
    5 format(i5)
      do 96 i=1,namlen
       fname(i:i)=root(i:i)
  96  continue
      do 97 i=1,5
       fname(namlen+i:namlen+i)=ch5(i:i)
   97 continue
c
c     read input file
c
      nbyte=nx*ny*nz
      call ropen(lu,0)
      call rread(lu,a2,max,nbyte,ierr)
      call rclose(lu)
c
c
c     scale from integer between iscal(1) [20] and iscal(2) [250]
c     assumine that t is between rmin and rmax
c     outside the range will be clipped
c     uncompress to values between rmin and rmax
c     scale using y=ax+b
c     where
c       a=(rmax-rmin)/(imax-imin)
c       b=(imax*rmin-imin*rmax)/(imax-imin)
c
      rmin=scal(1)
      rmax=scal(2)
      imin=iscal(1)
      imax=iscal(2)
      
      icount=1
      a=(rmax-rmin)/(imax-imin)
      b=(imax*rmin-imin*rmax)/(imax-imin)
      do 92 k=1,nz
       do 92 j=1,ny
         do 90 i=1,nx
           a1(2)=a2(icount)
           t(i,j,k)=a*itemp+b
           icount=icount+1
c           if(t(i,j,k) .ne. 0.)then
c           print *,i,j,k,t(i,j,k)
c           endif
           
   90 continue
   92 continue
      
      return
      end
